CategoricalArrays.jl
==================

[![Build status](https://github.com/JuliaData/CategoricalArrays.jl/workflows/CI/badge.svg)](https://github.com/JuliaData/CategoricalArrays.jl/actions?query=workflow%3ACI+branch%3Amaster)
[![Coveralls](https://coveralls.io/repos/github/JuliaData/CategoricalArrays.jl/badge.svg)](https://coveralls.io/github/JuliaData/CategoricalArrays.jl)
[![Codecov](https://codecov.io/gh/JuliaData/CategoricalArrays.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaData/CategoricalArrays.jl)

Documentation:

[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliadata.github.io/CategoricalArrays.jl/stable)

[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliadata.github.io/CategoricalArrays.jl/dev)

This package provides tools for working with categorical variables, both with unordered (nominal variables) and ordered categories (ordinal variables), optionally with missing values.

module TestView
using Test
using CategoricalArrays

const ≅ = isequal

@testset "view($(CategoricalArray{Union{T, eltype(a)}}), $inds), ordered=$order construction" for
    T in (Union{}, Missing), order in (true, false),
    a in (1:10, 10:-1:1, ["a", "c", "b", "b", "a"]),
    inds in [1:2, :, 1, []]

    x = CategoricalArray{Union{T, eltype(a)}}(a, ordered=order)
    v = view(x, inds)
    @test levels(x) isa CategoricalVector{nonmissingtype(eltype(a))}
    @test levels(v) == levels(x)
    @test unique(v) == (ndims(v) > 0 ? unique(a[inds]) : [a[inds]])
    @test isordered(v) === isordered(x)
end

@testset "views comparison" begin
    ca1 = CategoricalArray([1, 2, 3])
    ca2 = CategoricalArray{Union{Int, Missing}}([1, 2, 3])
    ca3 = CategoricalArray([1, 2, missing])
    ca4 = CategoricalArray([4, 3, 2])
    ca5 = CategoricalArray([1 2; 3 4])

    @test view(ca1, 1:2) == view(ca1, 1:2)
    @test view(ca2, 1:2) == view(ca2, 1:2)
    @test view(ca1, 1:2) == view(ca2, 1:2)
    @test view(ca1, 1:2) == view(ca3, 1:2)
    @test view(ca1, 1:2) != view(ca2, 1:3)
    @test view(ca1, 1:2) != view(ca5, 1:2, 1:1)
end

@testset "fill! on view" for
    a in (categorical(["c", "a", "b"]), categorical(["c", "a", missing]))
    v = view(a, 1:2)
    @test fill!(v, a[1]) == ["c", "c"]
    @test fill!(v, "a") == ["a", "a"]
    @test fill!(v, "d") == ["d", "d"]
    if eltype(a) >: Missing
        @test fill!(v, missing) ≅ [missing, missing]
    else
        @test_throws MethodError fill!(v, missing)
    end
end

end

module TestConstructors
using Test
using CategoricalArrays
using CategoricalArrays: DefaultRefType

@testset "Type parameter constraints" begin
    # cannot use categorical value as level type
    @test_throws TypeError CategoricalPool{CategoricalValue{Int,UInt8}, UInt8}(
            Dict{CategoricalValue{Int,UInt8}, UInt8}(), false)
    @test_throws TypeError CategoricalPool{CategoricalValue{Int,UInt8}, UInt8}(
                CategoricalValue{Int,UInt8}[], false)
end

@testset "empty CategoricalPool{String}" begin
    pool = CategoricalPool{String}()

    @test isa(pool, CategoricalPool{String})

    @test isa(pool.levels, Vector{String})
    @test length(pool.levels) == 0

    @test isa(pool.invindex, Dict{String, DefaultRefType})
    @test length(pool.invindex) == 0
end

@testset "empty CategoricalPool{Int}" begin
    pool = CategoricalPool{Int, UInt8}()

    @test isa(pool, CategoricalPool{Int, UInt8})

    @test isa(pool.levels, Vector{Int})
    @test length(pool.levels) == 0

    @test isa(pool.invindex, Dict{Int, UInt8})
    @test length(pool.invindex) == 0
end

@testset "CategoricalPool{String, DefaultRefType}(a b c)" begin
    pool = CategoricalPool(["a", "b", "c"])

    @test isa(pool, CategoricalPool{String, UInt32})

    @test isa(pool.levels, Vector{String})
    @test pool.levels == ["a", "b", "c"]

    @test isa(pool.invindex, Dict{String, DefaultRefType})
    @test length(pool.invindex) == 3
    @test pool.invindex["a"] === DefaultRefType(1)
    @test pool.invindex["b"] === DefaultRefType(2)
    @test pool.invindex["c"] === DefaultRefType(3)
end

@testset "CategoricalPool{String, UInt8}(a b c)" begin
    pool = CategoricalPool{String, UInt8}(["a", "b", "c"])

    @test isa(pool, CategoricalPool)

    @test isa(pool.levels, Vector{String})
    @test pool.levels == ["a", "b", "c"]

    @test isa(pool.invindex, Dict{String, UInt8})
    @test length(pool.invindex) == 3
    @test pool.invindex["a"] === UInt8(1)
    @test pool.invindex["b"] === UInt8(2)
    @test pool.invindex["c"] === UInt8(3)
end

@testset "CategoricalPool(a b c) with invindex" begin
    pool = CategoricalPool(
        Dict(
            "a" => DefaultRefType(1),
            "b" => DefaultRefType(2),
            "c" => DefaultRefType(3),
        )
    )

    @test isa(pool, CategoricalPool)

    @test isa(pool.levels, Vector{String})
    @test pool.levels == ["a", "b", "c"]

    @test isa(pool.invindex, Dict{String, DefaultRefType})
    @test length(pool.invindex) == 3
    @test pool.invindex["a"] === DefaultRefType(1)
    @test pool.invindex["b"] === DefaultRefType(2)
    @test pool.invindex["c"] === DefaultRefType(3)
end

@testset "CategoricalPool(a b c) with invindex" begin
    pool = CategoricalPool(
        Dict(
            "a" => 1,
            "b" => 2,
            "c" => 3,
        )
    )

    @test isa(pool, CategoricalPool)

    @test isa(pool.levels, Vector{String})
    @test pool.levels == ["a", "b", "c"]

    @test isa(pool.invindex, Dict{String, Int})
    @test length(pool.invindex) == 3
    @test pool.invindex["a"] === 1
    @test pool.invindex["b"] === 2
    @test pool.invindex["c"] === 3
end

@testset "CategoricalPool(c b a)" begin
    pool = CategoricalPool(["c", "b", "a"])

    @test isa(pool, CategoricalPool)

    @test pool.levels == ["c", "b", "a"]

    @test isa(pool.invindex, Dict{String, DefaultRefType})
    @test length(pool.invindex) == 3
    @test pool.invindex["c"] === DefaultRefType(1)
    @test pool.invindex["b"] === DefaultRefType(2)
    @test pool.invindex["a"] === DefaultRefType(3)
end

@testset "CategoricalPool(a b c) with ref codes not matching the natural order" begin
    pool = CategoricalPool(
        Dict(
            "a" => DefaultRefType(3),
            "b" => DefaultRefType(2),
            "c" => DefaultRefType(1),
        )
    )

    @test isa(pool, CategoricalPool)

    @test pool.levels == ["c", "b", "a"]

    @test isa(pool.invindex, Dict{String, DefaultRefType})
    @test length(pool.invindex) == 3
    @test pool.invindex["c"] === DefaultRefType(1)
    @test pool.invindex["b"] === DefaultRefType(2)
    @test pool.invindex["a"] === DefaultRefType(3)
end

@testset "CategoricalPool{Float64, UInt8}()" begin
    pool = CategoricalPool{Float64, UInt8}([1.0, 2.0, 3.0])

    @test isa(pool, CategoricalPool{Float64, UInt8})
    @test CategoricalValue(pool, 1) isa CategoricalValue{Float64, UInt8}
end

@testset "Invalid arguments" begin
    @test_throws ArgumentError CategoricalPool(Dict("a" => 1, "b" => 3))
    @test_throws ArgumentError CategoricalPool(["a", "a"])
end

@testset "Constructor with various vector types" begin
    @test CategoricalPool(2:4) == CategoricalPool(2.0:4.0) ==
        CategoricalPool([2, 3, 4])
    @test CategoricalPool(2:4, true) == CategoricalPool(2.0:4.0, true) ==
        CategoricalPool([2, 3, 4], true)
end

end

module TestIsLess
using Test
using CategoricalArrays

pool = CategoricalPool([1, 2, 3])

v1 = CategoricalValue(pool, 1)
v2 = CategoricalValue(pool, 2)
v3 = CategoricalValue(pool, 3)

@testset "values from unordered CategoricalPool" begin
    @test isordered(v1) === false
    @test isordered(v2) === false
    @test isordered(v3) === false

    @test_throws ArgumentError v1 < v1
    @test_throws ArgumentError v1 < v2
    @test_throws ArgumentError v1 < v3
    @test_throws ArgumentError v2 < v1
    @test_throws ArgumentError v2 < v2
    @test_throws ArgumentError v2 < v3
    @test_throws ArgumentError v3 < v1
    @test_throws ArgumentError v3 < v2
    @test_throws ArgumentError v3 < v3

    @test_throws ArgumentError v1 <= v1
    @test_throws ArgumentError v1 <= v2
    @test_throws ArgumentError v1 <= v3
    @test_throws ArgumentError v2 <= v1
    @test_throws ArgumentError v2 <= v2
    @test_throws ArgumentError v2 <= v3
    @test_throws ArgumentError v3 <= v1
    @test_throws ArgumentError v3 <= v2
    @test_throws ArgumentError v3 <= v3

    @test_throws ArgumentError v1 > v1
    @test_throws ArgumentError v1 > v2
    @test_throws ArgumentError v1 > v3
    @test_throws ArgumentError v2 > v1
    @test_throws ArgumentError v2 > v2
    @test_throws ArgumentError v2 > v3
    @test_throws ArgumentError v3 > v1
    @test_throws ArgumentError v3 > v2
    @test_throws ArgumentError v3 > v3

    @test_throws ArgumentError v1 >= v1
    @test_throws ArgumentError v1 >= v2
    @test_throws ArgumentError v1 >= v3
    @test_throws ArgumentError v2 >= v1
    @test_throws ArgumentError v2 >= v2
    @test_throws ArgumentError v2 >= v3
    @test_throws ArgumentError v3 >= v1
    @test_throws ArgumentError v3 >= v2
    @test_throws ArgumentError v3 >= v3

    @test isless(v1, v1) === false
    @test isless(v1, v2) === true
    @test isless(v1, v3) === true
    @test isless(v2, v1) === false
    @test isless(v2, v2) === false
    @test isless(v2, v3) === true
    @test isless(v3, v1) === false
    @test isless(v3, v2) === false
    @test isless(v3, v3) === false

    @testset "comparison with values of different types" begin
        @test_throws ArgumentError isless(v1, 1)
        @test_throws ArgumentError isless(v1, 2)
        @test_throws ArgumentError isless(v1, 10)
        @test_throws ArgumentError isless(v1, "a")
        @test_throws ArgumentError isless(1, v1)
        @test_throws ArgumentError isless("a", v1)
        @test_throws ArgumentError v1 < 1
        @test_throws ArgumentError v1 < 10
        @test_throws ArgumentError v1 < 2
        @test_throws ArgumentError v1 < "a"
        @test_throws ArgumentError v1 <= 1
        @test_throws ArgumentError v1 <= 2
        @test_throws ArgumentError v1 <= "a"
        @test_throws ArgumentError v1 > 1
        @test_throws ArgumentError v1 > 2
        @test_throws ArgumentError v1 > "a"
        @test_throws ArgumentError v1 >= 1
        @test_throws ArgumentError v1 >= 2
        @test_throws ArgumentError v1 >= "a"
    end

    @testset "comparison with missing" begin
        @test isless(v1, missing)
        @test !isless(missing, v1)
        @test ismissing(v1 < missing)
        @test ismissing(v1 <= missing)
        @test ismissing(v1 > missing)
        @test ismissing(v1 >= missing)
        @test ismissing(missing < v1)
        @test ismissing(missing <= v1)
        @test ismissing(missing > v1)
        @test ismissing(missing >= v1)
    end
end

@testset "values from ordered CategoricalPool" begin
    @test ordered!(pool, true) === pool
    @test isordered(pool) === true
    @test isordered(v1) === true
    @test isordered(v2) === true
    @test isordered(v3) === true

    @test (v1 < v1) === false
    @test (v1 < v2) === true
    @test (v1 < v3) === true
    @test (v2 < v1) === false
    @test (v2 < v2) === false
    @test (v2 < v3) === true
    @test (v3 < v1) === false
    @test (v3 < v2) === false
    @test (v3 < v3) === false

    @test (v1 <= v1) === true
    @test (v1 <= v2) === true
    @test (v1 <= v3) === true
    @test (v2 <= v1) === false
    @test (v2 <= v2) === true
    @test (v2 <= v3) === true
    @test (v3 <= v1) === false
    @test (v3 <= v2) === false
    @test (v3 <= v3) === true

    @test (v1 > v1) === false
    @test (v1 > v2) === false
    @test (v1 > v3) === false
    @test (v2 > v1) === true
    @test (v2 > v2) === false
    @test (v2 > v3) === false
    @test (v3 > v1) === true
    @test (v3 > v2) === true
    @test (v3 > v3) === false

    @test (v1 >= v1) === true
    @test (v1 >= v2) === false
    @test (v1 >= v3) === false
    @test (v2 >= v1) === true
    @test (v2 >= v2) === true
    @test (v2 >= v3) === false
    @test (v3 >= v1) === true
    @test (v3 >= v2) === true
    @test (v3 >= v3) === true

    @test isless(v1, v1) === false
    @test isless(v1, v2) === true
    @test isless(v1, v3) === true
    @test isless(v2, v1) === false
    @test isless(v2, v2) === false
    @test isless(v2, v3) === true
    @test isless(v3, v1) === false
    @test isless(v3, v2) === false
    @test isless(v3, v3) === false

    @testset "comparison with values of different types" begin
        @test_throws ArgumentError isless(v1, 1)
        @test_throws ArgumentError isless(v1, 2)
        @test_throws ArgumentError isless(v1, 10)
        @test_throws ArgumentError isless(v1, "a")
        @test_throws ArgumentError isless(1, v1)
        @test_throws ArgumentError isless("a", v1)
        @test_throws ArgumentError (v1 < 1)
        @test_throws ArgumentError (v1 < 2)
        @test_throws ArgumentError v1 < 10
        @test_throws ArgumentError v1 < "a"
        @test_throws ArgumentError (v1 <= 1)
        @test_throws ArgumentError (v1 <= 2)
        @test_throws ArgumentError v1 <= "a"
        @test_throws ArgumentError (v1 > 1)
        @test_throws ArgumentError (v1 > 2)
        @test_throws ArgumentError v1 > "a"
        @test_throws ArgumentError (v1 >= 1)
        @test_throws ArgumentError (v1 >= 2)
        @test_throws ArgumentError v1 >= "a"
    end

    @testset "comparison with values from different pools" begin
        poolb = copy(pool)
        v1b = CategoricalValue(poolb, 1)
        v2b = CategoricalValue(poolb, 2)
        v3b = CategoricalValue(poolb, 3)

        @test (v1 < v1b) === false
        @test (v1 < v2b) === true
        @test (v1 < v3b) === true
        @test (v2 < v1b) === false
        @test (v2 < v2b) === false
        @test (v2 < v3b) === true
        @test (v3 < v1b) === false
        @test (v3 < v2b) === false
        @test (v3 < v3b) === false

        @test isless(v1, v1b) === false
        @test isless(v1, v2b) === true
        @test isless(v1, v3b) === true
        @test isless(v2, v1b) === false
        @test isless(v2, v2b) === false
        @test isless(v2, v3b) === true
        @test isless(v3, v1b) === false
        @test isless(v3, v2b) === false
        @test isless(v3, v3b) === false

        poolc = copy(poolb)
        @test poolb == poolc # To set subsetof field
        v1c = CategoricalValue(poolc, 1)
        push!(poolc, 4)

        @test_throws ArgumentError v1b < v1c
        @test_throws ArgumentError isless(v1b, v1c)

        poolc = copy(poolb)
        @test poolb == poolc # To set subsetof field
        v1c = CategoricalValue(poolc, 1)
        push!(poolc, 4)

        @test_throws ArgumentError v1b < v1c
        @test_throws ArgumentError isless(v1b, v1c)

        poolc = copy(poolb)
        @test poolb == poolc # To set subsetof field
        v1c = CategoricalValue(poolc, 1)
        levels!(poolc, collect(1:4))

        @test_throws ArgumentError v1b < v1c
        @test_throws ArgumentError isless(v1b, v1c)
    end

    @testset "comparison with missing" begin
        @test isless(v1, missing)
        @test !isless(missing, v1)
        @test ismissing(v1 < missing)
        @test ismissing(v1 <= missing)
        @test ismissing(v1 > missing)
        @test ismissing(v1 >= missing)
        @test ismissing(missing < v1)
        @test ismissing(missing <= v1)
        @test ismissing(missing > v1)
        @test ismissing(missing >= v1)
    end
end

end

using Documenter, CategoricalArrays

# Workaround for JuliaLang/julia/pull/28625
if Base.HOME_PROJECT[] !== nothing
    Base.HOME_PROJECT[] = abspath(Base.HOME_PROJECT[])
end

makedocs(
    modules = [CategoricalArrays],
    sitename = "CategoricalArrays",
    format = Documenter.HTML(canonical = "https://juliadata.github.io/CategoricalArrays.jl/stable/"),
    pages = Any[
        "Overview" => "index.md",
        "Using CategoricalArrays" => "using.md",
        "Implementation details" => "implementation.md",
        "API index" => "apiindex.md"
        ],
    checkdocs = :exports
)

deploydocs(
    repo = "github.com/JuliaData/CategoricalArrays.jl.git"
)

module CategoricalArraysJSONExt

if isdefined(Base, :get_extension)
    using CategoricalArrays
    using JSON
else
    using ..CategoricalArrays
    using ..JSON
end

# JSON of CategoricalValue is JSON of the value it refers to
JSON.lower(x::CategoricalValue) = JSON.lower(unwrap(x))

end

module CategoricalArraysStructTypesExt

if isdefined(Base, :get_extension)
    using CategoricalArrays
    using StructTypes
else
    using ..CategoricalArrays
    using ..StructTypes
end

# define appropriate handlers for JSON3 interface
StructTypes.StructType(x::CategoricalValue) = StructTypes.StructType(unwrap(x))
StructTypes.StructType(::Type{<:CategoricalValue{T}}) where {T} = StructTypes.StructType(T)
StructTypes.numbertype(::Type{<:CategoricalValue{T}}) where {T <: Number} = T
StructTypes.construct(::Type{T}, x::CategoricalValue{T}) where {T} = T(unwrap(x))

# JSON3 writing/reading
StructTypes.StructType(::Type{<:CategoricalVector}) = StructTypes.ArrayType()

StructTypes.construct(::Type{<:CategoricalArray}, A::AbstractVector) =
    constructgeneral(A)
StructTypes.construct(::Type{<:CategoricalArray}, A::Vector) =
    constructgeneral(A)

function constructgeneral(A)
    if eltype(A) === Any
        # unlike `replace`, broadcast narrows the type, which allows us to return small
        # union eltypes (e.g. Union{String,Missing})
        categorical(ifelse.(A .=== nothing, missing, A))
    elseif eltype(A) >: Nothing
        categorical(replace(A, nothing=>missing))
    else
        categorical(A)
    end
end

StructTypes.construct(::Type{<:CategoricalArray{Union{Missing, T}}},
                    A::AbstractVector) where {T} =
    CategoricalArray{Union{Missing, T}}(replace(A, nothing=>missing))
StructTypes.construct(::Type{<:CategoricalArray{Union{Missing, T}}},
                    A::Vector) where {T} =
    CategoricalArray{Union{Missing, T}}(replace(A, nothing=>missing))

end

const catpool_seed = UInt === UInt32 ? 0xe3cf1386 : 0x356f2c715023f1a5

hashlevels(levs::AbstractVector) = foldl((h, x) -> hash(x, h), levs, init=catpool_seed)

CategoricalPool{T, R}(ordered::Bool=false) where {T, R} =
    CategoricalPool{T, R}(T[], ordered)
CategoricalPool{T}(ordered::Bool=false) where {T} =
    CategoricalPool{T, DefaultRefType}(T[], ordered)

CategoricalPool{T, R}(levels::AbstractVector, ordered::Bool=false) where {T, R} =
    CategoricalPool{T, R}(convert(Vector{T}, levels), ordered)
CategoricalPool(levels::AbstractVector{T}, ordered::Bool=false) where {T} =
    CategoricalPool{T, DefaultRefType}(convert(Vector{T}, levels), ordered)

CategoricalPool(invindex::Dict{T, R}, ordered::Bool=false) where {T, R <: Integer} =
    CategoricalPool{T, R}(invindex, ordered)

Base.convert(::Type{T}, pool::T) where {T <: CategoricalPool} = pool

Base.convert(::Type{CategoricalPool{S}}, pool::CategoricalPool{T, R}) where {S, T, R <: Integer} =
    convert(CategoricalPool{S, R}, pool)

function Base.convert(::Type{CategoricalPool{T, R}}, pool::CategoricalPool) where {T, R <: Integer}
    if length(pool.levels) > typemax(R)
        throw(LevelsException{T, R}(pool.levels[typemax(R)+1:end]))
    end

    levelsT = convert(Vector{T}, pool.levels)
    invindexT = convert(Dict{T, R}, pool.invindex)
    return CategoricalPool{T, R}(levelsT, invindexT, pool.ordered)
end

Base.copy(pool::CategoricalPool{T, R}) where {T, R} =
    CategoricalPool{T, R}(copy(pool.levels), copy(pool.invindex),
                          pool.ordered, pool.hash)

function Base.show(io::IO, pool::CategoricalPool{T, R}) where {T, R}
    @static if VERSION >= v"1.6.0"
        @printf(io, "%s{%s, %s}([%s])", CategoricalPool, T, R,
                join(map(repr, pool.levels), ", "))
    else
        @printf(io, "%s{%s,%s}([%s])", CategoricalPool, T, R,
                join(map(repr, pool.levels), ", "))
    end

    pool.ordered && print(io, " with ordered levels")
end

Base.length(pool::CategoricalPool) = length(pool.levels)

Base.getindex(pool::CategoricalPool, i::Integer) = CategoricalValue(pool, i)
Base.get(pool::CategoricalPool, level::Any) = pool.invindex[level]
Base.get(pool::CategoricalPool, level::Any, default::Any) = get(pool.invindex, level, default)

"""
after calling this method, add the returned value to pool.invindex:
it doesn't do this itself to avoid doing a dict lookup twice
"""
@inline function push_level!(pool::CategoricalPool{T, R}, level) where {T, R}
    x = convert(T, level)
    n = length(pool)
    if n >= typemax(R)
        throw(LevelsException{T, R}([level]))
    end

    i = R(n + 1)
    push!(pool.levels, x)
    push!(pool.levelsinds, i)
    pool_hash = pool.hash
    if pool_hash !== nothing
        pool.hash = hash(x, pool_hash)
    end
    pool.equalto = C_NULL
    pool.subsetof = C_NULL
    i
end

"""
    mergelevels(ordered::Bool, levels::AbstractVector...) -> (vec::Vector, ordered′::Bool)

Merge vectors of values `levels` and return:
- `vec`: a superset of all values in `levels`, respecting orders of values
  in each vector of levels if possible
- `ordered′`: if `ordered=true`, whether order comparisons between all pairs
  of levels in `vec` have a defined result based on orders of values in input `levels`
"""
function mergelevels(ordered::Bool, levels::AbstractVector...)
    T = cat_promote_eltype(levels...)
    res = Vector{T}(undef, 0)

    nonempty_lv = findfirst(!isempty, levels)
    if nonempty_lv === nothing
        # no levels
        return res, ordered
    elseif all(l -> isempty(l) || l == levels[nonempty_lv], levels)
        # Fast path if all non-empty levels are equal
        append!(res, levels[nonempty_lv])
        return res, ordered
    end

    union!(res, levels...)

    # Ensure that relative orders of levels are preserved if possible,
    # giving priority to the first sets of levels in case of conflicts
    for levs in reverse(levels)
        levelsmap = indexin(res, levs)

        # Do not touch levels from other sets at the end
        n = length(res)
        @inbounds for i in length(levelsmap):-1:1
            levelsmap[i] === nothing || break
            levelsmap[i] = n
        end
        j = 1
        @inbounds for i in 1:length(levelsmap)
            if levelsmap[i] === nothing
                levelsmap[i] = j
            else
                j = levelsmap[i] + 1
            end
        end
        permute!(res, sortperm(levelsmap, alg=Base.Sort.MergeSort))
    end

    # Check that result is ordered
    if ordered
        levelsmaps = [indexin(res, l) for l in levels]

        # Check that each original order is preserved
        for m in levelsmaps
            issorted(Iterators.filter(x -> x != nothing, m)) || return res, false
        end

        # Check that all order relations between pairs of subsequent elements
        # are defined in at least one set of original levels
        pairs = fill(false, length(res)-1)
        for m in levelsmaps
            @inbounds for i in eachindex(pairs)
                pairs[i] |= (m[i] != nothing) & (m[i+1] != nothing)
            end
            all(pairs) && return res, true
        end
    end

    res, false
end

@inline function Base.get!(pool::CategoricalPool, level::Any)
    get!(pool.invindex, level) do
        ordered!(pool, false)
        push_level!(pool, level)
    end
end

@inline function Base.get!(pool::CategoricalPool, level::CategoricalValue)
    if pool === level.pool || pool == level.pool
        return refcode(level)
    end
    if level.pool ⊈ pool
        newlevs, ordered = merge_pools(pool, level.pool)
        levels!(pool, newlevs)
        ordered!(pool, ordered)
    end
    get!(pool, unwrap(level))
end

@inline function Base.push!(pool::CategoricalPool, level)
    get!(pool.invindex, level) do
        push_level!(pool, level)
    end
    return pool
end

# TODO: optimize for multiple additions
function Base.append!(pool::CategoricalPool, levels)
    for level in levels
        push!(pool, level)
    end
    return pool
end

# Do not override Base.merge as for internal use we need to use the type and orderedness
# of the first pool rather than promoting both pools
function merge_pools(a::CategoricalPool{T}, b::CategoricalPool) where {T}
    if length(a) == 0 && length(b) == 0
        newlevs = T[]
        ordered = isordered(a)
    elseif length(a) == 0
        newlevs = Vector{T}(b.levels)
        ordered = isordered(b)
    elseif length(b) == 0
        newlevs = copy(a.levels)
        ordered = isordered(a)
    else
        ordered = isordered(a) && (isordered(b) || b ⊆ a)
        nl, ordered = mergelevels(ordered, a.levels, b.levels)
        newlevs = convert(Vector{T}, nl)
    end
    newlevs, ordered
end

@inline function Base.hash(pool::CategoricalPool, h::UInt)
    if pool.hash === nothing
        pool.hash = hashlevels(pool.levels)
    end
    hash(pool.hash, h)
end

@inline function Base.:(==)(a::CategoricalPool, b::CategoricalPool)
    pa = pointer_from_objref(a)
    pb = pointer_from_objref(b)
    # Checking both ways is needed to detect changes to a or b
    if a === b || (a.equalto == pb && b.equalto == pa)
        return true
    else
        if hash(a) == hash(b) && isequal(a.levels, b.levels)
            a.equalto = pb
            b.equalto = pa
            return true
        else
            return false
        end
    end
end

# Efficient equivalent of issubset(levels(a), levels(b)), i.e. ignoring order
function Base.issubset(a::CategoricalPool, b::CategoricalPool)
    pa = pointer_from_objref(a)
    pb = pointer_from_objref(b)
    # Checking both ways is needed to detect changes to a or b
    if a === b || (a.equalto == pb && b.equalto == pa) || a.subsetof == pb
        return true
    else
        # Equality check is faster than subset check so do it first
        if hash(a) == hash(b) && isequal(a.levels, b.levels)
            a.equalto = pb
            b.equalto = pa
            return true
        elseif issubset(a.levels, keys(b.invindex))
            a.subsetof = pb
            return true
        else
            return false
        end
    end
end

# Contrary to the CategoricalArray one, this method only allows adding new levels at the end
# so that existing CategoricalValue objects still point to the same value
function levels!(pool::CategoricalPool{S, R}, newlevels::AbstractVector;
                 checkunique::Bool=true) where {S, R}
    levs = newlevels isa CategoricalVector{S} ? newlevels : convert(Vector{S}, newlevels)
    if checkunique && !allunique(levs)
        throw(ArgumentError(string("duplicated levels found in levs: ",
                                   join(unique(filter(x->sum(levs.==x)>1, levs)), ", "))))
    elseif length(levs) < length(pool) || view(levs, 1:length(pool)) != pool.levels
        throw(ArgumentError("removing or reordering levels of existing CategoricalPool is not allowed"))
    end

    n = length(levs)

    if n > typemax(R)
        throw(LevelsException{S, R}(setdiff(levs, pool.levels)[typemax(R)-length(pool.levels)+1:end]))
    end

    empty!(pool.invindex)
    resize!(pool.levels, n)
    resize!(pool.levelsinds, n)
    pool.hash = nothing
    pool.equalto = C_NULL
    pool.subsetof = C_NULL
    for i in 1:n
        v = levs[i]
        pool.levels[i] = v
        pool.levelsinds[i] = i
        pool.invindex[v] = i
    end

    return pool
end

DataAPI.levels(pool::CategoricalPool{T}) where {T} =
    CategoricalVector{T}(pool.levelsinds, pool)
levels_missing(pool::CategoricalPool{T}) where {T} =
    CategoricalVector{Union{T, Missing}}(pool.levelsinds, pool)
_levels(pool::CategoricalPool) = pool.levels

isordered(pool::CategoricalPool) = pool.ordered
ordered!(pool::CategoricalPool, ordered) = (pool.ordered = ordered; pool)


# LevelsException
function Base.showerror(io::IO, err::LevelsException{T, R}) where {T, R}
    levs = join(repr.(err.levels), ", ", " and ")
    print(io, "cannot store level(s) $levs since reference type $R can only hold $(typemax(R)) levels. Use the decompress function to make room for more levels.")
end

import Base: getindex, setindex!, similar, in, collect

@inline function getindex(A::CategoricalArray{T}, I...) where {T>:Missing}
    @boundscheck checkbounds(A, I...)
    # Let Array indexing code handle everything
    @inbounds r = A.refs[I...]

    if isa(r, Array)
        ret = CategoricalArray{T, ndims(r)}(r, copy(A.pool))
        return ordered!(ret, isordered(A))
    else
        if r > 0
            @inbounds return A.pool[r]
        else
            return missing
        end
    end
end

@inline function setindex!(A::CategoricalArray{>:Missing}, v::Missing, I::Real...)
    @boundscheck checkbounds(A, I...)
    @inbounds A.refs[I...] = 0
end

@inline function Base.push!(A::CategoricalVector{>:Missing}, v::Missing)
    push!(A.refs, 0)
    return A
end

@inline function Base.insert!(A::CategoricalVector{>:Missing}, i::Integer, v::Missing)
    i isa Bool && throw(ArgumentError("invalid index: $i of type Bool"))
    if !(1 <= i <= length(A.refs) + 1)
        throw(BoundsError("attempt to insert to a vector with length $(length(A)) at index $i"))
    end
    insert!(A.refs, i, 0)
    return A
end

Base.fill!(A::CategoricalArray{>:Missing}, ::Missing) = (fill!(A.refs, 0); A)

in(x::Missing, y::CategoricalArray) = false
in(x::Missing, y::CategoricalArray{>:Missing}) = !all(v -> v > 0, y.refs)

function Missings.replace(a::CategoricalArray{T, N, R, V, C}, replacement::V) where {T, N, R, V, C}
    pool = copy(a.pool)
    v = C(pool, get!(pool, replacement))
    Missings.replace(a, v)
end

function collect(r::Missings.EachReplaceMissing{<:CategoricalArray{T, N, R, V}}) where {T, N, R, V}
    CategoricalArray{V,N}(R[refcode(v) for v in r], r.replacement.pool)
end

module TestShow
using Test
using Dates
using CategoricalArrays

@testset "show() for CategoricalPool{String} and its values" begin
    pool = CategoricalPool(["c", "b", "a"])
    opool = CategoricalPool(["c", "b", "a"], true)

    nv1 = CategoricalValue(pool, 1)
    nv2 = CategoricalValue(pool, 2)
    nv3 = CategoricalValue(pool, 3)

    ov1 = CategoricalValue(opool, 1)
    ov2 = CategoricalValue(opool, 2)
    ov3 = CategoricalValue(opool, 3)

    @test repr(MIME("text/plain"), pool) == "$CategoricalPool{String, UInt32}([\"c\", \"b\", \"a\"])"
    @test repr(MIME("text/plain"), opool) == "$CategoricalPool{String, UInt32}([\"c\", \"b\", \"a\"], true)"

    @test repr(MIME("text/plain"), nv1) == "$CategoricalValue{String, UInt32} \"c\""
    @test repr(MIME("text/plain"), nv2) == "$CategoricalValue{String, UInt32} \"b\""
    @test repr(MIME("text/plain"), nv3) == "$CategoricalValue{String, UInt32} \"a\""

    @test repr(nv1) == "CategoricalValue($CategoricalPool{String, UInt32}([\"c\", \"b\", \"a\"]), 1)"
    @test repr(nv2) == "CategoricalValue($CategoricalPool{String, UInt32}([\"c\", \"b\", \"a\"]), 2)"
    @test repr(nv3) == "CategoricalValue($CategoricalPool{String, UInt32}([\"c\", \"b\", \"a\"]), 3)"
    @test nv1 == eval(Meta.parse(repr(nv1)))
    @test nv2 == eval(Meta.parse(repr(nv2)))
    @test nv3 == eval(Meta.parse(repr(nv3)))

    @test repr(MIME"text/plain"(), ov1) == "$CategoricalValue{String, UInt32} \"c\" (1/3)"
    @test repr(MIME"text/plain"(), ov2) == "$CategoricalValue{String, UInt32} \"b\" (2/3)"
    @test repr(MIME"text/plain"(), ov3) == "$CategoricalValue{String, UInt32} \"a\" (3/3)"

    @test repr(ov1) == "CategoricalValue($CategoricalPool{String, UInt32}([\"c\", \"b\", \"a\"], true), 1)"
    @test repr(ov2) == "CategoricalValue($CategoricalPool{String, UInt32}([\"c\", \"b\", \"a\"], true), 2)"
    @test repr(ov3) == "CategoricalValue($CategoricalPool{String, UInt32}([\"c\", \"b\", \"a\"], true), 3)"
    @test ov1 == eval(Meta.parse(repr(ov1)))
    @test ov2 == eval(Meta.parse(repr(ov2)))
    @test ov3 == eval(Meta.parse(repr(ov3)))

    @test repr(MIME("text/plain"), nv1, context=:typeinfo=>typeof(nv1)) == "\"c\""
    @test repr(MIME("text/plain"), nv2, context=:typeinfo=>typeof(nv2)) == "\"b\""
    @test repr(MIME("text/plain"), nv3, context=:typeinfo=>typeof(nv3)) == "\"a\""

    @test repr(MIME("text/plain"), ov1, context=:typeinfo=>typeof(ov1)) == "\"c\""
    @test repr(MIME("text/plain"), ov2, context=:typeinfo=>typeof(ov2)) == "\"b\""
    @test repr(MIME("text/plain"), ov3, context=:typeinfo=>typeof(ov3)) == "\"a\""

    @test repr(MIME("text/plain"), nv1, context=:compact=>true) == "\"c\""
    @test repr(MIME("text/plain"), nv2, context=:compact=>true) == "\"b\""
    @test repr(MIME("text/plain"), nv3, context=:compact=>true) == "\"a\""

    @test repr(MIME("text/plain"), ov1, context=:compact=>true) == "\"c\""
    @test repr(MIME("text/plain"), ov2, context=:compact=>true) == "\"b\""
    @test repr(MIME("text/plain"), ov3, context=:compact=>true) == "\"a\""

    @test sprint(print, nv1) == sprint(print, ov1) == "c"
    @test sprint(print, nv2) == sprint(print, ov2) == "b"
    @test sprint(print, nv3) == sprint(print, ov3) == "a"

    @test string(nv1) == string(ov1) == "c"
    @test string(nv2) == string(ov2) == "b"
    @test string(nv3) == string(ov3) == "a"

    @test String(nv1) == String(ov1) == "c"
    @test String(nv2) == String(ov2) == "b"
    @test String(nv3) == String(ov3) == "a"

    b = IOBuffer()
    @test write(b, nv1) == 1
    @test String(take!(b)) == "c"
    @test write(b, nv2) == 1
    @test String(take!(b)) == "b"
    @test write(b, nv3) == 1
    @test String(take!(b)) == "a"
    @test write(b, ov1) == 1
    @test String(take!(b)) == "c"
    @test write(b, ov2) == 1
    @test String(take!(b)) == "b"
    @test write(b, ov3) == 1
    @test String(take!(b)) == "a"
end

using JSON
@testset "JSON.lower" for pool in (CategoricalPool(["a"]),
                                   CategoricalPool([1]),
                                   CategoricalPool([1.0]))
    v = CategoricalValue(pool, 1)
    @test JSON.lower(v) == JSON.lower(unwrap(v))
    @test typeof(JSON.lower(v)) == typeof(JSON.lower(unwrap(v)))
end

using JSON3
using StructTypes
@testset "JSON3.write" begin
    v = CategoricalValue(CategoricalPool(["a"]), 1)
    @test JSON3.write(v) === "\"a\""

    v = CategoricalValue(CategoricalPool([1]), 1)
    @test JSON3.write(v) === "1"
    @test StructTypes.numbertype(typeof(v)) === Int

    v = CategoricalValue(CategoricalPool([2.0]), 1)
    @test JSON3.write(v) === "2.0"
    @test StructTypes.numbertype(typeof(v)) === Float64

    v = CategoricalValue(CategoricalPool([BigFloat(3.0,10)]), 1)
    @test JSON3.write(v) === "3.0"
    @test StructTypes.numbertype(typeof(v)) === BigFloat

    v = CategoricalValue(CategoricalPool([true,false]), 2)
    @test JSON3.write(v) == "false"
    @test StructTypes.numbertype(typeof(v)) === Bool
end

end

module CategoricalArraysArrowExt

using CategoricalArrays
import Arrow
import Arrow: ArrowTypes

const CATARRAY_ARROWNAME = Symbol("JuliaLang.CategoricalArrays.CategoricalArray")
ArrowTypes.arrowname(::Type{<:CategoricalValue}) = CATARRAY_ARROWNAME
ArrowTypes.arrowmetadata(::Type{CategoricalValue{T, R}}) where {T, R} = string(R)
ArrowTypes.ArrowType(::Type{<:CategoricalValue{T}}) where {T} = T
ArrowTypes.toarrow(x::CategoricalValue) = unwrap(x)

ArrowTypes.arrowname(::Type{Union{<:CategoricalValue, Missing}}) = CATARRAY_ARROWNAME
ArrowTypes.arrowmetadata(::Type{Union{CategoricalValue{T, R}, Missing}}) where {T, R} =
    string(R)

const REFTYPES = Dict(string(T) => T for T in (Int128, Int16, Int32, Int64, Int8, UInt128,
                                               UInt16, UInt32, UInt64, UInt8))
function ArrowTypes.JuliaType(::Val{CATARRAY_ARROWNAME},
                              ::Type{S}, meta::String) where S
    R = REFTYPES[meta]
    return CategoricalValue{S, R}
end

for (MV, MT) in ((:V, :T), (:(Union{V,Missing}), :(Union{T,Missing})))
    @eval begin
        function Arrow.DictEncoding{$MV,S,A}(id, data::Arrow.List{U, O, B},
                                             isOrdered, metadata) where
            {T, R, V<:CategoricalValue{T,R}, S, O, A, B, U}
            newdata = Arrow.List{$MT,O,B}(data.arrow, data.validity, data.offsets,
                                          data.data, data.ℓ, data.metadata)
            levels = Missing <: $MT ? collect(skipmissing(newdata)) : newdata
            catdata = CategoricalVector{$MT,R}(newdata, levels=levels)
            return Arrow.DictEncoding{$MV,S,typeof(catdata)}(id, catdata,
                                                             isOrdered, metadata)
        end

        function Arrow.DictEncoding{$MV,S,A}(id, data::Arrow.Primitive{U, B},
                                            isOrdered, metadata) where
            {T, R, V<:CategoricalValue{T,R}, S, A, B, U}
            newdata = Arrow.Primitive{$MT,B}(data.arrow, data.validity, data.data,
                                            data.ℓ, data.metadata)
            levels = Missing <: $MT ? collect(skipmissing(newdata)) : newdata
            catdata = CategoricalVector{$MT,R}(newdata, levels=levels)
            return Arrow.DictEncoding{$MV,S,typeof(catdata)}(id, catdata,
                                                             isOrdered, metadata)
        end
    end
end

function Base.copy(x::Arrow.DictEncoded{V}) where {T, R, V<:CategoricalValue{T, R}}
    pool = CategoricalPool{T,R}(x.encoding.data)
    inds = x.indices
    refs = similar(inds, R)
    refs .= inds .+ one(R)
    return CategoricalVector{T}(refs, pool)
end

function Base.copy(x::Arrow.DictEncoded{Union{Missing,V}}) where
    {T, R, V<:CategoricalValue{T, R}}
    ismissing(x.encoding.data[1]) ||
        throw(ErrorException("`missing` must be the first value in a " *
                             "`CategoricalArray` pool"))
    levels = collect(skipmissing(x.encoding.data))
    pool = CategoricalPool{T,R}(levels)
    inds = x.indices
    refs = similar(inds, R)
    refs .= inds
    return CategoricalVector{Union{T,Missing}}(refs, pool)
end

end

module CategoricalArraysStatsBaseExt

if isdefined(Base, :get_extension)
    import CategoricalArrays: _wquantile
    using StatsBase
else
    import ..CategoricalArrays: _wquantile
    using ..StatsBase
end

_wquantile(x::AbstractArray, w::AbstractWeights, p::AbstractVector) = quantile(x, w, p)

end

module CategoricalArraysRecipesBaseExt

if isdefined(Base, :get_extension)
    using CategoricalArrays
    using RecipesBase
else
    using ..CategoricalArrays
    using ..RecipesBase
end

RecipesBase.@recipe function f(::Type{T}, v::T) where T <: CategoricalValue
    level_strings = [map(string, CategoricalArrays._levels(v)); missing]
    ticks --> eachindex(level_strings)
    v -> ismissing(v) ? length(level_strings) : Int(CategoricalArrays.refcode(v)),
    i -> level_strings[Int(i)]
end

end

module TestCopy
using Test
using CategoricalArrays
using CategoricalArrays: CategoricalPool

@testset "copy" begin
    pool = CategoricalPool(["d", "c", "b"])
    ordered!(pool, true)
    pool2 = copy(pool)

    @test length(pool2) == 3
    @test pool2.levels == ["d", "c", "b"]
    @test pool2.invindex == Dict("d"=>1, "c"=>2, "b"=>3)
    @test pool2.ordered

    levels!(pool2, ["d", "c", "b", "e"])
    ordered!(pool2, false)

    @test length(pool) == 3
    @test pool.levels == ["d", "c", "b"]
    @test pool.invindex == Dict("d"=>1, "c"=>2, "b"=>3)
    @test pool.ordered
end

end

#
# Correctness Tests
#

module TestCategoricalArrays
    fatalerrors = length(ARGS) > 0 && ARGS[1] == "-f"
    quiet = length(ARGS) > 0 && ARGS[1] == "-q"
    anyerrors = false

    using Test
    using CategoricalArrays

    const ≊ = isequal

    tests = [
        "01_value.jl",
        "04_constructors.jl",
        "05_convert.jl",
        "05_copy.jl",
        "06_show.jl",
        "07_levels.jl",
        "08_equality.jl",
        "09_hash.jl",
        "10_isless.jl",
        "11_array.jl",
        "12_missingarray.jl",
        "13_arraycommon.jl",
        "14_view.jl",
        "15_extras.jl",
        "16_recode.jl"
    ]

    @testset "$test" for test in tests
        include(test)
    end
end

module TestRecode
using Test
using CategoricalArrays
using CategoricalArrays: DefaultRefType

if VERSION < v"0.7.0-"
    using CategoricalArrays: replace!
end

const ≅ = isequal

@testset "recode_in" begin
    @testset "collection is a string" begin
        @test !CategoricalArrays.recode_in("a", "ab")
        @test CategoricalArrays.recode_in('a', "ab")
        @test !CategoricalArrays.recode_in('c', "ab")
        @test !CategoricalArrays.recode_in(missing, "b")
    end
    @testset "collection without missing" begin
        @test CategoricalArrays.recode_in(1, [1, 2])
        @test !CategoricalArrays.recode_in(1, [2, 3])
    end
    @testset "collection with missing" begin
        @test CategoricalArrays.recode_in(1, [1, 2, missing])
        @test !CategoricalArrays.recode_in(1, [2, missing])
        @test CategoricalArrays.recode_in(missing, [1, 2, missing])
    end
    @testset "collection is a single value" begin
        @test CategoricalArrays.recode_in(1, 1)
        @test !CategoricalArrays.recode_in(1, missing)
        @test !CategoricalArrays.recode_in(missing, missing)
    end
    @testset "tuple without missing" begin
        @test CategoricalArrays.recode_in(1, (1, 2))
        @test !CategoricalArrays.recode_in(1, (2, 3))
    end
    @testset "tuple with missing" begin
        @test CategoricalArrays.recode_in(1, (1, 2, missing))
        @test !CategoricalArrays.recode_in(1, (2, missing))
        @test CategoricalArrays.recode_in(missing, (1, 2, missing))
    end
    @testset "nested arrays" begin
        @test CategoricalArrays.recode_in([1,2], [[1, 2], [3, 4]])
        @test !CategoricalArrays.recode_in([1, 3], [[1, 2], [3, 4]])
    end
    @testset "NaN in array" begin
        @test CategoricalArrays.recode_in(NaN, [1, 2, NaN])
        @test !CategoricalArrays.recode_in(NaN, [1, 2, 3])
        @test CategoricalArrays.recode_in(2, [1, 2, NaN])
        @test !CategoricalArrays.recode_in(3, [1, 2, NaN])
    end
end

## Test recode!, used by recode

# Test both recoding into x itself and into an uninitialized vector
# (since for CategoricalVectors possible bugs can happen when working in-place)

@testset "Recoding from $(typeof(x)) to $(typeof(y))" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10)),
    y in (similar(x), Array{Int}(undef, size(x)),
          CategoricalArray{Int}(undef, size(x)),
          CategoricalArray{Union{Int, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, 1=>100, 2:4=>0, [5; 9:10]=>-1)
    @test y === z
    @test y == [100, 0, 0, 0, -1, 6, 7, 8, -1, -1]
    if isa(y, CategoricalArray)
        @test levels(y) == [6, 7, 8, 100, 0, -1]
        @test !isordered(y)
    end
end

@testset "Recoding from $(typeof(x)) to $(typeof(y)) using a Set as the first argument in a pair" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10)),
    y in (similar(x), Array{Int}(undef, size(x)),
          CategoricalArray{Int}(undef, size(x)),
          CategoricalArray{Union{Int, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, 1=>100, 2:4=>0, Set([5; 9:10])=>-1)
    @test y === z
    @test y == [100, 0, 0, 0, -1, 6, 7, 8, -1, -1]
    if isa(y, CategoricalArray)
        @test levels(y) == [6, 7, 8, 100, 0, -1]
        @test !isordered(y)
    end
end

@testset "Recoding from $(typeof(x)) to $(typeof(y)) with duplicate recoded values" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10)),
    y in (similar(x), Array{Int}(undef, size(x)),
          CategoricalArray{Int}(undef, size(x)),
          CategoricalArray{Union{Int, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, 1=>100, 2:4=>100, [5; 9:10]=>-1)
    @test y === z
    @test y == [100, 100, 100, 100, -1, 6, 7, 8, -1, -1]
    if isa(y, CategoricalArray)
        @test levels(y) == [6, 7, 8, 100, -1]
        @test !isordered(y)
    end
end

@testset "Recoding from $(typeof(x)) to $(typeof(y)) with unused level" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10)),
    y in (similar(x), Array{Int}(undef, size(x)),
          CategoricalArray{Int}(undef, size(x)),
          CategoricalArray{Union{Int, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, 1=>100, 2:4=>0, [5; 9:10]=>-1, 100=>1)
    @test y === z
    @test y == [100, 0, 0, 0, -1, 6, 7, 8, -1, -1]
    if isa(y, CategoricalArray)
        @test levels(y) == [6, 7, 8, 100, 0, -1, 1]
        @test !isordered(y)
    end
end

@testset "Recoding from $(typeof(x)) to $(typeof(y)) with duplicate default" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10)),
    y in (similar(x), Array{Int}(undef, size(x)),
          CategoricalArray{Int}(undef, size(x)),
          CategoricalArray{Union{Int, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, 100, 1=>100, 2:4=>100, [5; 9:10]=>-1)
    @test y === z
    @test y == [100, 100, 100, 100, -1, 100, 100, 100, -1, -1]
    if isa(y, CategoricalArray)
        @test levels(y) == [100, -1]
        @test !isordered(y)
    end
end

@testset "Recoding from $(typeof(x)) to $(typeof(y)) with default" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10)),
    y in (similar(x), Array{Int}(undef, size(x)),
          CategoricalArray{Int}(undef, size(x)),
          CategoricalArray{Union{Int, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, -10, 1=>100, 2:4=>0, [5; 9:10]=>-1)
    @test y === z
    @test y == [100, 0, 0, 0, -1, -10, -10, -10, -1, -1]
    if isa(y, CategoricalArray)
        @test levels(y) == [100, 0, -1, -10]
        @test !isordered(y)
    end
end

@testset "Recoding from $(typeof(x)) to $(typeof(y)) with first value being Float64" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10)),
    y in (similar(x), Array{Int}(undef, size(x)),
          CategoricalArray{Int}(undef, size(x)),
          CategoricalArray{Union{Int, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, 1.0=>100, 2:4=>0, [5; 9:10]=>-1)
    @test y == [100, 0, 0, 0, -1, 6, 7, 8, -1, -1]
    if isa(y, CategoricalArray)
        @test levels(y) == [6, 7, 8, 100, 0, -1]
        @test !isordered(y)
    end
end

@testset "Recoding from $(typeof(x)) to $(typeof(y)) with overlapping pairs" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10)),
    y in (similar(x), Array{Int}(undef, size(x)),
          CategoricalArray{Int}(undef, size(x)),
          CategoricalArray{Union{Int, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, 1=>100, 2:4=>0, [5; 9:10]=>-1, 1:10=>0)
    @test y === z
    @test y == [100, 0, 0, 0, -1, 0, 0, 0, -1, -1]
    if isa(y, CategoricalArray)
        @test levels(y) == [100, 0, -1]
        @test !isordered(y)
    end
end

@testset "Recoding from $(typeof(x)) to $(typeof(y)) with changes to levels order" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10)),
    y in (similar(x), Array{Int}(undef, size(x)),
          CategoricalArray{Int}(undef, size(x)),
          CategoricalArray{Union{Int, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, 1=>100, 2:4=>0, [5; 9:10]=>-1)
    @test y === z
    @test y == [100, 0, 0, 0, -1, 6, 7, 8, -1, -1]
    if isa(y, CategoricalArray)
        @test levels(y) == [6, 7, 8, 100, 0, -1]
        @test !isordered(y)
    end
end

@testset "Recoding from $(typeof(x)) to categorical array with missing values" for
    x in (["a", missing, "c", "d"], CategoricalArray(["a", missing, "c", "d"]))

    # check that error is thrown
    y = Vector{String}(undef, 4)
    @test_throws MissingException recode!(y, x, "a", "c"=>"b")

    y = CategoricalVector{String}(undef, 4)
    @test_throws MissingException recode!(y, x, "a", "c"=>"b")
end

@testset "Recoding array with missings and default from $(typeof(x)) to $(typeof(y))" for
    x in (["a", missing, "c", "d"], CategoricalArray(["a", missing, "c", "d"])),
    y in (similar(x), Array{Union{String, Missing}}(undef, size(x)),
          CategoricalArray{Union{String, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, "a", "c"=>"b")
    @test y === z
    @test y ≅ ["a", missing, "b", "a"]
    if isa(y, CategoricalArray)
        @test levels(y) == ["b", "a"]
        @test !isordered(y)
    end
end

@testset "Recoding array with missings and no default from $(typeof(x)) to $(typeof(y))" for
    x in (["a", missing, "c", "d"], CategoricalArray(["a", missing, "c", "d"])),
    y in (similar(x), Array{Union{String, Missing}}(undef, size(x)),
          CategoricalArray{Union{String, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, "c"=>"b")
    @test y === z
    @test y ≅ ["a", missing, "b", "d"]
    if isa(y, CategoricalArray)
        @test levels(y) == ["a", "d", "b"]
        @test !isordered(y)
    end
end

@testset "Collection in LHS recoding array with missings and no default from $(typeof(x)) to $(typeof(y))" for
    x in (["1", missing, "3", "4", "5"], CategoricalArray(["1", missing, "3", "4", "5"])),
    y in (similar(x), Array{Union{String, Missing}}(undef, size(x)),
          CategoricalArray{Union{String, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, ["3","4"]=>"2")
    @test y === z
    @test y ≅ ["1", missing, "2", "2", "5"]
    if isa(y, CategoricalArray)
        @test levels(y) == ["1", "5", "2"]
        @test !isordered(y)
    end
end

@testset "Recoding array with missings, default and with missing as a key pair from $(typeof(x)) to $(typeof(y))" for
    x in (["a", missing, "c", "d"], CategoricalArray(["a", missing, "c", "d"])),
    y in (similar(x), Array{Union{String, Missing}}(undef, size(x)),
          CategoricalArray{Union{String, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, "a", "c"=>"b", missing=>"d")
    @test y === z
    @test y == ["a", "d", "b", "a"]
    if isa(y, CategoricalArray)
        @test levels(y) == ["b", "d", "a"]
        @test !isordered(y)
    end
end

@testset "Collection with missing in LHS recoding array with missings, default from $(typeof(x)) to $(typeof(y))" for
    x in (["a", missing, "c", "d"], CategoricalArray(["a", missing, "c", "d"])),
    y in (similar(x), Array{Union{String, Missing}}(undef, size(x)),
          CategoricalArray{Union{String, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, "a", [missing, "c"]=>"b")
    @test y === z
    @test y == ["a", "b", "b", "a"]
    if isa(y, CategoricalArray)
        @test levels(y) == ["b", "a"]
        @test !isordered(y)
    end
end

@testset "Recoding array with missings, no default and with missing as a key pair from $(typeof(x)) to $(typeof(y))" for
    x in (["a", missing, "c", "d"], CategoricalArray(["a", missing, "c", "d"])),
    y in (similar(x), Array{Union{String, Missing}}(undef, size(x)),
          CategoricalArray{Union{String, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, "c"=>"b", missing=>"d")
    @test y === z
    @test y == ["a", "d", "b", "d"]
    if isa(y, CategoricalArray)
        @test levels(y) == ["a", "b", "d"]
        @test !isordered(y)
    end
end

@testset "Collection with missing in LHS recoding array with missings, no default from $(typeof(x)) to $(typeof(y))" for
    x in (["a", missing, "c", "d"], CategoricalArray(["a", missing, "c", "d"])),
    y in (similar(x), Array{Union{String, Missing}}(undef, size(x)),
          CategoricalArray{Union{String, Missing}}(undef, size(x)), x)

    z = @inferred recode!(y, x, ["c", missing]=>"b")
    @test y === z
    @test y == ["a", "b", "b", "d"]
    if isa(y, CategoricalArray)
        @test levels(y) == ["a", "d", "b"]
        @test !isordered(y)
    end
end

@testset "Recoding into an array of incompatible size from $(typeof(x)) to $(typeof(y))" for
    x in (["a", missing, "c", "d"], CategoricalArray(["a", missing, "c", "d"])),
    y in (similar(x, 0), Array{Union{String, Missing}}(undef, 0),
          CategoricalArray{Union{String, Missing}}(undef, 0))

    @test_throws DimensionMismatch recode!(y, x, "c"=>"b", missing=>"d")
end

@testset "Recoding into an array with incompatible eltype from $(typeof(x)) to $(typeof(y))" for
    x in ([1:10;], CategoricalArray(1:10)),
    y in (similar(x, String), Array{String}(undef, size(x)),
          CategoricalArray{String}(undef, size(x)))

    @test_throws ArgumentError recode!(y, x, 1=>"a", 2:4=>"b", [5; 9:10]=>"c")
end

@testset "Recoding into an array with incompatible eltype from $(typeof(x)) to $(typeof(y))" for
    x in ((Union{Int, Missing})[1:10;], CategoricalArray{Union{Int, Missing}}(1:10)),
    y in (similar(x), Array{Union{Int, Missing}}(undef, size(x)),
          CategoricalArray{Union{Int, Missing}}(undef, size(x)))

    @test_throws MethodError recode!(y, x, 1=>"a", 2:4=>"b", [5; 9:10]=>"c")
end

## Test in-place recode!()

@testset "Recoding from $(typeof(x)) to $(typeof(x)) without default" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10))

    z = @inferred recode!(x, 1=>100, 2:4=>0, [5; 9:10]=>-1)
    @test x === z
    @test x == [100, 0, 0, 0, -1, 6, 7, 8, -1, -1]
    if isa(x, CategoricalArray)
        @test levels(x) == [6, 7, 8, 100, 0, -1]
        @test !isordered(x)
    end
end

@testset "Recoding from $(typeof(x)) to $(typeof(x)) without default" for
    x in ([1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10))

    z = @inferred recode!(x, 1, 1=>100, 2:4=>0, [5; 9:10]=>-1)
    @test x === z
    @test x == [100, 0, 0, 0, -1, 1, 1, 1, -1, -1]
    if isa(x, CategoricalArray)
        @test levels(x) == [100, 0, -1, 1]
        @test !isordered(x)
    end
end

@testset "recode() promotion for $(typeof(x))" for
    x in (1:10, [1:10;], CategoricalArray(1:10), CategoricalArray{Union{Int, Missing}}(1:10))
    T = eltype(x) >: Missing ? Missing : Union{}

    # Recoding from Int to Float64 due to a second value being Float64
    y = @inferred recode(x, 1=>100.0, 2:4=>0, [5; 9:10]=>-1)
    @test y == [100, 0, 0, 0, -1, 6, 7, 8, -1, -1]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{Union{Float64, T}, DefaultRefType})
        @test levels(y) == [6, 7, 8, 100, 0, -1]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{Union{Float64, T}}
    end

    # Recoding from Int to Float64, with Float64 default and all other values Int
    y = @inferred recode(x, -10.0, 1=>100, 2:4=>0, [5; 9:10]=>-1)
    @test y == [100, 0, 0, 0, -1, -10, -10, -10, -1, -1]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{Union{Float64, T}, DefaultRefType})
        @test levels(y) == [100, 0, -1, -10]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{Union{Float64, T}}
    end

    # Recoding from Int to Union{Int, String}
    y = @inferred recode(x, 1=>"a", 2:4=>0, [5; 9:10]=>-1)
    @test y == ["a", 0, 0, 0, -1, 6, 7, 8, -1, -1]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{Union{Int, String, T}, DefaultRefType})
        @test levels(y) == [6, 7, 8, "a", 0, -1]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{Union{Int, String, T}}
    end

    # Recoding from Int to String, with String default
    y = @inferred recode(x, "d", 1=>"a", 2:4=>"b", [5; 9:10]=>"c")
    @test y == ["a", "b", "b", "b", "c", "d", "d", "d", "c", "c"]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{Union{String, T}, DefaultRefType})
        @test levels(y) == ["a", "b", "c", "d"]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{Union{String, T}}
    end

    # Recoding from Int to String, with all original levels recoded
    y = @inferred recode(x, 1:4=>"a", [5; 9:10]=>"b", 6:8=>"c")
    @test y == ["a", "a", "a", "a", "b", "c", "c", "c", "b", "b"]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{Union{String, T}, DefaultRefType})
        @test levels(y) == ["a", "b", "c"]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{Union{String, T}}
    end

    # Recoding from Int to Union{Int, String}, with default String and other values Int
    y = @inferred recode(x, "x", 1=>100, 2:4=>0, [5; 9:10]=>-1)
    @test y == [100, 0, 0, 0, -1, "x", "x", "x", -1, -1]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{Union{Int, String, T}, DefaultRefType})
        @test levels(y) == [100, 0, -1, "x"]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{Union{Int, String, T}}
    end

    # Recoding from Int to Int/String, without any Int value in pairs
    # and keeping some original Int levels
    # This must fail since we cannot take into account original eltype (whether original
    # levels are kept is only known at run time)
    res = @test_throws ArgumentError recode(x, 1=>"a", 2:4=>"b", [5; 9:10]=>"c")
    @test sprint(showerror, res.value) ==
        "ArgumentError: cannot `convert` value 6 (of type $Int) to type of recoded levels ($(Union{String, T})). " *
        "This will happen with recode() when not all original levels are recoded " *
        "(i.e. some are preserved) and their type is incompatible with that of recoded levels."

    # Recoding from Int to Union{Int, Missing} with missing default
    y = @inferred recode(x, missing, 1=>100, 2:4=>0, [5; 9:10]=>-1)
    @test y ≅ [100, 0, 0, 0, -1, missing, missing, missing, -1, -1]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{Union{Int, Missing}, DefaultRefType})
        @test levels(y) == [100, 0, -1]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{Union{Int, Missing}}
    end

    # Recoding from Int to Union{Int, Missing} with missing RHS
    y = @inferred recode(x, 1=>missing, 2:4=>0, [5; 9:10]=>-1)
    @test y ≅ [missing, 0, 0, 0, -1, 6, 7, 8, -1, -1]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{Union{Int, Missing}, DefaultRefType})
        @test levels(y) == [6, 7, 8, 0, -1]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{Union{Int, Missing}}
    end

    # Recoding from Int to Union{Int, Missing} with single missing RHS
    y = @inferred recode(x, 1=>missing)
    @test y ≅ [missing, 2, 3, 4, 5, 6, 7, 8, 9, 10]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{Union{Int, Missing}, DefaultRefType})
        @test levels(y) == collect(2:10)
        @test !isordered(y)
    else
        @test typeof(y) === Vector{Union{Int, Missing}}
    end
end

@testset "Recoding from $(typeof(x)) to $(typeof(x))" for
    x in (["a", "c", "b", "a"], CategoricalArray(["a", "c", "b", "a"]))

    y = @inferred recode(x, "c"=>"x", "b"=>"y", "a"=>"z")
    @test y == ["z", "x", "y", "z"]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{String, DefaultRefType})
        @test levels(y) == ["x", "y", "z"]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{String}
    end
end

@testset "Recoding a matrix $(typeof(x))" for
    x in (['a' 'c'; 'b' 'a'], CategoricalArray(['a' 'c'; 'b' 'a']))

    y = @inferred recode(x, 'c'=>'x', 'b'=>'y', 'a'=>'z')
    @test y == ['z' 'x'; 'y' 'z']
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalMatrix{Char, DefaultRefType})
        @test levels(y) == ['x', 'y', 'z']
        @test !isordered(y)
    else
        @test typeof(y) === Matrix{Char}
    end
end

@testset "Recoding from $(typeof(x)) to Union{Int, String}, with levels in custom order" for
    x in (10:-1:1, CategoricalArray(10:-1:1))

    y = @inferred recode(x, 0, 1=>"a", 2:4=>"c", [5; 9:10]=>"b")
    @test y == ["b", "b", 0, 0, 0, "b", "c", "c", "c", "a"]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{Union{Int, String}, DefaultRefType})
        @test levels(y) == ["a", "c", "b", 0]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{Union{Int, String}}
    end

    # Recoding from Int to String via default, with levels in custom order
    y = @inferred recode(x, "x", 1=>"a", 2:4=>"c", [5; 9:10]=>"b")
    @test y == ["b", "b", "x", "x", "x", "b", "c", "c", "c", "a"]
    if isa(x, CategoricalArray)
        @test isa(y, CategoricalVector{String, DefaultRefType})
        @test levels(y) == ["a", "c", "b", "x"]
        @test !isordered(y)
    else
        @test typeof(y) === Vector{String}
    end
end

@testset "Recoding CategoricalArray with custom reftype" begin
    x = CategoricalVector{Int, UInt8}(1:10)
    y = @inferred recode(x, 1=>100, 2:4=>0, [5; 9:10]=>-1)
    @test y == [100, 0, 0, 0, -1, 6, 7, 8, -1, -1]
    @test isa(y, CategoricalVector{Int, UInt8})
    @test levels(y) == [6, 7, 8, 100, 0, -1]
    @test !isordered(y)
end

@testset "Recoding ordered CategoricalArray and merging two categories" begin
    x = CategoricalArray(["a", "c", "b", "a"])
    ordered!(x, true)
    y = @inferred recode(x, "c"=>"a")
    @test y == ["a", "a", "b", "a"]
    @test isa(y, CategoricalVector{String, DefaultRefType})
    @test levels(y) == ["a", "b"]
    @test isordered(y)
end

@testset "Recoding ordered CategoricalArray and merging one category into another (contd.)" begin
    x = CategoricalArray(["a", "c", "b", "a"])
    ordered!(x, true)
    y = @inferred recode(x, "b"=>"c")
    @test y == ["a", "c", "c", "a"]
    @test isa(y, CategoricalVector{String, DefaultRefType})
    @test levels(y) == ["a", "c"]
    @test isordered(y)
end

@testset "Recoding ordered CategoricalArray with new level which cannot be ordered" begin
    x = CategoricalArray(["a", "c", "b", "a"])
    ordered!(x, true)
    y = @inferred recode(x, "b"=>"d")
    @test y == ["a", "c", "d", "a"]
    @test isa(y, CategoricalVector{String, DefaultRefType})
    @test levels(y) == ["a", "c", "d"]
    @test !isordered(y)
end

@testset "Recoding ordered CategoricalArray with conflicting orders" begin
    x = CategoricalArray(["a", "c", "b", "a"])
    ordered!(x, true)
    y = @inferred recode(x, "b"=>"b", "a"=>"a")
    @test y == ["a", "c", "b", "a"]
    @test isa(y, CategoricalVector{String, DefaultRefType})
    @test levels(y) == ["c", "b", "a"]
    @test !isordered(y)
end

@testset "Recoding ordered CategoricalArray with default already in levels" begin
    x = CategoricalArray(["a", "c", "b", "a"])
    ordered!(x, true)
    y = @inferred recode(x, "a", "c"=>"b")
    @test y == ["a", "b", "a", "a"]
    @test isa(y, CategoricalVector{String, DefaultRefType})
    @test levels(y) == ["b", "a"]
    @test !isordered(y)
end

@testset "Recoding ordered CategoricalArray with default not in levels" begin
    x = CategoricalArray(["d", "c", "b", "d"])
    ordered!(x, true)
    y = @inferred recode(x, "a", "c"=>"b")
    @test y == ["a", "b", "a", "a"]
    @test isa(y, CategoricalVector{String, DefaultRefType})
    @test levels(y) == ["b", "a"]
    @test !isordered(y)
end

@testset "Recoding CategoricalArray with missings and no default" begin
    x = CategoricalArray{Union{String, Missing}}(["a", "b", "c", "d"])
    x[2] = missing
    y = @inferred recode(x, "c"=>"b")
    @test y ≅ ["a", missing, "b", "d"]
    @test isa(y, CategoricalVector{Union{String, Missing}, DefaultRefType})
    @test levels(y) == ["a", "b", "d"]
    @test !isordered(y)
end

@testset "Recoding CategoricalArray with missings and non-missing default" begin
    x = CategoricalArray{Union{String, Missing}}(["a", "b", "c", "d"])
    x[2] = missing
    y = @inferred recode(x, "a", "c"=>"b")
    @test y ≅ ["a", missing, "b", "a"]
    @test isa(y, CategoricalVector{Union{String, Missing}, DefaultRefType})
    @test levels(y) == ["b", "a"]
    @test !isordered(y)
end

@testset "replace with CategoricalArray" begin
    function testf(replacef, T, x::CategoricalArray{S,R}, pairs::Pair...) where {S, R}
        ca = replacef(x, pairs...)
        @test ca isa CategoricalArray{T, R}

        if VERSION >= v"0.7.0-"
            a = replacef(Array(x), pairs...)
            @test ca ≅ a
        end

        ca
    end

    @testset "strings with missings" begin
        x = categorical(["a", "b", missing, "a"])

        testf(replace, String, x, missing => "")
        testf(replace, Union{String, Missing}, x, "b" => "c")
        testf(replace, Union{Int, String, Missing}, x, "a" => 1, "b" => 2)
        testf(replace, Union{Int, String}, x, "a" => 1, "b" => 2, missing => 3)
        y = testf(replace!, Union{String, Missing}, x, "b" => "c")
        @test y === x

        y = testf(replace!, Union{String, Missing}, x, missing => "")
        @test y === x
    end

    @testset "strings without missings" begin
        x = categorical(["a", "b", "", "a"])
        testf(replace, Union{String, Missing}, x, "" => missing)
        @test_throws MethodError replace!(x, "" => missing)

        x = categorical(Union{String, Missing}["a", "b", "", "a"])
        testf(replace!, Union{String, Missing}, x, "" => missing)
    end

    @testset "int to float" begin
        x = categorical([0, 2, 0])

        @testset "replace" begin
            testf(replace, Float64, x, 2 => 1.5, 0 => 0.5)
            testf(replace, Float64, x, 2 => 1.0)
        end

        @testset "replace!" begin
            @test_throws InexactError replace!(x, 2 => 1.5)

            y = testf(replace!, Int, x, 2 => 1.0)
            @test y === x
        end
    end

    @testset "float to int" begin
        x = categorical([0.5, 2.0, 0.5])

        @testset "replace" begin
            testf(replace, Float64, x, 2 => 1)
            testf(replace, Float64, x, 0.5 => 3)
        end

        @testset "replace!" begin
            y = testf(replace!, Float64, x, 2 => 1)
            @test x === y

            y = testf(replace!, Float64, x, 0.5 => 3)
            @test x === x
        end
    end
end

# TODO: move struct definition inside @testset block after 1.6 becomes LTS
struct UnorderedFoo0 <: Number
    a::String
end

@testset "recode AbstractVector with unordered eltype" begin
    x0 = [UnorderedFoo0("s$i") for i in 1:10]
    x = CategoricalArray{UnorderedFoo0}(undef, size(x0))
    recode!(x, x0, UnorderedFoo0("s3") => UnorderedFoo0("xxx"))

    @test x[3] == UnorderedFoo0("xxx")
    @test x[(1:end) .!= 3] == x0[(1:end) .!= 3]
    @test levels(x)[1:(end-1)] == x0[(1:end) .!= 3]

    x = CategoricalArray{UnorderedFoo0}(undef, size(x0))
    Base.isless(::UnorderedFoo0, ::UnorderedFoo0) = throw(ArgumentError("Blah"))
    @test_throws ArgumentError sort(x0)
    @test_throws ArgumentError recode!(x, x0, UnorderedFoo0("s4") => UnorderedFoo0("xxxx"))
end

end

module TestEquality
using Test
using CategoricalArrays

@testset "isequal and hash for CategoricalPool" begin
    pool1 = CategoricalPool(["a", "b", "c"])
    pool1b = CategoricalPool(["a", "b", "c"])
    pool2 = CategoricalPool(["c", "a", "b"])
    pool3 = CategoricalPool(["a", "b", "c", "d"])
    pool4 = CategoricalPool(String[])

    @test isequal(pool1, pool1)
    @test pool1 == pool1
    @test pool1.equalto == C_NULL

    @test isequal(pool1, pool1b)
    @test pool1 == pool1b
    @test pool1.equalto == pointer_from_objref(pool1b)
    @test pool1b.equalto == pointer_from_objref(pool1)

    @test !isequal(pool1, pool2)
    @test pool1 != pool2
    @test pool1.equalto == pointer_from_objref(pool1b)
    @test pool2.equalto == C_NULL

    @test !isequal(pool1, pool3)
    @test pool1 != pool3
    @test pool1.equalto == pointer_from_objref(pool1b)
    @test pool3.equalto == C_NULL

    @test !isequal(pool1, pool4)
    @test pool1 != pool4
    @test pool1.equalto == pointer_from_objref(pool1b)
    @test pool4.equalto == C_NULL

    pool1c = copy(pool1b)
    @test pool1b == pool1c # To set equalto field
    @test isequal(pool1, pool1c)
    push!(pool1c, "d")
    @test pool1b.equalto == pointer_from_objref(pool1c)
    @test pool1c.equalto == C_NULL
    @test pool1b != pool1c
    @test !isequal(pool1b, pool1c)
    @test pool1b.equalto == pointer_from_objref(pool1c)
    @test pool1c.equalto == C_NULL

    pool1c = copy(pool1b)
    @test pool1b == pool1c # To set equalto field
    @test isequal(pool1, pool1c)
    get!(pool1c, "d")
    @test pool1b.equalto == pointer_from_objref(pool1c)
    @test pool1c.equalto == C_NULL
    @test pool1b != pool1c
    @test !isequal(pool1b, pool1c)
    @test pool1b.equalto == pointer_from_objref(pool1c)
    @test pool1c.equalto == C_NULL

    pool1c = copy(pool1b)
    @test pool1b == pool1c # To set equalto field
    @test isequal(pool1, pool1c)
    levels!(pool1c, ["a", "b", "c", "d"])
    @test pool1b.equalto == pointer_from_objref(pool1c)
    @test pool1c.equalto == C_NULL
    @test pool1b != pool1c
    @test !isequal(pool1, pool1c)
    @test pool1b.equalto == pointer_from_objref(pool1c)
    @test pool1c.equalto == C_NULL

    @test hash(pool1) == hash(pool1b)
    @test hash(pool1) != hash(pool2) != hash(pool3) != hash(pool4)
    @test hash(pool1, UInt(1234)) == hash(pool1b, UInt(1234)) != hash(pool1)
    @test hash(pool1, UInt(1234)) != hash(pool2, UInt(1234))
    push!(pool1, "d")
    @test hash(pool1) == hash(CategoricalArrays.hashlevels(levels(pool1)))
    get!(pool1, "e")
    @test hash(pool1) == hash(CategoricalArrays.hashlevels(levels(pool1)))

    poolnan1 = CategoricalPool([1.0, NaN])
    poolnan2 = CategoricalPool([1.0, NaN])
    @test poolnan1 == poolnan2
    @test isequal(poolnan1, poolnan2)

    poolzero1 = CategoricalPool([1.0, -0.0])
    poolzero2 = CategoricalPool([1.0, 0.0])
    @test poolzero1 != poolzero2
    @test !isequal(poolzero1, poolzero2)
end

@testset "== and isequal() for CategoricalPool{Int} and CategoricalPool{Float64}" begin
    pool1 = CategoricalPool([1, 2, 3])
    pool2 = CategoricalPool([2.0, 1.0, 3.0])

    opool1 = CategoricalPool([1, 2, 3], true)
    opool2 = CategoricalPool([2.0, 1.0, 3.0], true)

    @test isequal(pool1, pool1) === true
    @test isequal(pool1, pool2) === false
    @test isequal(pool2, pool2) === true

    @test (pool1 == pool1) === true
    @test (pool1 == pool2) === false
    @test (pool2 == pool2) === true

    @test isequal(opool1, opool1) === true
    @test isequal(opool1, opool2) === false
    @test isequal(opool2, opool2) === true

    @test (opool1 == opool1) === true
    @test (opool1 == opool2) === false
    @test (opool2 == opool2) === true

    @test (pool1 == opool1) === true
    @test (pool2 == opool2) === true
    @test (pool1 == opool2) === false

    nv1a = CategoricalValue(pool1, 1)
    nv2a = CategoricalValue(pool2, 1)
    nv1b = CategoricalValue(pool1, 2)
    nv2b = CategoricalValue(pool2, 2)

    @test isequal(nv1a, nv1a) == true
    @test isequal(nv1a, nv2a) == false
    @test isequal(nv1a, nv1b) == false
    @test isequal(nv1a, nv2b) == true

    @test isequal(nv1b, nv1a) == false
    @test isequal(nv1b, nv2a) == true
    @test isequal(nv1b, nv1b) == true
    @test isequal(nv1b, nv2b) == false

    @test isequal(nv2a, nv1a) == false
    @test isequal(nv2a, nv2a) == true
    @test isequal(nv2a, nv1b) == true
    @test isequal(nv2a, nv2b) == false

    @test isequal(nv2b, nv1a) == true
    @test isequal(nv2b, nv2a) == false
    @test isequal(nv2b, nv1b) == false
    @test isequal(nv2b, nv2b) == true

    @test isequal(1, nv1a) == true
    @test isequal(1, nv2a) == false
    @test isequal(1, nv1b) == false
    @test isequal(1, nv2b) == true

    @test isequal(nv1a, 2) == false
    @test isequal(nv2a, 2) == true
    @test isequal(nv1b, 2) == true
    @test isequal(nv2b, 2) == false

    ov1a = CategoricalValue(opool1, 1)
    ov2a = CategoricalValue(opool2, 1)
    ov1b = CategoricalValue(opool1, 2)
    ov2b = CategoricalValue(opool2, 2)

    @test isequal(ov1a, ov1a) == true
    @test isequal(ov1a, ov2a) == false
    @test isequal(ov1a, ov1b) == false
    @test isequal(ov1a, ov2b) == true

    @test isequal(ov1b, ov1a) == false
    @test isequal(ov1b, ov2a) == true
    @test isequal(ov1b, ov1b) == true
    @test isequal(ov1b, ov2b) == false

    @test isequal(ov2a, ov1a) == false
    @test isequal(ov2a, ov2a) == true
    @test isequal(ov2a, ov1b) == true
    @test isequal(ov2a, ov2b) == false

    @test isequal(ov2b, ov1a) == true
    @test isequal(ov2b, ov2a) == false
    @test isequal(ov2b, ov1b) == false
    @test isequal(ov2b, ov2b) == true

    @test isequal(1, ov1a) == true
    @test isequal(1, ov2a) == false
    @test isequal(1, ov1b) == false
    @test isequal(1, ov2b) == true

    @test isequal(ov1a, 2) == false
    @test isequal(ov2a, 2) == true
    @test isequal(ov1b, 2) == true
    @test isequal(ov2b, 2) == false

    @test (ov1a == ov1a) == true
    @test (ov1a == ov2a) == false
    @test (ov1a == ov1b) == false
    @test (ov1a == ov2b) == true

    @test (ov1b == ov1a) == false
    @test (ov1b == ov2a) == true
    @test (ov1b == ov1b) == true
    @test (ov1b == ov2b) == false

    @test (ov2a == ov1a) == false
    @test (ov2a == ov2a) == true
    @test (ov2a == ov1b) == true
    @test (ov2a == ov2b) == false

    @test (ov2b == ov1a) == true
    @test (ov2b == ov2a) == false
    @test (ov2b == ov1b) == false
    @test (ov2b == ov2b) == true

    @testset "ordered and non-ordered values are equal" begin
    @test (ov1a == nv1a) === true
    @test (ov1a == nv2a) === false
    @test (ov1a == nv1b) === false
    @test (ov1a == nv2b) === true

    @test (ov1b == nv1a) === false
    @test (ov1b == nv2a) === true
    @test (ov1b == nv1b) === true
    @test (ov1b == nv2b) === false

    @test (ov2a == nv1a) === false
    @test (ov2a == nv2a) === true
    @test (ov2a == nv1b) === true
    @test (ov2a == nv2b) === false

    @test (ov2b == nv1a) === true
    @test (ov2b == nv2a) === false
    @test (ov2b == nv1b) === false
    @test (ov2b == nv2b) === true
    end

    @testset "non-equality with missing" begin
    @test ismissing(nv1a == missing)
    @test ismissing(ov1a == missing)
    @test ismissing(missing == nv1a)
    @test ismissing(missing == ov1a)

    @test isequal(nv1a, missing) == false
    @test isequal(ov1a, missing) == false
    @test isequal(missing, nv1a) == false
    @test isequal(missing, ov1a) == false
    end
end

@testset "in()" begin
    pool = CategoricalPool([5, 1, 3])
    nv = CategoricalValue(pool, 2)

    @test (nv in 1:3) === true
    @test (nv in [1, 2, 3]) === true
    @test (nv in 2:3) === false
    @test (nv in [2, 3]) === false
end

end

# delegate methods for SubArrays to support view

isordered(sa::SubArray{T,N,P}) where {T,N,P<:CategoricalArray} = isordered(parent(sa))
# This method cannot support allowmissing=true since that would modify the parent
levels!(sa::SubArray{T,N,P}, newlevels::Vector) where {T,N,P<:CategoricalArray} =
    levels!(parent(sa), newlevels)

refs(A::SubArray{<:Any, <:Any, <:CategoricalArray}) =
    view(parent(A).refs, parentindices(A)...)

pool(A::SubArray{<:Any, <:Any, <:CategoricalArray}) = A.parent.pool

function Base.fill!(A::SubArray{<:Any, <:Any, <:CategoricalArray}, v::Any)
    r = get!(A.parent.pool, convert(leveltype(A.parent), v))
    fill!(refs(A), r)
    A
end

Base.fill!(A::SubArray{<:Any, <:Any, <:CategoricalArray{>:Missing}}, ::Missing) =
    (fill!(refs(A), 0); A)

Base.Broadcast.broadcasted(::typeof(ismissing),
                           A::SubArray{<:Any, <:Any, <:CategoricalArray{T}}) where {T} =
    T >: Missing ? Base.Broadcast.broadcasted(==, refs(A), 0) :
                   Base.Broadcast.broadcasted(_ -> false, refs(A))

Base.Broadcast.broadcasted(::typeof(!ismissing),
                           A::SubArray{<:Any, <:Any, <:CategoricalArray{T}}) where {T} =
    T >: Missing ? Base.Broadcast.broadcasted(>, refs(A), 0) :
                   Base.Broadcast.broadcasted(_ -> true, refs(A))

CategoricalValue(pool::CategoricalPool{T, R}, level::Integer) where {T, R} =
    CategoricalValue(pool, convert(R, level))

"""
    CategoricalValue(value, source::Union{CategoricalValue, CategoricalArray})

Return a `CategoricalValue` object wrapping `value` and attached to
the `CategoricalPool` of `source`.
"""
function CategoricalValue(value, source::Union{CategoricalValue, CatArrOrSub})
    p = pool(source)
    i = get(p, value, nothing)
    i === nothing && throw(ArgumentError("level $value not found in source pool"))
    return CategoricalValue(p, i)
end

leveltype(::Type{<:CategoricalValue{T}}) where {T} = T
leveltype(::Type{T}) where {T} = T
leveltype(x::Any) = leveltype(typeof(x))
# to fix ambiguity
leveltype(x::Type{Union{}}) = Union{}

# integer type of category reference codes used by categorical value
reftype(::Type{<:CategoricalValue{<:Any, R}}) where {R} = R
reftype(x::Any) = reftype(typeof(x))

pool(x::CategoricalValue) = x.pool
refcode(x::CategoricalValue) = x.ref
isordered(x::CategoricalValue) = isordered(x.pool)
DataAPI.levels(x::CategoricalValue) = levels(pool(x))
_levels(x::CategoricalValue) = _levels(pool(x))

# extract the type of the original value from array eltype `T`
unwrap_catvaluetype(::Type{T}) where {T} = T
unwrap_catvaluetype(::Type{T}) where {T >: Missing} =
    Union{unwrap_catvaluetype(nonmissingtype(T)), Missing}
unwrap_catvaluetype(::Type{Union{}}) = Union{} # prevent incorrect dispatch to T<:CategoricalValue method
unwrap_catvaluetype(::Type{Any}) = Any # prevent recursion in T>:Missing method
unwrap_catvaluetype(::Type{T}) where {T <: CategoricalValue} = leveltype(T)

"""
    unwrap(x::CategoricalValue)
    unwrap(x::Missing)

Get the value wrapped by categorical value `x`. If `x` is `Missing` return `missing`.
"""
DataAPI.unwrap(x::CategoricalValue) = _levels(x)[refcode(x)]

"""
    levelcode(x::CategoricalValue)

Get the code of categorical value `x`, i.e. its index in the set
of possible values returned by [`levels(x)`](@ref DataAPI.levels).
"""
levelcode(x::CategoricalValue) = Signed(widen(refcode(x)))

"""
    levelcode(x::Missing)

Return `missing`.
"""
levelcode(x::Missing) = missing

function cat_promote_type(::Type{S}, ::Type{T}) where {S, T}
    U = promote_type(unwrap_catvaluetype(S), unwrap_catvaluetype(T))
    U <: Union{SupportedTypes, Missing} ?
        U : typeintersect(Union{SupportedTypes, Missing}, Union{S, T})
end

cat_promote_eltype() = Union{}
cat_promote_eltype(v1, vs...) = cat_promote_type(eltype(v1), cat_promote_eltype(vs...))

Base.promote_rule(::Type{C}, ::Type{T}) where {C <: CategoricalValue, T} =
    promote_type(leveltype(C), T)

Base.promote_rule(::Type{C}, ::Type{T}) where {C <: CategoricalValue, T >: Missing} =
    Union{promote_rule(C, nonmissingtype(T)), Missing}

# To fix ambiguities with definitions from Base
Base.promote_rule(::Type{C}, ::Type{Missing}) where {C <: CategoricalValue} = Union{C, Missing}
Base.promote_rule(::Type{C}, ::Type{Any}) where {C <: CategoricalValue} = Any

Base.promote_rule(::Type{C1}, ::Type{C2}) where
    {R1<:Integer, R2<:Integer,
     C1<:CategoricalValue{<: SupportedTypes, R1},
     C2<:CategoricalValue{<: SupportedTypes, R2}} =
    CategoricalValue{cat_promote_type(leveltype(C1), leveltype(C2)), promote_type(R1, R2)}
Base.promote_rule(::Type{C1}, ::Type{C2}) where {C1<:CategoricalValue, C2<:CategoricalValue} =
    CategoricalValue{cat_promote_type(leveltype(C1), leveltype(C2))}

# General fallback
Base.convert(::Type{S}, x::CategoricalValue) where {S <: SupportedTypes} =
    convert(S, unwrap(x))

(::Type{T})(x::T) where {T <: CategoricalValue} = x

Base.Broadcast.broadcastable(x::CategoricalValue) = Ref(x)

function Base.show(io::IO, x::CategoricalValue)
    if get(io, :compact, false) ||
        nonmissingtype(get(io, :typeinfo, Any)) === nonmissingtype(typeof(x))
        show(io, unwrap(x))
    else
        print(io, typeof(x))
        print(io, ' ')
        show(io, unwrap(x))
        if isordered(pool(x))
            @printf(io, " (%i/%i)", levelcode(x), length(pool(x)))
        end
    end
end

Base.print(io::IO, x::CategoricalValue) = print(io, unwrap(x))
Base.string(x::CategoricalValue) = string(unwrap(x))
Base.write(io::IO, x::CategoricalValue) = write(io, unwrap(x))
Base.String(x::CategoricalValue{<:AbstractString}) = String(unwrap(x))

@inline function Base.:(==)(x::CategoricalValue, y::CategoricalValue)
    if pool(x) === pool(y) || pool(x) == pool(y)
        return refcode(x) == refcode(y)
    else
        return unwrap(x) == unwrap(y)
    end
end

Base.:(==)(x::CategoricalValue, y::SupportedTypes) = unwrap(x) == y
Base.:(==)(x::SupportedTypes, y::CategoricalValue) = x == unwrap(y)

@inline function Base.isequal(x::CategoricalValue, y::CategoricalValue)
    if pool(x) === pool(y) || pool(x) == pool(y)
        return refcode(x) == refcode(y)
    else
        return isequal(unwrap(x), unwrap(y))
    end
end

Base.isequal(x::CategoricalValue, y::SupportedTypes) = isequal(unwrap(x), y)
Base.isequal(x::SupportedTypes, y::CategoricalValue) = isequal(x, unwrap(y))

Base.in(x::CategoricalValue, y::AbstractRange{T}) where {T<:Integer} = unwrap(x) in y

Base.hash(x::CategoricalValue, h::UInt) = hash(unwrap(x), h)

# Method defined even on unordered values so that sort() works
function Base.isless(x::CategoricalValue, y::CategoricalValue)
    if pool(x) === pool(y) || pool(x) == pool(y)
        return levelcode(x) < levelcode(y)
    else
        throw(ArgumentError("CategoricalValue objects from unequal pools cannot be tested for order"))
    end
end

Base.isless(x::CategoricalValue, y::SupportedTypes) =
    throw(ArgumentError("cannot compare a `CategoricalValue` to value `v` of type " *
                        "`$(typeof(y))`: wrap `v` using `CategoricalValue(v, catvalue)` " *
                        "or `CategoricalValue(v, catarray)` first"))
Base.isless(y::SupportedTypes, x::CategoricalValue) = isless(x, y)

function Base.:<(x::CategoricalValue, y::CategoricalValue)
    poolx = pool(x)
    pooly = pool(y)
    if poolx === pooly || poolx == pooly
        if isordered(poolx) && isordered(pooly)
            return levelcode(x) < levelcode(y)
        else
            throw(ArgumentError("Unordered CategoricalValue objects cannot be tested for order using <. Use isless instead, or call the ordered! function on the parent array to change this"))
        end
    else
        throw(ArgumentError("CategoricalValue objects from unequal pools cannot be tested for order"))
    end
end

Base.:<(x::CategoricalValue, y::SupportedTypes) =
    throw(ArgumentError("cannot compare a `CategoricalValue` to value `v` of type " *
                        "`$(typeof(y))`: wrap `v` using `CategoricalValue(v, catvalue)` " *
                        "or `CategoricalValue(v, catarray)` first"))
Base.:<(y::SupportedTypes, x::CategoricalValue) = x < y

DataAPI.defaultarray(::Type{CategoricalValue{T, R}}, N) where {T, R} =
    CategoricalArray{T, N, R}
DataAPI.defaultarray(::Type{Union{CategoricalValue{T, R}, Missing}}, N) where {T, R} =
    CategoricalArray{Union{T, Missing}, N, R}

module TestArray
using Test
using CategoricalArrays
using CategoricalArrays: DefaultRefType, leveltype

@testset "conversion ordered=$ordered reftype=$R" for ordered in (false, true),
    R in (CategoricalArrays.DefaultRefType, UInt8, UInt, Int8, Int)
    # Vector
    a = ["b", "a", "b"]
    x = CategoricalVector{String, R}(a, ordered=ordered)

    @test x == a
    @test leveltype(typeof(x)) === String
    @test leveltype(x) === String
    @test eltype(x) === CategoricalValue{String, R}
    @test isordered(x) === ordered
    @test levels(x) == sort(unique(a))
    @test unique(x) == unique(a)
    @test typeof(unique(x)) === typeof(x)
    @test size(x) === (3,)
    @test length(x) === 3

    @test convert(CategoricalArray, x) === x
    @test convert(CategoricalArray{String}, x) === x
    @test convert(CategoricalArray{String, 1}, x) === x
    @test convert(CategoricalArray{String, 1, R}, x) === x
    @test convert(CategoricalArray{String, 1, DefaultRefType}, x) == x
    @test convert(CategoricalArray{String, 1, UInt8}, x) == x

    @test convert(CategoricalVector, x) === x
    @test convert(CategoricalVector{String}, x) === x
    @test convert(CategoricalVector{String, R}, x) === x
    @test convert(CategoricalVector{String, DefaultRefType}, x) == x
    @test convert(CategoricalVector{String, UInt8}, x) == x

    @test convert(CategoricalArray, a) == x
    @test convert(CategoricalArray{String}, a) == x
    @test convert(CategoricalArray{String, 1}, a) == x
    @test convert(CategoricalArray{String, 1, R}, a) == x
    @test convert(CategoricalArray{String, 1, DefaultRefType}, a) == x
    @test convert(CategoricalArray{String, 1, UInt8}, a) == x

    @test convert(CategoricalVector, a) == x
    @test convert(CategoricalVector{String}, a) == x
    @test convert(CategoricalVector{String, R}, a) == x
    @test convert(CategoricalVector{String, DefaultRefType}, a) == x
    @test convert(CategoricalVector{String, UInt8}, a) == x

    @test CategoricalArray{String}(a, ordered=ordered) == x
    @test CategoricalArray{String, 1}(a, ordered=ordered) == x
    @test CategoricalArray{String, 1, R}(a, ordered=ordered) == x
    @test CategoricalArray{String, 1, DefaultRefType}(a, ordered=ordered) == x
    @test CategoricalArray{String, 1, UInt8}(a, ordered=ordered) == x

    @test CategoricalVector(a, ordered=ordered) == x
    @test CategoricalVector{String}(a, ordered=ordered) == x
    @test CategoricalVector{String, R}(a, ordered=ordered) == x
    @test CategoricalVector{String, DefaultRefType}(a, ordered=ordered) == x
    @test CategoricalVector{String, UInt8}(a, ordered=ordered) == x

    @test convert(CategoricalArray{Union{String, Missing}}, x) == x
    @test convert(CategoricalArray{Union{String, Missing}, 1}, x) == x
    @test convert(CategoricalArray{Union{String, Missing}, 1, R}, x) == x
    @test convert(CategoricalArray{Union{String, Missing}, 1, DefaultRefType}, x) == x
    @test convert(CategoricalArray{Union{String, Missing}, 1, UInt8}, x) == x

    @test convert(CategoricalVector{Union{String, Missing}}, x) == x
    @test convert(CategoricalVector{Union{String, Missing}, R}, x) == x
    @test convert(CategoricalVector{Union{String, Missing}, DefaultRefType}, x) == x
    @test convert(CategoricalVector{Union{String, Missing}, UInt8}, x) == x

    @test CategoricalArray{Union{String, Missing}}(x, ordered=ordered) == x
    @test CategoricalArray{Union{String, Missing}, 1}(x, ordered=ordered) == x
    @test CategoricalArray{Union{String, Missing}, 1, R}(x, ordered=ordered) == x
    @test CategoricalArray{Union{String, Missing}, 1, DefaultRefType}(x, ordered=ordered) == x
    @test CategoricalArray{Union{String, Missing}, 1, UInt8}(x, ordered=ordered) == x

    @test CategoricalVector{Union{String, Missing}}(x, ordered=ordered) == x
    @test CategoricalVector{Union{String, Missing}, R}(x, ordered=ordered) == x
    @test CategoricalVector{Union{String, Missing}, DefaultRefType}(x, ordered=ordered) == x
    @test CategoricalVector{Union{String, Missing}, UInt8}(x, ordered=ordered) == x

    @testset "categorical($(typeof(y)), compress=$comp) R1=$R1 R2=$R2" for (y, R1, R2, comp) in
        ((a, DefaultRefType, UInt8, true),
         (a, DefaultRefType, DefaultRefType, false),
         (x, R, UInt8, true),
         (x, R, R, false))

        x2 = @inferred categorical(y, ordered=ordered)
        @test x2 == x
        @test isa(x2, CategoricalVector{String, R1})
        @test isordered(x2) === ordered
        @test leveltype(x2) === String
        @test eltype(x2) === CategoricalValue{String, R1}

        x2 = categorical(y, compress=comp, ordered=ordered)
        @test x2 == x
        @test isa(x2, CategoricalVector{String, R2})
        @test isordered(x2) === ordered
        @test leveltype(x2) === String
        @test eltype(x2) === CategoricalValue{String, R2}
    end

    x2 = compress(x)
    @test x2 == x
    @test isa(x2, CategoricalVector{String, UInt8})
    @test isordered(x2) === isordered(x)
    @test levels(x2) == levels(x)

    x2 = copy(x)
    @test x2 == x
    @test typeof(x2) === typeof(x)
    @test isordered(x2) === isordered(x)
    @test levels(x2) == levels(x)

    if !isordered(x)
        @test ordered!(x, true) === x
        @test isordered(x) === true
    end
    @test x[1] > x[2]
    @test x[3] > x[2]

    @test ordered!(x, false) === x
    @test isordered(x) === false
    @test_throws Exception x[1] > x[2]
    @test_throws Exception x[3] > x[2]

    @test x[1] === CategoricalValue(x.pool, 2)
    @test x[2] === CategoricalValue(x.pool, 1)
    @test x[3] === CategoricalValue(x.pool, 2)
    @test_throws BoundsError x[4]

    x2 = x[:]
    @test typeof(x2) === typeof(x)
    @test x2 == x
    @test x2 !== x
    @test levels(x2) == levels(x)
    @test levels(x2) !== levels(x)
    @test isordered(x2) == isordered(x)

    x2 = x[1:2]
    @test typeof(x2) === typeof(x)
    @test x2 == ["b", "a"]
    @test levels(x2) == levels(x)
    @test levels(x2) !== levels(x)
    @test isordered(x2) == isordered(x)

    x2 = x[1:1]
    @test typeof(x2) === typeof(x)
    @test x2 == ["b"]
    @test levels(x2) == levels(x)
    @test levels(x2) !== levels(x)
    @test isordered(x2) == isordered(x)

    x2 = x[2:1]
    @test typeof(x2) === typeof(x)
    @test isempty(x2)
    @test levels(x2) == levels(x)
    @test levels(x2) !== levels(x)
    @test isordered(x2) == isordered(x)

    x[1] = x[2]
    @test x[1] === CategoricalValue(x.pool, 1)
    @test x[2] === CategoricalValue(x.pool, 1)
    @test x[3] === CategoricalValue(x.pool, 2)

    x[3] = "c"
    @test levels(x) == ["a", "b", "c"]
    @test x[1] === CategoricalValue(x.pool, 1)
    @test x[2] === CategoricalValue(x.pool, 1)
    @test x[3] === CategoricalValue(x.pool, 3)

    x[2:3] .= "b"
    @test levels(x) == ["a", "b", "c"]
    @test x[1] === CategoricalValue(x.pool, 1)
    @test x[2] === CategoricalValue(x.pool, 2)
    @test x[3] === CategoricalValue(x.pool, 2)

    @test droplevels!(x) === x
    @test levels(x) == ["a", "b"]
    @test x[1] === CategoricalValue(x.pool, 1)
    @test x[2] === CategoricalValue(x.pool, 2)
    @test x[3] === CategoricalValue(x.pool, 2)

    @test levels!(x, ["b", "a"]) === x
    @test levels(x) == ["b", "a"]
    @test x[1] === CategoricalValue(x.pool, 2)
    @test x[2] === CategoricalValue(x.pool, 1)
    @test x[3] === CategoricalValue(x.pool, 1)

    @test_throws ArgumentError levels!(x, ["a"])
    # check that x is restored correctly when dropping levels is not allowed
    @test x == ["a", "b", "b"]
    @test levels(x) == ["b", "a"]

    @test_throws ArgumentError levels!(x, ["e", "b"])

    @test_throws ArgumentError levels!(x, ["e", "a", "b", "a"])
    # once again check that x is restored correctly when dropping levels is not allowed
    @test x == ["a", "b", "b"]
    @test levels(x) == ["b", "a"]

    @test levels!(x, ["e", "a", "b"]) === x
    @test levels(x) == ["e", "a", "b"]
    @test x[1] === CategoricalValue(x.pool, 2)
    @test x[2] === CategoricalValue(x.pool, 3)
    @test x[3] === CategoricalValue(x.pool, 3)

    x[1] = "c"
    @test x[1] === CategoricalValue(x.pool, 4)
    @test x[2] === CategoricalValue(x.pool, 3)
    @test x[3] === CategoricalValue(x.pool, 3)
    @test levels(x) == ["e", "a", "b", "c"]

    y = copy(x)
    
    push!(x, "a")
    @test length(x) == 4
    @test x[end] == "a"
    @test levels(x) == ["e", "a", "b", "c"]

    push!(x, "zz")
    @test length(x) == 5
    @test x[end] == "zz"
    @test levels(x) == ["e", "a", "b", "c", "zz"]

    push!(x, x[1])
    @test length(x) == 6
    @test x[1] == x[end]
    @test levels(x) == ["e", "a", "b", "c", "zz"]

    x2 = copy(x)
    @test_throws MethodError push!(x, 1)
    @test x == x2
    @test x.pool.levels == x2.pool.levels
    @test x.pool.invindex == x2.pool.invindex

    x = y
    insert!(x, 1, "a")
    @test length(x) == 4
    @test x[1] == "a"
    @test levels(x) == ["e", "a", "b", "c"]

    insert!(x, length(x) + 1, "zz")
    @test length(x) == 5
    @test x[end] == "zz"
    @test levels(x) == ["e", "a", "b", "c", "zz"]

    insert!(x, 2, x[1])
    @test length(x) == 6
    @test x[1] == x[2]
    @test levels(x) == ["e", "a", "b", "c", "zz"]

    x2 = copy(x)
    @test_throws MethodError insert!(x, 1, 1)
    @test_throws ArgumentError insert!(x, true, "a")
    @test_throws BoundsError insert!(x, 0, "a")
    @test_throws BoundsError insert!(x, 100, "a")
    @test x == x2
    @test x.pool.levels == x2.pool.levels
    @test x.pool.invindex == x2.pool.invindex

    empty!(x)
    @test length(x) == 0
    @test levels(x) == ["e", "a", "b", "c", "zz"]

    @testset "Vector created from range" begin
        # (i.e. non-Array AbstractArray),
        # direct conversion to a vector with different eltype
        a = 0.0:0.5:1.5
        x = CategoricalVector{Float64, R}(a, ordered=ordered)

        @test x == collect(a)
        @test isordered(x) === ordered
        @test levels(x) == unique(x) == unique(a)
        @test typeof(unique(x)) === typeof(x)
        @test size(x) === (4,)
        @test length(x) === 4
        @test leveltype(x) === Float64
        @test eltype(x) <: CategoricalValue{Float64}

        @test convert(CategoricalArray, x) === x
        @test convert(CategoricalArray{Float64}, x) === x
        @test convert(CategoricalArray{Float64, 1}, x) === x
        @test convert(CategoricalArray{Float64, 1, R}, x) === x
        @test convert(CategoricalArray{Float64, 1, DefaultRefType}, x) == x
        @test convert(CategoricalArray{Float64, 1, UInt8}, x) == x

        @test convert(CategoricalVector, x) === x
        @test convert(CategoricalVector{Float64}, x) === x
        @test convert(CategoricalVector{Float32}, x) == x
        @test convert(CategoricalVector{Float64, R}, x) === x
        @test convert(CategoricalVector{Float32, R}, x) == x
        @test convert(CategoricalVector{Float64, DefaultRefType}, x) == x
        @test convert(CategoricalVector{Float32, DefaultRefType}, x) == x
        @test convert(CategoricalVector{Float64, UInt8}, x) == x
        @test convert(CategoricalVector{Float32, UInt8}, x) == x

        @test convert(CategoricalArray, a) == x
        @test convert(CategoricalArray{Float64}, a) == x
        @test convert(CategoricalArray{Float32}, a) == x
        @test convert(CategoricalArray{Float64, 1}, a) == x
        @test convert(CategoricalArray{Float32, 1}, a) == x
        @test convert(CategoricalArray{Float64, 1, R}, a) == x
        @test convert(CategoricalArray{Float32, 1, R}, a) == x
        @test convert(CategoricalArray{Float64, 1, DefaultRefType}, a) == x
        @test convert(CategoricalArray{Float32, 1, DefaultRefType}, a) == x
        @test convert(CategoricalArray{Float64, 1, UInt8}, a) == x
        @test convert(CategoricalArray{Float32, 1, UInt8}, a) == x

        @test convert(CategoricalVector, a) == x
        @test convert(CategoricalVector{Float64}, a) == x
        @test convert(CategoricalVector{Float32}, a) == x
        @test convert(CategoricalVector{Float64, R}, a) == x
        @test convert(CategoricalVector{Float32, R}, a) == x
        @test convert(CategoricalVector{Float64, DefaultRefType}, a) == x
        @test convert(CategoricalVector{Float32, DefaultRefType}, a) == x
        @test convert(CategoricalVector{Float64, UInt8}, a) == x
        @test convert(CategoricalVector{Float32, UInt8}, a) == x

        @test CategoricalArray{Float64}(a, ordered=ordered) == x
        @test CategoricalArray{Float32}(a, ordered=ordered) == x
        @test CategoricalArray{Float64, 1}(a, ordered=ordered) == x
        @test CategoricalArray{Float32, 1}(a, ordered=ordered) == x
        @test CategoricalArray{Float64, 1, R}(a, ordered=ordered) == x
        @test CategoricalArray{Float32, 1, R}(a, ordered=ordered) == x
        @test CategoricalArray{Float64, 1, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalArray{Float32, 1, DefaultRefType}(a, ordered=ordered) == x

        @test CategoricalVector(a, ordered=ordered) == x
        @test CategoricalVector{Float64}(a, ordered=ordered) == x
        @test CategoricalVector{Float32}(a, ordered=ordered) == x
        @test CategoricalVector{Float64, R}(a, ordered=ordered) == x
        @test CategoricalVector{Float32, R}(a, ordered=ordered) == x
        @test CategoricalVector{Float64, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalVector{Float32, DefaultRefType}(a, ordered=ordered) == x

        @test convert(CategoricalArray{Union{Float64, Missing}}, x) == x
        @test convert(CategoricalArray{Union{Float32, Missing}}, x) == x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1}, x) == x
        @test convert(CategoricalArray{Union{Float32, Missing}, 1}, x) == x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1, R}, x) == x
        @test convert(CategoricalArray{Union{Float32, Missing}, 1, R}, x) == x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1, DefaultRefType}, x) == x
        @test convert(CategoricalArray{Union{Float32, Missing}, 1, DefaultRefType}, x) == x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1, UInt8}, x) == x
        @test convert(CategoricalArray{Union{Float32, Missing}, 1, UInt8}, x) == x

        @test convert(CategoricalVector{Union{Float64, Missing}}, x) == x
        @test convert(CategoricalVector{Union{Float32, Missing}}, x) == x
        @test convert(CategoricalVector{Union{Float64, Missing}, R}, x) == x
        @test convert(CategoricalVector{Union{Float32, Missing}, R}, x) == x
        @test convert(CategoricalVector{Union{Float64, Missing}, DefaultRefType}, x) == x
        @test convert(CategoricalVector{Union{Float32, Missing}, DefaultRefType}, x) == x
        @test convert(CategoricalVector{Union{Float64, Missing}, UInt8}, x) == x
        @test convert(CategoricalVector{Union{Float32, Missing}, UInt8}, x) == x

        @test CategoricalArray{Union{Float64, Missing}}(x, ordered=ordered) == x
        @test CategoricalArray{Union{Float32, Missing}}(x, ordered=ordered) == x
        @test CategoricalArray{Union{Float64, Missing}, 1}(x, ordered=ordered) == x
        @test CategoricalArray{Union{Float32, Missing}, 1}(x, ordered=ordered) == x
        @test CategoricalArray{Union{Float64, Missing}, 1, R}(x, ordered=ordered) == x
        @test CategoricalArray{Union{Float32, Missing}, 1, R}(x, ordered=ordered) == x
        @test CategoricalArray{Union{Float64, Missing}, 1, DefaultRefType}(x, ordered=ordered) == x
        @test CategoricalArray{Union{Float32, Missing}, 1, DefaultRefType}(x, ordered=ordered) == x

        @test CategoricalVector{Union{Float64, Missing}}(x, ordered=ordered) == x
        @test CategoricalVector{Union{Float32, Missing}}(x, ordered=ordered) == x
        @test CategoricalVector{Union{Float64, Missing}, R}(x, ordered=ordered) == x
        @test CategoricalVector{Union{Float32, Missing}, R}(x, ordered=ordered) == x
        @test CategoricalVector{Union{Float64, Missing}, DefaultRefType}(x, ordered=ordered) == x
        @test CategoricalVector{Union{Float32, Missing}, DefaultRefType}(x, ordered=ordered) == x

        @testset "categorical($(typeof(y)), compress=$comp) R1=$R1 R2=$R2" for (y, R1, R2, comp) in
            ((a, DefaultRefType, UInt8, true),
             (a, DefaultRefType, DefaultRefType, false),
             (x, R, UInt8, true),
             (x, R, R, false))

            x2 = @inferred categorical(y, ordered=ordered)
            @test x2 == x
            @test isa(x2, CategoricalVector{Float64, R1})
            @test isordered(x2) === ordered
            @test leveltype(x2) === Float64
            @test eltype(x2) === CategoricalValue{Float64, R1}

            x2 = categorical(y, compress=comp, ordered=ordered)
            @test x2 == x
            @test isa(x2, CategoricalVector{Float64, R2})
            @test isordered(x2) === ordered
            @test leveltype(x2) === Float64
            @test eltype(x2) === CategoricalValue{Float64, R2}
        end

        x2 = copy(x)
        @test x2 == x
        @test typeof(x2) === typeof(x)
        @test isordered(x2) === isordered(x)
        @test levels(x2) == levels(x)

        @test x[1] === CategoricalValue(x.pool, 1)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 3)
        @test x[4] === CategoricalValue(x.pool, 4)
        @test_throws BoundsError x[5]

        x2 = x[:]
        @test typeof(x2) === typeof(x)
        @test x2 == x
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[1:2]
        @test typeof(x2) === typeof(x)
        @test x2 == [0.0, 0.5]
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[1:1]
        @test typeof(x2) === typeof(x)
        @test x2 == [0.0]
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[2:1]
        @test typeof(x2) === typeof(x)
        @test isempty(x2)
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x[2] = 1
        @test x[1] === CategoricalValue(x.pool, 1)
        @test x[2] === CategoricalValue(x.pool, 3)
        @test x[3] === CategoricalValue(x.pool, 3)
        @test x[4] === CategoricalValue(x.pool, 4)
        @test levels(x) == unique(a)
        @test unique(x) == unique(collect(x))
        @test typeof(unique(x)) === typeof(x)

        x[1:2] .= -1
        @test x[1] === CategoricalValue(x.pool, 5)
        @test x[2] === CategoricalValue(x.pool, 5)
        @test x[3] === CategoricalValue(x.pool, 3)
        @test x[4] === CategoricalValue(x.pool, 4)
        @test levels(x) == vcat(unique(a), -1)
        @test unique(x) == unique(collect(x))

        push!(x, 2.0)
        @test length(x) == 5
        @test x[end] == 2.0
        @test isordered(x) === false
        @test levels(x) == [0.0,  0.5,  1.0,  1.5, -1.0,  2.0]

        ordered!(x, ordered)
        push!(x, x[1])
        @test length(x) == 6
        @test x[1] == x[end]
        @test isordered(x) === ordered
        @test levels(x) == [0.0,  0.5,  1.0,  1.5, -1.0,  2.0]

        ordered!(x, ordered)
        empty!(x)
        @test length(x) == 0
        @test isordered(x) === ordered
        @test levels(x) == [0.0, 0.5, 1.0, 1.5, -1.0, 2.0]
    end

    @testset "Matrix" begin
        a = ["a" "b" "c"; "b" "a" "c"]
        x = CategoricalMatrix{String, R}(a, ordered=ordered)

        @test x == a
        @test isordered(x) === ordered
        @test levels(x) == unique(x) == unique(a)
        @test unique(x) isa CategoricalVector{String, R}
        @test size(x) === (2, 3)
        @test length(x) === 6

        @test convert(CategoricalArray, x) === x
        @test convert(CategoricalArray{String}, x) === x
        @test convert(CategoricalArray{String, 2}, x) === x
        @test convert(CategoricalArray{String, 2, R}, x) === x
        @test convert(CategoricalArray{String, 2, DefaultRefType}, x) == x
        @test convert(CategoricalArray{String, 2, UInt8}, x) == x

        @test convert(CategoricalMatrix, x) === x
        @test convert(CategoricalMatrix{String}, x) === x
        @test convert(CategoricalMatrix{String, R}, x) === x
        @test convert(CategoricalMatrix{String, DefaultRefType}, x) == x
        @test convert(CategoricalMatrix{String, UInt8}, x) == x

        @test convert(CategoricalArray, a) == x
        @test convert(CategoricalArray{String}, a) == x
        @test convert(CategoricalArray{String, 2, R}, a) == x
        @test convert(CategoricalArray{String, 2, DefaultRefType}, a) == x
        @test convert(CategoricalArray{String, 2, UInt8}, a) == x

        @test convert(CategoricalMatrix, a) == x
        @test convert(CategoricalMatrix{String}, a) == x
        @test convert(CategoricalMatrix{String, R}, a) == x
        @test convert(CategoricalMatrix{String, DefaultRefType}, a) == x
        @test convert(CategoricalMatrix{String, UInt8}, a) == x

        @test CategoricalArray{String}(a, ordered=ordered) == x
        @test CategoricalArray{String, 2}(a, ordered=ordered) == x
        @test CategoricalArray{String, 2}(a, ordered=ordered) == x
        @test CategoricalArray{String, 2, R}(a, ordered=ordered) == x
        @test CategoricalArray{String, 2, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalArray{String, 2, UInt8}(a, ordered=ordered) == x

        @test CategoricalMatrix(a, ordered=ordered) == x
        @test CategoricalMatrix{String}(a, ordered=ordered) == x
        @test CategoricalMatrix{String, R}(a, ordered=ordered) == x
        @test CategoricalMatrix{String, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalMatrix{String, UInt8}(a, ordered=ordered) == x

        @test convert(CategoricalArray{Union{String, Missing}}, x) == x
        @test convert(CategoricalArray{Union{String, Missing}, 2, R}, x) == x
        @test convert(CategoricalArray{Union{String, Missing}, 2, DefaultRefType}, x) == x
        @test convert(CategoricalArray{Union{String, Missing}, 2, UInt8}, x) == x

        @test convert(CategoricalMatrix{Union{String, Missing}}, x) == x
        @test convert(CategoricalMatrix{Union{String, Missing}, R}, x) == x
        @test convert(CategoricalMatrix{Union{String, Missing}, DefaultRefType}, x) == x
        @test convert(CategoricalMatrix{Union{String, Missing}, UInt8}, x) == x

        @test CategoricalArray{Union{String, Missing}}(x, ordered=ordered) == x
        @test CategoricalArray{Union{String, Missing}, 2}(x, ordered=ordered) == x
        @test CategoricalArray{Union{String, Missing}, 2}(x, ordered=ordered) == x
        @test CategoricalArray{Union{String, Missing}, 2, R}(x, ordered=ordered) == x
        @test CategoricalArray{Union{String, Missing}, 2, DefaultRefType}(x, ordered=ordered) == x
        @test CategoricalArray{Union{String, Missing}, 2, UInt8}(x, ordered=ordered) == x

        @test CategoricalMatrix{Union{String, Missing}}(x, ordered=ordered) == x
        @test CategoricalMatrix{Union{String, Missing}, R}(x, ordered=ordered) == x
        @test CategoricalMatrix{Union{String, Missing}, DefaultRefType}(x, ordered=ordered) == x
        @test CategoricalMatrix{Union{String, Missing}, UInt8}(x, ordered=ordered) == x

        @testset "categorical($(typeof(y)), compress=$comp) R1=$R1 R2=$R2" for (y, R1, R2, comp) in
            ((a, DefaultRefType, UInt8, true),
             (a, DefaultRefType, DefaultRefType, false),
             (x, R, UInt8, true),
             (x, R, R, false))

            x2 = @inferred categorical(y, ordered=ordered)
            @test x2 == x
            @test isa(x2, CategoricalMatrix{String, R1})
            @test isordered(x2) === ordered

            x2 = categorical(y, compress=comp, ordered=ordered)
            @test x2 == x
            @test isa(x2, CategoricalMatrix{String, R2})
            @test isordered(x2) === ordered
        end

        x2 = compress(x)
        @test x2 == x
        @test isa(x2, CategoricalMatrix{String, UInt8})
        @test isordered(x2) === isordered(x)
        @test levels(x2) == levels(x)

        x2 = copy(x)
        @test x2 == x
        @test typeof(x2) === typeof(x)
        @test isordered(x2) === isordered(x)
        @test levels(x2) == levels(x)

        @test x[1] === CategoricalValue(x.pool, 1)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 2)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 3)
        @test x[6] === CategoricalValue(x.pool, 3)
        @test_throws BoundsError x[7]

        @test x[1,1] === CategoricalValue(x.pool, 1)
        @test x[2,1] === CategoricalValue(x.pool, 2)
        @test x[1,2] === CategoricalValue(x.pool, 2)
        @test x[2,2] === CategoricalValue(x.pool, 1)
        @test x[1,3] === CategoricalValue(x.pool, 3)
        @test x[2,3] === CategoricalValue(x.pool, 3)
        @test_throws BoundsError x[1,4]
        @test_throws BoundsError x[4,1]
        @test_throws BoundsError x[4,4]

        x2 = x[1:2,:]
        @test typeof(x2) === typeof(x)
        @test x2 == x
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[:,[1, 3]]
        @test typeof(x2) === typeof(x)
        @test x2 == ["a" "c"; "b" "c"]
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[1:1,2]
        @test isa(x2, CategoricalVector{String, R})
        @test x2 == ["b"]
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[1:0,:]
        @test typeof(x2) === typeof(x)
        @test size(x2) == (0,3)
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        @test_throws BoundsError x[1:4, :]
        @test_throws BoundsError x[1:1, -1:1]
        @test_throws BoundsError x[4, :]

        x[1] = "z"
        @test x[1] === CategoricalValue(x.pool, 4)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 2)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 3)
        @test x[6] === CategoricalValue(x.pool, 3)
        @test levels(x) == ["a", "b", "c", "z"]
        @test isordered(x) === false

        x[1,:] .= "a"
        @test x[1] === CategoricalValue(x.pool, 1)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 1)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === CategoricalValue(x.pool, 3)
        @test levels(x) == ["a", "b", "c", "z"]
        @test isordered(x) === false

        x[1,1:2] .= "z"
        @test x[1] === CategoricalValue(x.pool, 4)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 4)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === CategoricalValue(x.pool, 3)
        @test levels(x) == ["a", "b", "c", "z"]
        @test isordered(x) === false

        x[1,2] = "b"
        @test x[1] === CategoricalValue(x.pool, 4)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 2)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === CategoricalValue(x.pool, 3)
        @test levels(x) == ["a", "b", "c", "z"]
        @test isordered(x) === false
    end

    # Uninitialized array
    v = Any[CategoricalArray(undef, 2, ordered=ordered),
            CategoricalArray{String}(undef, 2, ordered=ordered),
            CategoricalArray{String, 1}(undef, 2, ordered=ordered),
            CategoricalArray{String, 1, R}(undef, 2, ordered=ordered),
            CategoricalVector(undef, 2, ordered=ordered),
            CategoricalVector{String}(undef, 2, ordered=ordered),
            CategoricalVector{String, R}(undef, 2, ordered=ordered),
            CategoricalArray(undef, 2, 3, ordered=ordered),
            CategoricalArray{String}(undef, 2, 3, ordered=ordered),
            CategoricalArray{String, 2}(undef, 2, 3, ordered=ordered),
            CategoricalArray{String, 2, R}(undef, 2, 3, ordered=ordered),
            CategoricalMatrix(undef, 2, 3, ordered=ordered),
            CategoricalMatrix{String}(undef, 2, 3, ordered=ordered),
            CategoricalMatrix{String, R}(undef, 2, 3, ordered=ordered)]

    @testset "compress($(typeof(x))) and setindex!()" for x in v
        @test !isassigned(x, 1) && isdefined(x, 1)
        @test !isassigned(x, 2) && isdefined(x, 2)
        @test_throws UndefRefError x[1]
        @test_throws UndefRefError x[2]
        @test isordered(x) === ordered
        @test levels(x) == []

        x2 = compress(x)
        @test isa(x2, CategoricalArray{leveltype(x), ndims(x), UInt8})
        @test !isassigned(x2, 1) && isdefined(x2, 1)
        @test !isassigned(x2, 2) && isdefined(x2, 2)
        @test_throws UndefRefError x2[1]
        @test_throws UndefRefError x2[2]
        @test levels(x2) == []

        x[1] = "c"
        @test x[1] === CategoricalValue(x.pool, 1)
        @test !isassigned(x, 2) && isdefined(x, 2)
        @test_throws UndefRefError x[2]
        @test isordered(x) === false
        @test levels(x) == ["c"]

        x[1] = "a"
        @test x[1] === CategoricalValue(x.pool, 2)
        @test !isassigned(x, 2) && isdefined(x, 2)
        @test_throws UndefRefError x[2]
        @test isordered(x) === false
        @test levels(x) == ["c", "a"]

        x[2] = "c"
        @test x[1] === CategoricalValue(x.pool, 2)
        @test x[2] === CategoricalValue(x.pool, 1)
        @test isordered(x) === false
        @test levels(x) == ["c", "a"]

        x[1] = "b"
        @test x[1] === CategoricalValue(x.pool, 3)
        @test x[2] === CategoricalValue(x.pool, 1)
        @test isordered(x) === false
        @test levels(x) == ["c", "a", "b"]

        ordered!(x, ordered)
        v = CategoricalValue(CategoricalPool(["xyz", "b"]), 2)
        x[1] = v
        @test x[1] === CategoricalValue(x.pool, 4)
        @test x[2] === CategoricalValue(x.pool, 1)
        @test isordered(x) === false
        @test levels(x) == ["c", "a", "xyz", "b"]
    end
end

@testset "unique() and levels()" begin
    x = CategoricalArray(["Old", "Young", "Middle", "Young"])
    @test levels!(x, ["Young", "Middle", "Old"]) === x
    @test levels(x) == ["Young", "Middle", "Old"]
    @test unique(x) == ["Old", "Young", "Middle"]
    @test typeof(unique(x)) === typeof(x)
    @test levels!(x, ["Young", "Middle", "Old", "Unused"]) === x
    @test levels(x) == ["Young", "Middle", "Old", "Unused"]
    @test unique(x) == ["Old", "Young", "Middle"]
    @test levels!(x, ["Unused1", "Young", "Middle", "Old", "Unused2"]) === x
    @test levels(x) == ["Unused1", "Young", "Middle", "Old", "Unused2"]
    @test unique(x) == ["Old", "Young", "Middle"]

    y = copy(x)
    @test unique!(y) === y
    @test y == unique(x)

    x = CategoricalArray(String[])
    @test isa(levels(x), CategoricalVector{String, DefaultRefType}) && isempty(levels(x))
    @test isa(unique(x), typeof(x)) && isempty(unique(x))
    @test levels!(x, ["Young", "Middle", "Old"]) === x
    @test levels(x) == ["Young", "Middle", "Old"]
    @test isa(unique(x), typeof(x)) && isempty(unique(x))

    y = copy(x)
    @test unique!(y) === y
    @test y == unique(x)

    # To test short-circuiting
    x = CategoricalArray(repeat(1:10, inner=10))
    @test levels(x) == collect(1:10)
    @test unique(x) == collect(1:10)
    @test unique(x) isa typeof(x)
    @test levels!(x, [19:-1:1; 20]) === x
    @test levels(x) == [19:-1:1; 20]
    @test unique(x) == collect(1:10)
    @test unique(x) isa typeof(x)

    y = copy(x)
    @test unique!(y) === y
    @test y == 1:10
end

end

module TestConvert
using Test
using CategoricalArrays
using CategoricalArrays: DefaultRefType, refcode, reftype, leveltype

@testset "convert() for CategoricalPool{Int, DefaultRefType} and values" begin
    pool = CategoricalPool([1, 2, 3])
    @test convert(CategoricalPool{Int, DefaultRefType}, pool) === pool
    @test convert(CategoricalPool{Int}, pool) === pool
    @test convert(CategoricalPool, pool) === pool
    convert(CategoricalPool{Float64, UInt8}, pool)
    convert(CategoricalPool{Float64}, pool)
    convert(CategoricalPool, pool)

    v1 = CategoricalValue(pool, 1)
    v2 = CategoricalValue(pool, 2)
    v3 = CategoricalValue(pool, 3)
    @test eltype(v1) === Any
    @test eltype(typeof(v1)) === Any
    @test leveltype(v1) === Int
    @test leveltype(typeof(v1)) === Int
    @test reftype(v1) === DefaultRefType
    @test reftype(typeof(v1)) === DefaultRefType
    @test v1 isa CategoricalArrays.CategoricalValue{Int, DefaultRefType}

    @test convert(Int, v1) === 1
    @test convert(Int, v2) === 2
    @test convert(Int, v3) === 3

    @test convert(Int32, v1) === Int32(1)
    @test convert(Int32, v2) === Int32(2)
    @test convert(Int32, v3) === Int32(3)

    @test convert(UInt8, v1) === 0x01
    @test convert(UInt8, v2) === 0x02
    @test convert(UInt8, v3) === 0x03

    @test convert(CategoricalValue, v1) === v1
    @test convert(CategoricalValue{Int}, v1) === v1
    @test convert(CategoricalValue{Int, DefaultRefType}, v1) === v1

    @test convert(Any, v1) === v1
    @test convert(Any, v2) === v2
    @test convert(Any, v3) === v3

    for T in (typeof(v1), CategoricalValue{Int}, CategoricalValue), U in (Missing, Nothing)
        @test convert(Union{T, U}, v1) === v1
        @test convert(Union{T, U}, v2) === v2
        @test convert(Union{T, U}, v3) === v3
    end

    for T in (Int, Int8, Float64), U in (Missing, Nothing)
        @test convert(Union{T, U}, v1)::T == v1
        @test convert(Union{T, U}, v2)::T == v2
        @test convert(Union{T, U}, v3)::T == v3
    end

    @test unwrap(v1) === 1
    @test unwrap(v2) === 2
    @test unwrap(v3) === 3

    @test promote(1, v1) === (1, 1)
    @test promote(1.0, v1) === (1.0, 1.0)
    @test promote(0x1, v1) === (1, 1)
end

@testset "promote_type" begin
    @test promote_type(CategoricalValue{Int}, CategoricalValue{Float64}) ===
        CategoricalValue{Float64}
    @test promote_type(CategoricalValue{Int, UInt8}, CategoricalValue{Float64, UInt32}) ===
        CategoricalValue{Float64, UInt32}
    @test promote_type(CategoricalValue{Int, UInt8}, CategoricalValue{Float64}) ===
        CategoricalValue{Float64}
    @test promote_type(CategoricalValue{Int, UInt8}, CategoricalValue{String}) ===
        CategoricalValue{Union{Int, String}}
    # Tests that return Any before Julia 1.3 are due to JuliaLang/julia#29348
    if VERSION >= v"1.3.0-DEV"
        @test promote_type(CategoricalValue{Int},
                           Union{CategoricalValue{Float64}, Missing}) ===
            Union{CategoricalValue{Float64}, Missing}
        @test promote_type(CategoricalValue{Int},
                           Union{CategoricalValue{String}, Missing}) ===
            Union{CategoricalValue{Union{Int, String}}, Missing}
        @test promote_type(CategoricalValue{Int, UInt8},
                           Union{CategoricalValue{Float64, UInt32}, Missing}) ===
            Union{CategoricalValue{Float64, UInt32}, Missing}
        @test promote_type(CategoricalValue{Int, UInt8},
                           Union{CategoricalValue{String, UInt32}, Missing}) ===
            Union{CategoricalValue{Union{Int, String}, UInt32}, Missing}
        @test promote_type(Union{CategoricalValue{Int}, Missing},
                           CategoricalValue{Float64}) ===
            Union{CategoricalValue{Float64}, Missing}
        @test promote_type(Union{CategoricalValue{Int}, Missing},
                           CategoricalValue{String}) ===
            Union{CategoricalValue{Union{Int, String}}, Missing}
        @test promote_type(Union{CategoricalValue{Int, UInt8}, Missing},
                           CategoricalValue{Float64, UInt32}) ===
            Union{CategoricalValue{Float64, UInt32}, Missing}
        @test promote_type(Union{CategoricalValue{Int, UInt8}, Missing},
                           CategoricalValue{String, UInt32}) ===
            Union{CategoricalValue{Union{Int, String}, UInt32}, Missing}
        @test promote_type(Union{CategoricalValue{Int}, Missing},
                           Union{CategoricalValue{Float64}, Missing}) ===
            Union{CategoricalValue{Float64}, Missing}
        @test promote_type(Union{CategoricalValue{Int}, Missing},
                           Union{CategoricalValue{String}, Missing}) ===
            Union{CategoricalValue{Union{Int, String}}, Missing}
    else
        @test promote_type(CategoricalValue{Int},
                           Union{CategoricalValue{Float64}, Missing}) ===
            Union{CategoricalValue{Float64}, Missing}
        @test promote_type(CategoricalValue{Int},
                           Union{CategoricalValue{String}, Missing}) ===
            Union{CategoricalValue{Union{Int, String}}, Missing}
        @test promote_type(CategoricalValue{Int, UInt8},
                           Union{CategoricalValue{Float64, UInt32}, Missing}) ===
            Union{CategoricalValue{Float64, UInt32}, Missing}
        @test promote_type(CategoricalValue{Int, UInt8},
                           Union{CategoricalValue{String, UInt32}, Missing}) ===
            Union{CategoricalValue{Union{Int, String}, UInt32}, Missing}
        @test promote_type(Union{CategoricalValue{Int}, Missing},
                           CategoricalValue{Float64}) ===
            Union{CategoricalValue{Float64}, Missing}
        @test promote_type(Union{CategoricalValue{Int}, Missing},
                           CategoricalValue{String}) ===
            Union{CategoricalValue{Union{Int, String}}, Missing}
        @test promote_type(Union{CategoricalValue{Int, UInt8}, Missing},
                           CategoricalValue{Float64, UInt32}) ===
            Union{CategoricalValue{Float64, UInt32}, Missing}
        @test promote_type(Union{CategoricalValue{Int, UInt8}, Missing},
                           CategoricalValue{String, UInt32}) ===
            Union{CategoricalValue{Union{Int, String}, UInt32}, Missing}
        @test promote_type(Union{CategoricalValue{Int}, Missing},
                           Union{CategoricalValue{Float64}, Missing}) ===
            Any
        @test promote_type(Union{CategoricalValue{Int}, Missing},
                           Union{CategoricalValue{String}, Missing}) ===
            Any
    end
    @test promote_type(Union{CategoricalValue{Int, UInt8}, Missing},
                       Union{CategoricalValue{Float64, UInt32}, Missing}) ===
        Union{CategoricalValue{Float64, UInt32}, Missing}
    @test promote_type(Union{CategoricalValue{Int, UInt8}, Missing},
                       Union{CategoricalValue{String, UInt32}, Missing}) ===
        Union{CategoricalValue{Union{Int, String}, UInt32}, Missing}

    @test promote_type(CategoricalValue, Missing) === Union{CategoricalValue, Missing}
    @test promote_type(CategoricalValue{Int}, Missing) === Union{CategoricalValue{Int}, Missing}
    @test promote_type(CategoricalValue{Int, UInt32}, Missing) ===
        Union{CategoricalValue{Int, UInt32}, Missing}
    @test promote_type(CategoricalValue{Int, UInt32}, Any) === Any
end

@testset "convert() preserves `ordered`" begin
    pool = CategoricalPool([1, 2, 3], true)
    @test convert(CategoricalPool{Float64, UInt8}, pool).ordered === true
end

@testset "levelcode" begin
    pool = CategoricalPool{Int,UInt8}([2, 1, 3])
    for i in 1:3
        v = CategoricalValue(pool, i)
        @test levelcode(v) isa Int16
        @test levels(pool)[levelcode(v)] == v
    end

    @test levelcode(missing) === missing
end


end

using Statistics

function fill_refs!(refs::AbstractArray, X::AbstractArray,
                    breaks::AbstractVector, extend::Union{Bool, Missing})
    n = length(breaks)
    lower = first(breaks)
    upper = last(breaks)

    @inbounds for i in eachindex(X)
        x = X[i]

        if x isa Number && isnan(x)
            throw(ArgumentError("NaN values are not allowed in input vector"))
        elseif ismissing(x)
            refs[i] = 0
        elseif isequal(x, upper)
            refs[i] = n-1
        elseif extend !== true &&
            !((isless(lower, x) || isequal(x, lower)) && isless(x, upper))
            extend === missing ||
                throw(ArgumentError("value $x (at index $i) does not fall inside the breaks: " *
                                    "adapt them manually, or pass extend=true or extend=missing"))
            refs[i] = 0
        else
            refs[i] = searchsortedlast(breaks, x)
        end
    end
end

if VERSION >= v"1.10"
    const CUT_FMT = Printf.Format("%.*g")
end

"""
    CategoricalArrays.default_formatter(from, to, i::Integer;
                                        leftclosed::Bool, rightclosed::Bool,
                                        sigdigits::Integer)

Provide the default label format for the `cut(x, breaks)` method,
which is `"[from, to)"` if `leftclosed` is `true` and `"[from, to)"` otherwise.

If they are floating points values, breaks are turned into to strings using
`@sprintf("%.*g", sigdigits, break)`
(or `to` using `@sprintf("%.*g", sigdigits, break)` for the last break).
"""
function default_formatter(from, to, i::Integer;
                           leftclosed::Bool, rightclosed::Bool,
                           sigdigits::Integer)
    @static if VERSION >= v"1.10"
        from_str = from isa AbstractFloat ?
            Printf.format(CUT_FMT, sigdigits, from) :
            string(from)
        to_str = to isa AbstractFloat ?
            Printf.format(CUT_FMT, sigdigits, to) :
            string(to)
    else
        from_str = from isa AbstractFloat ?
            Printf.format(Printf.Format("%.$(sigdigits)g"), from) :
            string(from)
        to_str = to isa AbstractFloat ?
            Printf.format(Printf.Format("%.$(sigdigits)g"), to) :
            string(to)
    end
    string(leftclosed ? "[" : "(", from_str, ", ", to_str, rightclosed ? "]" : ")")
end

"""
    CategoricalArrays.numbered_formatter(from, to, i::Integer;
                                         leftclosed::Bool, rightclosed::Bool,
                                         sigdigits::Integer)

Provide the default label format for the `cut(x, ngroups)` method
when `allowempty=true`, which is `"i: [from, to)"` if `leftclosed`
is `true` and `"i: [from, to)"` otherwise.

If they are floating points values, breaks are turned into to strings using
`@sprintf("%.*g", sigdigits, breaks)`
(or `to` using `@sprintf("%.*g", sigdigits, break)` for the last break).
"""
numbered_formatter(from, to, i::Integer;
                   leftclosed::Bool, rightclosed::Bool,
                   sigdigits::Integer) =
    string(i, ": ",
           default_formatter(from, to, i, leftclosed=leftclosed, rightclosed=rightclosed,
                             sigdigits=sigdigits))

@doc raw"""
    cut(x::AbstractArray, breaks::AbstractVector;
        labels::Union{AbstractVector,Function},
        sigdigits::Integer=3,
        extend::Union{Bool,Missing}=false, allowempty::Bool=false)

Cut a numeric array into intervals at values `breaks`
and return an ordered `CategoricalArray` indicating
the interval into which each entry falls. Intervals are of the form `[lower, upper)`
(closed on the left), i.e. the lower bound is included and the upper bound is excluded, except
the last interval, which is closed on both ends, i.e. `[lower, upper]`.

If `x` accepts missing values (i.e. `eltype(x) >: Missing`) the returned array will
also accept them.

!!! note
    For floating point data, breaks may be rounded to `sigdigits` significant digits
    when generating interval labels, meaning that they may not reflect exactly the cutpoints
    used.

# Keyword arguments
* `extend::Union{Bool, Missing}=false`: when `false`, an error is raised if some values
  in `x` fall outside of the breaks; when `true`, breaks are automatically added to include
  all values in `x`; when `missing`, values outside of the breaks generate `missing` entries.
* `labels::Union{AbstractVector, Function}`: a vector of strings, characters
  or numbers giving the names to use for the intervals; or a function
  `f(from, to, i::Integer; leftclosed::Bool, rightclosed::Bool, sigdigits::Integer)` that generates
  the labels from the left and right interval boundaries and the group index. Defaults to
  [`CategoricalArrays.default_formatter`](@ref), giving `"[from, to)"` (or `"[from, to]"`
  for the rightmost interval if `extend == true`).
* `sigdigits::Integer=3`: the minimum number of significant digits to use in labels.
  This value is increased automatically if necessary so that rounded breaks are unique.
  Only used for floating point types and when `labels` is a function, in which case it
  is passed to it as a keyword argument.
* `allowempty::Bool=false`: when `false`, an error is raised if some breaks other than
  the last one appear multiple times, generating empty intervals; when `true`,
  duplicate breaks are allowed and the intervals they generate are kept as
  unused levels (but duplicate labels are not allowed).

# Examples
```jldoctest
julia> using CategoricalArrays

julia> cut(-1:0.5:1, [0, 1], extend=true)
5-element CategoricalArray{String,1,UInt32}:
 "[-1, 0)"
 "[-1, 0)"
 "[0, 1]"
 "[0, 1]"
 "[0, 1]" 

julia> cut(-1:0.5:1, 2)
5-element CategoricalArray{String,1,UInt32}:
 "[-1, 0)"
 "[-1, 0)"
 "[0, 1]"
 "[0, 1]"
 "[0, 1]"

julia> cut(-1:0.5:1, 2, labels=["A", "B"])
5-element CategoricalArray{String,1,UInt32}:
 "A"
 "A"
 "B"
 "B"
 "B"

julia> cut(-1:0.5:1, 2, labels=[-0.5, +0.5])
5-element CategoricalArray{Float64,1,UInt32}:
 -0.5
 -0.5
 0.5
 0.5
 0.5

julia> fmt(from, to, i; leftclosed, rightclosed) = "grp $i ($from//$to)"
fmt (generic function with 1 method)

julia> cut(-1:0.5:1, 3, labels=fmt)
5-element CategoricalArray{String,1,UInt32}:
 "grp 1 (-1.0//0.0)"
 "grp 1 (-1.0//0.0)"
 "grp 2 (0.0//0.5)"
 "grp 3 (0.5//1.0)"
 "grp 3 (0.5//1.0)"
```
"""
@inline function cut(x::AbstractArray, breaks::AbstractVector;
                     extend::Union{Bool, Missing}=false,
                     labels::Union{AbstractVector{<:SupportedTypes},Function}=default_formatter,
                     sigdigits::Integer=3,
                     allowempty::Bool=false)
    return _cut(x, breaks, extend, labels, sigdigits, allowempty)
end

# Separate function for inferability (thanks to inlining of cut)
function _cut(x::AbstractArray{T, N}, breaks::AbstractVector,
              extend::Union{Bool, Missing},
              labels::Union{AbstractVector{<:SupportedTypes},Function},
              sigdigits::Integer,
              allowempty::Bool) where {T, N}
    if !issorted(breaks)
        breaks = sort(breaks)
    end

    if any(x -> x isa Number && isnan(x), breaks)
        throw(ArgumentError("NaN values are not allowed in breaks"))
    end

    if !allowempty && !allunique(@view breaks[1:end-1])
        throw(ArgumentError("all breaks other than the last one must be unique " *
                            "unless `allowempty=true`"))
    end

    if extend === true
        xnm = T >: Missing ? skipmissing(x) : x
        length(breaks) >= 1 || throw(ArgumentError("at least one break must be provided"))
        local min_x, max_x
        try
            min_x, max_x = extrema(xnm)
        catch err
            if T >: Missing && all(ismissing, xnm)
                if length(breaks) < 2
                    throw(ArgumentError("could not extend breaks as all values are missing: " *
                                        "please specify at least two breaks manually"))
                else
                    min_x, max_x = missing, missing
                end
            else
                rethrow(err)
            end
        end
        if !ismissing(min_x) && isless(min_x, breaks[1])
            # this type annotation is needed on Julia<1.7 for stable inference
            breaks = [min_x::nonmissingtype(eltype(x)); breaks]
        end
        if !ismissing(max_x) && isless(breaks[end], max_x)
            breaks = [breaks; max_x::nonmissingtype(eltype(x))]
        end
        length(breaks) > 1 ||
            throw(ArgumentError("could not extend breaks as all values are equal: " *
                                "please specify at least two breaks manually"))
    end

    refs = Array{DefaultRefType, N}(undef, size(x))
    try
        fill_refs!(refs, x, breaks, extend)
    catch err
        # So that the error appears to come from cut() itself,
        # since it refers to its keyword arguments
        if isa(err, ArgumentError)
            throw(err)
        else
            rethrow(err)
        end
    end

    # Find minimal number of digits so that distinct breaks remain so
    if eltype(breaks) <: AbstractFloat
        while true
            local i
            for outer i in 2:lastindex(breaks)
                b1 = breaks[i-1]
                b2 = breaks[i]
                isequal(b1, b2) && continue

                @static if VERSION >= v"1.10"
                    b1_str = Printf.format(CUT_FMT, sigdigits, b1)
                    b2_str = Printf.format(CUT_FMT, sigdigits, b2)
                else
                    b1_str = Printf.format(Printf.Format("%.$(sigdigits)g"), b1)
                    b2_str = Printf.format(Printf.Format("%.$(sigdigits)g"), b2)
                end
                if b1_str == b2_str
                    sigdigits += 1
                    break
                end
            end
            i == lastindex(breaks) && break
        end
    end
    n = length(breaks)
    n >= 2 || throw(ArgumentError("at least two breaks must be provided when extend is not true"))
    if labels isa Function
        from = breaks[1:n-1]
        to = breaks[2:n]
        local firstlevel
        try
            firstlevel = labels(from[1], to[1], 1,
                                leftclosed=!isequal(breaks[1], breaks[2]), rightclosed=false,
                                sigdigits=sigdigits)
        catch
            # Support functions defined before v1.0, where sigdigits did not exist
            Base.depwarn("`labels` function is now required to accept a `sigdigits` keyword argument",
                         :cut)
            labels_orig = labels
            labels = (from, to, i; leftclosed, rightclosed, sigdigits) ->
                labels_orig(from, to, i; leftclosed, rightclosed)
            firstlevel = labels_orig(from[1], to[1], 1,
                                     leftclosed=!isequal(breaks[1], breaks[2]), rightclosed=false)
        end
        levs = Vector{typeof(firstlevel)}(undef, n-1)
        levs[1] = firstlevel
        for i in 2:n-2
            levs[i] = labels(from[i], to[i], i,
                             leftclosed=!isequal(breaks[i], breaks[i+1]), rightclosed=false,
                             sigdigits=sigdigits)
        end
        levs[end] = labels(from[end], to[end], n-1,
                           leftclosed=true, rightclosed=true,
                           sigdigits=sigdigits)
    else
        length(labels) == n-1 ||
            throw(ArgumentError("labels must be of length $(n-1), but got length $(length(labels))"))
        levs = copy(labels)
    end
    if !allunique(levs)
        if labels === default_formatter
            throw(ArgumentError("all labels must be unique, but `breaks` contains duplicates: " *
                                "specify custom `labels` with unique names"))
        else
            throw(ArgumentError("all labels must be unique"))
        end
    end

    pool = CategoricalPool(levs, true)
    S = T >: Missing || extend isa Missing ? Union{eltype(levs), Missing} : eltype(levs)
    CategoricalArray{S, N}(refs, pool)
end

"""
Find first value in (sorted) `v` which is greater than or equal to each quantile
in (sorted) `qs`.
"""
function find_breaks(v::AbstractVector, qs::AbstractVector)
    n = length(qs)
    breaks = similar(v, n)
    n == 0 && return breaks

    i = 1
    q = qs[1]
    @inbounds for x in v
        # Use isless and isequal to differentiate -0.0 from 0.0
        if isless(q, x) || isequal(q, x)
            breaks[i] = x
            i += 1
            i > n && break
            q = qs[i]
        end
    end
    return breaks
end

# AbstractWeights method is defined in StatsBase extension
# There is no in-place weighted quantile method in StatsBase
_wquantile(x::AbstractArray, w::AbstractVector, p::AbstractVector) =
    throw(ArgumentError("`weights` must be an `AbstractWeights` vector from StatsBase.jl"))

"""
    cut(x::AbstractArray, ngroups::Integer;
        labels::Union{AbstractVector{<:AbstractString},Function},
        sigdigits::Integer=3,
        allowempty::Bool=false,
        weights::Union{AbstractWeights, Nothing}=nothing)

Cut a numeric array into `ngroups` quantiles.

This is equivalent to `cut(x, quantile(x, (0:ngroups)/ngroups))`,
but breaks are taken from actual data values instead of estimated quantiles.

If `x` contains `missing` values, they are automatically skipped when computing
quantiles.

!!! note
    For floating point data, breaks may be rounded to `sigdigits` significant digits
    when generating interval labels, meaning that they may not reflect exactly the cutpoints
    used.

# Keyword arguments
* `labels::Union{AbstractVector, Function}`: a vector of strings, characters
  or numbers giving the names to use for the intervals; or a function
  `f(from, to, i::Integer; leftclosed::Bool, rightclosed::Bool, sigdigits::Integer)` that generates
  the labels from the left and right interval boundaries and the group index. Defaults to
  [`CategoricalArrays.default_formatter`](@ref), giving `"[from, to)"` (or `"[from, to]"`
  for the rightmost interval if `extend == true`) if `allowempty=false`, otherwise to
  [`CategoricalArrays.numbered_formatter`](@ref), which prefixes the label with the quantile
  number to ensure uniqueness.
* `sigdigits::Integer=3`: the minimum number of significant digits to use when rounding
  breaks for inclusion in generated labels. This value is increased automatically if necessary
  so that rounded breaks are unique. Only used for floating point types and when `labels` is a
  function, in which case it is passed to it as a keyword argument.
* `allowempty::Bool=false`: when `false`, an error is raised if some quantiles breakpoints
  other than the last one are equal, generating empty intervals;
  when `true`, duplicate breaks are allowed and the intervals they generate are kept as
  unused levels (but duplicate labels are not allowed).
* `weights::Union{AbstractWeights, Nothing}=nothing`: observations weights to used when
  computing quantiles (see `quantile` documentation in StatsBase).
"""
function cut(x::AbstractArray, ngroups::Integer;
             labels::Union{AbstractVector{<:SupportedTypes},Function,Nothing}=nothing,
             sigdigits::Integer=3,
             allowempty::Bool=false,
             weights::Union{AbstractVector, Nothing}=nothing)
    ngroups >= 1 || throw(ArgumentError("ngroups must be strictly positive (got $ngroups)"))
    if weights === nothing
        sorted_x = eltype(x) >: Missing ? sort!(collect(skipmissing(x))) : sort(x)
        min_x, max_x = first(sorted_x), last(sorted_x)
        if (min_x isa Number && isnan(min_x)) ||
            (max_x isa Number && isnan(max_x))
            throw(ArgumentError("NaN values are not allowed in input vector"))
        end
        qs = quantile!(sorted_x, (1:(ngroups-1))/ngroups, sorted=true)
    else
        if eltype(x) >: Missing
            nm_inds = findall(!ismissing, x)
            nm_x = view(x, nm_inds)
            # TODO: use a view once this is supported (JuliaStats/StatsBase.jl#723)
            nm_weights = weights[nm_inds]
        else
            nm_x = x
            nm_weights = weights
        end
        sorted_x = sort(nm_x)
        min_x, max_x = first(sorted_x), last(sorted_x)
        if (min_x isa Number && isnan(min_x)) ||
            (max_x isa Number && isnan(max_x))
            throw(ArgumentError("NaN values are not allowed in input vector"))
        end
        qs = _wquantile(nm_x, nm_weights, (1:(ngroups-1))/ngroups)
    end
    breaks = [min_x; find_breaks(sorted_x, qs); max_x]
    if !allowempty && !allunique(@view breaks[1:end-1])
        throw(ArgumentError("cannot compute $ngroups quantiles due to " *
                            "too many duplicated values in `x`. " *
                            "Pass `allowempty=true` to allow empty quantiles or " *
                            "choose a lower value for `ngroups`."))
    end
    if labels === nothing
        labels = allowempty ? numbered_formatter : default_formatter
    end
    return cut(x, breaks; labels=labels, sigdigits=sigdigits, allowempty=allowempty)
end

const DefaultRefType = UInt32
const SupportedTypes = Union{AbstractString, AbstractChar, Number}

## Pools

# Type params:
# * `T` type of categorized values
# * `R` integer type for referencing category levels
mutable struct CategoricalPool{T <: SupportedTypes, R <: Integer}
    levels::Vector{T}          # category levels ordered by their reference codes
    levelsinds::Vector{R}      # set to 1:length(levels), used by `levels(p)`
    invindex::Dict{T, R}       # map from category levels to their reference codes
    ordered::Bool              # whether levels can be compared using <
    hash::Union{UInt, Nothing} # hash of levels
    subsetof::Ptr{Nothing}     # last seen strict superset pool
    equalto::Ptr{Nothing}      # last seen equal pool

    function CategoricalPool{T, R}(levels::Vector{T},
                                   ordered::Bool) where {T, R}
        if length(levels) > typemax(R)
            throw(LevelsException{T, R}(levels[Int(typemax(R))+1:end]))
        end
        invindex = Dict{T, R}(v => i for (i, v) in enumerate(levels))
        if length(invindex) != length(levels)
            throw(ArgumentError("Duplicate entries are not allowed in levels"))
        end
        CategoricalPool{T, R}(levels, invindex, ordered)
    end
    function CategoricalPool{T, R}(invindex::Dict{T, R},
                                   ordered::Bool) where {T, R}
        levels = Vector{T}(undef, length(invindex))
        # If invindex contains non consecutive values, a BoundsError will be thrown
        try
            for (k, v) in invindex
                levels[v] = k
            end
        catch BoundsError
            throw(ArgumentError("Reference codes must be in 1:length(invindex)"))
        end
        if length(invindex) > typemax(R)
            throw(LevelsException{T, R}(levels[typemax(R)+1:end]))
        end
        CategoricalPool{T, R}(levels, invindex, ordered)
    end
    function CategoricalPool{T, R}(levels::Vector{T},
                                   invindex::Dict{T, R},
                                   ordered::Bool,
                                   hash::Union{UInt, Nothing}=nothing) where {T, R}
        return new(levels, 1:length(levels), invindex,
                   ordered, hash, C_NULL, C_NULL)
    end
end

struct LevelsException{T, R} <: Exception
    levels::Vector{T}
end

## Values

"""
    CategoricalValue{T <: $SupportedTypes, R <: Integer}

A wrapper around a value of type `T` corresponding to a level
in a `CategoricalPool`.

`CategoricalValue` objects are considered as equal to the value of type `T`
they wrap by `==` and `isequal`.
However, order comparisons like `<` and `isless` are only possible
if [`isordered`](@ref) is `true` for the value's pool, and in that case
the order of the pool's [`levels`](@ref DataAPI.levels) is used rather than the standard
ordering of values of type `T`.
"""
struct CategoricalValue{T <: SupportedTypes, R <: Integer}
    pool::CategoricalPool{T, R}
    ref::R
end

## Arrays

# Type params:
# * `T` original type of elements before categorization, could be Union{T, Missing}
# * `N` array dimension
# * `R` integer type for referencing category levels
# * `V` original type of elements (excluding Missing) before categorization
# * `C` categorical value type
# * `U` type of missing value, `Union{}` if missing values are not accepted
abstract type AbstractCategoricalArray{T <: Union{CategoricalValue, SupportedTypes, Missing}, N,
                                       R <: Integer, V, C <: CategoricalValue, U} <:
    AbstractArray{Union{C, U}, N} end
const AbstractCategoricalVector{T, R, V, C, U} = AbstractCategoricalArray{T, 1, R, V, C, U}
const AbstractCategoricalMatrix{T, R, V, C, U} = AbstractCategoricalArray{T, 2, R, V, C, U}

mutable struct CategoricalArray{T, N, R <: Integer, V, C, U} <: AbstractCategoricalArray{T, N, R, V, C, U}
    refs::Array{R, N}
    pool::CategoricalPool{V, R}

    function CategoricalArray{T, N}(refs::Array{R, N},
                                    pool::CategoricalPool{V, R}) where
                                                 {T, N, R <: Integer, V}
        T === V || T == Union{V, Missing} || throw(ArgumentError("T ($T) must be equal to $V or Union{$V, Missing}"))
        U = T >: Missing ? Missing : Union{}
        new{T, N, R, V, CategoricalValue{V, R}, U}(refs, pool)
    end
end
const CategoricalVector{T, R <: Integer, V, C, U} = CategoricalArray{T, 1, R, V, C, U}
const CategoricalMatrix{T, R <: Integer, V, C, U} = CategoricalArray{T, 2, R, V, C, U}

CatArrOrSub{T, N, R} = Union{CategoricalArray{T, N, R},
                             SubArray{<:Any, N, <:CategoricalArray{T, <:Any, R}}} where
                             {T, N, R<:Integer}

const ≅ = isequal

"""
    recode!(dest::AbstractArray, src::AbstractArray[, default::Any], pairs::Pair...)

Fill `dest` with elements from `src`, replacing those matching a key of `pairs`
with the corresponding value.

For each `Pair` in `pairs`, if the element is equal to (according to `isequal`))
the key (first item of the pair) or to one of its entries if it is a collection,
then the corresponding value (second item) is copied to `dest`.
If the element matches no key and `default` is not provided or `nothing`, it is copied as-is;
if `default` is specified, it is used in place of the original element.
`dest` and `src` must be of the same length, but not necessarily of the same type.
Elements of `src` as well as values from `pairs` will be `convert`ed when possible
on assignment.
If an element matches more than one key, the first match is used.

    recode!(dest::CategoricalArray, src::AbstractArray[, default::Any], pairs::Pair...)

If `dest` is a `CategoricalArray` then the ordering of resulting levels is determined
by the order of passed `pairs` and `default` will be the last level if provided.

    recode!(dest::AbstractArray, src::AbstractArray{>:Missing}[, default::Any], pairs::Pair...)

If `src` contains missing values, they are never replaced with `default`:
use `missing` in a pair to recode them.
"""
function recode! end

recode!(dest::AbstractArray, src::AbstractArray, pairs::Pair...) =
    recode!(dest, src, nothing, pairs...)
# To fix ambiguity
recode!(dest::CategoricalArray, src::AbstractArray, pairs::Pair...) =
    recode!(dest, src, nothing, pairs...)
recode!(dest::CategoricalArray, src::CategoricalArray, pairs::Pair...) =
    recode!(dest, src, nothing, pairs...)

"""
    recode_in(x, collection)

Helper function to test if `x` is a member of `collection`.

The default method is to test if any element in the `collection` `isequal` to
`x`. For `Set`s `in` is used as it is faster than the default method and equivalent to it.
A user defined type could override this method to define an appropriate test function.
"""
@inline recode_in(x, ::Missing) = false
@inline recode_in(x, collection::Set) = x in collection
@inline recode_in(x, collection) = any(x ≅ y for y in collection)

optimize_pair(pair::Pair) = pair
optimize_pair(pair::Pair{<:AbstractArray}) = Set(pair.first) => pair.second

function recode!(dest::AbstractArray, src::AbstractArray, default::Any, pairs::Pair...)
    if length(dest) != length(src)
        throw(DimensionMismatch("dest and src must be of the same length (got $(length(dest)) and $(length(src)))"))
    end

    opt_pairs = optimize_pair.(pairs)

    _recode!(dest, src, default, opt_pairs)
end

function _recode!(dest::AbstractArray{T}, src::AbstractArray, default,
                  pairs::NTuple{<:Any, Pair}) where {T}
    recode_to = last.(pairs)
    recode_from = first.(pairs)
    
    @inbounds for i in eachindex(dest, src)
        x = src[i]

        # @inline is needed for type stability and Compat for compatibility before julia v1.8
        # we use isequal and recode_in because we cannot really
        # distinguish scalars from collections
        j = Compat.@inline findfirst(y -> isequal(x, y) || recode_in(x,y), recode_from)
        
        # Value in one of the pairs
        if j !== nothing
            dest[i] = recode_to[j]
        # Value not in any of the pairs
        elseif ismissing(x)
            eltype(dest) >: Missing ||
                throw(MissingException("missing value found, but dest does not support them: " *
                                       "recode them to a supported value"))
            dest[i] = missing
        elseif default isa Nothing
            try
                dest[i] = x
            catch err
                isa(err, MethodError) || rethrow(err)
                throw(ArgumentError("cannot `convert` value $(repr(x)) (of type $(typeof(x))) to type of recoded levels ($T). " *
                                    "This will happen with recode() when not all original levels are recoded " *
                                    "(i.e. some are preserved) and their type is incompatible with that of recoded levels."))
            end
        else
            dest[i] = default
        end
    end

    dest
end

function _recode!(dest::CategoricalArray{T, <:Any, R}, src::AbstractArray, default::Any,
                  pairs::NTuple{<:Any, Pair}) where {T, R}
    recode_from = first.(pairs)
    vals = T[p.second for p in pairs]

    default !== nothing && push!(vals, default)

    levels!(dest.pool, filter!(!ismissing, unique(vals)))
    # In the absence of duplicated recoded values, we do not need to lookup the reference
    # for each pair in the loop, which is more efficient (with loop unswitching)
    dupvals = length(vals) != length(_levels(dest.pool))

    drefs = dest.refs
    pairmap = [ismissing(v) ? zero(R) : get(dest.pool, v) for v in vals]
    defaultref = default === nothing || ismissing(default) ? zero(R) : get(dest.pool, default)

    @inbounds for i in eachindex(drefs, src)
        x = src[i]

        # @inline is needed for type stability and Compat for compatibility before julia v1.8  
        # we use isequal and recode_in because we cannot really
        # distinguish scalars from collections
        j = Compat.@inline findfirst(y -> isequal(x, y) || recode_in(x, y), recode_from)

        # Value in one of the pairs
        if j !== nothing
            drefs[i] = dupvals ? pairmap[j] : j
        # Value not in any of the pairs
        elseif ismissing(x)
            eltype(dest) >: Missing ||
                throw(MissingException("missing value found, but dest does not support them: " *
                                       "recode them to a supported value"))
            drefs[i] = 0
        elseif default === nothing
            try
                dest[i] = x # Need a dictionary lookup, and potentially adding a new level
            catch err
                isa(err, MethodError) || rethrow(err)
                throw(ArgumentError("cannot `convert` value $(repr(x)) (of type $(typeof(x))) to type of recoded levels ($T). " *
                                    "This will happen with recode() when not all original levels are recoded "*
                                    "(i.e. some are preserved) and their type is incompatible with that of recoded levels."))
            end
        else
            drefs[i] = defaultref
        end
    end

    # Put existing levels first, and sort them if possible
    # for consistency with CategoricalArray
    oldlevels = setdiff(_levels(dest), vals)
    filter!(!ismissing, oldlevels)
    L = eltype(oldlevels)
    if Base.OrderStyle(L) isa Base.Ordered
        sort!(oldlevels)
    elseif hasmethod(isless, (L, L))
        # isless may throw an error, e.g. for AbstractArray{T} of unordered T
        try
            sort!(oldlevels)
        catch e
            e isa MethodError || rethrow(e)
        end
    end
    levels!(dest, union(oldlevels, _levels(dest)))

    dest
end

function _recode!(dest::CategoricalArray{T, N, R}, src::CategoricalArray,
                  default::Any, pairs::NTuple{<:Any, Pair}) where {T, N, R<:Integer}
    recode_from = first.(pairs)
    vals = T[p.second for p in pairs]
             
    if default === nothing
        srclevels = _levels(src)

        # Remove recoded levels as they won't appear in result
        keptlevels = Vector{T}(undef, 0)
        sizehint!(keptlevels, length(srclevels))

        for l in srclevels
            if !(any(x -> x ≅ l, recode_from) ||
                 any(f -> recode_in(l, f), recode_from))
                try
                    push!(keptlevels, l)
                catch err
                    isa(err, MethodError) || rethrow(err)
                    throw(ArgumentError("cannot `convert` value $(repr(l)) (of type $(typeof(l))) to type of recoded levels ($T). " *
                                        "This will happen with recode() when not all original levels are recoded " *
                                        "(i.e. some are preserved) and their type is incompatible with that of recoded levels."))
                end
            end
        end
        levs, ordered = mergelevels(isordered(src), keptlevels, filter!(!ismissing, unique(vals)))
    else
        push!(vals, default)
        levs = filter!(!ismissing, unique(vals))
        # The order of default cannot be determined
        ordered = false
    end

    srclevels = src.pool === dest.pool ? copy(_levels(src.pool)) : _levels(src.pool)
    if length(levs) > length(srclevels) && view(levs, 1:length(srclevels)) == srclevels
        levels!(dest.pool, levs)
    else
        dest.pool = CategoricalPool{nonmissingtype(T), R}(levs, isordered(dest))
    end

    drefs = dest.refs
    srefs = src.refs

    origmap = [get(dest.pool, v, 0) for v in srclevels]
    levelsmap = Vector{DefaultRefType}(undef, length(srclevels)+1)
    # For missing values (0 if no missing in pairs' keys)
    levelsmap[1] = 0
    for p in pairs
        if (ismissing(p.first) || any(ismissing, p.first))
            levelsmap[1] = get(dest.pool, p.second)
            break
        end
    end
    pairmap = [ismissing(p.second) ? 0 : get(dest.pool, p.second) for p in pairs]
    # Preserving ordered property only makes sense if new order is consistent with previous one
    ordered && (ordered = issorted(pairmap))
    ordered!(dest, ordered)
    defaultref = default === nothing || ismissing(default) ? 0 : get(dest.pool, default)
    @inbounds for (i, l) in enumerate(srclevels)
        for j in 1:length(pairs)
            p = pairs[j]
            if l ≅ p.first || recode_in(l, p.first)
                levelsmap[i+1] = pairmap[j]
                @goto nextitem
            end
        end

        # Value not in any of the pairs
        if default === nothing
            levelsmap[i+1] = origmap[i]
        else
            levelsmap[i+1] = defaultref
        end

        @label nextitem
    end

    @inbounds for i in eachindex(drefs)
        v = levelsmap[srefs[i]+1]
        if !(eltype(dest) >: Missing)
            v > 0 || throw(MissingException("missing value found, but dest does not support them: " *
                                            "recode them to a supported value"))
        end
        drefs[i] = v
    end

    dest
end

"""
    recode!(a::AbstractArray[, default::Any], pairs::Pair...)

Convenience function for in-place recoding, equivalent to `recode!(a, a, ...)`.

# Examples
```jldoctest
julia> using CategoricalArrays

julia> x = collect(1:10);

julia> recode!(x, 1=>100, 2:4=>0, [5; 9:10]=>-1);

julia> x
10-element Vector{Int64}:
 100
   0
   0
   0
  -1
   6
   7
   8
  -1
  -1
```
"""
recode!(a::AbstractArray, default::Any, pairs::Pair...) =
    recode!(a, a, default, pairs...)
recode!(a::AbstractArray, pairs::Pair...) = recode!(a, a, nothing, pairs...)

cat_promote_valuetype(x::Pair{K, V}) where {K, V} = V
cat_promote_valuetype(x::Pair{K, V}, y::Pair...) where {K, V} =
    cat_promote_type(V, cat_promote_valuetype(y...))

keytype_hasmissing(x::Pair{K}) where {K} = K === Missing
keytype_hasmissing(x::Pair{K}, y::Pair...) where {K} = K === Missing || keytype_hasmissing(y...)

"""
    recode(a::AbstractArray[, default::Any], pairs::Pair...)

Return a copy of `a`, replacing elements matching a key of `pairs` with the corresponding value.
The type of the array is chosen so that it can
hold all recoded elements (but not necessarily original elements from `a`).

For each `Pair` in `pairs`, if the element is equal to (according to `isequal`)
or `in` the key (first item of the pair), then the corresponding value
(second item) is used.
If the element matches no key and `default` is not provided or `nothing`, it is copied as-is;
if `default` is specified, it is used in place of the original element.
If an element matches more than one key, the first match is used.

    recode(a::CategoricalArray[, default::Any], pairs::Pair...)

If `a` is a `CategoricalArray` then the ordering of resulting levels is determined
by the order of passed `pairs` and `default` will be the last level if provided.

# Examples
```jldoctest
julia> using CategoricalArrays

julia> recode(1:10, 1=>100, 2:4=>0, [5; 9:10]=>-1)
10-element Vector{Int64}:
 100
   0
   0
   0
  -1
   6
   7
   8
  -1
  -1

```

     recode(a::AbstractArray{>:Missing}[, default::Any], pairs::Pair...)

If `a` contains missing values, they are never replaced with `default`:
use `missing` in a pair to recode them. If that's not the case, the returned array
will accept missing values.

# Examples
```jldoctest
julia> using CategoricalArrays

julia> recode(1:10, 1=>100, 2:4=>0, [5; 9:10]=>-1, 6=>missing)
10-element Vector{Union{Missing, Int64}}:
 100
   0
   0
   0
  -1
    missing
   7
   8
  -1
  -1    

```
"""
function recode end

recode(a::AbstractArray, pairs::Pair...) = recode(a, nothing, pairs...)
# To fix ambiguity
recode(a::CategoricalArray, pairs::Pair...) = recode(a, nothing, pairs...)

function recode(a::AbstractArray, default::Any, pairs::Pair...)
    V = cat_promote_valuetype(pairs...)
    # T cannot take into account eltype(src), since we can't know
    # whether it matters at compile time (all levels recoded or not)
    # and using a wider type than necessary would be annoying
    T = default isa Nothing ? V : cat_promote_type(typeof(default), V)
    # Exception 1: if T === Missing and default not missing,
    # assume the caller wants to recode only some values to missing,
    # but accept original values
    if T === Missing && !isa(default, Missing)
        dest = Array{Union{eltype(a), Missing}}(undef, size(a))
    # Exception 2: if original array accepted missing values and missing does not appear
    # in one of the pairs' LHS, result must accept missing values
    elseif T >: Missing || default isa Missing || (eltype(a) >: Missing && !keytype_hasmissing(pairs...))
        dest = Array{Union{T, Missing}}(undef, size(a))
    else
        dest = Array{nonmissingtype(T)}(undef, size(a))
    end
    recode!(dest, a, default, pairs...)
end

function recode(a::CategoricalArray{S, N, R}, default::Any, pairs::Pair...) where {S, N, R}
    V = cat_promote_valuetype(pairs...)
    # T cannot take into account eltype(src), since we can't know
    # whether it matters at compile time (all levels recoded or not)
    # and using a wider type than necessary would be annoying
    T = default isa Nothing ? V : cat_promote_type(typeof(default), V)
    # Exception 1: if T === Missing and default not missing,
    # assume the caller wants to recode only some values to missing,
    # but accept original values
    # Example: recode(categorical([0,1]), 0=>missing)
    if T === Missing && !isa(default, Missing)
        dest = CategoricalArray{Union{S, Missing}, N, R}(undef, size(a))
    # Exception 2: if original array accepted missing values and missing does
    # not appear in one of the pairs' LHS, result must accept missing values
    # Example: recode(categorical([missing,1]), 1=>0)
    elseif T >: Missing || default isa Missing || (eltype(a) >: Missing && !keytype_hasmissing(pairs...))
        dest = CategoricalArray{Union{T, Missing}, N, R}(undef, size(a))
    else
        dest = CategoricalArray{nonmissingtype(T), N, R}(undef, size(a))
    end
    recode!(dest, a, default, pairs...)
end

function Base.replace(a::CategoricalArray{S, N, R}, pairs::Pair...) where {S, N, R}
    # Base.replace(a::Array, pairs::Pair...) uses a wider type promotion than
    # recode. It promotes the source type S with the replaced types T.
    T = cat_promote_valuetype(pairs...)
    # Exception: replacing missings
    # Example: replace(categorical([missing,1.5]), missing=>0)
    if keytype_hasmissing(pairs...)
        dest = CategoricalArray{cat_promote_type(nonmissingtype(S), T), N, R}(undef, size(a))
    else
        dest = CategoricalArray{cat_promote_type(S, T), N, R}(undef, size(a))
    end
    recode!(dest, a, nothing, pairs...)
end

if VERSION >= v"0.7.0-"
    Base.replace!(a::CategoricalArray, pairs::Pair...) = recode!(a, pairs...)
else
    replace!(a::CategoricalArray, pairs::Pair...) = recode!(a, pairs...)
end

module TestArrayCommon
using Test
using Missings
using Future: copy!
using CategoricalArrays, DataAPI
using CategoricalArrays: DefaultRefType, pool
using PooledArrays
using JSON3
using StructTypes
using RecipesBase
using RecipesPipeline
using SentinelArrays
using Arrow
using Missings

const ≅ = isequal
const ≇ = !isequal

@testset "mergelevels()" begin
    # Test that mergelevels handles mutually compatible orderings
    @test CategoricalArrays.mergelevels(true, [6, 2, 4, 8], [2, 3, 5, 4], [2, 4, 8]) ==
        ([6, 2, 3, 5, 4, 8], true)
    @test CategoricalArrays.mergelevels(true, ["A", "B", "D"], ["C", "D", "E", "F"], ["B", "C", "E"]) ==
        (["A", "B", "C", "D", "E", "F"], true)
    @test CategoricalArrays.mergelevels(true, ["A", "B", "D"], ["C", "D", "E", "F"], ["A", "B", "C", "F"]) ==
        (["A", "B", "C", "D", "E", "F"], true)
    @test CategoricalArrays.mergelevels(true, ["B", "C", "D"], ["A", "B"]) ==
        (["A", "B", "C", "D"], true)
    @test CategoricalArrays.mergelevels(true, ["B", "C", "D"], []) ==
        (["B", "C", "D"], true)
    @test CategoricalArrays.mergelevels(true, [], ["A", "C"]) ==
        (["A", "C"], true)
    @test CategoricalArrays.mergelevels(true, [], []) ==
        ([], true)
    @test CategoricalArrays.mergelevels(true, ["A", "B", "C"], [], ["A", "C", "D"]) ==
        (["A", "B", "C", "D"], true)
    @test CategoricalArrays.mergelevels(true, [], ["A", "B", "C"], ["A", "C", "D"]) ==
        (["A", "B", "C", "D"], true)
    @test CategoricalArrays.mergelevels(true, ["A", "C", "D"], ["A", "B", "C"], []) ==
        (["A", "B", "C", "D"], true)
    @test CategoricalArrays.mergelevels(true, [], ["A", "C", "D"], []) ==
        (["A", "C", "D"], true)
    @test CategoricalArrays.mergelevels(true, ["A", "C", "D"], [], []) ==
        (["A", "C", "D"], true)
    @test CategoricalArrays.mergelevels(true, [], [], ["A", "C", "D"]) ==
        (["A", "C", "D"], true)
    @test CategoricalArrays.mergelevels(true, [], [], []) ==
        ([], true)
    @test CategoricalArrays.mergelevels(true, ["A", "C", "D"], ["A", "B", "C"], ["A", "D", "E"], ["C", "D"]) ==
        (["A", "B", "C", "D", "E"], true)

    # Test that mergelevels handles mutually incompatible orderings
    # by giving priority to first sets of levels
    @test CategoricalArrays.mergelevels(true, [6, 3, 4, 7], [2, 3, 6, 5, 4], [2, 4, 8]) ==
        ([2, 6, 3, 5, 4, 7, 8], false)
    @test CategoricalArrays.mergelevels(true, ["A", "C", "D"], ["D", "C"], []) ==
        (["A", "C", "D"], false)
    @test CategoricalArrays.mergelevels(true, ["A", "D", "C"], ["A", "B", "C"], ["A", "D", "E"], ["C", "D"]) ==
        (["A", "B", "D", "C", "E"], false)

    # Test that mergelevels handles incomplete orderings
    @test CategoricalArrays.mergelevels(true, ["B", "C", "D"], ["A", "C"]) ==
        (["B", "A", "C", "D"], false)
    @test CategoricalArrays.mergelevels(true, ["A", "B", "D"], ["C", "D", "E", "F"]) ==
        (["A", "B", "C", "D", "E", "F"], false)
    @test CategoricalArrays.mergelevels(true, ["A", "B", "E", "G"], ["C", "D", "E", "F"]) ==
        (["A", "B", "C", "D", "E", "G", "F"], false)
    @test CategoricalArrays.mergelevels(true, ["A", "B", "D"], ["C", "D", "E", "F"], ["A", "B", "D", "F"]) ==
        (["A", "B", "C", "D", "E", "F"], false)

    # Test with ordered=false (simpler, almost a subset of code paths tested above)
    @test CategoricalArrays.mergelevels(false, ["A", "B", "E", "G"], ["C", "D", "E", "F"]) ==
        (["A", "B", "C", "D", "E", "G", "F"], false)
end

@testset "Testing $T" for T in (Union{}, Missing)
    @testset "vcat()" begin
        # Test that vcat of compress arrays uses a reftype that doesn't overflow
        a1 = 3:200
        a2 = 300:-1:100
        ca1 = CategoricalArray{Union{T, Int}}(a1)
        ca2 = CategoricalArray{Union{T, Int}}(a2)
        cca1 = compress(ca1)
        cca2 = compress(ca2)
        r = vcat(cca1, cca2)
        @test r == vcat(a1, a2)
        @test isa(cca1, CategoricalArray{Union{T, Int}, 1, UInt8})
        @test isa(cca2, CategoricalArray{Union{T, Int}, 1, UInt8})
        @test isa(r, CategoricalArray{Union{T, Int}, 1, CategoricalArrays.DefaultRefType})
        @test isa(vcat(cca1, ca2), CategoricalArray{Union{T, Int}, 1, CategoricalArrays.DefaultRefType})
        @test isordered(r) == false
        @test levels(r) == collect(3:300)

        # Test vcat of multidimensional arrays
        a1 = Array{Int}(undef, 2, 3, 4, 5)
        a2 = Array{Int}(undef, 3, 3, 4, 5)
        a1[1:end] = (length(a1):-1:1) .+ 2
        a2[1:end] = (1:length(a2)) .+ 10
        ca1 = CategoricalArray{Union{T, Int}}(a1)
        ca2 = CategoricalArray{Union{T, Int}}(a2)
        cca1 = compress(ca1)
        cca2 = compress(ca2)
        r = vcat(cca1, cca2)
        @test r == vcat(a1, a2)
        @test isa(r, CategoricalArray{Union{T, Int}, 4, CategoricalArrays.DefaultRefType})
        @test isordered(r) == false
        @test levels(r) == collect(3:length(a2)+10)

        # Test concatenation of mutually compatible levels
        a1 = ["Young", "Middle"]
        a2 = ["Middle", "Old"]
        ca1 = CategoricalArray{Union{T, String}}(a1, ordered=true)
        ca2 = CategoricalArray{Union{T, String}}(a2, ordered=true)
        @test levels!(ca1, ["Young", "Middle"]) === ca1
        @test levels!(ca2, ["Middle", "Old"]) === ca2
        r = vcat(ca1, ca2)
        @test r == vcat(a1, a2)
        @test levels(r) == ["Young", "Middle", "Old"]
        @test isordered(r) == true

        # Test concatenation of conflicting ordering. This drops the ordering
        a1 = ["Old", "Young", "Young"]
        a2 = ["Old", "Young", "Middle", "Young"]
        ca1 = CategoricalArray{Union{T, String}}(a1, ordered=true)
        ca2 = CategoricalArray{Union{T, String}}(a2, ordered=true)
        levels!(ca1, ["Young", "Middle", "Old"])
        # ca2 has another order
        r = vcat(ca1, ca2)
        @test r == vcat(a1, a2)
        @test levels(r) == ["Young", "Middle", "Old"]
        @test isordered(r) == false
    end

    @testset "undef constructors preserve reftype" begin
        x = CategoricalArray{Union{T, CategoricalValue{Int, UInt8}}}(undef, 3)
        @test x isa CategoricalArray{Union{T, Int}, 1, UInt8}

        x = CategoricalArray{Union{T, CategoricalValue{Int, UInt8}}, 1}(undef, 3)
        @test x isa CategoricalArray{Union{T, Int}, 1, UInt8}
    end

    @testset "similar()" begin
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        y = similar(x)
        @test typeof(x) === typeof(y)
        @test size(y) == size(x)
        if T === Missing
            @test all(ismissing, y)
        else
            @test !any(isassigned(y, i) for i in 1:length(y))
        end

        y = similar(x, 3)
        @test typeof(x) === typeof(y)
        @test size(y) == (3,)
        if T === Missing
            @test all(ismissing, y)
        else
            @test !any(isassigned(y, i) for i in 1:length(y))
        end

        y = similar(x, Int)
        @test isa(y, Vector{Int})
        @test size(y) == size(x)

        y = similar(x, Int, 3, 2)
        @test isa(y, Matrix{Int})
        @test size(y) == (3, 2)

        x = CategoricalArray{Union{T, String}, 1, UInt8}(["Old", "Young", "Middle", "Young"])
        y = similar(x, Union{T, CategoricalValue{String}})
        @test typeof(x) === typeof(y)
        @test size(y) == size(x)
        T === Missing && @test all(ismissing, y)

        y = similar(x, Union{T, CategoricalValue{String, UInt32}})
        @test isa(y, CategoricalVector{Union{T, String}, UInt32})
        @test size(y) == size(x)
        T === Missing && @test all(ismissing, y)

        y = similar(x, Union{Missing, CategoricalValue{String}}, 3, 2)
        @test isa(y, CategoricalMatrix{Union{String, Missing}, UInt8})
        @test size(y) == (3, 2)
        @test all(ismissing, y)

        y = similar(x, CategoricalValue{String})
        @test isa(y, CategoricalVector{String, UInt8})
        @test size(y) == size(x)
        @test !any(isassigned(y, i) for i in 1:length(y))

        y = similar(x, CategoricalValue{String, UInt32})
        @test isa(y, CategoricalVector{String, UInt32})
        @test size(y) == size(x)
        @test !any(isassigned(y, i) for i in 1:length(y))

        y = similar(x, CategoricalValue{Int, UInt32})
        @test isa(y, CategoricalVector{Int, UInt32})
        @test size(y) == size(x)

        y = similar([], Union{CategoricalValue{Int}, T}, (3,))
        @test isa(y, CategoricalVector{Union{Int, T}, UInt32})
        @test size(y) == (3,)

        y = similar([], Union{CategoricalValue{String}, T}, (3,))
        @test isa(y, CategoricalVector{Union{String, T}, UInt32})
        @test size(y) == (3,)

        y = similar([], Union{CategoricalValue{Int, UInt8}, T}, (3,))
        @test isa(y, CategoricalVector{Union{Int, T}, UInt8})
        @test size(y) == (3,)

        y = similar([], Union{CategoricalValue{String, UInt8}, T}, (3,))
        @test isa(y, CategoricalVector{Union{String, T}, UInt8})
        @test size(y) == (3,)

        y = similar(Vector{Union{CategoricalValue{Int}, T}}, (3,))
        @test isa(y, CategoricalVector{Union{Int, T}, UInt32})
        @test size(y) == (3,)

        y = similar(Vector{Union{CategoricalValue{String}, T}}, (3,))
        @test isa(y, CategoricalVector{Union{String, T}, UInt32})
        @test size(y) == (3,)

        y = similar(Vector{Union{CategoricalValue{Int, UInt8}, T}}, (3,))
        @test isa(y, CategoricalVector{Union{Int, T}, UInt8})
        @test size(y) == (3,)

        y = similar(Vector{Union{CategoricalValue{String, UInt8}, T}}, (3,))
        @test isa(y, CategoricalVector{Union{String, T}, UInt8})
        @test size(y) == (3,)

        y = similar(Vector{T}, (3,))
        @test isa(y, Vector{T})
        @test size(y) == (3,)

        y = similar(1:1, Union{CategoricalValue{String, UInt8}, T})
        @test isa(y, CategoricalVector{Union{String, T}, UInt8})
        @test size(y) == (1,)

        y = similar(1:1, Union{CategoricalValue{String, UInt8}, T}, (3,))
        @test isa(y, CategoricalVector{Union{String, T}, UInt8})
        @test size(y) == (3,)
    end

    @testset "copy" begin
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        levels!(x, ["Young", "Middle", "Old"])
        ordered!(x, true)

        y = copy(x)
        @test y == x
        levels!(y, ["Z", "Middle", "Old", "Young"])
        y[1] = "Z"
        @test x == ["Old", "Young", "Middle", "Young"]
        @test levels(x) == ["Young", "Middle", "Old"]

        # Test with missing values
        if T === Missing
            x[3] = missing
            @test copy(x) ≅ x
        end
    end

    @testset "copy! and copyto!" for ordered in (false, true)
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        levels!(x, ["Young", "Middle", "Old"])
        ordered!(x, ordered)
        y = CategoricalArray{Union{T, String}}(["X", "Z", "Y", "X"])

        for copyf! in (copy!, copyto!)
            x2 = copy(x)
            @test copyf!(x2, y) === x2
            @test x2 == y
            @test levels(x2) == ["Young", "Middle", "Old", "X", "Y", "Z"]
            @test !isordered(x2)
        end

        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        levels!(x, ["Young", "Middle", "Old"])
        ordered!(x, ordered)
        x2 = copy(x)
        y = CategoricalArray{Union{T, String}}(["X", "Z", "Y", "X"])
        a = Union{String, Missing}["Z", "Y", "X", "Young"]
        # Test with missing values
        if T === Missing
            x[3] = x2[3] = missing
            y[3] = a[2] = missing
        end
        @test copyto!(x2, 1, y, 2) === x2
        @test x2 ≅ a
        @test levels(x2) == ["Young", "Middle", "Old", "X", "Y", "Z"]
        @test !isordered(x2)

        @testset "0-length copy!/copyto!" begin
            # 0-length copy!/copyto! does nothing (including bounds checks) except setting levels
            u = x[1:0]
            v = y[1:0]

            x2 = copy(x)
            @test copyto!(x2, 1, y, 3, 0) === x2
            @test levels(x2) == ["Young", "Middle", "Old", "X", "Y", "Z"]
            @test !isordered(x2)
            @test x2 ≅ x

            x2 = copy(x)
            @test copyto!(x2, 1, y, 5, 0) === x2
            @test levels(x2) == ["Young", "Middle", "Old", "X", "Y", "Z"]
            @test !isordered(x2)
            @test x2 ≅ x

            u2 = copy(u)
            @test copyto!(u2, -5, v, 2, 0) === u2
            @test levels(u2) == ["Young", "Middle", "Old", "X", "Y", "Z"]
            @test !isordered(x2)
            @test isempty(u2)

            x2 = copy(x)
            @test copyto!(x2, -5, v, 2, 0) === x2
            @test levels(x2) == ["Young", "Middle", "Old", "X", "Y", "Z"]
            @test !isordered(x2)
            @test x2 ≅ x

            u2 = copy(u)
            @test copyto!(u2, v) === u2
            @test levels(u2) == ["Young", "Middle", "Old", "X", "Y", "Z"]
            @test !isordered(x2)
            @test isempty(u2)

            x2 = copy(x)
            @test copyto!(x2, v) === x2
            @test levels(x2) == ["Young", "Middle", "Old", "X", "Y", "Z"]
            @test !isordered(x2)
            @test x2 ≅ x

            u2 = copy(u)
            @test copy!(u2, v) === u2
            @test levels(u2) == ["Young", "Middle", "Old", "X", "Y", "Z"]
            @test !isordered(x2)
            @test isempty(u2)

            x2 = copy(x)
            @test copy!(x2, v) === x2
            @test levels(x2) == ["Young", "Middle", "Old", "X", "Y", "Z"]
            @test !isordered(x2)
            @test x2 ≅ x

            # test with zero-levels source
            x2 = copy(x)
            @test copy!(x2, categorical(String[])) === x2
            @test levels(x2) == ["Young", "Middle", "Old"]
            @test isordered(x2) === ordered
            @test x2 ≅ x

            # test with zero-levels destination
            for ordered2 in (true, false)
                x2 = CategoricalArray{String}(undef, 2, ordered=ordered2)
                @test copy!(x2, u) === x2
                @test levels(x2) == ["Young", "Middle", "Old"]
                @test isordered(x2) === ordered
                @test length(x2) == 2
                @test !any(isassigned(x2, i) for i in eachindex(x2))
            end

            # test with zero-levels source and destination
            for ordered2 in (true, false)
                x2 = CategoricalArray{String}(undef, 2, ordered=ordered2)
                @test copy!(x2, categorical(String[], ordered=ordered)) === x2
                @test isempty(levels(x2))
                @test isordered(x2) === ordered2
                @test length(x2) == 2
                @test !any(isassigned(x2, i) for i in eachindex(x2))
            end
        end

        @testset "nonzero-length copy!/copyto! into/from empty array throws bounds error" begin
            u = x[1:0]
            v = y[1:0]
            x2 = copy(x)

            @test_throws BoundsError copy!(u, x)
            @test u ≅ v
            @test_throws BoundsError copyto!(u, x)
            @test u ≅ v
            @test_throws BoundsError copyto!(u, 1, v, 1, 1)
            @test u ≅ v
            @test_throws BoundsError copyto!(x2, 1, v, 1, 1)
            @test x2 ≅ x
        end

        @testset "no corruption happens in case of bounds error" begin
            @test_throws BoundsError copyto!(x2, 10, y, 2)
            @test x2 ≅ x
            @test_throws BoundsError copyto!(x2, 1, y, 10)
            @test x2 ≅ x
            @test_throws BoundsError copyto!(x2, 10, y, 20)
            @test x2 ≅ x
            @test_throws BoundsError copyto!(x2, 10, y, 2)
            @test x2 ≅ x
            @test_throws BoundsError copyto!(x2, 1, y, 2, 10)
            @test x2 ≅ x
            @test_throws BoundsError copyto!(x2, 4, y, 1, 2)
            @test x2 ≅ x
            @test_throws BoundsError copyto!(x2, 1, y, 4, 2)
            @test x2 ≅ x
        end
    end

    @testset "$copyf!" for copyf! in (copy!, copyto!)
        @testset "copy src not supporting missings into dest not supporting missings" begin
            v = ["a", "b", "c"]
            src = levels!(CategoricalVector(v), reverse(v))
            dest = CategoricalVector{String}(undef, 3)
            copyf!(dest, src)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)
        end

        @testset "copy src supporting missings into dest not supporting missings" begin
            v = ["a", "b", "c"]
            src = levels!(CategoricalVector{Union{Missing, String}}(v), reverse(v))
            dest = CategoricalVector{String}(undef, 3)
            copyf!(dest, src)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)
        end

        @testset "copy src not supporting missings into dest supporting missings" begin
            v = ["a", "b", "c"]
            src = levels!(CategoricalVector(v), reverse(v))
            dest = CategoricalVector{Union{String, Missing}}(undef, 3)
            copyf!(dest, src)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)
        end

        @testset "copy src supporting missings into dest supporting missings" begin
            v = ["a", "b", "c"]
            src = levels!(CategoricalVector{Union{String, Missing}}(v), reverse(v))
            dest = CategoricalVector{Union{String, Missing}}(undef, 3)
            copyf!(dest, src)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)
        end

        @testset "copy viewed src not supporting missings into dest not supporting missings" begin
            v = ["a", "b", "c"]
            src = levels!(CategoricalVector(v), reverse(v))
            vsrc = view(src, 1:length(src))
            dest = CategoricalVector{String}(undef, 3)
            copyf!(dest, vsrc)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)
        end

        @testset "copy viewed src supporting missings into dest not supporting missings" begin
            v = ["a", "b", "c"]
            src = levels!(CategoricalVector{Union{String, Missing}}(v), reverse(v))
            vsrc = view(src, 1:length(src))
            dest = CategoricalVector{String}(undef, 3)
            copyf!(dest, vsrc)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)
        end

        @testset "copy viewed src not supporting missings into dest supporting missings" begin
            v = ["a", "b", "c"]
            src = levels!(CategoricalVector(v), reverse(v))
            vsrc = view(src, 1:length(src))
            dest = CategoricalVector{Union{String, Missing}}(undef, 3)
            copyf!(dest, vsrc)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)
        end

        @testset "copy viewed src supporting missings into dest supporting missings" begin
            v = ["a", "b", "c"]
            src = levels!(CategoricalVector{Union{String, Missing}}(v), reverse(v))
            vsrc = view(src, 1:length(src))
            dest = CategoricalVector{Union{String, Missing}}(undef, 3)
            copyf!(dest, vsrc)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)
        end

        @testset "copy a viewed subset of src into dest" begin
            v = ["a", "b", "c"]
            src = levels!(CategoricalVector(v), reverse(v))
            vsrc = view(src, 1:2)
            dest = CategoricalVector{String}(undef, 3)
            copyf!(dest, vsrc)
            @test dest[1:2] == src[1:2]
            @test levels(dest) == levels(src)

            vsrc = view(src, 1:2)
            dest = CategoricalVector{String}(undef, 2)
            copyf!(dest, vsrc)
            @test dest == src[1:2]
            @test levels(dest) == levels(src)
        end

        @testset "copy a src into viewed dest" begin
            v = ["a", "b"]
            src = levels!(CategoricalVector(v), reverse(v))
            dest = CategoricalVector{String}(["e", "f", "g"])
            vdest = view(dest, 1:2)
            copyf!(vdest, src)
            @test dest[1:2] == src[1:2]
            @test levels(dest) == levels(vdest) == ["e", "f", "g", "b", "a"]

            dest = CategoricalVector{String}(["e", "f"])
            vdest = view(dest, 1:2)
            copyf!(vdest, src)
            @test vdest == src[1:2]
            @test levels(dest) == levels(vdest) == ["e", "f", "b", "a"]

            # Destination without any levels should be marked as ordered
            src = levels!(CategoricalVector(v, ordered=true), reverse(v))
            dest = CategoricalVector{Union{String,Missing}}([missing, missing])
            vdest = view(dest, 1:2)
            copyf!(vdest, src)
            @test dest ≅ src
            @test levels(vdest) == levels(dest)
            @test isordered(dest)
        end

        @testset "copy a src into viewed dest and breaking orderedness" begin
            v = ["a", "b"]
            src = levels!(CategoricalVector(v), reverse(v))
            dest = CategoricalVector{String}(["e", "f", "g"], ordered=true)
            vdest = view(dest, 1:2)
            copyf!(vdest, src)
            @test dest[1:2] == ["a", "b"]
            @test levels(dest) == levels(vdest) == ["e", "f", "g", "b", "a"]
            @test !isordered(dest) && !isordered(vdest)

            dest = CategoricalVector{String}(["e", "f"], ordered=true)
            vdest = view(dest, 1:2)
            copyf!(vdest, src)
            @test dest == ["a", "b"]
            @test levels(dest) == levels(vdest) == ["e", "f", "b", "a"]
            @test !isordered(dest) && !isordered(vdest)
        end

        @testset "viable mixed src and dest types" begin
            v = ["a", "b", "c"]
            src = CategoricalVector{Union{eltype(v), Missing}}(v)
            levels!(src, reverse(v))
            dest = CategoricalVector{String}(undef, 3)
            copyf!(dest, src)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)

            vsrc = view(src, 1:length(src))
            copyf!(dest, vsrc)
            @test dest == vsrc
            @test levels(dest) == levels(vsrc) == reverse(v)

            src = CategoricalVector{AbstractString}(v)
            levels!(src, reverse(v))
            dest = CategoricalVector{String}(undef, 3)
            copyf!(dest, src)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)

            src = CategoricalVector{String}(v)
            levels!(src, reverse(v))
            dest = CategoricalVector{AbstractString}(undef, 3)
            copyf!(dest, src)
            @test dest == src
            @test levels(dest) == levels(src) == reverse(v)
        end

        @testset "inviable mixed src and dest types" begin
            v = ["a", "b", missing]
            src = CategoricalVector(v)
            dest = CategoricalVector{String}(undef, 3)
            @test_throws MissingException copyf!(dest, src)

            vsrc = view(src, 1:length(src))
            @test_throws MissingException copyf!(dest, vsrc)

            v = Integer[-1, -2, -3]
            src = CategoricalVector(v)
            dest = CategoricalVector{UInt}(undef, 3)
            @test_throws InexactError copyf!(dest, src)
        end

        @testset "partial copyto! between arrays with identical levels" begin
            v = ["a", "b", "c"]
            src = CategoricalVector{Union{eltype(v), Missing}}(v)
            levels!(src, reverse(v))
            dest = CategoricalVector{Union{eltype(v), Missing}}(fill(missing, 6))
            levels!(dest, levels(src))
            copyto!(dest, 3, src)
            @test dest ≅ [missing, missing, "a", "b", "c", missing]
            @test levels(dest) == levels(src) == reverse(v)
            copyto!(dest, 3, src, 2, 1)
            @test dest ≅ [missing, missing, "b", "b", "c", missing]
            @test levels(dest) == levels(src) == reverse(v)
        end
    end

    @testset "assigning into array with empty levels uses orderedness of source" begin
        # destination is marked as ordered when source is ordered
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        levels!(x, ["Young", "Middle", "Old"])
        ordered!(x, true)

        for copyf! in (copyto!, copy!)
            y = CategoricalArray{Union{T, String}}(undef, 4)
            copyf!(y, x)
            @test isordered(y)
            @test levels(y) == levels(x)
            if T >: Missing
                y = CategoricalArray{Union{T, String}}(fill(missing, 4))
                copyf!(y, x)
                @test isordered(y)
                @test levels(y) == levels(x)
            end
        end

        y = CategoricalArray{Union{T, String}}(undef, 4)
        y[1] = x[1]
        @test isordered(y)
        @test levels(y) == levels(x)
        if T >: Missing
            y = CategoricalArray{Union{T, String}}(fill(missing, 4))
            y[1] = x[1]
            @test isordered(y)
            @test levels(y) == levels(x)
        end

        # destination is marked as unordered when source is unordered
        ordered!(x, false)

        for copyf! in (copyto!, copy!)
            y = CategoricalArray{Union{T, String}}(undef, 4)
            ordered!(y, true)
            copyf!(y, x)
            @test !isordered(y)
            @test levels(y) == levels(x)
            if T >: Missing
                y = CategoricalArray{Union{T, String}}(fill(missing, 4))
                ordered!(y, true)
                copyf!(y, x)
                @test !isordered(y)
                @test levels(y) == levels(x)
            end
        end

        y = CategoricalArray{Union{T, String}}(undef, 4)
        y[1] = x[1]
        @test !isordered(y)
        @test levels(y) == levels(x)
        if T >: Missing
            y = CategoricalArray{Union{T, String}}(fill(missing, 4))
            y[1] = x[1]
            @test !isordered(y)
            @test levels(y) == levels(x)
        end
    end

    @testset "resize!()" begin
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        @test resize!(x, 3) === x
        @test x == ["Old", "Young", "Middle"]
        @test resize!(x, 4) === x
        if T === Missing
            @test x ≅ ["Old", "Young", "Middle", missing]
        else
            @test x[1:3] == ["Old", "Young", "Middle"]
            @test !isassigned(x, 4)
        end
    end

    @testset "$copyf! and conflicting orders sstart=$sstart dstart=$dstart n=$n" for
        (sstart, dstart, n) in ((1, 1, 4), (1, 2, 3)),
        copyf! in (copy!, copyto!)
        # Conflicting orders: check that the destination wins and that result is not ordered
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        levels!(x, ["Young", "Middle", "Old"])
        ordered!(x, true)
        y = CategoricalArray{Union{T, String}}(["Middle", "Middle", "Old", "Young"])
        levels!(y, ["Old", "Middle", "Young"])
        ordered!(x, true)
        @test copyf!(x, y) === x
        @test x == y
        @test levels(x) == ["Young", "Middle", "Old"]
        @test !isordered(x)

        # Destination ordered, but not origin: check that destination wins
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        levels!(x, ["Young", "Middle", "Old"])
        ordered!(x, true)
        y = CategoricalArray{Union{T, String}}(["Middle", "Middle", "Old", "Young"])
        levels!(y, ["Young", "Middle", "Old"])
        @test copyf!(x, y) === x
        @test x == y
        @test levels(x) == ["Young", "Middle", "Old"]
        @test isordered(x)

        # Origin ordered, but not destination: check that destination wins
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        levels!(x, ["Young", "Middle", "Old"])
        y = CategoricalArray{Union{T, String}}(["Middle", "Middle", "Old", "Young"])
        ordered!(y, true)
        levels!(y, ["Young", "Middle", "Old"])
        @test copyf!(x, y) === x
        @test x == y
        @test levels(x) == ["Young", "Middle", "Old"]
        @test !isordered(x)

        # Origin ordered, destination ordered with no levels: check that result is ordered
        y = CategoricalArray{Union{T, String}}(["Middle", "Middle", "Old", "Young"])
        ordered!(y, true)
        levels!(y, ["Young", "Middle", "Old"])
        x = similar(x)
        ordered!(x, true)
        @test copyf!(x, y) === x
        @test x == y
        @test levels(x) == ["Young", "Middle", "Old"]
        @test isordered(x)

        # Destination ordered, but not origin, and new levels: check that result is unordered
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        levels!(x, ["Young", "Middle", "Old"])
        ordered!(x, true)
        y = CategoricalArray{Union{T, String}}(["Middle", "Middle", "Old", "Young"])
        levels!(y, ["X", "Young", "Middle", "Old"])
        copyf!(x, y)
        @test levels(x) == ["X", "Young", "Middle", "Old"]
        @test !isordered(x)
    end

    @testset "fill!()" begin
        x = CategoricalArray{Union{String, T}}(["a", "b", "c"])
        x2 = copy(x)
        @test fill!(x2, "a") === x2
        @test x2 == ["a", "a", "a"]
        @test levels(x2) == ["a", "b", "c"]

        @test fill!(x2, x[2]) == ["b", "b", "b"]
        @test levels(x2) == ["a", "b", "c"]

        x2 = copy(x)
        @test_throws MethodError fill!(x2, 3)
        @test x2 == x

        if T === Missing
            x2 = fill!(copy(x), missing)
            @test all(ismissing, x2)
        else
            @test_throws MethodError fill!(x2, missing)
            @test x2 == x
        end

        fill!(x2, "c")
        @test x2 == ["c", "c", "c"]
        @test levels(x2) == ["a", "b", "c"]

        fill!(x2, "0")
        @test x2 == ["0", "0", "0"]
        @test levels(x2) == ["a", "b", "c", "0"]

        y = categorical(["d", "e"])
        ordered!(y, true)
        levels!(y, ["0", "e", "d"])
        fill!(x2, y[1])
        @test x2 == ["d", "d", "d"]
        @test levels(x2) == ["a", "b", "c", "0", "e", "d"]

        x3 = similar(x2)
        fill!(x3, y[1])
        @test x3 == ["d", "d", "d"]
        @test levels(x3) == ["0", "e", "d"]
        @test isordered(x3)
    end

    @testset "overflow of reftype is detected and doesn't corrupt data and levels" begin
        res = @test_throws LevelsException{Int, UInt8} CategoricalArray{Union{T, Int}, 1, UInt8}(256:-1:1)
        @test res.value.levels == [1]
        @test sprint(showerror, res.value) == "cannot store level(s) 1 since reference type UInt8 can only hold 255 levels. Use the decompress function to make room for more levels."

        x = CategoricalArray{Union{T, Int}, 1, UInt8}(254:-1:1)
        x[1] = 1000
        res = @test_throws LevelsException{Int, UInt8} x[1] = 1001
        @test res.value.levels == [1001]
        @test sprint(showerror, res.value) == "cannot store level(s) 1001 since reference type UInt8 can only hold 255 levels. Use the decompress function to make room for more levels."
        @test x == vcat(1000, 253:-1:1)
        @test levels(x) == vcat(1:254, 1000)

        x = CategoricalArray{Union{T, Int}, 1, UInt8}(1:254)
        res = @test_throws LevelsException{Int, UInt8} x[1:2] = 1000:1001
        @test res.value.levels == [1001]
        @test sprint(showerror, res.value) == "cannot store level(s) 1001 since reference type UInt8 can only hold 255 levels. Use the decompress function to make room for more levels."
        @test x == vcat(1000, 2:254)
        @test levels(x) == vcat(1:254, 1000)

        x = CategoricalArray{Union{T, Int}, 1, UInt8}([1, 3, 256])
        res = @test_throws LevelsException{Int, UInt8} levels!(x, collect(1:256))
        @test res.value.levels == [256]
        @test sprint(showerror, res.value) == "cannot store level(s) 256 since reference type UInt8 can only hold 255 levels. Use the decompress function to make room for more levels."

        x = CategoricalArray{Union{T, Int}}(30:2:131115)
        res = @test_throws LevelsException{Int, UInt16} CategoricalVector{Int, UInt16}(x)
        @test res.value.levels == collect(131100:2:131114)
        @test sprint(showerror, res.value) == "cannot store level(s) 131100, 131102, 131104, 131106, 131108, 131110, 131112 and 131114 since reference type UInt16 can only hold 65535 levels. Use the decompress function to make room for more levels."

        x = CategoricalArray{Union{T, String}, 1, UInt8}(string.(Char.(65:318)))
        res = @test_throws LevelsException{String, UInt8} levels!(x, vcat(levels(x), "az", "bz", "cz"))
        @test res.value.levels == ["bz", "cz"]
        @test sprint(showerror, res.value) == "cannot store level(s) \"bz\" and \"cz\" since reference type UInt8 can only hold 255 levels. Use the decompress function to make room for more levels."
        @test x == string.(Char.(65:318))
        lev = copy(levels(x))
        levels!(x, vcat(lev, "az"))
        @test levels(x) == vcat(lev, "az")
    end

    @testset "compress()/decompress()" begin
        x = compress(CategoricalArray{Union{T, Int}}([1, 3, 736251]))
        ux = decompress(x)
        @test x == ux
        @test isa(x, CategoricalArray{Union{T, Int}, 1, UInt8})
        @test isa(ux, CategoricalArray{Union{T, Int}, 1, CategoricalArrays.DefaultRefType})
    end

    @testset "reshape()" begin
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        levels!(x, ["Young", "Middle", "Old"])
        ordered!(x, true)

        y = reshape(x, 1, 4)
        @test isa(y, CategoricalArray{Union{T, String}, 2, CategoricalArrays.DefaultRefType})
        @test y == ["Old" "Young" "Middle" "Young"]
        @test levels(x) == levels(y)
        @test isordered(x)

        y = reshape(x, 2, 2)
        @test isa(y, CategoricalArray{Union{T, String}, 2, CategoricalArrays.DefaultRefType})
        @test y == ["Old"  "Middle"; "Young" "Young"]
        @test levels(x) == levels(y)
        @test isordered(x)

        # Test with missing values
        if T === Missing
            x[3] = missing
            y = reshape(x, 1, 4)
            @test isa(y, CategoricalArray{Union{T, String}, 2, CategoricalArrays.DefaultRefType})
            @test y ≅ ["Old" "Young" missing "Young"]
            @test levels(x) == levels(y)
            @test isordered(x)
        end
    end

    @testset "sort" begin
        x = CategoricalArray{Union{T, String}}(["Old", "Young", "Middle", "Young"])
        levels!(x, ["Young", "Middle", "Old"])
        @test sort(x) == ["Young", "Young", "Middle", "Old"]
        ordered!(x, true)
        @test sort(x) == ["Young", "Young", "Middle", "Old"]
        @test sort!(x) === x
        @test x == ["Young", "Young", "Middle", "Old"]

        if T !== Missing
            v = rand(["a", "b", "c", "d"], 1000)
        else
            v = rand(["a", "b", "c", "d", missing], 1000)
        end

        for rev in (true, false)
            cv = categorical(v)
            sv = sort(v, rev=rev)

            @test sort(cv, rev=rev) ≅ sv
            @test sort!(cv, rev=rev) === cv ≅ sv

            cv = categorical(v)
            levels!(cv, ["b", "a", "c", "d"])
            @test sort(cv, rev=rev) ≅
                ["b", "a", "c", "d", missing][sort([5; 1:4][cv.refs .+ 1], rev=rev)]

            levels!(cv, ["x", "z", "b", "a", "y", "c", "d", "0"])
            @test sort(cv, rev=rev) ≅
                ["x", "z", "b", "a", "y", "c", "d", "0", missing][sort([9; 1:8][cv.refs .+ 1], rev=rev)]

            cv = categorical(v)
            @test sort(cv, rev=rev, lt=(x, y) -> isless(y, x)) ≅
                sort(cv, rev=!rev) ≅
                sort(cv, order=Base.Sort.ord((x, y) -> isless(y, x), identity, rev))

            # Function changing order
            byf1 = x -> ismissing(x) ? "c" : (x == "a" ? "z" : "b")
            @test sort(cv, rev=rev, by=byf1) ≅ sort(cv, rev=rev, by=byf1)

            # Check that by function is not called on unused levels/missing
            byf2 = x -> (@assert x != "b"; x)
            replace!(cv, missing=>"a", "b"=>"a")
            @test sort(cv, rev=rev, by=byf2) ≅ sort(cv, rev=rev, by=byf2)
        end
    end
end

@testset "constructors and convert() between categorical arrays, ordered_orig=$ordered_orig, ordered=$ordered, R=$R, T=$T, CVM2=$CVM2, N=$N" for ordered_orig in (true, false),
    ordered in (true, false),
    R in (DefaultRefType, UInt8, UInt, Int8, Int),
    T in (String, Union{String, Missing}),
    (CVM2, N) in ((CategoricalVector, 1), (CategoricalMatrix, 2))
    # check that ctors/converters preserve levels and ordering by default even across types,
    # do not modify original array when changing ordering, and make copies
    # only when necessary (though for construcors the pool is always copied because of ordered)
    if CVM2 <: AbstractVector
        x = CategoricalArray{T, N, R}(["A", "B"], ordered=ordered_orig)
    else
        x = CategoricalArray{T, N, R}(["A" "B"], ordered=ordered_orig)
    end

    # Do not use lexicographic order in order to catch bugs about order preservation
    levels!(x, ["B", "A"])

    for y in (CategoricalArray(x),
              CategoricalArray{T}(x),
              CategoricalArray{T, N}(x),
              CategoricalArray{T, N, R}(x),
              CategoricalArray{T, N, DefaultRefType}(x),
              CategoricalArray{T, N, UInt8}(x),
              CVM2(x),
              CVM2{T}(x),
              CVM2{T, R}(x),
              CVM2{T, DefaultRefType}(x),
              CVM2{T, UInt8}(x))
        @test isa(y, CVM2{T})
        @test isordered(y) === isordered(x)
        @test isordered(x) === ordered_orig
        @test y.refs == x.refs
        @test levels(y) == levels(x)
        @test y.refs !== x.refs
        @test y.pool !== x.pool
    end
    for y in (@inferred(categorical(x)),
              categorical(x, compress=false),
              categorical(x, compress=true))
        @test isa(y, CategoricalArray{T, N})
        @test isordered(y) === isordered(x)
        @test isordered(x) === ordered_orig
        @test y.refs == x.refs
        @test levels(y) == levels(x)
        @test y.refs !== x.refs
        @test y.pool !== x.pool
    end
    for y in (CategoricalArray(x, ordered=ordered),
              CategoricalArray{T}(x, ordered=ordered),
              CategoricalArray{T, N}(x, ordered=ordered),
              CategoricalArray{T, N, R}(x, ordered=ordered),
              CategoricalArray{T, N, DefaultRefType}(x, ordered=ordered),
              CategoricalArray{T, N, UInt8}(x, ordered=ordered),
              CVM2(x, ordered=ordered),
              CVM2{T}(x, ordered=ordered),
              CVM2{T, R}(x, ordered=ordered),
              CVM2{T, DefaultRefType}(x, ordered=ordered),
              CVM2{T, UInt8}(x, ordered=ordered))
        @test isa(y, CVM2{T})
        @test isordered(y) === ordered
        @test isordered(x) === ordered_orig
        @test y.refs == x.refs
        @test levels(y) == levels(x)
        @test y.refs !== x.refs
        @test y.pool !== x.pool
    end
    for y in (@inferred(categorical(x, ordered=ordered)),
              categorical(x, compress=false, ordered=ordered),
              categorical(x, compress=true, ordered=ordered))
        @test isa(y, CategoricalArray{T, N})
        @test isordered(y) === ordered
        @test isordered(x) === ordered_orig
        @test y.refs == x.refs
        @test levels(y) == levels(x)
        @test y.refs !== x.refs
        @test y.pool !== x.pool
    end
    for y in (convert(CategoricalArray, x),
              convert(CategoricalArray{T}, x),
              convert(CategoricalArray{T, N}, x),
              convert(CategoricalArray{T, N, R}, x),
              convert(CategoricalArray{T, N, DefaultRefType}, x),
              convert(CategoricalArray{T, N, UInt8}, x))
        @test isa(y, CVM2{T})
        @test isordered(y) === isordered(x)
        @test isordered(x) === ordered_orig
        @test y.refs == x.refs
        @test levels(y) == levels(x)
        @test (y.refs === x.refs) == (eltype(x.refs) === eltype(y.refs))
        @test (y.pool === x.pool) == (eltype(x.refs) === eltype(y.refs))
    end
end

@testset "levels argument to constructors" begin
    for T in (String, Union{String, Missing}),
        ord in (false, true),
        levs in (nothing, [], ["a"], ["b", "c", "a"])
        for (U, x) in ((String, CategoricalArray(undef, 2, levels=levs, ordered=ord)),
                        (T, CategoricalArray{T}(undef, 2, levels=levs, ordered=ord)),
                        (T, CategoricalArray{T, 1}(undef, 2, levels=levs, ordered=ord)),
                        (T, CategoricalArray{T, 1, UInt32}(undef, 2, levels=levs, ordered=ord)),
                        (String, CategoricalVector(undef, 2, levels=levs, ordered=ord)),
                        (T, CategoricalVector{T}(undef, 2, levels=levs, ordered=ord)),
                        (T, CategoricalVector{T, UInt32}(undef, 2, levels=levs, ordered=ord)),
                        (String, CategoricalArray(undef, 2, 3, levels=levs, ordered=ord)),
                        (T, CategoricalArray{T}(undef, 2, 3, levels=levs, ordered=ord)),
                        (T, CategoricalArray{T, 2}(undef, 2, 3, levels=levs, ordered=ord)),
                        (T, CategoricalArray{T, 2, UInt32}(undef, 2, 3, levels=levs, ordered=ord)),
                        (String, CategoricalMatrix(undef, 2, 3, levels=levs, ordered=ord)),
                        (T, CategoricalMatrix{T}(undef, 2, 3, levels=levs, ordered=ord)),
                        (T, CategoricalMatrix{T, UInt32}(undef, 2, 3, levels=levs, ordered=ord)))
            @test x isa CategoricalArray{U, <:Any, UInt32}
            if U >: Missing
                @test all(ismissing, x)
            else
                @test !any(i -> isassigned(x, i), eachindex(x))
            end
            @test levels(x) == something(levs, [])
            @test isordered(x) === ord
            @test CategoricalArrays.pool(x).levels !== levs
        end

        for v in (T["b", "c", "a"], categorical(T["b", "c", "a"]))
            if levs === nothing || unique(v) ⊆ levs
                for x in (categorical(v, levels=levs, ordered=ord),
                          CategoricalArray(v, levels=levs, ordered=ord),
                          CategoricalArray{T}(v, levels=levs, ordered=ord),
                          CategoricalArray{T, 1}(v, levels=levs, ordered=ord),
                          CategoricalArray{T, 1, UInt32}(v, levels=levs, ordered=ord),
                          CategoricalVector(v, levels=levs, ordered=ord),
                          CategoricalVector{T}(v, levels=levs, ordered=ord),
                          CategoricalVector{T, UInt32}(v, levels=levs, ordered=ord),
                          CategoricalArray(v, levels=levs, ordered=ord))
                        @test x isa CategoricalVector{T, UInt32}
                        @test x == v
                        @test levels(x) == something(levs, sort!(unique(x)))
                        @test isordered(x) === ord
                        @test CategoricalArrays.pool(x).levels !== levs
                end
            else
                @test_throws ArgumentError categorical(v, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalArray(v, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalArray{T}(v, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalArray{T, 1}(v, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalArray{T, 1, UInt32}(v, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalVector(v, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalVector{T}(v, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalVector{T, UInt32}(v, levels=levs, ordered=ord)
            end
        end

        for m in (T["c" "b"; "a" "b"], categorical(T["c" "b"; "a" "b"]))
            if levs === nothing || unique(m) ⊆ levs
                for x in (categorical(m, levels=levs, ordered=ord),
                          CategoricalArray{T}(m, levels=levs, ordered=ord),
                          CategoricalArray{T, 2}(m, levels=levs, ordered=ord),
                          CategoricalArray{T, 2, UInt32}(m, levels=levs, ordered=ord),
                          CategoricalMatrix(m, levels=levs, ordered=ord),
                          CategoricalMatrix{T}(m, levels=levs, ordered=ord),
                          CategoricalMatrix{T, UInt32}(m, levels=levs, ordered=ord))
                    @test x isa CategoricalMatrix{T, UInt32}
                    @test x == m
                    @test levels(x) == something(levs, sort!(unique(x)))
                    @test isordered(x) === ord
                    @test CategoricalArrays.pool(x).levels !== levs
                end
            else
                @test_throws ArgumentError categorical(m, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalArray(m, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalArray{T}(m, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalArray{T, 2}(m, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalArray{T, 2, UInt32}(m, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalMatrix(m, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalMatrix{T}(m, levels=levs, ordered=ord)
                @test_throws ArgumentError CategoricalMatrix{T, UInt32}(m, levels=levs, ordered=ord)
            end
        end
    end
end

@testset "constructors with SubString" begin
    for x in ([SubString("ab", 1, 1), SubString("c", 1, 1)],
              SubString[SubString("ab", 1, 1), SubString("c", 1, 1)],
              [SubString("ab", 1, 1), "c"]),
        f in (CategoricalArray, CategoricalVector, categorical)
        y = @inferred f(x)
        @test y isa CategoricalArray{String}
        @test y == x

        y = @inferred f(allowmissing(x))
        @test y isa CategoricalArray{Union{String, Missing}}
        @test y == x
    end

    for x in ([SubString("ab", 1, 1) SubString("c", 1, 1)],
              SubString[SubString("ab", 1, 1) SubString("c", 1, 1)],
              [SubString("ab", 1, 1) "c"]),
        f in (CategoricalArray, CategoricalMatrix, categorical)
        y = @inferred f(x)
        @test y isa CategoricalArray{String}
        @test y == x

        y = @inferred f(allowmissing(x))
        @test y isa CategoricalArray{Union{String, Missing}}
        @test y == x
    end
end

@testset "constructors from arrays with unsupported eltypes" begin
    for (CT, a) in zip((CategoricalVector, CategoricalMatrix),
                        ([1, 2, 3], [1 2 3])),
        f in (categorical, CategoricalArray, CT,
                x -> convert(CategoricalArray, x),
                x -> convert(CT, x)),
        T in (Any, Union{Int, Symbol}, Union{Real, Symbol, Missing})
        x = f(collect(T, a))
        @test x isa CT{Int}
        @test x == categorical(a)
    end
    for (CT, a) in zip((CategoricalVector, CategoricalMatrix),
                        ([1, missing, 3], [1 missing 3])),
        f in (categorical, CategoricalArray, CT,
                x -> convert(CategoricalArray, x),
                x -> convert(CT, x)),
        T in (Any, Union{Int, Symbol, Missing}, Union{Real, Symbol, Missing})
        x = f(collect(T, a))
        @test x isa CT{Union{Int, Missing}}
        @test x ≅ categorical(a)
    end

    for f in (categorical, CategoricalArray, CategoricalVector,
              x -> convert(CategoricalArray, x),
              x -> convert(CategoricalVector, x))
        @test_throws ArgumentError f([:a])
        @test_throws ArgumentError f(Any[:a])
        @test_throws ArgumentError f([nothing])
        @test_throws ArgumentError f(Any[nothing])
        @test_throws ArgumentError f([1, nothing])
    end
    for f in (categorical, CategoricalArray, CategoricalMatrix,
              x -> convert(CategoricalArray, x),
              x -> convert(CategoricalMatrix, x))
        @test_throws ArgumentError f([:a :a])
        @test_throws ArgumentError f(Any[:a :a])
        @test_throws ArgumentError f([nothing nothing])
        @test_throws ArgumentError f(Any[nothing nothing])
        @test_throws ArgumentError f([1 nothing])
    end
end

@testset "converting from array with missings to array without missings CategoricalArray fails with missings" begin
    x = CategoricalArray{Union{String, Missing}}(undef, 1)
    @test_throws MissingException CategoricalArray{String}(x)
    @test_throws MissingException convert(CategoricalArray{String}, x)
end

@testset "in($T, CategoricalArray{$T})" for T in (Int, Union{Int, Missing})
    ca1 = CategoricalArray{T}([1, 2, 3])
    ca2 = CategoricalArray{T}([4, 3, 2])

    @test (ca1[1] in ca1) === true
    @test (ca2[2] in ca1) === true
    @test (ca2[1] in ca1) === false

    @test (1 in ca1) === true
    @test (5 in ca1) === false
end

@testset "comparison" begin
    a1 = [1, 2, 3]
    a2 = Union{Int, Missing}[1, 2, 3]
    a3 = [1, 2, missing]
    a4 = [4, 3, 2]
    a5 = [1 2; 3 4]
    ca1 = CategoricalArray(a1)
    ca2 = CategoricalArray{Union{Int, Missing}}(a2)
    ca2b = CategoricalArray{Union{Int, Missing}, 1}(ca2.refs, ca2.pool)
    ca3 = CategoricalArray(a3)
    ca3b = CategoricalArray{Union{Int, Missing}, 1}(ca3.refs, ca2.pool)
    ca4 = CategoricalArray(a4)
    ca5 = CategoricalArray(a5)

    @testset "==" begin
        @test ca1 == copy(ca1) == a1
        @test ca2 == copy(ca2) == a2
        @test ismissing(ca3 == copy(ca3)) && ismissing(ca3 == ca3b) && ismissing(ca3 == a3)
        @test ca4 == copy(ca4) == a4
        @test ca5 == copy(ca5) == a5
        @test ca1 == ca2 == a2
        @test ismissing(ca1 != ca3) && ismissing(ca1 != a3)
        @test ca1 != ca4
        @test ca1 != a4
        @test a1 != ca4
        @test ca1 != ca5
        @test ca1 != a5
        @test a1 != ca5
        @test ca3 != ca4
        @test ca3 != a4
        @test a3 != ca4
        @test ismissing(ca2b != ca3b)
    end

    @testset "isequal()" begin
        @test ca1 ≅ copy(ca1) ≅ a1
        @test ca2 ≅ copy(ca2) ≅ a2
        @test ca3 ≅ copy(ca3) ≅ ca3b ≅ a3
        @test ca4 ≅ copy(ca4) ≅ a4
        @test ca5 ≅ copy(ca5) ≅ a5
        @test ca1 ≅ ca2 ≅ a2
        @test ca1 ≇ ca3 && ca1 ≇ a3
        @test ca1 ≇ ca4
        @test ca1 ≇ a4
        @test a1 ≇ ca4
        @test ca1 ≇ ca5
        @test ca1 ≇ a5
        @test a1 ≇ ca5
        @test ca3 ≇ ca4
        @test ca3 ≇ a4
        @test a3 ≇ ca4
        @test ca2b ≇ ca3b
    end
end

@testset "summary()" begin
    @test summary(CategoricalArray([1, 2, 3])) ==
        "3-element $CategoricalArray{$Int,1,UInt32}"
    @test summary(CategoricalArray{Union{Int, Missing}}([1 2 3])) ==
        "1×3 $CategoricalArray{$(Union{Missing, Int}),2,UInt32}"
end

@testset "vcat() takes into account element type even when array is empty" begin
    # or when both arrays have the same levels but of different types
    x = CategoricalVector{String}(undef, 0)
    y = CategoricalVector{Int}(undef, 0)
    z1 = CategoricalVector{Float64}([1.0])
    z2 = CategoricalVector{Int}([1])
    if VERSION > v"1.2.0-DEV"
        @inferred vcat(x, y)
    end
    @test vcat(x, y) isa CategoricalVector{Union{String, Int}}
    if VERSION > v"1.2.0-DEV"
        @inferred vcat(x, z1)
    end
    @test vcat(x, z1) isa CategoricalVector{Union{String, Float64}}
    if VERSION > v"1.2.0-DEV"
        @inferred vcat(y, z1)
    end
    @test vcat(y, z1) isa CategoricalVector{Float64}
    if VERSION > v"1.2.0-DEV"
        @inferred vcat(x, x)
    end
    @test vcat(x, x) isa CategoricalVector{String}
    if VERSION > v"1.2.0-DEV"
        @inferred vcat(y, y)
    end
    @test vcat(y, y) isa CategoricalVector{Int}
    if VERSION > v"1.2.0-DEV"
        @inferred vcat(z1, z1)
    end
    @test vcat(z1, z1) isa CategoricalVector{Float64}
    if VERSION > v"1.2.0-DEV"
        @inferred vcat(z1, z2)
    end
    @test vcat(z1, z2) isa CategoricalVector{Float64}
end

@testset "categorical() makes a copy of pool and refs" begin
    xs = Any[Int8[1:10;], [Int8[1:10;]; missing]]
    for x in xs, o1 in [true, false], o2 in [true, false], T in [Int64, Int8]
        y = categorical(x, ordered=o1)
        if x === xs[1]
            z = CategoricalArray{T}(y, ordered=o2)
        else
            z = CategoricalArray{Union{T, Missing}}(y, ordered=o2)
        end
        @test z.refs !== y.refs
        @test z.pool !== y.pool
    end
end

@testset "collect of CategoricalArray produces CategoricalArray" begin
    x = [1,1,2,2]
    y = categorical(x)
    for z in (collect(y), collect(eltype(y), y), collect(Iterators.take(y, 4)))
        @test typeof(y) == typeof(z)
        @test z == y == x
    end

    x = [1,1,2,missing]
    y = categorical(x)
    for z in (collect(y), collect(eltype(y), y), collect(Iterators.take(y, 4)))
        @test typeof(y) == typeof(z)
        @test z ≅ y ≅ x
    end
end

@testset "collect for SkipMissing" begin
    for x in (categorical([1, missing, 3, missing, 2]),
              view(categorical([2, 1, missing, 3, missing, 2]), 2:6),
              categorical([1 missing; 3 missing]),
              view(categorical([2 1; missing 3; missing 2]), 2:3, :),
              categorical(fill(1)))
        levels!(x, [2, 1, 3, 4])
        res = collect(skipmissing(x))
        @test res == collect(skipmissing(unwrap.(x)))
        @test res isa CategoricalVector{Int, UInt32}
        @test levels(x) == [2, 1, 3, 4]
    end

    x = categorical(Array{Union{Int,Missing}, 0}(undef))
    x[1] = 1
    levels!(x, [2, 1, 3, 4])
    res = collect(skipmissing(x))
    @test res isa CategoricalVector{Int, UInt32}
    @test res == [1]
    @test levels(x) == [2, 1, 3, 4]

    x = categorical(Array{Union{Int,Missing}, 0}(missing))
    levels!(x, [2, 1, 3, 4])
    res = collect(skipmissing(x))
    @test res isa CategoricalVector{Int, UInt32}
    @test isempty(res)
    @test levels(x) == [2, 1, 3, 4]

    res = collect(skipmissing(categorical(fill(missing))))
    @test res isa CategoricalVector{Union{}, UInt32}
    @test isempty(res)
    @test levels(x) == [2, 1, 3, 4]
end

@testset "Array(::CatArrOrSub{T}) produces Array{T}" begin
    x = [1,1,2,2]
    y = categorical(x)
    z = Array(y)
    @test typeof(x) == typeof(z)
    @test z == x
    z = Array(view(y, 1:4))
    @test typeof(x) == typeof(z)
    @test z == x

    x = [1,1,2,missing]
    y = categorical(x)
    z = Array(y)
    @test typeof(x) == typeof(z)
    @test z ≅ x
    z = Array(view(y, 1:4))
    @test typeof(x) == typeof(z)
    @test z ≅ x

    x = [1,1,2,2]
    y = categorical(x)
    z = Vector(y)
    @test typeof(x) == typeof(z)
    @test z == x
    z = Vector(view(y, 1:4))
    @test typeof(x) == typeof(z)
    @test z == x

    x = [1,1,2,missing]
    y = categorical(x)
    z = Vector(y)
    @test typeof(x) == typeof(z)
    @test z ≅ x
    z = Vector(view(y, 1:4))
    @test typeof(x) == typeof(z)
    @test z ≅ x

    x = [1 1 2 2]
    y = categorical(x)
    z = Matrix(y)
    @test typeof(x) == typeof(z)
    @test z == x
    z = Matrix(view(y, :, 1:4))
    @test typeof(x) == typeof(z)
    @test z == x

    x = [1 1 2 missing]
    y = categorical(x)
    z = Matrix(y)
    @test typeof(x) == typeof(z)
    @test z ≅ x
    z = Matrix(view(y, :, 1:4))
    @test typeof(x) == typeof(z)
    @test z ≅ x
end

@testset "convert(Array, ::CatArrOrSub{T}) produces Array{T}" begin
    x = [1,1,2,2]
    y = categorical(x)
    z = convert(Array, y)
    @test typeof(x) == typeof(z)
    @test z == x
    z = convert(Array, view(y, 1:4))
    @test typeof(x) == typeof(z)
    @test z == x

    x = [1,1,2,missing]
    y = categorical(x)
    z = convert(Array, y)
    @test typeof(x) == typeof(z)
    @test z ≅ x
    z = convert(Array, view(y, 1:4))
    @test typeof(x) == typeof(z)
    @test z ≅ x

    x = [1,1,2,2]
    y = categorical(x)
    z = convert(Vector, y)
    @test typeof(x) == typeof(z)
    @test z == x
    z = convert(Vector, view(y, 1:4))
    @test typeof(x) == typeof(z)
    @test z == x

    x = [1,1,2,missing]
    y = categorical(x)
    z = convert(Vector, y)
    @test typeof(x) == typeof(z)
    @test z ≅ x
    z = convert(Vector, view(y, 1:4))
    @test typeof(x) == typeof(z)
    @test z ≅ x

    x = [1 1 2 2]
    y = categorical(x)
    z = convert(Matrix, y)
    @test typeof(x) == typeof(z)
    @test z == x
    z = convert(Matrix, view(y, :, 1:4))
    @test typeof(x) == typeof(z)
    @test z == x

    x = [1 1 2 missing]
    y = categorical(x)
    z = convert(Matrix, y)
    @test typeof(x) == typeof(z)
    @test z ≅ x
    z = convert(Matrix, view(y, :, 1:4))
    @test typeof(x) == typeof(z)
    @test z ≅ x
end

@testset "Array{T} constructors and convert" begin
    x = [1,1,2,2]
    y = categorical(x)
    z = Array{Int}(y)
    @test typeof(x) == typeof(z)
    @test z == x
    z = convert(Array{Int}, y)
    @test typeof(x) == typeof(z)
    @test z == x

    x = [1,1,2,missing]
    y = categorical(x)
    z = Array{Union{Int, Missing}}(y)
    @test typeof(x) == typeof(z)
    @test z ≅ x
    z = convert(Array{Union{Int, Missing}}, y)
    @test typeof(x) == typeof(z)
    @test z ≅ x
end

@testset "Array(::CatArrOrSub{T<:CategoricalValue}) produces Array{T}" begin
    x = [1,1,2,2]
    y = categorical(x)
    z = Array{eltype(y)}(y)
    @test z isa Array{eltype(y)}
    @test z == x
    z = Array{eltype(y)}(view(y, 1:4))
    @test z isa Array{eltype(y)}
    @test z == x

    x = [1,1,2,missing]
    y = categorical(x)
    z = Array{eltype(y)}(y)
    @test z isa Array{eltype(y)}
    @test z ≅ x
    z = Array{eltype(y)}(view(y, 1:4))
    @test z isa Array{eltype(y)}
    @test z ≅ x

    x = [1,1,2,2]
    y = categorical(x)
    z = Vector{eltype(y)}(y)
    @test z isa Vector{eltype(y)}
    @test z == x
    z = Vector{eltype(y)}(view(y, 1:4))
    @test z isa Vector{eltype(y)}
    @test z == x

    x = [1,1,2,missing]
    y = categorical(x)
    z = Vector{eltype(y)}(y)
    @test z isa Vector{eltype(y)}
    @test z ≅ x
    z = Vector{eltype(y)}(view(y, 1:4))
    @test z isa Vector{eltype(y)}
    @test z ≅ x

    x = [1 1 2 2]
    y = categorical(x)
    z = Matrix{eltype(y)}(y)
    @test z isa Matrix{eltype(y)}
    @test z == x
    z = Matrix{eltype(y)}(view(y, :, 1:4))
    @test z isa Matrix{eltype(y)}
    @test z == x

    x = [1 1 2 missing]
    y = categorical(x)
    z = Matrix{eltype(y)}(y)
    @test z isa Matrix{eltype(y)}
    @test z ≅ x
    z = Matrix{eltype(y)}(view(y, :, 1:4))
    @test z isa Matrix{eltype(y)}
    @test z ≅ x
end


@testset "convert(Array, ::CatArrOrSub{T<:CategoricalValue}) produces Array{T}" begin
    x = [1,1,2,2]
    y = categorical(x)
    z = convert(Array{eltype(y)}, y)
    @test z isa Array{eltype(y)}
    @test z == x
    z = convert(Array{eltype(y)}, view(y, 1:4))
    @test z isa Array{eltype(y)}
    @test z == x

    x = [1,1,2,missing]
    y = categorical(x)
    z = convert(Array{eltype(y)}, y)
    @test z isa Array{eltype(y)}
    @test z ≅ x
    z = convert(Array{eltype(y)}, view(y, 1:4))
    @test z isa Array{eltype(y)}
    @test z ≅ x

    x = [1,1,2,2]
    y = categorical(x)
    z = convert(Vector{eltype(y)}, y)
    @test z isa Vector{eltype(y)}
    @test z == x
    z = convert(Vector{eltype(y)}, view(y, 1:4))
    @test z isa Vector{eltype(y)}
    @test z == x

    x = [1,1,2,missing]
    y = categorical(x)
    z = convert(Vector{eltype(y)}, y)
    @test z isa Vector{eltype(y)}
    @test z ≅ x
    z = convert(Vector{eltype(y)}, view(y, 1:4))
    @test z isa Vector{eltype(y)}
    @test z ≅ x

    x = [1 1 2 2]
    y = categorical(x)
    z = convert(Matrix{eltype(y)}, y)
    @test z isa Matrix{eltype(y)}
    @test z == x
    z = convert(Matrix{eltype(y)}, view(y, :, 1:4))
    @test z isa Matrix{eltype(y)}
    @test z == x

    x = [1 1 2 missing]
    y = categorical(x)
    z = convert(Matrix{eltype(y)}, y)
    @test z isa Matrix{eltype(y)}
    @test z ≅ x
    z = convert(Matrix{eltype(y)}, view(y, :, 1:4))
    @test z isa Matrix{eltype(y)}
    @test z ≅ x
end

@testset "convert(AbstractArray{T}, x)" begin
    x = [1,1,2,2]
    y = categorical(x)
    z = convert(AbstractArray{Int}, y)
    @test typeof(x) == typeof(z)
    @test z == x

    x = [1,1,2,missing]
    y = categorical(x)
    z = convert(AbstractArray{Union{Int, Missing}}, y)
    @test typeof(x) == typeof(z)
    @test z ≅ x

    # Check that convert is a no-op when appropriate
    for x in (categorical([1,1,2,2]), categorical([1,1,2,missing]))
        y = convert(AbstractArray, x)
        @test x === y
        y = convert(AbstractVector, x)
        @test x === y
        y = convert(AbstractArray{eltype(x)}, x)
        @test x === y
        y = convert(AbstractArray{eltype(x), 1}, x)
        @test x === y
    end
end

@testset "DataAPI.refarray constructors and copyto!" begin
    for y1 in (CategoricalVector{Int}(undef, 6),
               CategoricalVector([1, 2, 1, 1, 3, 2], levels=[2, 1, 3]),
               CategoricalVector([2, 2, 2, 2, 2, 2], levels=[2]),
               CategoricalVector([2, 2, 2, 2, 2, 2], levels=[3, 1, 2, 4]),
               CategoricalVector([1, 2, 1, 3, 3, 2], levels=[3, 1, 2, 4]),
               CategoricalVector(Float64[2, 3, 1, 2, 2, 1], levels=[3, 1, 2]),
               view(CategoricalVector([3, 1, 2, 1, 1, 2, 2, 3], levels=[3, 1, 2, 4]), 2:7)),
        x in (PooledArray([3, 1, 2, 1, 1, 3]),
              PooledArray(PooledArrays.RefArray([3, 1, 2, 1, 1, 3]), Dict(1=>1, 0=>2, 3=>3, 2=>4)),
              PooledArray(PooledArrays.RefArray([3, 1, 4, 1, 1, 3]), Dict(1=>1, missing=>2, 3=>3, 2=>4)))
        levs = levels(y1)

        y2 = deepcopy(y1)
        @test copyto!(y2, x) === y2
        @test x == y2
        @test levels(y2) == [levs; sort!(setdiff(unique(x), levs))]

        y2 = deepcopy(y1)
        @test copy!(y2, x) === y2
        @test x == y2
        @test levels(y2) == [levs; sort!(setdiff(unique(x), levs))]

        y2 = deepcopy(y1)
        @test copyto!(y2, 1, x, 1, length(x)) === y2
        @test x == y2
        @test levels(y2) == [levs; sort!(setdiff(unique(x), levs))]

        y2 = deepcopy(y1)
        @test copyto!(y2, 2, x, 3, 3) === y2
        @test x[3:5] ≅ y2[2:4]
        @test levels(y2) == [levs; sort!(setdiff(unique(x[3:5]), levs))]

        y2 = deepcopy(y1)
        @test copyto!(y2, 2, x[3:end]) === y2
        @test x[3:6] ≅ y2[2:5]
        @test levels(y2) == [levs; sort!(setdiff(unique(x[3:6]), levs))]
    end

    for y1 in (CategoricalVector{Union{Int, Missing}}(undef, 6),
               CategoricalVector([1, 2, missing, 1, 3, 2], levels=[2, 1, 3]),
               CategoricalVector([2, 2, missing, 2, 2, 2], levels=[2]),
               CategoricalVector([2, 2, missing, 2, 2, 2], levels=[3, 1, 2, 4]),
               CategoricalVector([1, 2, missing, 3, 3, 2], levels=[3, 1, 2, 4]),
               CategoricalVector(Union{Float64, Missing}[2, 3, missing, 2, 2, 1], levels=[3, 1, 2]),
               view(CategoricalVector([3, 1, 2, missing, 1, 2, 2, 3], levels=[3, 1, 2, 4]), 2:7),
               view(CategoricalVector([3, 1, 2, 1, 1, 2, 2, missing], levels=[3, 1, 2, 4]), 2:7)),
         x in (PooledArray([3, 1, 2, 1, missing, 3]),
               PooledArray(PooledArrays.RefArray([3, 1, 2, 1, 1, 3]), Dict(1=>1, 0=>2, 3=>3, 2=>4)),
               PooledArray(PooledArrays.RefArray([3, 1, 4, 1, 1, 3]), Dict(1=>1, missing=>2, 3=>3, 2=>4)))
        levs = levels(y1)

        y2 = deepcopy(y1)
        @test copyto!(y2, x) === y2
        @test x ≅ y2
        @test levels(y2) == [levs; sort!(setdiff(skipmissing(unique(x)), levs))]

        y2 = deepcopy(y1)
        @test copy!(y2, x) === y2
        @test x ≅ y2
        @test levels(y2) == [levs; sort!(setdiff(skipmissing(unique(x)), levs))]

        y2 = deepcopy(y1)
        @test copyto!(y2, 1, x, 1, length(x)) === y2
        @test x ≅ y2
        @test levels(y2) == [levs; sort!(setdiff(skipmissing(unique(x)), levs))]

        y2 = deepcopy(y1)
        @test copyto!(y2, 2, x, 3, 3) === y2
        @test x[3:5] ≅ y2[2:4]
        @test levels(y2) == [levs; sort!(setdiff(skipmissing(unique(x[3:5])), levs))]

        y2 = deepcopy(y1)
        @test copyto!(y2, 2, x[3:6]) === y2
        @test x[3:6] ≅ y2[2:5]
        @test levels(y2) == [levs; sort!(setdiff(skipmissing(unique(x[3:6])), levs))]
    end

    x = PooledArray(["c", missing, "b", "c", "b", "a"])
    y = CategoricalVector{String}(undef, length(x))
    @test_throws MethodError copyto!(y, x)
    @test_throws MethodError copy!(y, x)
    @test_throws MethodError copyto!(y, 1, x, 1, length(x))
    y = CategoricalVector{Union{Missing, Int}}(undef, length(x))
    @test_throws MethodError copyto!(y, x)
    @test_throws MethodError copy!(y, x)
    @test_throws MethodError copyto!(y, 1, x, 1, length(x))
end

@testset "copyto! from CategoricalArray" begin
    vecs = (CategoricalVector([1, 2, 1, 1, 3, 2], levels=[2, 1, 3]),
            CategoricalVector([2, 2, 2, 2, 2, 2], levels=[2]),
            CategoricalVector([2, 2, 2, 2, 2, 2], levels=[3, 1, 2, 4]),
            CategoricalVector([1, 2, 1, 3, 3, 2], levels=[3, 1, 2, 4]),
            CategoricalVector(Float64[2, 3, 1, 2, 2, 1], levels=[3, 1, 2]),
            view(CategoricalVector([3, 1, 2, 1, 1, 2, 2, 3], levels=[3, 1, 2, 4]), 2:7))
    for y1 in vecs, x in vecs
        levs = levels(y1)
        newlevs, _ = CategoricalArrays.mergelevels(false, levs, levels(x))

        y2 = deepcopy(y1)
        @test copyto!(y2, x) === y2
        @test x == y2
        @test levels(y2) == newlevs

        y2 = deepcopy(y1)
        @test copy!(y2, x) === y2
        @test x == y2
        @test levels(y2) == newlevs

        y2 = deepcopy(y1)
        @test copyto!(y2, 1, x, 1, length(x)) === y2
        @test x == y2
        @test levels(y2) == newlevs

        y2 = deepcopy(y1)
        @test copyto!(y2, 2, x, 3, 3) === y2
        @test x[3:5] ≅ y2[2:4]
        @test levels(y2) == newlevs

        y2 = deepcopy(y1)
        @test copyto!(y2, 2, x[3:end]) === y2
        @test x[3:6] ≅ y2[2:5]
        @test levels(y2) == newlevs
    end

    vecs = (CategoricalVector{Union{Int, Missing}}(undef, 6),
            CategoricalVector([1, 2, missing, 1, 3, 2], levels=[2, 1, 3]),
            CategoricalVector([2, 2, missing, 2, 2, 2], levels=[2]),
            CategoricalVector([2, 2, missing, 2, 2, 2], levels=[3, 1, 2, 4]),
            CategoricalVector([1, 2, missing, 3, 3, 2], levels=[3, 1, 2, 4]),
            CategoricalVector(Union{Float64, Missing}[2, 3, missing, 2, 2, 1], levels=[3, 1, 2]),
            view(CategoricalVector([3, 1, 2, missing, 1, 2, 2, 3], levels=[3, 1, 2, 4]), 2:7),
            view(CategoricalVector([3, 1, 2, 1, 1, 2, 2, missing], levels=[3, 1, 2, 4]), 2:7))
    for y1 in vecs, x in vecs
        levs = levels(y1)
        newlevs, _ = CategoricalArrays.mergelevels(false, levs, levels(x))

        y2 = deepcopy(y1)
        @test copyto!(y2, x) === y2
        @test x ≅ y2
        @test levels(y2) == newlevs

        y2 = deepcopy(y1)
        @test copy!(y2, x) === y2
        @test x ≅ y2
        @test levels(y2) == newlevs

        y2 = deepcopy(y1)
        @test copyto!(y2, 1, x, 1, length(x)) === y2
        @test x ≅ y2
        @test levels(y2) == newlevs

        y2 = deepcopy(y1)
        @test copyto!(y2, 2, x, 3, 3) === y2
        @test x[3:5] ≅ y2[2:4]
        @test levels(y2) == newlevs

        y2 = deepcopy(y1)
        @test copyto!(y2, 2, x[3:6]) === y2
        @test x[3:6] ≅ y2[2:5]
        @test levels(y2) == newlevs
    end
end

@testset "float() and complex()" begin
    x = categorical([1,2,3])
    @test float(x) == x
    @test float(x) isa Vector{Float64}

    x = categorical([1,2,3])
    @test complex(x) == x
    @test complex(x) isa Vector{Complex{Int}}

    @test_throws ErrorException float(categorical(Union{Int,Missing}[1]))
    @test_throws ErrorException complex(categorical(Union{Int,Missing}[1]))
end

@testset "droplevels" for a in (["a", "b", "c"], ["a", "b", missing, "c"])
    x = categorical(a)
    levels!(x, ["b", "c", "a"])
    @test droplevels!(x) === x
    @test levels(x) == ["b", "c", "a"]
    x[2] = "a"
    @test droplevels!(x) === x
    @test levels(x) == ["c", "a"]
    x .= "a"
    @test droplevels!(x) === x
    @test levels(x) == ["a"]
end

@testset "show" begin
    x = categorical([2, 1])
    @test sprint((io,a)->show(io, "text/plain", a), x) ==
        """
        2-element $CategoricalArray{$Int,1,UInt32}:
         2
         1"""

    x = categorical([2, 1, missing])
    if VERSION >= v"1.4-DEV"
        @test sprint((io,a)->show(io, "text/plain", a), x) ==
            """
            3-element $CategoricalArray{$(Union{Missing,Int}),1,UInt32}:
             2
             1
             missing"""
    else
        @test sprint((io,a)->show(io, "text/plain", a), x) ==
            """
            3-element $CategoricalArray{$(Union{Missing,Int}),1,UInt32}:
             2      
             1      
             missing"""
    end
end

@testset "broadcast" for x in (CategoricalArray(1:3),
                               CategoricalArray{Union{Int,Missing}}(1:3),
                               CategoricalArray(["a", "b", "c"]),
                               CategoricalArray(["a", missing, "c"]),
                               CategoricalArray([missing, "b", "c"]))
    y = identity.(x)
    @test x ≅ y
    @test x !== y
    @test y isa CategoricalArray

    y = broadcast(v->v, x)
    @test x ≅ y
    @test x !== y
    @test y isa CategoricalArray

    y = broadcast(v->x[3], x)
    @test x !== y
    @test y isa CategoricalArray

    y = broadcast(v->1, x)
    @test y == [1, 1, 1]
    @test y isa Vector{Int}

    x[1:2] .= x[3]
    @test x == fill(x[3], 3)
end

@testset "append! ordered=$ordered" for ordered in (false, true)
    @testset "append! String" begin
        a = ["a", "b", "c"]
        x = CategoricalVector{String}(a, ordered=ordered)

        append!(x, x)
        @test length(x) == 6
        @test x == ["a", "b", "c", "a", "b", "c"]
        @test isordered(x) === ordered
        @test levels(x) == ["a", "b", "c"]

        b = ["z","y","x"]
        y = CategoricalVector{String}(b)
        ordered!(x, ordered)
        append!(x, y)
        @test !isordered(x)
        @test length(x) == 9
        @test x == ["a", "b", "c", "a", "b", "c", "z", "y", "x"]
        @test levels(x) == ["a", "b", "c", "x", "y", "z"]

        z1 = view(CategoricalVector{String}(["ex1", "ex2"]), 1)
        z2 = view(CategoricalVector{String}(["ex3", "ex4"]), 1:1)
        ordered!(x, ordered)
        append!(x, z1)
        append!(x, z2)
        @test !isordered(x)
        @test length(x) == 11
        @test x == ["a", "b", "c", "a", "b", "c", "z", "y", "x", "ex1", "ex3"]
        @test levels(x) == ["a", "b", "c", "x", "y", "z", "ex1", "ex2", "ex3", "ex4"]
    end

    @testset "append! Float64" begin
        a = [-1.0, 0.0, 1.0]
        x = CategoricalVector{Float64}(a, ordered=ordered)

        append!(x, x)
        @test length(x) == 6
        @test x == [-1.0, 0.0, 1.0, -1.0, 0.0, 1.0]
        @test isordered(x) === ordered
        @test levels(x) == [-1.0, 0.0, 1.0]

        b = [2.5, 3.0, 3.5]
        y = CategoricalVector{Float64}(b, ordered=ordered)
        append!(x, y)
        @test length(x) == 9
        @test x == [-1.0, 0.0, 1.0, -1.0, 0.0, 1.0, 2.5, 3.0, 3.5]
        @test !isordered(x)
        @test levels(x) == [-1.0, 0.0, 1.0, 2.5, 3.0, 3.5]

        z1 = view(CategoricalVector{Float64}([100.0, 101.0]), 1)
        z2 = view(CategoricalVector{Float64}([102.0, 103.0]), 1:1)
        ordered!(x, ordered)
        append!(x, z1)
        append!(x, z2)
        @test length(x) == 11
        @test x == [-1.0, 0.0, 1.0, -1.0, 0.0, 1.0, 2.5, 3.0, 3.5, 100.0, 102.0]
        @test !isordered(x)
        @test levels(x) == [-1.0, 0.0, 1.0, 2.5, 3.0, 3.5, 100.0, 101.0, 102.0, 103.0]
    end
end

@testset "append! ordered=$ordered" for ordered in (false, true)
    cases = (["b", "a", missing], Union{String, Missing}["b", "a", "b"])
    @testset "String, has missing: $(any(ismissing.(a)))" for a in cases
        x = CategoricalVector{Union{String, Missing}}(a, ordered=ordered)

        append!(x, x)
        @test x ≅ [a; a]
        @test levels(x) == ["a", "b"]
        @test isordered(x) === ordered
        @test length(x) == 6

        b = ["x","y",missing]
        y = CategoricalVector{Union{String, Missing}}(b)
        ordered!(x, ordered)
        append!(x, y)
        @test length(x) == 9
        @test !isordered(x)
        @test levels(x) == ["a", "b", "x", "y"]
        @test x ≅ [a; a; b]

        z1 = view(CategoricalVector{Union{String, Missing}}([missing, "ex2"]), 1)
        z2 = view(CategoricalVector{Union{String, Missing}}(["ex3", "ex4"]), 1:1)
        ordered!(x, ordered)
        append!(x, z1)
        append!(x, z2)
        @test length(x) == 11
        @test !isordered(x)
        @test levels(x) == ["a", "b", "x", "y", "ex2", "ex3", "ex4"]
        @test x ≅ [a; a; b; missing; "ex3"]
    end

    @testset "Float64" begin
        a = 0.0:0.5:1.0
        x = CategoricalVector{Union{Float64, Missing}}(a, ordered=ordered)

        append!(x, x)
        @test length(x) == 6
        @test x == [a; a]
        @test isordered(x) === ordered
        @test levels(x) == [0.0,  0.5,  1.0]

        b = [2.5, 3.0, missing]
        y = CategoricalVector{Union{Float64, Missing}}(b)
        ordered!(x, ordered)
        append!(x, y)
        @test length(x) == 9
        @test x ≅ [a; a; b]
        @test !isordered(x)
        @test levels(x) == [0.0, 0.5, 1.0, 2.5, 3.0]

        z1 = view(CategoricalVector{Union{Float64, Missing}}([missing, 101.0]), 1)
        z2 = view(CategoricalVector{Union{Float64, Missing}}([102.0, 103.0]), 1:1)
        ordered!(x, ordered)
        append!(x, z1)
        append!(x, z2)
        @test length(x) == 11
        @test x ≅ [a; a; b; missing; 102.0]
        @test !isordered(x)
        @test levels(x) == [0.0, 0.5, 1.0, 2.5, 3.0, 101.0, 102.0, 103.0]
    end
end

@testset "push! ordered=$ordered" for ordered in (false, true)
    @testset "push! String" begin
        a = ["a", "b", "c"]
        x = CategoricalVector{String}(a, ordered=ordered)

        push!(x, "a")
        @test x == ["a", "b", "c", "a"]
        @test isordered(x) === ordered
        @test levels(x) == ["a", "b", "c"]

        push!(x, "z")
        @test !isordered(x)
        @test x == ["a", "b", "c", "a", "z"]
        @test levels(x) == ["a", "b", "c", "z"]

        b = ["z","y","x"]
        y = CategoricalVector{String}(b)
        ordered!(x, ordered)
        push!(x, y[1])
        @test !isordered(x)
        @test x == ["a", "b", "c", "a", "z", "z"]
        @test levels(x) == ["a", "b", "c", "x", "y", "z"]
    end

    @testset "push! Float64" begin
        a = [-1.0, 0.0, 1.0]
        x = CategoricalVector{Float64}(a, ordered=ordered)

        push!(x, 0.0)
        @test x == [-1.0, 0.0, 1.0, 0.0]
        @test isordered(x) === ordered
        @test levels(x) == [-1.0, 0.0, 1.0]

        push!(x, 3.0)
        @test x == [-1.0, 0.0, 1.0, 0.0, 3.0]
        @test !isordered(x)
        @test levels(x) == [-1.0, 0.0, 1.0, 3.0]

        b = [2.5, 3.0, 3.5]
        y = CategoricalVector{Float64}(b, ordered=ordered)
        ordered!(x, ordered)
        push!(x, y[1])
        @test x == [-1.0, 0.0, 1.0, 0.0, 3.0, 2.5]
        @test !isordered(x)
        @test levels(x) == [-1.0, 0.0, 1.0, 2.5, 3.0, 3.5]
    end
end

@testset "insert! ordered=$ordered" for ordered in (false, true)
    @testset "insert! String" begin
        a = ["a", "b", "c"]
        x = CategoricalVector{String}(a, ordered=ordered)

        insert!(x, 4, "a")
        @test x == ["a", "b", "c", "a"]
        @test isordered(x) === ordered
        @test levels(x) == ["a", "b", "c"]

        insert!(x, 5, "z")
        @test !isordered(x)
        @test x == ["a", "b", "c", "a", "z"]
        @test levels(x) == ["a", "b", "c", "z"]

        b = ["z","y","x"]
        y = CategoricalVector{String}(b)
        ordered!(x, ordered)
        insert!(x, 6, y[1])
        @test !isordered(x)
        @test x == ["a", "b", "c", "a", "z", "z"]
        insert!(x, 1, "b")
        @test x == ["b", "a", "b", "c", "a", "z", "z"]
        @test levels(x) == ["a", "b", "c", "x", "y", "z"]
    end

    @testset "insert! Float64" begin
        a = [-1.0, 0.0, 1.0]
        x = CategoricalVector{Float64}(a, ordered=ordered)

        insert!(x, 4, 0.0)
        @test x == [-1.0, 0.0, 1.0, 0.0]
        @test isordered(x) === ordered
        @test levels(x) == [-1.0, 0.0, 1.0]

        insert!(x, 5, 3.0)
        @test x == [-1.0, 0.0, 1.0, 0.0, 3.0]
        @test !isordered(x)
        @test levels(x) == [-1.0, 0.0, 1.0, 3.0]

        b = [2.5, 3.0, 3.5]
        y = CategoricalVector{Float64}(b, ordered=ordered)
        ordered!(x, ordered)
        insert!(x, 6, y[1])
        @test x == [-1.0, 0.0, 1.0, 0.0, 3.0, 2.5]
        insert!(x, 3, -1.0)
        @test x == [-1.0, 0.0, -1.0, 1.0, 0.0, 3.0, 2.5]
        @test !isordered(x)
        @test levels(x) == [-1.0, 0.0, 1.0, 2.5, 3.0, 3.5]
    end
end

@testset "append! ordered=$ordered" for ordered in (false, true)
    cases = (["b", "a", missing], Union{String, Missing}["b", "a", "b"])
    @testset "String, has missing: $(any(ismissing.(a)))" for a in cases
        x = CategoricalVector{Union{String, Missing}}(a, ordered=ordered)

        push!(x, missing)
        @test x ≅ [a; missing]
        insert!(x, 1, missing)
        @test x ≅ [missing; a; missing]
        insert!(x, 2, missing)
        @test x ≅ [missing; missing; a; missing]
        @test levels(x) == ["a", "b"]
        @test isordered(x) === ordered
    end

    @testset "Float64" begin
        a = 0.0:0.5:1.0
        x = CategoricalVector{Union{Float64, Missing}}(a, ordered=ordered)

        push!(x, missing)
        @test x ≅ [a; missing]
        insert!(x, 1, missing)
        @test x ≅ [missing; a; missing]
        insert!(x, 2, missing)
        @test x ≅ [missing; missing; a; missing]
        @test isordered(x) === ordered
        @test levels(x) == [0.0, 0.5, 1.0]
    end
end

@testset "deleteat!" begin
    x = ['a':'z';]
    y = categorical(x)
    deleteat!(x, [1, 3])
    deleteat!(y, [1, 3])
    @test x == y
    @test levels(y) == 'a':'z'
end

@testset "DataAPI" begin
    @test DataAPI.defaultarray(CategoricalValue{String, UInt32}, 1) <: CategoricalArray{String,1,UInt32}
    @test DataAPI.defaultarray(Union{Missing, CategoricalValue{String, UInt32}}, 1) <: CategoricalArray{Union{Missing, String},1,UInt32}
    @test DataAPI.defaultarray(CategoricalValue{Int, UInt32}, 1) <: CategoricalArray{Int,1,UInt32}
    @test DataAPI.defaultarray(Union{Missing, CategoricalValue{Int, UInt32}}, 1) <: CategoricalArray{Union{Missing, Int},1,UInt32}
end

@testset "optimized broadcasting with ismissing" begin
    x = categorical([1, missing, 3, 4, missing])
    @test ismissing.(x) == [false, true, false, false, true]
    @test ismissing.(view(x, 2:4)) == [true, false, false]
    @test (!ismissing).(x) == [true, false, true, true, false]
    @test (!ismissing).(view(x, 2:4)) == [false, true, true]

    x = categorical([1, 0, 3, 4, 0])
    @test ismissing.(x) == [false, false, false, false, false]
    @test ismissing.(view(x, 2:4)) == [false, false, false]
    @test (!ismissing).(x) == [true, true, true, true, true]
    @test (!ismissing).(view(x, 2:4)) == [true, true, true]
end

@testset "optimized broadcasting with levelcode" begin
    x = categorical([3, missing, 1, 4, missing])
    levels!(x, [4, 1, 3])
    @test levelcode.(x) ≅ [3, missing, 2, 1, missing]
    @test levelcode.(x) isa Vector{Union{Missing,Int64}}

    replace!(x, missing=>1)
    @test levelcode.(x) ≅ [3, 2, 2, 1, 2]
    @test levelcode.(x) isa Vector{Int64}

    x = CategoricalVector{Int,UInt8}([3, 0, 1, 4, 0])
    levels!(x, [4, 1, 3, 0])
    @test levelcode.(x) ≅ [3, 4, 2, 1, 4]
    @test levelcode.(x) isa Vector{Int16}

    x = CategoricalVector{Union{Missing,Int},UInt8}([3, missing, 1, 4, missing])
    levels!(x, [4, 1, 3])
    @test levelcode.(x) ≅ [3, missing, 2, 1, missing]
    @test levelcode.(x) isa Vector{Union{Missing,Int16}}
end

@testset "fill()" begin
    for ordered in (false, true), dims in ([1], [(1,)], [2, 3], [(2, 3)], [], [()])
        x = CategoricalArray{String, 1, UInt8}(["a", "b", "c"],
                                            ordered=ordered)

        y = fill(x[1], dims...)
        yref = fill("a", dims...)
        @test y == yref
        @test y isa CategoricalArray{String, ndims(yref), UInt8}
        @test levels(y) == levels(x)
        @test isordered(y) === isordered(x)
    end
end

@testset "repeat" begin
    for o in (false, true), c in (false, true), i in 0:2,
        a in (["b", "a", "b"], ["b" "a"; "b" "c"],
              [missing, "a", "b"], ["b" "a"; missing "c"]),
        x in (categorical(a, ordered=o, compress=c),
              view(categorical(a, ordered=o, compress=c), axes(a)...),
              view(categorical([a a], ordered=o, compress=c), axes(a)...))
        xr = @inferred repeat(x, i)
        @test which(repeat, (typeof(x), Int)).module == CategoricalArrays
        @test typeof(parent(x)) == typeof(xr)
        @test isordered(x) == isordered(xr)
        @test xr ≅ categorical(repeat(a, i), ordered=o, compress=c)
        for j in 0:2
            ir = ntuple(x -> i, ndims(a))
            or = ntuple(x -> j, ndims(a))
            xr = @inferred repeat(x, inner=ir, outer=or)
            @test which(repeat, (typeof(x),)).module == CategoricalArrays
            @test typeof(parent(x)) == typeof(xr)
            @test isordered(x) == isordered(xr)
            @test xr ≅ categorical(repeat(a, inner=ir, outer=or), ordered=o, compress=c)
        end
    end
end

@testset "levels! with #undef" begin
    x = CategoricalVector(undef, 3)
    x[2] = "a"
    @test levels!(x, ["b", "a"]) === x
    @test levels(x) == ["b", "a"]
    @test x[2] == "a"
    @test !isassigned(x, 1)
    @test !isassigned(x, 3)
end

@testset "levels! with various vector types" begin
    for levs in (3:-1:1, categorical(3:-1:1),
                 3.0:-1.0:1.0, categorical(3.0:-1.0:1.0))
        x = CategoricalVector([1, 2, 3])
        @test levels!(x, levs) === x
        @test levels(x) == 3:-1:1
    end
end

# TODO: move struct definition inside @testset block once we require Julia 1.6
struct UnorderedBar <: Number
    a::String
end

@testset "vector of unordered" begin
    x0 = [UnorderedBar("s$i") for i in 1:10]
    x = CategoricalArray(x0)
    @test x == x0
    @test levels(x) == x0

    Base.isless(::UnorderedBar, ::UnorderedBar) = throw(ArgumentError("Blah"))
    @test_throws ArgumentError sort(x0)
    @test_throws ArgumentError CategoricalArray(x0)
end

struct MyCustomTypeMissing
    id::Vector{Int}
    var::CategoricalVector{Union{Missing,String}}
end
StructTypes.StructType(::Type{<:MyCustomTypeMissing}) = StructTypes.Struct()

struct MyCustomType
    id::Vector{Int}
    var::CategoricalVector{String}
end
StructTypes.StructType(::Type{<:MyCustomType}) = StructTypes.Struct()

@testset "Reading CategoricalVector objects using JSON3" begin
    x = CategoricalArray(["x","y","z","y","y","z"])
    str = JSON3.write(x)
    readx = JSON3.read(str, CategoricalArray)
    @test readx == x
    @test levels(readx) == levels(x)
    @test readx isa CategoricalVector{String}

    x = CategoricalArray([missing,"y","z","y",missing,"z","x"])
    str = JSON3.write(x)

    readx = JSON3.read(str, CategoricalVector)
    @test x ≅ readx
    @test sort(levels(readx)) == levels(x)
    @test readx isa CategoricalVector{Union{Missing,String}}

    readx = JSON3.read(str, CategoricalArray)
    @test x ≅ readx
    @test sort(levels(readx)) == levels(x)
    @test readx isa CategoricalVector{Union{Missing,String}}

    readx = JSON3.read(str, CategoricalArray{Union{Missing,String}})
    @test x ≅ readx
    @test levels(readx) == levels(x)
    @test readx isa CategoricalVector{Union{Missing,String}}

    readx = JSON3.read(str, CategoricalVector{Union{Missing,String}})
    @test x ≅ readx
    @test levels(readx) == levels(x)
    @test readx isa CategoricalVector{Union{Missing,String}}

    x = MyCustomType(
        collect(1:3),
        CategoricalArray(["x","y","z"])
    )
    str = JSON3.write(x)
    readx = JSON3.read(str, MyCustomType)
    @test readx.var == x.var
    @test levels(readx.var) == levels(x.var)

    x = MyCustomTypeMissing(
        collect(1:3),
        CategoricalArray(["x","y","z",missing])
    )
    str = JSON3.write(x)
    readx = JSON3.read(str, MyCustomTypeMissing)
    @test x.var ≅ readx.var
    @test levels(readx.var) == levels(x.var)
end

if Int == Int64
    @testset "writing and reading Arrow files" for f in (identity, passmissing(string))
        xref = f.([3, 1, 4, 1, 4])
        x = categorical(f.([3, 1, 4, 1, 4]))
        tbl = mktemp() do path, io
            Arrow.write(path, (x=x,))
            Arrow.Table(path)
        end
        @test tbl.x == x
        @test tbl.x isa Arrow.DictEncoded{CategoricalValue{eltype(xref), UInt32}, Int8,
                                          <: CategoricalVector{eltype(xref), UInt32}}
        @test copy(tbl.x) == x
        @test copy(x) isa CategoricalArray{eltype(xref),1,UInt32}

        x = categorical(f.([3, 1, 4, 1, 4]), compress=true)
        tbl = mktemp() do path, io
            Arrow.write(path, (x=x,))
            Arrow.Table(path)
        end
        @test tbl.x == x
        @test tbl.x isa Arrow.DictEncoded{CategoricalValue{eltype(xref), UInt8}, Int8,
                                          <: CategoricalVector{eltype(xref), UInt8}}
        @test copy(tbl.x) == x
        @test copy(x) isa CategoricalArray{eltype(xref),1,UInt8}

        x = categorical(recode(xref, 1 => missing))
        tbl = mktemp() do path, io
            Arrow.write(path, (x=x,))
            Arrow.Table(path)
        end
        @test tbl.x ≅ x
        @test tbl.x isa Arrow.DictEncoded{Union{CategoricalValue{eltype(xref), UInt32}, Missing},
                                          Int8,
                                          <: CategoricalVector{Union{eltype(xref), Missing},
                                                               UInt32}}
        @test copy(tbl.x) ≅ x
        @test copy(x) isa CategoricalArray{Union{eltype(xref), Missing},1,UInt32}

        recode!(x, missing => f(1))
        tbl = mktemp() do path, io
            Arrow.write(path, (x=x,))
            Arrow.Table(path)
        end
        @test tbl.x == x
        @test tbl.x isa Arrow.DictEncoded{Union{CategoricalValue{eltype(xref), UInt32}, Missing}, Int8,
                                          <: CategoricalVector{Union{eltype(xref), Missing}, UInt32}}
        @test copy(tbl.x) == x
        @test copy(x) isa CategoricalArray{Union{eltype(xref), Missing},1,UInt32}
    end
end

@testset "refarray, refvalue, refpool, and invrefpool" begin
    for y in (categorical(["b", "a", "c", "b"]),
              view(categorical(["a", "a", "c", "b"]), 1:3),
              categorical(["b" missing; "a" "c"; "b" missing]),
              view(categorical(["b" missing; "a" "c"; "b" missing]), 2:3, 1))
        @test DataAPI.refarray(y) === CategoricalArrays.refs(y)
        @test DataAPI.refvalue.(Ref(y), DataAPI.refarray(y)) ≅ y
        @test DataAPI.getindex.(Ref(DataAPI.refpool(y)), DataAPI.refarray(y)) ≅ y
        @test_throws BoundsError DataAPI.refvalue(y, -1)
        @test_throws BoundsError DataAPI.refvalue(y, length(levels(y))+1)
        if !(eltype(y) >: Missing)
            @test_throws BoundsError DataAPI.refvalue(y, 0)
        end

        rp = DataAPI.refpool(y)
        @test rp isa AbstractVector{eltype(y)}
        @test Base.IndexStyle(rp) isa Base.IndexLinear
        @test LinearIndices(rp) == axes(rp, 1)
        if eltype(y) >: Missing
            @test collect(rp) ≅ [missing; levels(y)]
            @test size(rp) == (length(levels(y)) + 1,)
            @test axes(rp) == (0:length(levels(y)),)
            if VERSION >= v"1.5"
                @test_throws ArgumentError reshape(rp, length(rp))
            end
        else
            @test collect(rp) == levels(y)
            @test size(rp) == (length(levels(y)),)
            @test axes(rp) == (1:length(levels(y)),)
            @test reshape(rp, length(rp)) == rp
            @test_throws BoundsError rp[0]
        end
        @test_throws BoundsError rp[-1]
        @test_throws BoundsError rp[end + 1]
        @test_throws MethodError similar(rp)

        irp = DataAPI.invrefpool(y)
        for lev in (eltype(y) >: Missing ? [missing; levels(y)] : levels(y))
            @test isequal(rp[irp[lev]], lev)
            @test isequal(rp[get(irp, lev, nothing)], lev)
        end

        @test_throws KeyError irp[1]
        @test_throws KeyError irp["z"]
        @test get(irp, 1, nothing) === nothing
        @test get(irp, "z", nothing) === nothing
        if !(eltype(y) >: Missing)
            @test_throws KeyError irp[missing]
        end
    end
end

@testset "unwrap" begin
    x = categorical(["a", missing, "b", missing])
    @test unwrap.(x) ≅ ["a", missing, "b", missing]
end

@testset "plot recipes" begin
    x = categorical(["B", "A", "C", "A"], levels=["C", "A", "B"])
    y = categorical([10, 1, missing, 2], levels=[10, 2, 1])

    res = RecipesBase.apply_recipe(Dict{Symbol, Any}(:plot_object => nothing), x, y)[1]
    @test res.args[1] isa Formatted
    @test res.args[1].data == [3, 2, 1, 2]
    @test res.args[2] isa Formatted
    @test res.args[2].data == [1, 3, 4, 2]
end

@testset "sizehint! tests and additional empty! tests" begin
    x = categorical([1])
    @test sizehint!(x, 1000) === x
    @test x == [1]
    @test_throws MethodError empty!(categorical([1 2; 3 4]))
    @test_throws MethodError sizehint!(categorical([1 2; 3 4]))
end


@testset "levels!() exceptions handling and rolling back to previous state" begin
    orig = ["A", "B", "B", "C", "D", "B", "A"]
    origmissing = convert(Vector{Union{String,Missing}}, orig)
    origmissing[2] = missing

    @testset "throws if duplicate levels provided" begin
        x = CategoricalArray(orig)
        oldpool = pool(x)
        @test_throws ArgumentError levels!(x, ["B", "A", "C", "D", "A"])
        @test x == orig
        @test pool(x) == oldpool
        @test levels(x) == ["A", "B", "C", "D"]
    end

    @testset "can drop unused levels if element type is $(eltype(x0))" for x0 in (orig, origmissing)
        x = CategoricalArray(x0)
        levels!(x, ["E", "A", "B", "C", "D"])
        @test levels(x) == ["E", "A", "B", "C", "D"]
        @test x === levels!(x, ["B", "A", "C", "D"])
        @test x ≅ x0
        @test levels(x) == ["B", "A", "C", "D"]
    end

    @testset "CategoricalArray which cannot store missings" begin
        x = CategoricalArray(orig)
        @test levels(x) == ["A", "B", "C", "D"]
        oldpool = pool(x)
        @test_throws ArgumentError levels!(x, ["B", "A", "C"])
        # check that the x contents have not changed
        @test x == orig
        @test pool(x) === oldpool
        @test levels(x) == ["A", "B", "C", "D"]

        # still throws even if allowmissing=true
        @test_throws ArgumentError levels!(x, ["B", "A", "C"], allowmissing=true)
        # check that the x contents have not changed
        @test x == orig
        @test pool(x) === oldpool
        @test levels(x) == ["A", "B", "C", "D"]
    end

    @testset "CategoricalArray which can store missing" begin
        x = CategoricalArray(origmissing)
        oldpool = pool(x)
        @test levels(x) == ["A", "B", "C", "D"]
        # throws if missings are not explicitly allowed
        @test_throws ArgumentError levels!(x, ["B", "A", "C"])
        # check that the x contents have not changed
        @test x ≅ origmissing
        @test pool(x) === oldpool
        @test levels(x) == ["A", "B", "C", "D"]

        @test x === levels!(x, ["B", "A", "C", "E"], allowmissing=true)
        @test x ≅ ["A", missing, "B", "C", missing, "B", "A"]
        @test levels(x) == ["B", "A", "C", "E"]
    end

    @testset "interaction with ChainedVector" begin
        x = ChainedVector([["a", "b"], ["c", "d", "e"]])
        @test CategoricalArray(x) == CategoricalArray{String}(x) ==
            CategoricalArray{Union{String, Missing}}(x) == x
        @test copy!(CategoricalArray{String}(undef, 5), x) ==
            copyto!(CategoricalArray{String}(undef, 5), x) ==
            copyto!(CategoricalArray{String}(undef, 5), 1, x, 1, 5) ==
            x

        x .= "z"
        y = categorical(["a", "b", "c", "d", "e"])
        @test copy!(x, y) == y
        x .= "z"
        @test copyto!(x, y) == y
        x .= "z"
        @test copyto!(x, 1, y, 1, 5) == y
    end
end

@testset "promotion" begin
    @test [CategoricalVector([1, 2]),
           CategoricalVector(["a", "b"])] isa
        Vector{CategoricalVector{<:Any, UInt32, <:Any, <:Any, Union{}}}
    @test [CategoricalVector([1, missing]),
           CategoricalVector(["a", "b"])] isa
        Vector{CategoricalVector{<:Any, UInt32}}
    @test [CategoricalVector([1, missing]),
           CategoricalVector([1, 2])] isa
        Vector{CategoricalVector{Union{Missing, Int}, UInt32, Int,
                                 CategoricalValue{Int, UInt32}, Missing}}
    @test [CategoricalVector([1, missing]),
           CategoricalVector(["a", missing])] isa
        Vector{CategoricalVector{<:Any, UInt32, <:Any, <:Any, Missing}}
    @test [CategoricalVector([Int8(1), missing]),
           CategoricalVector([Int16(2)])] isa
        Vector{CategoricalVector{<:Any, UInt32}}
    @test [CategoricalVector([1, 2]),
           CategoricalMatrix(["a" "b"])] isa
        Vector{CategoricalArray{<:Any, <:Any, UInt32, <:Any, <:Any, Union{}}}
    @test [CategoricalVector([1, 2]),
           CategoricalMatrix([1 2])] isa
        Vector{CategoricalArray{Int, <:Any, UInt32, Int,
                                CategoricalValue{Int, UInt32}, Union{}}}
    @test [CategoricalVector([1, 2]),
           CategoricalMatrix([1 missing])] isa
        Vector{CategoricalArray{<:Any, <:Any, UInt32, Int,
                                CategoricalValue{Int, UInt32}}}
    @test [categorical([1, 2], compress=true),
           CategoricalVector([1, 2])] isa
        Vector{CategoricalVector{Int, UInt32, Int, CategoricalValue{Int, UInt32}, Union{}}}
    @test [categorical([1, 2], compress=true),
           CategoricalVector(["a", "b"])] isa
        Vector{CategoricalVector{<:Any, <:Integer, <:Any, <:Any, Union{}}}
end

@testset "levels with skipmissing argument" begin
    for x in (categorical(["a", "b", "a"], levels=["b", "c", "a"]),
              view(categorical(["c", "b", "a"], levels=["b", "c", "a"]), 2:3))
        @test @inferred(levels(x)) == ["b", "c", "a"]
        @test @inferred(levels(x, skipmissing=true)) == ["b", "c", "a"]
        @test @inferred(levels(x, skipmissing=false)) == ["b", "c", "a"]
    end

    for x in (categorical(Union{String, Missing}["a", "b", "a"], levels=["b", "c", "a"]),
              view(categorical(Union{String, Missing}["c", "b", "a"], levels=["b", "c", "a"]), 2:3),
              view(categorical(Union{String, Missing}[missing, "b", "a"], levels=["b", "c", "a"]), 2:3))
        @test @inferred(levels(x)) == ["b", "c", "a"]
        @test levels(x, skipmissing=true) == ["b", "c", "a"]
        @test levels(x, skipmissing=true) isa CategoricalVector{String}
        @test levels(x, skipmissing=false) == ["b", "c", "a"]
        @test levels(x, skipmissing=false) isa CategoricalVector{Union{String, Missing}}
    end

    for x in (categorical(Union{String, Missing}["a", "b", missing], levels=["b", "c", "a"]),
              view(categorical(Union{String, Missing}["c", "b", missing], levels=["b", "c", "a"]), 2:3))
        @test @inferred(levels(x)) == ["b", "c", "a"]
        @test levels(x, skipmissing=true) == ["b", "c", "a"]
        @test levels(x, skipmissing=true) isa CategoricalVector{String}
        @test levels(x, skipmissing=false) ≅ ["b", "c", "a", missing]
        @test levels(x, skipmissing=false) isa CategoricalVector{Union{String, Missing}}
    end
end

end

module CategoricalArraysSentinelArraysExt

if isdefined(Base, :get_extension)
    using CategoricalArrays
    using SentinelArrays
else
    using ..CategoricalArrays
    using ..SentinelArrays
end

Base.copyto!(dest::CategoricalArrays.CatArrOrSub{<:Any, 1}, src::SentinelArrays.ChainedVector) =
    copyto!(dest, 1, src, 1, length(src))
Base.copyto!(dest::CategoricalArrays.CatArrOrSub{<:Any, 1}, dstart::Union{Signed, Unsigned},
    src::SentinelArrays.ChainedVector, sstart::Union{Signed, Unsigned},
    n::Union{Signed, Unsigned}) =
    invoke(copyto!, Tuple{AbstractArray, Union{Signed, Unsigned},
                        SentinelArrays.ChainedVector,
                        Union{Signed, Unsigned}, Union{Signed, Unsigned}},
        dest, dstart, src, sstart, n)

end

module TestHash
using Test
using CategoricalArrays

@testset "hash() for CategoricalPool{Int} and CategoricalPool{Float64} and its values" begin
    pool1 = CategoricalPool([1, 2, 3])
    pool2 = CategoricalPool([2.0, 1.0, 3.0])

    @test (hash(pool1) == hash(pool1)) === true
    @test (hash(pool1) == hash(pool2)) === false
    @test (hash(pool2) == hash(pool2)) === true

    opool1 = CategoricalPool([1, 2, 3], true)
    opool2 = CategoricalPool([2.0, 1.0, 3.0], true)

    @test (hash(opool1) == hash(opool1)) === true
    @test (hash(opool1) == hash(opool2)) === false
    @test (hash(opool2) == hash(opool2)) === true

    nv1a = CategoricalValue(pool1, 1)
    nv2a = CategoricalValue(pool2, 1)
    nv1b = CategoricalValue(pool1, 2)
    nv2b = CategoricalValue(pool2, 2)

    @test (hash(nv1a) == hash(nv1a)) === true
    @test (hash(nv1a) == hash(nv2a)) === false
    @test (hash(nv1a) == hash(nv1b)) === false
    @test (hash(nv1a) == hash(nv2b)) === true

    @test (hash(nv1b) == hash(nv1a)) === false
    @test (hash(nv1b) == hash(nv2a)) === true
    @test (hash(nv1b) == hash(nv1b)) === true
    @test (hash(nv1b) == hash(nv2b)) === false

    @test (hash(nv2a) == hash(nv1a)) === false
    @test (hash(nv2a) == hash(nv2a)) === true
    @test (hash(nv2a) == hash(nv1b)) === true
    @test (hash(nv2a) == hash(nv2b)) === false

    @test (hash(nv2b) == hash(nv1a)) === true
    @test (hash(nv2b) == hash(nv2a)) === false
    @test (hash(nv2b) == hash(nv1b)) === false
    @test (hash(nv2b) == hash(nv2b)) === true

    ov1a = CategoricalValue(opool1, 1)
    ov2a = CategoricalValue(opool2, 1)
    ov1b = CategoricalValue(opool1, 2)
    ov2b = CategoricalValue(opool2, 2)

    @test (hash(ov1a) == hash(ov1a)) === true
    @test (hash(ov1a) == hash(ov2a)) === false
    @test (hash(ov1a) == hash(ov1b)) === false
    @test (hash(ov1a) == hash(ov2b)) === true

    @test (hash(ov1b) == hash(ov1a)) === false
    @test (hash(ov1b) == hash(ov2a)) === true
    @test (hash(ov1b) == hash(ov1b)) === true
    @test (hash(ov1b) == hash(ov2b)) === false

    @test (hash(ov2a) == hash(ov1a)) === false
    @test (hash(ov2a) == hash(ov2a)) === true
    @test (hash(ov2a) == hash(ov1b)) === true
    @test (hash(ov2a) == hash(ov2b)) === false

    @test (hash(ov2b) == hash(ov1a)) === true
    @test (hash(ov2b) == hash(ov2a)) === false
    @test (hash(ov2b) == hash(ov1b)) === false
    @test (hash(ov2b) == hash(ov2b)) === true

    @testset "ordered and non-ordered values hash equal" begin
    @test (hash(ov1a) == hash(nv1a)) === true
    @test (hash(ov1a) == hash(nv2a)) === false
    @test (hash(ov1a) == hash(nv1b)) === false
    @test (hash(ov1a) == hash(nv2b)) === true

    @test (hash(ov1b) == hash(nv1a)) === false
    @test (hash(ov1b) == hash(nv2a)) === true
    @test (hash(ov1b) == hash(nv1b)) === true
    @test (hash(ov1b) == hash(nv2b)) === false

    @test (hash(ov2a) == hash(nv1a)) === false
    @test (hash(ov2a) == hash(nv2a)) === true
    @test (hash(ov2a) == hash(nv1b)) === true
    @test (hash(ov2a) == hash(nv2b)) === false

    @test (hash(ov2b) == hash(nv1a)) === true
    @test (hash(ov2b) == hash(nv2a)) === false
    @test (hash(ov2b) == hash(nv1b)) === false
    @test (hash(ov2b) == hash(nv2b)) === true
    end
end

end

module TestMissingArray
using Test
using CategoricalArrays
using CategoricalArrays: DefaultRefType, leveltype
using Missings

const ≅ = isequal

@testset "conversion ordered=$ordered" for ordered in (false, true)
    @testset "conversion reftype=$R" for R in (CategoricalArrays.DefaultRefType, UInt8, UInt, Int8, Int)
        @testset "conversion of $(typeof(a))" for a in (["b", "a", "b"], Union{String, Missing}["b", "a", "b"])
            @testset "Vector with no missing values" begin
                x = CategoricalVector{Union{String, Missing}, R}(a, ordered=ordered)

                @test x == a
                @test leveltype(typeof(x)) === String
                @test leveltype(x) === String
                @test eltype(x) === Union{CategoricalValue{String, R}, Missing}
                @test isordered(x) === ordered
                @test levels(x) == sort(unique(a))
                @test unique(x) == unique(a)
                @test typeof(unique(x)) === typeof(x)
                @test size(x) === (3,)
                @test length(x) === 3

                y = copy(x)
                @test y === unique!(y)
                @test y == unique(x)

                @test convert(CategoricalArray, x) === x
                @test convert(CategoricalArray{Union{String, Missing}}, x) === x
                @test convert(CategoricalArray{Union{String, Missing}, 1}, x) === x
                @test convert(CategoricalArray{Union{String, Missing}, 1, R}, x) === x
                @test convert(CategoricalArray{Union{String, Missing}, 1, DefaultRefType}, x) == x
                @test convert(CategoricalArray{Union{String, Missing}, 1, UInt8}, x) == x

                @test convert(CategoricalVector, x) === x
                @test convert(CategoricalVector{Union{String, Missing}}, x) === x
                @test convert(CategoricalVector{Union{String, Missing}, R}, x) === x
                @test convert(CategoricalVector{Union{String, Missing}, DefaultRefType}, x) == x
                @test convert(CategoricalVector{Union{String, Missing}, UInt8}, x) == x

                @test convert(CategoricalArray, a) == x
                @test convert(CategoricalArray{Union{String, Missing}}, a) == x
                @test convert(CategoricalArray{Union{String, Missing}, 1}, a) == x
                @test convert(CategoricalArray{Union{String, Missing}, 1, R}, a) == x
                @test convert(CategoricalArray{Union{String, Missing}, 1, DefaultRefType}, a) == x
                @test convert(CategoricalArray{Union{String, Missing}, 1, UInt8}, a) == x

                @test convert(CategoricalVector, a) == x
                @test convert(CategoricalVector{Union{String, Missing}}, a) == x
                @test convert(CategoricalVector{Union{String, Missing}, R}, a) == x
                @test convert(CategoricalVector{Union{String, Missing}, DefaultRefType}, a) == x
                @test convert(CategoricalVector{Union{String, Missing}, UInt8}, a) == x

                @test CategoricalArray{Union{String, Missing}}(a, ordered=ordered) == x
                @test CategoricalArray{Union{String, Missing}, 1}(a, ordered=ordered) == x
                @test CategoricalArray{Union{String, Missing}, 1, R}(a, ordered=ordered) == x
                @test CategoricalArray{Union{String, Missing}, 1, DefaultRefType}(a, ordered=ordered) == x
                @test CategoricalArray{Union{String, Missing}, 1, UInt8}(a, ordered=ordered) == x

                @test CategoricalVector(a, ordered=ordered) == x
                @test CategoricalVector{Union{String, Missing}}(a, ordered=ordered) == x
                @test CategoricalVector{Union{String, Missing}, R}(a, ordered=ordered) == x
                @test CategoricalVector{Union{String, Missing}, DefaultRefType}(a, ordered=ordered) == x
                @test CategoricalVector{Union{String, Missing}, UInt8}(a, ordered=ordered) == x

                @test convert(CategoricalArray{String}, x) == x
                @test convert(CategoricalArray{String, 1}, x) == x
                @test convert(CategoricalArray{String, 1, R}, x) == x
                @test convert(CategoricalArray{String, 1, DefaultRefType}, x) == x
                @test convert(CategoricalArray{String, 1, UInt8}, x) == x

                @test convert(CategoricalVector{String}, x) == x
                @test convert(CategoricalVector{String, R}, x) == x
                @test convert(CategoricalVector{String, DefaultRefType}, x) == x
                @test convert(CategoricalVector{String, UInt8}, x) == x

                @test CategoricalArray{String, 1}(x, ordered=ordered) == x
                @test CategoricalArray{String, 1, R}(x, ordered=ordered) == x
                @test CategoricalArray{String, 1, DefaultRefType}(x, ordered=ordered) == x
                @test CategoricalArray{String, 1, UInt8}(x, ordered=ordered) == x

                @test CategoricalVector{String}(x, ordered=ordered) == x
                @test CategoricalVector{String, R}(x, ordered=ordered) == x
                @test CategoricalVector{String, DefaultRefType}(x, ordered=ordered) == x
                @test CategoricalVector{String, UInt8}(x, ordered=ordered) == x

                @testset "categorical($(typeof(y)), compress=$comp) R1=$R1 R2=$R2" for (y, R1, R2, comp) in
                    ((a, DefaultRefType, UInt8, true),
                     (a, DefaultRefType, DefaultRefType, false),
                     (x, R, UInt8, true),
                     (x, R, R, false))

                    x2 = @inferred categorical(y, ordered=ordered)
                    @test leveltype(x2) === String
                    @test nonmissingtype(eltype(x2)) === CategoricalValue{String, R1}
                    @test x2 == y
                    if eltype(y) >: Missing
                        @test isa(x2, CategoricalVector{Union{String, Missing}, R1})
                    else
                        @test isa(x2, CategoricalVector{String, R1})
                    end
                    @test isordered(x2) === ordered

                    x2 = categorical(y, compress=comp, ordered=ordered)
                    @test x2 == y
                    @test leveltype(x2) === String
                    @test nonmissingtype(eltype(x2)) === CategoricalValue{String, R2}
                    if eltype(y) >: Missing
                        @test isa(x2, CategoricalVector{Union{String, Missing}, R2})
                    else
                        @test isa(x2, CategoricalVector{String, R2})
                    end
                    @test isordered(x2) === ordered
                end

                x2 = compress(x)
                @test x2 == x
                @test isa(x2, CategoricalVector{Union{String, Missing}, UInt8})
                @test isordered(x2) === isordered(x)
                @test levels(x2) == levels(x)

                x2 = copy(x)
                @test x2 == x
                @test isordered(x2) === isordered(x)
                @test typeof(x2) === typeof(x)
                @test levels(x2) == levels(x)

                if !isordered(x)
                    @test ordered!(x, true) === x
                    @test isordered(x) === true
                end
                @test x[1] > x[2]
                @test x[3] > x[2]

                @test ordered!(x, false) === x
                @test isordered(x) === false
                @test_throws Exception x[1] > x[2]
                @test_throws Exception x[3] > x[2]

                @test x[1] === CategoricalValue(x.pool, 2)
                @test x[2] === CategoricalValue(x.pool, 1)
                @test x[3] === CategoricalValue(x.pool, 2)
                @test_throws BoundsError x[4]

                x2 = x[:]
                @test typeof(x2) === typeof(x)
                @test x2 == x
                @test x2 !== x
                @test levels(x2) == levels(x)
                @test levels(x2) !== levels(x)
                @test isordered(x2) == isordered(x)

                x2 = x[2:3]
                @test typeof(x2) === typeof(x)
                @test x2 == ["a", "b"]
                @test levels(x2) == levels(x)
                @test levels(x2) !== levels(x)
                @test isordered(x2) == isordered(x)

                x2 = x[1:1]
                @test typeof(x2) === typeof(x)
                @test x2 == ["b"]
                @test levels(x2) == levels(x)
                @test levels(x2) !== levels(x)
                @test isordered(x2) == isordered(x)

                x2 = x[2:1]
                @test typeof(x2) === typeof(x)
                @test isempty(x2)
                @test levels(x2) == levels(x)
                @test levels(x2) !== levels(x)
                @test isordered(x2) == isordered(x)

                x[1] = x[2]
                @test x[1] === CategoricalValue(x.pool, 1)
                @test x[2] === CategoricalValue(x.pool, 1)
                @test x[3] === CategoricalValue(x.pool, 2)

                x[3] = "c"
                @test x[1] === CategoricalValue(x.pool, 1)
                @test x[2] === CategoricalValue(x.pool, 1)
                @test x[3] === CategoricalValue(x.pool, 3)
                @test levels(x) == ["a", "b", "c"]

                x[2:3] .= "b"
                @test x[1] === CategoricalValue(x.pool, 1)
                @test x[2] === CategoricalValue(x.pool, 2)
                @test x[3] === CategoricalValue(x.pool, 2)
                @test levels(x) == ["a", "b", "c"]

                @test droplevels!(x) === x
                @test levels(x) == ["a", "b"]
                @test x[1] === CategoricalValue(x.pool, 1)
                @test x[2] === CategoricalValue(x.pool, 2)
                @test x[3] === CategoricalValue(x.pool, 2)
                @test levels(x) == ["a", "b"]

                @test levels!(x, ["b", "a"]) === x
                @test levels(x) == ["b", "a"]
                @test x[1] === CategoricalValue(x.pool, 2)
                @test x[2] === CategoricalValue(x.pool, 1)
                @test x[3] === CategoricalValue(x.pool, 1)
                @test levels(x) == ["b", "a"]

                @test_throws ArgumentError levels!(x, ["a"])
                # check that x is restored correctly when dropping levels is not allowed
                @test x == ["a", "b", "b"]
                @test levels(x) == ["b", "a"]

                @test_throws ArgumentError levels!(x, ["e", "b"])

                @test_throws ArgumentError levels!(x, ["e", "a", "b", "a"])
                # once again check that x is restored correctly when dropping levels is not allowed
                @test x == ["a", "b", "b"]
                @test levels(x) == ["b", "a"]

                @test levels!(x, ["e", "a", "b"]) === x
                @test levels(x) == ["e", "a", "b"]
                @test x[1] === CategoricalValue(x.pool, 2)
                @test x[2] === CategoricalValue(x.pool, 3)
                @test x[3] === CategoricalValue(x.pool, 3)
                @test levels(x) == ["e", "a", "b"]

                x[1] = "c"
                @test x[1] === CategoricalValue(x.pool, 4)
                @test x[2] === CategoricalValue(x.pool, 3)
                @test x[3] === CategoricalValue(x.pool, 3)
                @test levels(x) == ["e", "a", "b", "c"]

                # check once more that x is restored correctly when dropping levels is not allowed
                @test_throws ArgumentError levels!(x, ["e", "c"])
                @test x == ["c", "b", "b"]
                @test levels(x) == ["e", "a", "b", "c"]
                # check that with allowed missings the absent levels are converted to missing
                @test levels!(x, ["e", "c"], allowmissing=true) === x
                @test levels(x) == ["e", "c"]
                @test x[1] === CategoricalValue(x.pool, 2)
                @test x[2] === missing
                @test x[3] === missing

                y = copy(x)

                push!(x, "e")
                @test length(x) == 4
                @test x ≅ ["c", missing, missing, "e"]
                @test levels(x) == ["e", "c"]

                push!(x, "zz")
                @test length(x) == 5
                @test x ≅ ["c", missing, missing, "e", "zz"]
                @test levels(x) == ["e", "c", "zz"]

                push!(x, x[1])
                @test length(x) == 6
                @test x ≅ ["c", missing, missing, "e", "zz", "c"]
                @test levels(x) == ["e", "c", "zz"]

                push!(x, missing)
                @test length(x) == 7
                @test x ≅ ["c", missing, missing, "e", "zz", "c", missing]
                @test levels(x) == ["e", "c", "zz"]

                empty!(x)
                @test isordered(x) === false
                @test length(x) == 0
                @test levels(x) == ["e", "c", "zz"]

                x = y
                insert!(x, 4, "e")
                @test length(x) == 4
                @test x ≅ ["c", missing, missing, "e"]
                @test levels(x) == ["e", "c"]

                insert!(x, 5, "zz")
                @test length(x) == 5
                @test x ≅ ["c", missing, missing, "e", "zz"]
                @test levels(x) == ["e", "c", "zz"]

                insert!(x, 6, x[1])
                @test length(x) == 6
                @test x ≅ ["c", missing, missing, "e", "zz", "c"]
                @test levels(x) == ["e", "c", "zz"]

                insert!(x, 7, missing)
                @test length(x) == 7
                @test x ≅ ["c", missing, missing, "e", "zz", "c", missing]
                @test levels(x) == ["e", "c", "zz"]

                @test_throws ArgumentError insert!(x, true, missing)
                @test_throws BoundsError insert!(x, 0, missing)
                @test_throws BoundsError insert!(x, 100, missing)
            end
        end

        @testset "Vector with missing values" begin
            a = ["a", "b", missing]
            x = CategoricalVector{Union{String, Missing}, R}(a, ordered=ordered)

            @test x ≅ a
            @test levels(x) == filter(x->!ismissing(x), unique(a))
            @test unique(x) ≅ unique(a)
            @test typeof(unique(x)) === typeof(x)
            @test size(x) === (3,)
            @test length(x) === 3

            @test convert(CategoricalArray, x) === x
            @test convert(CategoricalArray{Union{String, Missing}}, x) === x
            @test convert(CategoricalArray{Union{String, Missing}, 1}, x) === x
            @test convert(CategoricalArray{Union{String, Missing}, 1, R}, x) === x
            @test convert(CategoricalArray{Union{String, Missing}, 1, DefaultRefType}, x) ≅ x
            @test convert(CategoricalArray{Union{String, Missing}, 1, UInt8}, x) ≅ x

            @test convert(CategoricalVector, x) === x
            @test convert(CategoricalVector{Union{String, Missing}}, x) === x
            @test convert(CategoricalVector{Union{String, Missing}, R}, x) === x
            @test convert(CategoricalVector{Union{String, Missing}, DefaultRefType}, x) ≅ x
            @test convert(CategoricalVector{Union{String, Missing}, UInt8}, x) ≅ x

            @test convert(CategoricalArray, a) ≅ x
            @test convert(CategoricalArray{Union{String, Missing}}, a) ≅ x
            @test convert(CategoricalArray{Union{String, Missing}, 1}, a) ≅ x
            @test convert(CategoricalArray{Union{String, Missing}, 1, R}, a) ≅ x
            @test convert(CategoricalArray{Union{String, Missing}, 1, DefaultRefType}, a) ≅ x
            @test convert(CategoricalArray{Union{String, Missing}, 1, UInt8}, a) ≅ x

            @test convert(CategoricalVector, a) ≅ x
            @test convert(CategoricalVector{Union{String, Missing}}, a) ≅ x
            @test convert(CategoricalVector{Union{String, Missing}, R}, a) ≅ x
            @test convert(CategoricalVector{Union{String, Missing}, DefaultRefType}, a) ≅ x
            @test convert(CategoricalVector{Union{String, Missing}, UInt8}, a) ≅ x

            @test CategoricalArray{Union{String, Missing}}(a, ordered=ordered) ≅ x
            @test CategoricalArray{Union{String, Missing}, 1}(a, ordered=ordered) ≅ x
            @test CategoricalArray{Union{String, Missing}, 1, R}(a, ordered=ordered) ≅ x
            @test CategoricalArray{Union{String, Missing}, 1, DefaultRefType}(a, ordered=ordered) ≅ x
            @test CategoricalArray{Union{String, Missing}, 1, UInt8}(a, ordered=ordered) ≅ x

            @test CategoricalVector(a, ordered=ordered) ≅ x
            @test CategoricalVector{Union{String, Missing}}(a, ordered=ordered) ≅ x
            @test CategoricalVector{Union{String, Missing}, R}(a, ordered=ordered) ≅ x
            @test CategoricalVector{Union{String, Missing}, DefaultRefType}(a, ordered=ordered) ≅ x
            @test CategoricalVector{Union{String, Missing}, UInt8}(a, ordered=ordered) ≅ x

            @testset "categorical($(typeof(y)), compress=$comp) R1=$R1 R2=$R2" for (y, R1, R2, comp) in
                ((a, DefaultRefType, UInt8, true),
                 (a, DefaultRefType, DefaultRefType, false),
                 (x, R, UInt8, true),
                 (x, R, R, false))

                x2 = @inferred categorical(y, ordered=ordered)
                @test x2 ≅ y
                if eltype(y) >: Missing
                    @test isa(x2, CategoricalVector{Union{String, Missing}, R1})
                else
                    @test isa(x2, CategoricalVector{String, R1})
                end
                @test isordered(x2) === ordered

                x2 = categorical(y, compress=comp, ordered=ordered)
                @test x2 ≅ y
                if eltype(y) >: Missing
                    @test isa(x2, CategoricalVector{Union{String, Missing}, R2})
                else
                    @test isa(x2, CategoricalVector{String, R2})
                end
                @test isordered(x2) === ordered
            end

            x2 = compress(x)
            @test x2 ≅ x
            @test isa(x2, CategoricalVector{Union{String, Missing}, UInt8})
            @test levels(x2) == levels(x)

            x2 = copy(x)
            @test x2 ≅ x
            @test typeof(x2) === typeof(x)
            @test levels(x2) == levels(x)

            @test x[1] === CategoricalValue(x.pool, 1)
            @test x[2] === CategoricalValue(x.pool, 2)
            @test x[3] === missing
            @test_throws BoundsError x[4]

            x2 = x[:]
            @test typeof(x2) === typeof(x)
            @test x2 ≅ x
            @test x2 !== x
            @test levels(x2) == levels(x)
            @test levels(x2) !== levels(x)
            @test isordered(x2) == isordered(x)

            x2 = x[2:3]
            @test typeof(x2) === typeof(x)
            @test x2 ≅ ["b", missing]
            @test levels(x2) == levels(x)
            @test levels(x2) !== levels(x)
            @test isordered(x2) == isordered(x)

            x2 = x[1:1]
            @test typeof(x2) === typeof(x)
            @test x2 == ["a"]
            @test levels(x2) == levels(x)
            @test levels(x2) !== levels(x)
            @test isordered(x2) == isordered(x)

            x2 = x[2:1]
            @test typeof(x2) === typeof(x)
            @test isempty(x2)
            @test levels(x2) == levels(x)
            @test levels(x2) !== levels(x)
            @test isordered(x2) == isordered(x)

            x[1] = "b"
            @test x[1] === CategoricalValue(x.pool, 2)
            @test x[2] === CategoricalValue(x.pool, 2)
            @test x[3] === missing

            x[3] = "c"
            @test x[1] === CategoricalValue(x.pool, 2)
            @test x[2] === CategoricalValue(x.pool, 2)
            @test x[3] === CategoricalValue(x.pool, 3)
            @test isordered(x) === false
            @test levels(x) == ["a", "b", "c"]

            x[1] = missing
            @test x[1] === missing
            @test x[2] === CategoricalValue(x.pool, 2)
            @test x[3] === CategoricalValue(x.pool, 3)
            @test levels(x) == ["a", "b", "c"]

            x[2:3] .= missing
            @test x[1] === missing
            @test x[2] === missing
            @test x[3] === missing
            @test levels(x) == ["a", "b", "c"]
        end

        @testset "Vector created from range" begin
        # (i.e. non-Array AbstractArray),
        # direct conversion to a vector with different eltype
        a = 0.0:0.5:1.5
        x = CategoricalVector{Union{Float64, Missing}, R}(a, ordered=ordered)

        @test x == collect(a)
        @test isordered(x) === ordered
        @test levels(x) == unique(x) == unique(a)
        @test typeof(unique(x)) === typeof(x)
        @test size(x) === (4,)
        @test length(x) === 4
        @test leveltype(x) === Float64
        @test eltype(x) == Union{CategoricalValue{Float64, R}, Missing}

        @test convert(CategoricalArray, x) === x
        @test convert(CategoricalArray{Union{Float64, Missing}}, x) === x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1}, x) === x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1, R}, x) === x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1, DefaultRefType}, x) == x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1, UInt8}, x) == x

        @test convert(CategoricalVector, x) === x
        @test convert(CategoricalVector{Union{Float64, Missing}}, x) === x
        @test convert(CategoricalVector{Union{Float64, Missing}, R}, x) === x
        @test convert(CategoricalVector{Union{Float64, Missing}, DefaultRefType}, x) == x
        @test convert(CategoricalVector{Union{Float64, Missing}, UInt8}, x) == x

        @test convert(CategoricalArray, a) == x
        @test convert(CategoricalArray{Union{Float64, Missing}}, a) == x
        @test convert(CategoricalArray{Union{Float32, Missing}}, a) == x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1}, a) == x
        @test convert(CategoricalArray{Union{Float32, Missing}, 1}, a) == x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1, R}, a) == x
        @test convert(CategoricalArray{Union{Float32, Missing}, 1, R}, a) == x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1, DefaultRefType}, a) == x
        @test convert(CategoricalArray{Union{Float32, Missing}, 1, DefaultRefType}, a) == x
        @test convert(CategoricalArray{Union{Float64, Missing}, 1, UInt8}, a) == x
        @test convert(CategoricalArray{Union{Float32, Missing}, 1, UInt8}, a) == x

        @test convert(CategoricalVector, a) == x
        @test convert(CategoricalVector{Union{Float64, Missing}}, a) == x
        @test convert(CategoricalVector{Union{Float32, Missing}}, a) == x
        @test convert(CategoricalVector{Union{Float64, Missing}, R}, a) == x
        @test convert(CategoricalVector{Union{Float32, Missing}, R}, a) == x
        @test convert(CategoricalVector{Union{Float64, Missing}, DefaultRefType}, a) == x
        @test convert(CategoricalVector{Union{Float32, Missing}, DefaultRefType}, a) == x
        @test convert(CategoricalVector{Union{Float64, Missing}, UInt8}, a) == x
        @test convert(CategoricalVector{Union{Float32, Missing}, UInt8}, a) == x

        @test CategoricalArray{Union{Float64, Missing}}(a, ordered=ordered) == x
        @test CategoricalArray{Union{Float32, Missing}}(a, ordered=ordered) == x
        @test CategoricalArray{Union{Float64, Missing}, 1}(a, ordered=ordered) == x
        @test CategoricalArray{Union{Float32, Missing}, 1}(a, ordered=ordered) == x
        @test CategoricalArray{Union{Float64, Missing}, 1, R}(a, ordered=ordered) == x
        @test CategoricalArray{Union{Float32, Missing}, 1, R}(a, ordered=ordered) == x
        @test CategoricalArray{Union{Float64, Missing}, 1, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalArray{Union{Float32, Missing}, 1, DefaultRefType}(a, ordered=ordered) == x

        @test CategoricalVector(a, ordered=ordered) == x
        @test CategoricalVector{Union{Float64, Missing}}(a, ordered=ordered) == x
        @test CategoricalVector{Union{Float32, Missing}}(a, ordered=ordered) == x
        @test CategoricalVector{Union{Float64, Missing}, R}(a, ordered=ordered) == x
        @test CategoricalVector{Union{Float32, Missing}, R}(a, ordered=ordered) == x
        @test CategoricalVector{Union{Float64, Missing}, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalVector{Union{Float32, Missing}, DefaultRefType}(a, ordered=ordered) == x

        @test convert(CategoricalArray{Float64}, x) == x
        @test convert(CategoricalArray{Float32}, x) == x
        @test convert(CategoricalArray{Float64, 1}, x) == x
        @test convert(CategoricalArray{Float32, 1}, x) == x
        @test convert(CategoricalArray{Float64, 1, R}, x) == x
        @test convert(CategoricalArray{Float32, 1, R}, x) == x
        @test convert(CategoricalArray{Float64, 1, DefaultRefType}, x) == x
        @test convert(CategoricalArray{Float32, 1, DefaultRefType}, x) == x
        @test convert(CategoricalArray{Float64, 1, UInt8}, x) == x
        @test convert(CategoricalArray{Float32, 1, UInt8}, x) == x

        @test convert(CategoricalVector{Float64}, x) == x
        @test convert(CategoricalVector{Float32}, x) == x
        @test convert(CategoricalVector{Float64, R}, x) == x
        @test convert(CategoricalVector{Float32, R}, x) == x
        @test convert(CategoricalVector{Float64, DefaultRefType}, x) == x
        @test convert(CategoricalVector{Float32, DefaultRefType}, x) == x
        @test convert(CategoricalVector{Float64, UInt8}, x) == x
        @test convert(CategoricalVector{Float32, UInt8}, x) == x

        @test CategoricalArray{Float64}(a, ordered=ordered) == x
        @test CategoricalArray{Float32}(a, ordered=ordered) == x
        @test CategoricalArray{Float64, 1}(a, ordered=ordered) == x
        @test CategoricalArray{Float32, 1}(a, ordered=ordered) == x
        @test CategoricalArray{Float64, 1, R}(a, ordered=ordered) == x
        @test CategoricalArray{Float32, 1, R}(a, ordered=ordered) == x
        @test CategoricalArray{Float64, 1, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalArray{Float32, 1, DefaultRefType}(a, ordered=ordered) == x

        @test CategoricalVector{Float64}(a, ordered=ordered) == x
        @test CategoricalVector{Float32}(a, ordered=ordered) == x
        @test CategoricalVector{Float64, R}(a, ordered=ordered) == x
        @test CategoricalVector{Float32, R}(a, ordered=ordered) == x
        @test CategoricalVector{Float64, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalVector{Float32, DefaultRefType}(a, ordered=ordered) == x

        @testset "categorical($(typeof(y)), compress=$comp) R1=$R1 R2=$R2" for (y, R1, R2, comp) in
            ((a, DefaultRefType, UInt8, true),
             (a, DefaultRefType, DefaultRefType, false),
             (x, R, UInt8, true),
             (x, R, R, false))

            x2 = @inferred categorical(y, ordered=ordered)
            @test x2 == collect(y)
            if eltype(y) >: Missing
                @test isa(x2, CategoricalVector{Union{Float64, Missing}, R1})
            else
                @test isa(x2, CategoricalVector{Float64, R1})
            end
            @test isordered(x2) === ordered
            @test leveltype(x2) === Float64
            @test nonmissingtype(eltype(x2)) === CategoricalValue{Float64, R1}

            x2 = categorical(y, compress=comp, ordered=ordered)
            @test x2 == collect(y)
            if eltype(y) >: Missing
                @test isa(x2, CategoricalVector{Union{Float64, Missing}, R2})
            else
                @test isa(x2, CategoricalVector{Float64, R2})
            end
            @test isordered(x2) === ordered
            @test leveltype(x2) === Float64
            @test nonmissingtype(eltype(x2)) === CategoricalValue{Float64, R2}
        end

        x2 = compress(x)
        @test x2 == x
        @test isordered(x2) === isordered(x)
        @test isa(x2, CategoricalVector{Union{Float64, Missing}, UInt8})
        @test levels(x2) == levels(x)

        x2 = copy(x)
        @test x2 == x
        @test isordered(x2) === isordered(x)
        @test typeof(x2) === typeof(x)
        @test levels(x2) == levels(x)

        @test x[1] === CategoricalValue(x.pool, 1)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 3)
        @test x[4] === CategoricalValue(x.pool, 4)
        @test_throws BoundsError x[5]

        x2 = x[:]
        @test typeof(x2) === typeof(x)
        @test x2 == x
        @test x2 !== x
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[1:2]
        @test typeof(x2) === typeof(x)
        @test x2 == [0.0, 0.5]
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[1:1]
        @test typeof(x2) === typeof(x)
        @test x2 == [0.0]
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[2:1]
        @test typeof(x2) === typeof(x)
        @test isempty(x2)
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x[2] = 1
        @test x[1] === CategoricalValue(x.pool, 1)
        @test x[2] === CategoricalValue(x.pool, 3)
        @test x[3] === CategoricalValue(x.pool, 3)
        @test x[4] === CategoricalValue(x.pool, 4)
        @test levels(x) == unique(a)
        @test unique(x) == unique(collect(x))
        @test typeof(unique(x)) === typeof(x)

        x[1:2] .= -1
        @test x[1] === CategoricalValue(x.pool, 5)
        @test x[2] === CategoricalValue(x.pool, 5)
        @test x[3] === CategoricalValue(x.pool, 3)
        @test x[4] === CategoricalValue(x.pool, 4)
        @test isordered(x) === false
        @test levels(x) == vcat(unique(a), -1)
        @test unique(x) == unique(collect(x))
        @test typeof(unique(x)) === typeof(x)


        ordered!(x, ordered)
        push!(x, 2.0)
        @test length(x) == 5
        @test x == [-1.0, -1.0, 1.0, 1.5, 2.0]
        @test isordered(x) === false
        @test levels(x) == [0.0,  0.5,  1.0,  1.5, -1.0,  2.0]

        ordered!(x, ordered)
        push!(x, x[1])
        @test length(x) == 6
        @test x == [-1.0, -1.0, 1.0, 1.5, 2.0, -1.0]
        @test isordered(x) === ordered
        @test levels(x) == [0.0,  0.5,  1.0,  1.5, -1.0,  2.0]

        empty!(x)
        @test length(x) == 0
        @test isordered(x) === ordered
        @test levels(x) == [0.0, 0.5, 1.0, 1.5, -1.0, 2.0]
    end

    @testset "Matrix $(typeof(a)) with no missing values" for a in
        (["a" "b" "c"; "b" "a" "c"],
         Union{String, Missing}["a" "b" "c"; "b" "a" "c"])

        x = CategoricalMatrix{Union{String, Missing}, R}(a, ordered=ordered)

        @test x == a
        @test isordered(x) === ordered
        @test levels(x) == unique(x) == unique(a)
        @test unique(x) isa CategoricalVector{Union{String, Missing}, R}
        @test size(x) === (2, 3)
        @test length(x) === 6

        @test convert(CategoricalArray, x) === x
        @test convert(CategoricalArray{Union{String, Missing}}, x) === x
        @test convert(CategoricalArray{Union{String, Missing}, 2}, x) === x
        @test convert(CategoricalArray{Union{String, Missing}, 2, R}, x) === x
        @test convert(CategoricalArray{Union{String, Missing}, 2, DefaultRefType}, x) == x
        @test convert(CategoricalArray{Union{String, Missing}, 2, UInt8}, x) == x

        @test convert(CategoricalMatrix, x) === x
        @test convert(CategoricalMatrix{Union{String, Missing}}, x) === x
        @test convert(CategoricalMatrix{Union{String, Missing}, R}, x) === x
        @test convert(CategoricalMatrix{Union{String, Missing}, DefaultRefType}, x) == x
        @test convert(CategoricalMatrix{Union{String, Missing}, UInt8}, x) == x

        @test convert(CategoricalArray, a) == x
        @test convert(CategoricalArray{Union{String, Missing}}, a) == x
        @test convert(CategoricalArray{Union{String, Missing}, 2, R}, a) == x
        @test convert(CategoricalArray{Union{String, Missing}, 2, DefaultRefType}, a) == x
        @test convert(CategoricalArray{Union{String, Missing}, 2, UInt8}, a) == x

        @test convert(CategoricalMatrix, a) == x
        @test convert(CategoricalMatrix{Union{String, Missing}}, a) == x
        @test convert(CategoricalMatrix{Union{String, Missing}, R}, a) == x
        @test convert(CategoricalMatrix{Union{String, Missing}, DefaultRefType}, a) == x
        @test convert(CategoricalMatrix{Union{String, Missing}, UInt8}, a) == x

        @test CategoricalArray{Union{String, Missing}}(a, ordered=ordered) == x
        @test CategoricalArray{Union{String, Missing}, 2}(a, ordered=ordered) == x
        @test CategoricalArray{Union{String, Missing}, 2}(a, ordered=ordered) == x
        @test CategoricalArray{Union{String, Missing}, 2, R}(a, ordered=ordered) == x
        @test CategoricalArray{Union{String, Missing}, 2, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalArray{Union{String, Missing}, 2, UInt8}(a, ordered=ordered) == x

        @test CategoricalMatrix(a, ordered=ordered) == x
        @test CategoricalMatrix{Union{String, Missing}}(a, ordered=ordered) == x
        @test CategoricalMatrix{Union{String, Missing}, R}(a, ordered=ordered) == x
        @test CategoricalMatrix{Union{String, Missing}, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalMatrix{Union{String, Missing}, UInt8}(a, ordered=ordered) == x

        @test convert(CategoricalArray{String}, x) == x
        @test convert(CategoricalArray{String, 2, R}, x) == x
        @test convert(CategoricalArray{String, 2, DefaultRefType}, x) == x
        @test convert(CategoricalArray{String, 2, UInt8}, x) == x

        @test convert(CategoricalMatrix{String}, x) == x
        @test convert(CategoricalMatrix{String, R}, x) == x
        @test convert(CategoricalMatrix{String, DefaultRefType}, x) == x
        @test convert(CategoricalMatrix{String, UInt8}, x) == x

        @test CategoricalArray{String}(a, ordered=ordered) == x
        @test CategoricalArray{String, 2}(a, ordered=ordered) == x
        @test CategoricalArray{String, 2}(a, ordered=ordered) == x
        @test CategoricalArray{String, 2, R}(a, ordered=ordered) == x
        @test CategoricalArray{String, 2, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalArray{String, 2, UInt8}(a, ordered=ordered) == x

        @test CategoricalMatrix{String}(a, ordered=ordered) == x
        @test CategoricalMatrix{String, R}(a, ordered=ordered) == x
        @test CategoricalMatrix{String, DefaultRefType}(a, ordered=ordered) == x
        @test CategoricalMatrix{String, UInt8}(a, ordered=ordered) == x

        @testset "categorical($(typeof(y)), compress=$comp) R1=$R1 R2=$R2" for (y, R1, R2, comp) in
            ((a, DefaultRefType, UInt8, true),
             (a, DefaultRefType, DefaultRefType, false),
             (x, R, UInt8, true),
             (x, R, R, false))

            x2 = @inferred categorical(y, ordered=ordered)
            @test x2 == y
            if eltype(y) >: Missing
                @test isa(x2, CategoricalMatrix{Union{String, Missing}, R1})
            else
                @test isa(x2, CategoricalMatrix{String, R1})
            end
            @test isordered(x2) === ordered

            x2 = categorical(y, compress=comp, ordered=ordered)
            @test x2 == y
            if eltype(y) >: Missing
                @test isa(x2, CategoricalMatrix{Union{String, Missing}, R2})
            else
                @test isa(x2, CategoricalMatrix{String, R2})
            end
            @test isordered(x2) === ordered
        end

        x2 = compress(x)
        @test x2 == x
        @test isa(x2, CategoricalMatrix{Union{String, Missing}, UInt8})
        @test isordered(x2) === isordered(x)
        @test levels(x2) == levels(x)

        x2 = copy(x)
        @test x2 == x
        @test typeof(x2) === typeof(x)
        @test isordered(x2) === isordered(x)
        @test levels(x2) == levels(x)

        @test x[1] === CategoricalValue(x.pool, 1)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 2)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 3)
        @test x[6] === CategoricalValue(x.pool, 3)
        @test_throws BoundsError x[7]

        @test x[1,1] === CategoricalValue(x.pool, 1)
        @test x[2,1] === CategoricalValue(x.pool, 2)
        @test x[1,2] === CategoricalValue(x.pool, 2)
        @test x[2,2] === CategoricalValue(x.pool, 1)
        @test x[1,3] === CategoricalValue(x.pool, 3)
        @test x[2,3] === CategoricalValue(x.pool, 3)
        @test_throws BoundsError x[1,4]
        @test_throws BoundsError x[4,1]
        @test_throws BoundsError x[4,4]

        @test x[1:2,:] == x
        @test typeof(x[1:2,:]) === typeof(x)
        @test x[1:2,1] == ["a", "b"]
        @test isa(x[1:2,1], CategoricalVector{Union{String, Missing}, R})

        x[1] = "z"
        @test x[1] === CategoricalValue(x.pool, 4)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 2)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 3)
        @test x[6] === CategoricalValue(x.pool, 3)
        @test isordered(x) === false
        @test levels(x) == ["a", "b", "c", "z"]

        x[1,:] .= "a"
        @test x[1] === CategoricalValue(x.pool, 1)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 1)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === CategoricalValue(x.pool, 3)
        @test levels(x) == ["a", "b", "c", "z"]

        x[1,1:2] .= "z"
        @test x[1] === CategoricalValue(x.pool, 4)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 4)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === CategoricalValue(x.pool, 3)
        @test levels(x) == ["a", "b", "c", "z"]
        end

        @testset "Matrix with missing values" begin
        a = ["a" missing "c"; "b" "a" missing]
        x = CategoricalMatrix{Union{String, Missing}, R}(a, ordered=ordered)

        @test x ≅ a
        @test isordered(x) === ordered
        @test levels(x) == filter(x->!ismissing(x), unique(a))
        @test unique(x) ≅ unique(a)
        @test unique(x) isa CategoricalVector{Union{String, Missing}, R}
        @test size(x) === (2, 3)
        @test length(x) === 6

        @test convert(CategoricalArray, x) === x
        @test convert(CategoricalArray{Union{String, Missing}}, x) === x
        @test convert(CategoricalArray{Union{String, Missing}, 2}, x) === x
        @test convert(CategoricalArray{Union{String, Missing}, 2, R}, x) === x
        @test convert(CategoricalArray{Union{String, Missing}, 2, DefaultRefType}, x) ≅ x
        @test convert(CategoricalArray{Union{String, Missing}, 2, UInt8}, x) ≅ x

        @test convert(CategoricalMatrix, x) === x
        @test convert(CategoricalMatrix{Union{String, Missing}}, x) === x
        @test convert(CategoricalMatrix{Union{String, Missing}, R}, x) === x
        @test convert(CategoricalMatrix{Union{String, Missing}, DefaultRefType}, x) ≅ x
        @test convert(CategoricalMatrix{Union{String, Missing}, UInt8}, x) ≅ x

        @test convert(CategoricalArray, a) ≅ x
        @test convert(CategoricalArray{Union{String, Missing}}, a) ≅ x
        @test convert(CategoricalArray{Union{String, Missing}, 2, R}, a) ≅ x
        @test convert(CategoricalArray{Union{String, Missing}, 2, DefaultRefType}, a) ≅ x
        @test convert(CategoricalArray{Union{String, Missing}, 2, UInt8}, a) ≅ x

        @test convert(CategoricalMatrix, a) ≅ x
        @test convert(CategoricalMatrix{Union{String, Missing}}, a) ≅ x
        @test convert(CategoricalMatrix{Union{String, Missing}, R}, a) ≅ x
        @test convert(CategoricalMatrix{Union{String, Missing}, DefaultRefType}, a) ≅ x
        @test convert(CategoricalMatrix{Union{String, Missing}, UInt8}, a) ≅ x

        @test CategoricalArray{Union{String, Missing}}(a, ordered=ordered) ≅ x
        @test CategoricalArray{Union{String, Missing}, 2}(a, ordered=ordered) ≅ x
        @test CategoricalArray{Union{String, Missing}, 2}(a, ordered=ordered) ≅ x
        @test CategoricalArray{Union{String, Missing}, 2, R}(a, ordered=ordered) ≅ x
        @test CategoricalArray{Union{String, Missing}, 2, DefaultRefType}(a, ordered=ordered) ≅ x
        @test CategoricalArray{Union{String, Missing}, 2, UInt8}(a, ordered=ordered) ≅ x

        @test CategoricalMatrix(a, ordered=ordered) ≅ x
        @test CategoricalMatrix{Union{String, Missing}}(a, ordered=ordered) ≅ x
        @test CategoricalMatrix{Union{String, Missing}, R}(a, ordered=ordered) ≅ x
        @test CategoricalMatrix{Union{String, Missing}, DefaultRefType}(a, ordered=ordered) ≅ x
        @test CategoricalMatrix{Union{String, Missing}, UInt8}(a, ordered=ordered) ≅ x

        @testset "categorical($(typeof(y)), compress=$comp) R1=$R1 R2=$R2" for (y, R1, R2, comp) in
            ((a, DefaultRefType, UInt8, true),
             (a, DefaultRefType, DefaultRefType, false),
             (x, R, UInt8, true),
             (x, R, R, false))

            x2 = @inferred categorical(y, ordered=ordered)
            @test x2 ≅ y
            @test isa(x2, CategoricalMatrix{Union{String, Missing}, R1})
            @test isordered(x2) === ordered

            x2 = categorical(y, compress=comp, ordered=ordered)
            @test x2 ≅ y
            @test isa(x2, CategoricalMatrix{Union{String, Missing}, R2})
            @test isordered(x2) === ordered
        end

        x2 = compress(x)
        @test x2 ≅ x
        @test isa(x2, CategoricalMatrix{Union{String, Missing}, UInt8})
        @test isordered(x2) === isordered(x)
        @test levels(x2) == levels(x)

        x2 = copy(x)
        @test x2 ≅ x
        @test typeof(x2) === typeof(x)
        @test isordered(x2) === isordered(x)
        @test levels(x2) == levels(x)

        @test x[1] === CategoricalValue(x.pool, 1)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === missing
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 3)
        @test x[6] === missing
        @test_throws BoundsError x[7]

        @test x[1,1] === CategoricalValue(x.pool, 1)
        @test x[2,1] === CategoricalValue(x.pool, 2)
        @test x[1,2] === missing
        @test x[2,2] === CategoricalValue(x.pool, 1)
        @test x[1,3] === CategoricalValue(x.pool, 3)
        @test x[2,3] === missing
        @test_throws BoundsError x[1,4]
        @test_throws BoundsError x[4,1]
        @test_throws BoundsError x[4,4]

        x2 = x[1:2,:]
        @test typeof(x2) === typeof(x)
        @test x2 ≅ x
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[:,[1, 3]]
        @test typeof(x2) === typeof(x)
        @test x2 ≅ ["a" "c"; "b" missing]
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[1:1,2]
        @test isa(x2, CategoricalVector{Union{String, Missing}, R})
        @test x2 ≅ [missing]
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        x2 = x[1:0,:]
        @test typeof(x2) === typeof(x)
        @test size(x2) == (0,3)
        @test levels(x2) == levels(x)
        @test levels(x2) !== levels(x)
        @test isordered(x2) == isordered(x)

        @test_throws BoundsError x[1:4, :]
        @test_throws BoundsError x[1:1, -1:1]
        @test_throws BoundsError x[4, :]

        x[1] = "z"
        @test x[1] === CategoricalValue(x.pool, 4)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === missing
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 3)
        @test x[6] === missing
        @test isordered(x) === false
        @test levels(x) == ["a", "b", "c", "z"]

        x[1,:] .= "a"
        @test x[1] === CategoricalValue(x.pool, 1)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 1)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === missing
        @test levels(x) == ["a", "b", "c", "z"]

        x[1,1:2] .= "z"
        @test x[1] === CategoricalValue(x.pool, 4)
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 4)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === missing
        @test levels(x) == ["a", "b", "c", "z"]

        x[1] = missing
        @test x[1] === missing
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 4)
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === missing
        @test levels(x) == ["a", "b", "c", "z"]

        x[1,1:2] .= missing
        @test x[1] === missing
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === missing
        @test x[4] === CategoricalValue(x.pool, 1)
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === missing
        @test levels(x) == ["a", "b", "c", "z"]

        x[:,2] .= missing
        @test x[1] === missing
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === missing
        @test x[4] === missing
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === missing
        @test levels(x) == ["a", "b", "c", "z"]

        x[1,2] = "a"
        @test x[1] === missing
        @test x[2] === CategoricalValue(x.pool, 2)
        @test x[3] === CategoricalValue(x.pool, 1)
        @test x[4] === missing
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === missing
        @test levels(x) == ["a", "b", "c", "z"]

        x[2,1] = missing
        @test x[1] === missing
        @test x[2] === missing
        @test x[3] === CategoricalValue(x.pool, 1)
        @test x[4] === missing
        @test x[5] === CategoricalValue(x.pool, 1)
        @test x[6] === missing
        @test levels(x) == ["a", "b", "c", "z"]
        end

        # Uninitialized array
        v = Any[CategoricalArray{Union{String, Missing}}(undef, 2, ordered=ordered),
                CategoricalArray{Union{String, Missing}, 1}(undef, 2, ordered=ordered),
                CategoricalArray{Union{String, Missing}, 1, R}(undef, 2, ordered=ordered),
                CategoricalVector{Union{String, Missing}}(undef, 2, ordered=ordered),
                CategoricalVector{Union{String, Missing}, R}(undef, 2, ordered=ordered),
                CategoricalArray{Union{String, Missing}}(undef, 2, 3, ordered=ordered),
                CategoricalArray{Union{String, Missing}, 2}(undef, 2, 3, ordered=ordered),
                CategoricalArray{Union{String, Missing}, 2, R}(undef, 2, 3, ordered=ordered),
                CategoricalMatrix{Union{String, Missing}}(undef, 2, 3, ordered=ordered),
                CategoricalMatrix{Union{String, Missing}, R}(undef, 2, 3, ordered=ordered)]

        @testset "Uninitialized $(typeof(x))" for x in v
        @test isordered(x) === ordered
        @test ismissing(x[1])
        @test ismissing(x[2])
        @test levels(x) == []

        x2 = compress(x)
        @test x2 ≅ x
        @test isa(x2, CategoricalArray{Union{leveltype(x), Missing}, ndims(x), UInt8})
        @test isordered(x2) === isordered(x)
        @test levels(x2) == []

        x2 = copy(x)
        @test x2 ≅ x
        @test typeof(x2) === typeof(x)
        @test isordered(x2) === isordered(x)
        @test levels(x2) == []

        x[1] = "c"
        @test x[1] === CategoricalValue(x.pool, 1)
        @test ismissing(x[2])
        @test isordered(x) === false
        @test levels(x) == ["c"]

        ordered!(x, ordered)
        x[1] = "a"
        @test x[1] === CategoricalValue(x.pool, 2)
        @test ismissing(x[2])
        @test isordered(x) === false
        @test levels(x) == ["c", "a"]

        ordered!(x, ordered)
        x[2] = missing
        @test x[1] === CategoricalValue(x.pool, 2)
        @test x[2] === missing
        @test isordered(x) === ordered
        @test levels(x) == ["c", "a"]

        x[1] = "b"
        @test x[1] === CategoricalValue(x.pool, 3)
        @test x[2] === missing
        @test isordered(x) === false
        @test levels(x) == ["c", "a", "b"]
        end
    end
end

@testset "vcat with missings" begin
    ca1 = CategoricalArray(["a", missing])
    ca2 = CategoricalArray([missing, "a"])
    r = vcat(ca1, ca2)
    @test r ≅ CategoricalArray(["a", missing, missing, "a"])
    @test levels(r) == ["a"]
    @test !isordered(r)
    ordered!(ca1,true)
    @test !isordered(vcat(ca1, ca2))
    ordered!(ca2,true)
    @test isordered(vcat(ca1, ca2))
    ordered!(ca1,false)
    @test !isordered(vcat(ca1, ca2))
end

@testset "vcat with all missings" begin
    ca1 = CategoricalArray(["a", missing])
    ca2 = CategoricalArray([missing, missing])
    r = vcat(ca1, ca2)
    @test r ≅ ["a", missing, missing, missing]
    @test levels(r) == ["a"]
    @test !isordered(r)

    @testset "preserves isordered" begin
    # needed for instance when expanding an array with missings
    # such as vcat of DataFrame with missing columns
    ordered!(ca1, true)
    @test isempty(levels(ca2))
    r = vcat(ca1, ca2)
    @test isordered(r)
    end
end

@testset "vcat with all empty array" begin
    ca1 = CategoricalArray(undef, 0)
    ca2 = CategoricalArray([missing, "b"])
    r = vcat(ca1, ca2)
    @test r ≅ [missing, "b"]
    @test levels(r) == ["b"]
    @test !isordered(r)
end

@testset "vcat with all missings and empty" begin
    ca1 = CategoricalArray(undef, 0)
    ca2 = CategoricalArray([missing, missing])
    r = vcat(ca1, ca2)
    @test r ≅ [missing, missing]
    @test levels(r) == String[]
    @test !isordered(r)

    ordered!(ca1, true)
    @test isempty(levels(ca2))
    r = vcat(ca1, ca2)
    @test isordered(r)

    ca1 = CategoricalArray(["a", missing])
    ca2 = CategoricalArray{Union{String, Missing}}(undef, 2)
    ordered!(ca1, true)
    @test isempty(levels(ca2))
    r = vcat(ca1, ca2)
    @test r ≅ ["a", missing, missing, missing]
    @test isordered(r)
end

@testset "unique() and levels()" begin
    x = CategoricalArray(["Old", "Young", "Middle", missing, "Young"])
    @test levels(x) == ["Middle", "Old", "Young"]
    @test unique(x) ≅ ["Old", "Young", "Middle", missing]
    @test typeof(unique(x)) === typeof(x)
    @test levels!(x, ["Young", "Middle", "Old"]) === x
    @test levels(x) == ["Young", "Middle", "Old"]
    @test unique(x) ≅ ["Old", "Young", "Middle", missing]
    @test levels!(x, ["Young", "Middle", "Old", "Unused"]) === x
    @test levels(x) == ["Young", "Middle", "Old", "Unused"]
    @test unique(x) ≅ ["Old", "Young", "Middle", missing]
    @test levels!(x, ["Unused1", "Young", "Middle", "Old", "Unused2"]) === x
    @test levels(x) == ["Unused1", "Young", "Middle", "Old", "Unused2"]
    @test unique(x) ≅ ["Old", "Young", "Middle", missing]

    x = CategoricalArray((Union{String, Missing})[missing])
    @test isa(levels(x), CategoricalVector{String, DefaultRefType}) && isempty(levels(x))
    @test unique(x) ≅ [missing]
    @test levels!(x, ["Young", "Middle", "Old"]) === x
    @test levels(x) == ["Young", "Middle", "Old"]
    @test unique(x) ≅ [missing]

    # To test short-circuiting
    x = CategoricalArray{Union{Int, Missing}}(repeat(1:10, inner=10))
    @test levels(x) == collect(1:10)
    @test unique(x) == collect(1:10)
    @test levels!(x, [19:-1:1; 20]) === x
    x[3] = missing
    @test levels(x) == [19:-1:1; 20]
    @test unique(x) ≅ [1; missing; 2:10]

    # in
    x = CategoricalArray{Int}(repeat(1:1500, inner=10))
    @test !(missing in x)

    x = CategoricalArray{Union{Int, Missing}}(repeat(1:1500, inner=10))
    x[1] = missing
    @test missing in x
end

@testset "Missings.replace should work on CategoricalArrays" begin
    x = categorical(["a", "b", missing, "a"])
    y = ["a", "b", "", "a"]
    r = Missings.replace(x, "")
    @test isa(r, Missings.EachReplaceMissing)
    a = collect(r)
    @test isa(a, CategoricalVector{String})
    @test y == a
    @test levels(x) == ["a", "b"]
    @test levels(a) == ["a", "b", ""]

    r = Missings.replace(x, "b")
    y = ["a", "b", "b", "a"]
    @test isa(r, Missings.EachReplaceMissing)
    a = collect(r)
    @test isa(a, CategoricalVector{String})
    @test y == a
    @test levels(x) == ["a", "b"]
    @test levels(a) == ["a", "b"]

    @test_throws MethodError Missings.replace(x, 1)
end

@testset "Missings.replace should work on CategoricalArrays without missing values" begin
    x = categorical(["a", "b", "", "a"])
    y = ["a", "b", "", "a"]
    r = Missings.replace(x, "dummy")
    @test isa(r, Missings.EachReplaceMissing)
    a = collect(r)
    @test isa(a, CategoricalVector{String})
    @test y == a
    @test levels(x) == ["", "a", "b"]
    @test levels(a) == ["", "a", "b", "dummy"]

    r = Missings.replace(x, "")
    @test isa(r, Missings.EachReplaceMissing)
    a = collect(r)
    @test isa(a, CategoricalVector{String})
    @test y == a
    @test levels(x) == ["", "a", "b"]
    @test levels(a) == ["", "a", "b"]
end

@testset "Missings.replace should work on CategoricalArrays with empty pools" begin
    x = categorical(Union{String,Missing}[missing])
    y = [""]
    r = Missings.replace(x, "")
    @test isa(r, Missings.EachReplaceMissing)
    a = collect(r)
    @test isa(a, CategoricalVector{String})
    @test y == a
end

@testset "Missings.replace should work on empty CategoricalArrays" begin
    x = categorical(Union{String,Missing}[])
    y = String[]
    r = Missings.replace(x, "")
    @test isa(r, Missings.EachReplaceMissing)
    a = collect(r)
    @test isa(a, CategoricalVector{String})
    @test y == a
end

end

module TestValue
using Test
using CategoricalArrays
using CategoricalArrays: DefaultRefType, refcode,  reftype, leveltype

@testset "leveltype on non CategoricalValue types" begin
    @test leveltype("abc") === String
    @test leveltype(String) === String
    @test leveltype(1.0) === Float64
    @test leveltype(Float64) === Float64
end

@testset "CategoricalValue on DefaultRefType pool in sorted order" begin
    pool = CategoricalPool(
        Dict(
            "a" => DefaultRefType(1),
            "b" => DefaultRefType(2),
            "c" => DefaultRefType(3),
        )
    )

    for i in 1:3
        x = CategoricalValue(pool, i)

        @test levels(x) == levels(pool)
        @test levels(x) isa CategoricalVector{String, UInt32}
        @test leveltype(x) === String
        @test leveltype(typeof(x)) === String
        @test reftype(x) === DefaultRefType
        @test reftype(typeof(x)) === DefaultRefType
        @test x isa CategoricalValue{String, DefaultRefType}

        @test refcode(x) === DefaultRefType(i)
        @test CategoricalArrays.pool(x) === pool

        @test typeof(x)(x) === x
        @test CategoricalValue(pool, UInt8(i)) == x
    end
end

@testset "CategoricalValue on UInt8 pool in custom order" begin
    pool = CategoricalPool(
        Dict(
            "a" => UInt8(3),
            "b" => UInt8(2),
            "c" => UInt8(1),
        )
    )

    for i in 1:3
        x = CategoricalValue(pool, i)

        @test levels(x) == levels(pool)
        @test levels(x) isa CategoricalVector{String, UInt8}
        @test leveltype(x) === String
        @test leveltype(typeof(x)) === String
        @test reftype(x) === UInt8
        @test reftype(typeof(x)) === UInt8
        @test x isa CategoricalValue{String, UInt8}

        @test refcode(x) === UInt8(i)
        @test CategoricalArrays.pool(x) === pool

        @test typeof(x)(x) === x
        @test CategoricalValue(pool, UInt32(i)) == x
    end
end

@testset "constructor from other value" begin
    pool = CategoricalPool([2, 3, 1])
    arr = CategoricalVector{Int}(DefaultRefType[2, 1, 3], pool)
    for x in (CategoricalValue(pool, 1), arr, view(arr, 2:3))
        for (i, v) in enumerate(levels(pool))
            @test CategoricalValue(v, x) ===
                CategoricalValue(unwrap(v), x) ===
                CategoricalValue(float(unwrap(v)), x) ===
                CategoricalValue(CategoricalValue(pool, i), x) ===
                CategoricalValue(pool, i)
        end

        @test_throws ArgumentError CategoricalValue(4, x)
        @test_throws ArgumentError CategoricalValue(missing, x)
    end
end

end

module TestLevels
using Test
using CategoricalArrays
using CategoricalArrays: DefaultRefType, levels!, hashlevels, _levels

@testset "CategoricalPool{Int} updates levels and order correctly" begin
    pool = CategoricalPool([2, 1, 3])

    @test isa(levels(pool), CategoricalVector{Int, DefaultRefType})
    @test length(pool) === 3
    @test levels(pool) == _levels(pool) == [2, 1, 3]
    @test all([levels(CategoricalValue(pool, i)) for i in 1:3] .== Ref(levels(pool)))
    @test pool.levelsinds == 1:3
    @test pool.invindex == Dict(2=>1, 1=>2, 3=>3)
    @test pool.hash === nothing
    @test pool.equalto == C_NULL
    @test pool.subsetof == C_NULL

    for rep in 1:3
        push!(pool, 4)

        @test isa(pool.levels, Vector{Int})
        @test length(pool) === 4
        @test levels(pool) == _levels(pool) == [2, 1, 3, 4]
        @test pool.levelsinds == 1:4
        @test pool.invindex == Dict(2=>1, 1=>2, 3=>3, 4=>4)
        @test pool.hash === nothing
        @test pool.equalto == C_NULL
        @test pool.subsetof == C_NULL
        @test get(pool, 4) === DefaultRefType(4)
        @test pool[4] === CategoricalValue(pool, 4)
    end

    for rep in 1:3
        push!(pool, 0)

        @test isa(pool.levels, Vector{Int})
        @test length(pool) === 5
        @test levels(pool) == _levels(pool) == [2, 1, 3, 4, 0]
        @test pool.levelsinds == 1:5
        @test pool.invindex == Dict(2=>1, 1=>2, 3=>3, 4=>4, 0=>5)
        @test pool.hash === nothing
        @test pool.equalto == C_NULL
        @test pool.subsetof == C_NULL
        @test get(pool, 0) === DefaultRefType(5)
        @test pool[5] === CategoricalValue(pool, 5)
    end

    for rep in 1:3
        push!(pool, 10, 11)

        @test isa(pool.levels, Vector{Int})
        @test length(pool) === 7
        @test levels(pool) == _levels(pool) == [2, 1, 3, 4, 0, 10, 11]
        @test pool.levelsinds == 1:7
        @test pool.invindex == Dict(2=>1, 1=>2, 3=>3, 4=>4, 0=>5, 10=>6, 11=>7)
        @test pool.hash === nothing
        @test pool.equalto == C_NULL
        @test pool.subsetof == C_NULL
        @test get(pool, 10) === DefaultRefType(6)
        @test get(pool, 11) === DefaultRefType(7)
        @test pool[6] === CategoricalValue(pool, 6)
        @test pool[7] === CategoricalValue(pool, 7)
    end

    for rep in 1:3
        push!(pool, 12, 13)

        @test isa(pool.levels, Vector{Int})
        @test length(pool) === 9
        @test levels(pool) == _levels(pool) == [2, 1, 3, 4, 0, 10, 11, 12, 13]
        @test pool.levelsinds == 1:9
        @test pool.invindex == Dict(2=>1, 1=>2, 3=>3, 4=>4, 0=>5, 10=>6, 11=>7, 12=>8, 13=>9)
        @test pool.hash === nothing
        @test pool.equalto == C_NULL
        @test pool.subsetof == C_NULL
        @test get(pool, 12) === DefaultRefType(8)
        @test get(pool, 13) === DefaultRefType(9)
        @test pool[8] === CategoricalValue(pool, 8)
        @test pool[9] === CategoricalValue(pool, 9)
    end

    # Removing levels
    @test_throws ArgumentError levels!(pool, levels(pool)[2:end])

    # Changing order while preserving existing levels
    @test_throws ArgumentError levels!(pool, reverse(levels(pool)))

    # Adding levels while preserving existing ones
    levs = [2, 1, 3, 4, 0, 10, 11, 12, 13, 15, 14]
    @test levels!(pool, levs) === pool
    @test levels(pool) == _levels(pool) == levs
    @test pool.levels !== levs
    @test isa(pool.levels, Vector{Int})
    @test pool.levelsinds == 1:11
    @test pool.invindex == Dict(2=>1, 1=>2, 3=>3, 4=>4, 0=>5, 10=>6, 11=>7, 12=>8, 13=>9,
                                15=>10, 14=>11)
    @test pool.hash === nothing
    @test pool.equalto == C_NULL
    @test pool.subsetof == C_NULL
    @test get(pool, 15) === DefaultRefType(10)
    @test get(pool, 14) === DefaultRefType(11)
    @test pool[10] === CategoricalValue(pool, 10)
    @test pool[11] === CategoricalValue(pool, 11)

    # get! adding new level works even for ordered pool
    ordered!(pool, true)
    @test get!(pool, 20) === DefaultRefType(12)

    @test isa(pool.levels, Vector{Int})
    @test length(pool) == 12
    @test levels(pool) ==
        _levels(pool) ==
        [2, 1, 3, 4, 0, 10, 11, 12, 13, 15, 14, 20]
    @test pool.levelsinds == 1:12
    @test pool.invindex == Dict(2=>1, 1=>2, 3=>3, 4=>4, 0=>5, 10=>6, 11=>7, 12=>8, 13=>9,
                                15=>10, 14=>11, 20=>12)
    @test pool.hash === nothing
    @test pool.equalto == C_NULL
    @test pool.subsetof == C_NULL
    @test get(pool, 20) === DefaultRefType(12)

    # get! with CategoricalValue adding new levels in conflicting order
    v = CategoricalValue(CategoricalPool([100, 99, 4, 2]), 2)
    @test_throws ArgumentError get!(pool, v)

    # get! with CategoricalValue adding new levels in compatible order
    v = CategoricalValue(CategoricalPool([2, 4, 100, 99]), 4)

    @test get!(pool, v) === DefaultRefType(14)

    @test isa(pool.levels, Vector{Int})
    @test length(pool) == 14
    @test levels(pool) ==
        _levels(pool) ==
        [2, 1, 3, 4, 0, 10, 11, 12, 13, 15, 14, 20, 100, 99]
    @test pool.levelsinds == 1:14
    @test pool.invindex == Dict(2=>1, 1=>2, 3=>3, 4=>4, 0=>5, 10=>6, 11=>7, 12=>8, 13=>9,
                                15=>10, 14=>11, 20=>12, 100=>13, 99=>14)
    @test pool.hash === nothing
    @test pool.equalto == C_NULL
    @test pool.subsetof == C_NULL
    @test get(pool, 100) === DefaultRefType(13)
    @test get(pool, 99) === DefaultRefType(14)

    # get! with CategoricalValue not adding new levels
    v = CategoricalValue(CategoricalPool([100, 2]), 1)
    @test get!(pool, v) === DefaultRefType(13)

    @test isa(pool.levels, Vector{Int})
    @test length(pool) == 14
    @test levels(pool) ==
        _levels(pool) ==
        [2, 1, 3, 4, 0, 10, 11, 12, 13, 15, 14, 20, 100, 99]
    @test pool.levelsinds == 1:14
    @test pool.invindex == Dict(2=>1, 1=>2, 3=>3, 4=>4, 0=>5, 10=>6, 11=>7, 12=>8, 13=>9,
                                15=>10, 14=>11, 20=>12, 100=>13, 99=>14)
    @test pool.hash === CategoricalArrays.hashlevels(levels(pool))
    @test pool.equalto == C_NULL
    @test pool.subsetof == C_NULL

    # get! with CategoricalValue from same pool
    @test get!(pool, pool[1]) === DefaultRefType(1)

    @test isa(pool.levels, Vector{Int})
    @test length(pool) == 14
    @test levels(pool) ==
        _levels(pool) ==
        [2, 1, 3, 4, 0, 10, 11, 12, 13, 15, 14, 20, 100, 99]
    @test pool.levelsinds == 1:14
    @test pool.invindex == Dict(2=>1, 1=>2, 3=>3, 4=>4, 0=>5, 10=>6, 11=>7, 12=>8, 13=>9,
                                15=>10, 14=>11, 20=>12, 100=>13, 99=>14)
    @test pool.hash === CategoricalArrays.hashlevels(levels(pool))
    @test pool.equalto == C_NULL
    @test pool.subsetof == C_NULL

    # get! with CategoricalValue conversion error
    v = CategoricalValue(CategoricalPool(["a", "b"]), 1)
    @test_throws MethodError get!(pool, v)

    # get! with ordered CategoricalValue marks unordered empty pool as ordered
    p1 = CategoricalPool(['b', 'c', 'a'])
    ordered!(p1, true)
    p2 = CategoricalPool(Char[])
    @test get!(p2, p1[1]) === UInt32(1)
    @test isordered(p2)
    # But push! does not
    p2 = CategoricalPool(Char[])
    @test push!(p2, p1[1]) === p2
    @test !isordered(p2)
end

@testset "levels!(::CategoricalPool, ::CategoricalVector)" begin
    pool = CategoricalPool([2, 1, 3])
    levels!(pool, categorical([2, 1, 3, 4]))
    @test levels(pool) == [2, 1, 3, 4]

    pool = CategoricalPool([2, 1, 3])
    levels!(pool, categorical([2.0, 1.0, 3.0, 4.0]))
    @test levels(pool) == [2, 1, 3, 4]

    pool = CategoricalPool([2, 1, 3])
    @test_throws ArgumentError levels!(pool, categorical([2, 2, 1, 3, 4]))

    pool = CategoricalPool([2, 1, 3])
    @test_throws ArgumentError levels!(pool, categorical(1:3))
end

@testset "overflow of reftype is detected and doesn't corrupt levels" begin
    res = @test_throws LevelsException{Int, UInt8} CategoricalPool{Int, UInt8}(collect(256:-1:1))
    @test res.value.levels == [1]
    @test sprint(showerror, res.value) == "cannot store level(s) 1 since reference type UInt8 can only hold 255 levels. Use the decompress function to make room for more levels."

    pool = CategoricalPool(collect(30:288))
    res = @test_throws LevelsException{Int, UInt8} convert(CategoricalPool{Int, UInt8}, pool)
    @test res.value.levels == collect(285:288)
    @test sprint(showerror, res.value) == "cannot store level(s) 285, 286, 287 and 288 since reference type UInt8 can only hold 255 levels. Use the decompress function to make room for more levels."

    pool = CategoricalPool{String, UInt8}(string.(318:-1:65))
    res = @test_throws LevelsException{String, UInt8} levels!(pool, vcat(levels(pool), "az", "bz", "cz"))
    @test res.value.levels == ["bz", "cz"]
    @test sprint(showerror, res.value) == "cannot store level(s) \"bz\" and \"cz\" since reference type UInt8 can only hold 255 levels. Use the decompress function to make room for more levels."
    lev = copy(levels(pool))
    levels!(pool, vcat(lev, "az"))
    @test levels(pool) == vcat(lev, "az")
end

@testset "issubset" begin
    pool1 = CategoricalPool(["a", "b", "c"])
    pool1b = CategoricalPool(["a", "b", "c"])
    pool2 = CategoricalPool(["c", "a", "b"])
    pool3 = CategoricalPool(["a", "b", "c", "d"])
    pool4 = CategoricalPool(["a", "b"])
    pool5 = CategoricalPool(["a", "b", "e"])
    pool6 = CategoricalPool(String[])

    @test issubset(pool1, pool1)
    @test pool1.equalto == C_NULL
    @test pool1.subsetof == C_NULL

    @test issubset(pool2, pool1)
    @test pool1.equalto == pool2.equalto == C_NULL
    @test pool1.subsetof == C_NULL
    @test pool2.subsetof == pointer_from_objref(pool1)

    @test issubset(pool1b, pool1)
    @test pool1.equalto == pointer_from_objref(pool1b)
    @test pool1b.equalto == pointer_from_objref(pool1)
    @test pool1.subsetof == C_NULL
    @test pool2.subsetof == pointer_from_objref(pool1)

    @test !issubset(pool3, pool1)
    @test pool1.equalto == pointer_from_objref(pool1b)
    @test pool3.equalto == C_NULL
    @test pool1.subsetof == pool3.subsetof == C_NULL

    @test issubset(pool1, pool3)
    @test pool1.equalto == pointer_from_objref(pool1b)
    @test pool3.equalto == C_NULL
    @test pool1.subsetof == pointer_from_objref(pool3)
    @test pool3.subsetof == C_NULL

    @test issubset(pool4, pool1)
    @test pool1.equalto == pointer_from_objref(pool1b)
    @test pool4.equalto == C_NULL
    @test pool1.subsetof == pointer_from_objref(pool3)
    @test pool4.subsetof == pointer_from_objref(pool1)

    @test !issubset(pool5, pool1)
    @test pool1.equalto == pointer_from_objref(pool1b)
    @test pool5.equalto == C_NULL
    @test pool1.subsetof == pointer_from_objref(pool3)
    @test pool5.subsetof == C_NULL

    @test issubset(pool6, pool1)
    @test pool1.equalto == pointer_from_objref(pool1b)
    @test pool6.equalto == C_NULL
    @test pool1.subsetof == pointer_from_objref(pool3)
    @test pool6.subsetof == pointer_from_objref(pool1)
end

end

module CategoricalArrays
    export CategoricalPool, CategoricalValue
    export AbstractCategoricalArray, AbstractCategoricalVector, AbstractCategoricalMatrix,
           CategoricalArray, CategoricalVector, CategoricalMatrix
    export LevelsException

    export categorical, compress, decompress, droplevels!, levels, levels!, levelcode,
           isordered, ordered!
    export cut, recode, recode!

    import DataAPI: unwrap
    export unwrap

    using Compat
    @compat public default_formatter, numbered_formatter

    using DataAPI
    using Missings
    using Printf

    # JuliaLang/julia#36810
    if VERSION < v"1.5.2"
        Base.OrderStyle(::Type{Union{}}) = Base.Ordered()
    end

    include("typedefs.jl")

    include("pool.jl")
    include("value.jl")

    include("array.jl")
    include("missingarray.jl")
    include("subarray.jl")

    include("extras.jl")
    include("recode.jl")

    if !isdefined(Base, :get_extension)
        using Requires: @require
    end

    @static if !isdefined(Base, :get_extension)
        function __init__()
            @require Arrow="69666777-d1a9-59fb-9406-91d4454c9d45" include("../ext/CategoricalArraysArrowExt.jl")
            @require JSON="682c06a0-de6a-54ab-a142-c8b1cf79cde6" include("../ext/CategoricalArraysJSONExt.jl")
            @require RecipesBase="3cdcf5f2-1ef4-517c-9805-6587b60abb01" include("../ext/CategoricalArraysRecipesBaseExt.jl")
            @require SentinelArrays="91c51154-3ec4-41a3-a24f-3f23e20d615c" include("../ext/CategoricalArraysSentinelArraysExt.jl")
            @require StatsBase="2913bbd2-ae8a-5f71-8c99-4fb6c76f3a91" include("../ext/CategoricalArraysStatsBaseExt.jl")
            @require StructTypes="856f2bd8-1eba-4b0a-8007-ebc267875bd4" include("../ext/CategoricalArraysStructTypesExt.jl")
        end
    end
end

using BenchmarkTools
using CategoricalArrays
using Printf

const SUITE = BenchmarkGroup()

SUITE["isequal"] = BenchmarkGroup()

function sumequals(A::AbstractArray, v::Any)
    n = 0
    @inbounds for x in A
        n += isequal(x, v)
    end
    n
end

ca = CategoricalArray(repeat(string.('A':'J'), outer=1000))
nca = CategoricalArray(repeat([missing; string.('A':'J')], outer=1000))

SUITE["isequal"]["CategoricalArray{String}", "String"] =
    @benchmarkable  sumequals(ca, "D")
SUITE["isequal"]["CategoricalArray{Union{String, Missing}}", "String"] =
    @benchmarkable sumequals(nca, "D")

function sumequals(A::AbstractArray, v::CategoricalValue)
    n = 0
    @inbounds for x in A
        n += isequal(x, v)
    end
    n
end

ca = CategoricalArray(repeat(string.('A':'J'), outer=1000))
nca = CategoricalArray(repeat([missing; string.('A':'J')], outer=1000))

SUITE["isequal"]["CategoricalArray{String}", "CategoricalValue"] =
    @benchmarkable sumequals(ca, ca[1])
SUITE["isequal"]["CategoricalArray{Union{String, Missing}}", "CategoricalValue"] =
    @benchmarkable sumequals(nca, nca[1])

SUITE["isequal"]["CategoricalArray{String}", "CategoricalValue different pool"] =
    @benchmarkable sumequals(ca, nca[1])
SUITE["isequal"]["CategoricalArray{Union{String, Missing}}", "CategoricalValue  different pool"] =
    @benchmarkable sumequals(nca, ca[1])


# With many levels, checking whether some levels have been dropped can be very slow (#93)
SUITE["many levels"] = BenchmarkGroup()

a = rand([@sprintf("id%010d", k) for k in 1:1000], 10000)

SUITE["many levels"]["CategoricalArray(::Vector{String})"] =
    @benchmarkable CategoricalArray(a)

a = rand([@sprintf("id%010d", k) for k in 1:1000], 10000)
ca = CategoricalArray(a)

levs = unwrap.(levels(ca))
SUITE["many levels"]["levels! with original levels"] =
    @benchmarkable levels!(ca, levs)

levs = reverse(unwrap.(levels(ca)))
SUITE["many levels"]["levels! with resorted levels"] =
    @benchmarkable levels!(ca, levs)

levs = [levels(ca); [@sprintf("id2%010d", k) for k in 1:1000]]
SUITE["many levels"]["levels! with many additional levels"] =
    @benchmarkable levels!(ca, levs)


SUITE["repeated assignment"] = BenchmarkGroup()

function mycopy!(dest, src)
    @inbounds for i in eachindex(dest, src)
        dest[i] = src[i]
    end
end

a = categorical(rand([@sprintf("id%010d", k) for k in 1:1000], 10000))
b = CategoricalArray{String}(undef, 10000)
c = categorical(rand([@sprintf("id%010d", k) for k in 1:1000], 10000))
d = categorical(rand([@sprintf("id%010d", k) for k in 1001:2000], 10000))

SUITE["repeated assignment"]["empty dest"] =
    @benchmarkable mycopy!(b2, a) setup = b2=copy(b)
SUITE["repeated assignment"]["same levels dest"] =
    @benchmarkable mycopy!(c2, a) setup = c2=copy(c)
SUITE["repeated assignment"]["many levels dest"] =
    @benchmarkable mycopy!(d2, a) setup = d2=copy(d)

orig_vec = (x -> repeat(x, 32)).(string.([x % 1000 for x in 1:1000000]))
cat2merge_vec = (x -> repeat(x, 32)).(string.([x % 1000 for x in 1:100000]))
SUITE["recode"] = BenchmarkGroup()
SUITE["recode"]["vectors"] = @benchmarkable recode(orig_vec, cat2merge_vec => "None")
SUITE["recode"]["categorical_vectors"] = @benchmarkable recode(categorical(orig_vec), cat2merge_vec => "None")
SUITE["recode"]["matrices"] = @benchmarkable recode(reshape(orig_vec, :, 1), reshape(cat2merge_vec, :, 1) => "None")
SUITE["recode"]["categorical_matrices"] = @benchmarkable recode(categorical(reshape(orig_vec, :, 1)), reshape(cat2merge_vec, :, 1) => "None")

## Code for CategoricalArray

import Base: Array, Vector, Matrix, convert, collect, copy, getindex,
             setindex!, similar, size,
             unique, unique!, vcat, in, summary, float, complex, copyto!

# Used for keyword argument default value
_isordered(x::AbstractCategoricalArray) = isordered(x)
_isordered(x::Any) = false

function reftype(sz::Int)
    if sz <= typemax(UInt8)
        return UInt8
    elseif sz <= typemax(UInt16)
        return UInt16
    elseif sz <= typemax(UInt32)
        return UInt32
    else
        return UInt64
    end
end

# This check is only there to print a user-friendly warning before
# a TypeError is thrown due to restrictions in the type signature
function check_supported_eltype(::Type{T}, ::Type{U}) where {T, U}
    T === Symbol &&
    throw(ArgumentError("CategoricalArray no longer supports Symbol as element type "*
                        "as that forces recompiling too many Julia Base methods: " *
                        "use strings instead, e.g. via categorical(string.(x))"))
    T <: Union{SupportedTypes, Missing} ||
        throw(ArgumentError("CategoricalArray only supports " *
                            "AbstractString, AbstractChar and Number element types " *
                            "(got element type $U)"))
end

fixstringtype(T::Type) = T <: SubString || T === AbstractString ? String : T
fixstringtype(T::Union) = Union{fixstringtype(T.a), fixstringtype(T.b)}
fixstringtype(::Type{Union{}}) = Union{}

# Find a narrow type that is supported to hold all elements if possible
function fixtype(A::AbstractArray{T}) where T
    if T <: Union{SupportedTypes, Missing}
        return fixstringtype(T)
    else
        U = fixstringtype(mapreduce(typeof, Base.promote_typejoin, A))
        check_supported_eltype(U, T)
        return U
    end
end

"""
    CategoricalArray{T}(undef, dims::Dims; levels=nothing, ordered=false)
    CategoricalArray{T}(undef, dims::Int...; levels=nothing, ordered=false)

Construct an uninitialized `CategoricalArray` with levels of type
`T <: $SupportedTypes` and dimensions `dims`.

The `levels` keyword argument can be a vector specifying possible values for the data
(this is equivalent to but more efficient than calling [`levels!`](@ref)
on the resulting array).
The `ordered` keyword argument determines whether the array values can be compared
according to the ordering of levels or not (see [`isordered`](@ref)).

    CategoricalArray{T, N, R}(undef, dims::Dims; levels=nothing, ordered=false)
    CategoricalArray{T, N, R}(undef, dims::Int...; levels=nothing, ordered=false)

Similar to definition above, but uses reference type `R` instead of the default type
(`$DefaultRefType`).

    CategoricalArray(A::AbstractArray; levels=nothing, ordered=false)

Construct a new `CategoricalArray` with the values from `A` and the same element type.

The `levels` keyword argument can be a vector specifying possible values for the data
(this is equivalent to but more efficient than calling [`levels!`](@ref)
on the resulting array).
If `levels` is omitted and the element type supports it, levels are sorted
in ascending order; else, they are kept in their order of appearance in `A`.
The `ordered` keyword argument determines whether the array values can be compared
according to the ordering of levels or not (see [`isordered`](@ref)).

If `A` is already a `CategoricalArray`, its levels, orderedness and reference type
are preserved unless explicitly overriden.
"""
function CategoricalArray end

"""
    CategoricalVector{T}(undef, m::Int; levels=nothing, ordered=false)

Construct an uninitialized `CategoricalVector` with levels of type
`T <: $SupportedTypes` and dimensions `dim`.

The `levels` keyword argument can be a vector specifying possible values for the data
(this is equivalent to but more efficient than calling [`levels!`](@ref)
on the resulting array).
The `ordered` keyword argument determines whether the array values can be compared
according to the ordering of levels or not (see [`isordered`](@ref)).

    CategoricalVector{T, R}(undef, m::Int; levels=nothing, ordered=false)

Similar to definition above, but uses reference type `R` instead of the default type
(`$DefaultRefType`).

    CategoricalVector(A::AbstractVector; levels=nothing, ordered=false)

Construct a `CategoricalVector` with the values from `A` and the same element type.

The `levels` keyword argument can be a vector specifying possible values for the data
(this is equivalent to but more efficient than calling [`levels!`](@ref)
on the resulting array).
If `levels` is omitted and the element type supports it, levels are sorted
in ascending order; else, they are kept in their order of appearance in `A`.
The `ordered` keyword argument determines whether the array values can be compared
according to the ordering of levels or not (see [`isordered`](@ref)).

If `A` is already a `CategoricalVector`, its levels, orderedness and reference type
are preserved unless explicitly overriden.
"""
function CategoricalVector end

"""
    CategoricalMatrix{T}(undef, m::Int, n::Int; levels=nothing, ordered=false)

Construct an uninitialized `CategoricalMatrix` with levels of type
`T <: $SupportedTypes` and dimensions `dim`.
The `ordered` keyword argument determines whether the array values can be compared
according to the ordering of levels or not (see [`isordered`](@ref)).

    CategoricalMatrix{T, R}(undef, m::Int, n::Int; levels=nothing, ordered=false)

Similar to definition above, but uses reference type `R` instead of the default type
(`$DefaultRefType`).

    CategoricalMatrix(A::AbstractMatrix; levels=nothing, ordered=false)

Construct a `CategoricalMatrix` with the values from `A` and the same element type.

The `levels` keyword argument can be a vector specifying possible values for the data
(this is equivalent to but more efficient than calling [`levels!`](@ref)
on the resulting array).
If `levels` is omitted and the element type supports it, levels are sorted
in ascending order; else, they are kept in their order of appearance in `A`.
The `ordered` keyword argument determines whether the array values can be compared
according to the ordering of levels or not (see [`isordered`](@ref)).

If `A` is already a `CategoricalMatrix`, its levels, orderedness and reference type
are preserved unless explicitly overriden.
"""
function CategoricalMatrix end

# UndefInitializer array constructors

CategoricalArray(::UndefInitializer, dims::Int...;
                 levels::Union{AbstractVector, Nothing}=nothing,
                 ordered::Bool=false) =
    CategoricalArray{String}(undef, dims, levels=levels, ordered=ordered)

function CategoricalArray{T, N, R}(::UndefInitializer, dims::NTuple{N,Int};
                                   levels::Union{AbstractVector, Nothing}=nothing,
                                   ordered::Bool=false) where {T, N, R}
    U = leveltype(nonmissingtype(T))
    S = T >: Missing ? Union{U, Missing} : U
    check_supported_eltype(S, T)
    levs = levels === nothing ? U[] : collect(U, levels)
    CategoricalArray{S, N}(zeros(R, dims), CategoricalPool{U, R}(levs, ordered))
end

CategoricalArray{T, N}(::UndefInitializer, dims::NTuple{N,Int};
                       levels::Union{AbstractVector, Nothing}=nothing,
                       ordered::Bool=false) where {T, N} =
    CategoricalArray{T, N, DefaultRefType}(undef, dims, levels=levels, ordered=ordered)
CategoricalArray{T, N}(::UndefInitializer, dims::NTuple{N,Int};
                       levels::Union{AbstractVector, Nothing}=nothing,
                       ordered::Bool=false) where
    {R, T <: Union{Missing, CategoricalValue{<:Any, R}}, N} =
    CategoricalArray{T, N, R}(undef, dims, levels=levels, ordered=ordered)
CategoricalArray{T}(::UndefInitializer, dims::NTuple{N,Int};
                    levels::Union{AbstractVector, Nothing}=nothing,
                    ordered::Bool=false) where {T, N} =
    CategoricalArray{T, N}(undef, dims, levels=levels, ordered=ordered)
CategoricalArray{T, 1}(::UndefInitializer, m::Int;
                       levels::Union{AbstractVector, Nothing}=nothing,
                       ordered::Bool=false) where {T} =
    CategoricalArray{T, 1}(undef, (m,), levels=levels, ordered=ordered)
CategoricalArray{T, 2}(::UndefInitializer, m::Int, n::Int;
                       levels::Union{AbstractVector, Nothing}=nothing,
                       ordered::Bool=false) where {T} =
    CategoricalArray{T, 2}(undef, (m, n), levels=levels, ordered=ordered)
CategoricalArray{T, 1, R}(::UndefInitializer, m::Int;
                          levels::Union{AbstractVector, Nothing}=nothing,
                          ordered=false) where {T, R} =
    CategoricalArray{T, 1, R}(undef, (m,), levels=levels, ordered=ordered)
# R <: Integer is required to prevent default constructor from being called instead
CategoricalArray{T, 2, R}(::UndefInitializer, m::Int, n::Int;
                          levels::Union{AbstractVector, Nothing}=nothing,
                          ordered::Bool=false) where {T, R <: Integer} =
    CategoricalArray{T, 2, R}(undef, (m, n), levels=levels, ordered=ordered)
CategoricalArray{T, 3, R}(::UndefInitializer, m::Int, n::Int, o::Int;
                          levels::Union{AbstractVector, Nothing}=nothing,
                          ordered::Bool=false) where {T, R} =
    CategoricalArray{T, 3, R}(undef, (m, n, o), levels=levels, ordered=ordered)
CategoricalArray{T}(::UndefInitializer, m::Int;
                    levels::Union{AbstractVector, Nothing}=nothing,
                    ordered::Bool=false) where {T} =
    CategoricalArray{T}(undef, (m,), levels=levels, ordered=ordered)
CategoricalArray{T}(::UndefInitializer, m::Int, n::Int;
                    levels::Union{AbstractVector, Nothing}=nothing,
                    ordered::Bool=false) where {T} =
    CategoricalArray{T}(undef, (m, n), levels=levels, ordered=ordered)
CategoricalArray{T}(::UndefInitializer, m::Int, n::Int, o::Int;
                    levels::Union{AbstractVector, Nothing}=nothing,
                    ordered::Bool=false) where {T} =
    CategoricalArray{T}(undef, (m, n, o), levels=levels, ordered=ordered)

CategoricalVector(::UndefInitializer, m::Integer;
                  levels::Union{AbstractVector, Nothing}=nothing,
                  ordered::Bool=false) =
    CategoricalArray(undef, m, levels=levels, ordered=ordered)

CategoricalMatrix(::UndefInitializer, m::Int, n::Int;
                  levels::Union{AbstractVector, Nothing}=nothing,
                  ordered::Bool=false) =
    CategoricalArray(undef, m, n, levels=levels, ordered=ordered)

## Constructors from arrays

function CategoricalArray{T, N, R}(A::CategoricalArray{S, N, Q};
                                   levels::Union{AbstractVector, Nothing}=nothing,
                                   ordered::Bool=_isordered(A)) where {S, T, N, Q, R}
    V = unwrap_catvaluetype(T)
    res = convert(CategoricalArray{V, N, R}, A)
    refs = res.refs === A.refs ? copy(res.refs) : res.refs
    pool = res.pool === A.pool ? copy(res.pool) : res.pool
    ordered!(pool, ordered)
    res = CategoricalArray{V, N}(refs, pool)
    if levels !== nothing
        # Calling levels! is faster than checking beforehand which values are used
        try
            levels!(res, levels)
        catch err
            err isa LevelsException || rethrow(err)
            throw(ArgumentError("encountered value(s) not in specified `levels`: " *
                                "$(setdiff(_levels(res), levels))"))
        end
    end
    return res
end

function CategoricalArray{T, N, R}(A::AbstractArray;
                                   levels::Union{AbstractVector, Nothing}=nothing,
                                   ordered::Bool=_isordered(A)) where {T, N, R}
    V = unwrap_catvaluetype(T)
    ordered!(_convert(CategoricalArray{V, N, R}, A, levels=levels), ordered)
end

# From AbstractArray

CategoricalArray{T, N}(A::AbstractArray{S, N};
                       levels::Union{AbstractVector, Nothing}=nothing,
                       ordered::Bool=_isordered(A)) where {S, T, N} =
    CategoricalArray{T, N, DefaultRefType}(A, levels=levels, ordered=ordered)
CategoricalArray{T}(A::AbstractArray{S, N};
                    levels::Union{AbstractVector, Nothing}=nothing,
                    ordered::Bool=_isordered(A)) where {S, T, N} =
    CategoricalArray{T, N}(A, levels=levels, ordered=ordered)
CategoricalArray(A::AbstractArray{T, N};
                 levels::Union{AbstractVector, Nothing}=nothing,
                 ordered::Bool=_isordered(A)) where {T, N} =
    CategoricalArray{fixtype(A), N}(A, levels=levels, ordered=ordered)

CategoricalVector(A::AbstractVector{T};
                  levels::Union{AbstractVector, Nothing}=nothing,
                  ordered::Bool=_isordered(A)) where {T} =
    CategoricalArray{fixtype(A), 1}(A, levels=levels, ordered=ordered)

CategoricalMatrix(A::AbstractMatrix{T};
                  levels::Union{AbstractVector, Nothing}=nothing,
                  ordered::Bool=_isordered(A)) where {T} =
    CategoricalArray{fixtype(A), 2}(A, levels=levels, ordered=ordered)

# From CategoricalArray (preserve R)
CategoricalArray{T, N}(A::CategoricalArray{S, N, R};
                       levels::Union{AbstractVector, Nothing}=nothing,
                       ordered::Bool=_isordered(A)) where {S, T, N, R} =
    CategoricalArray{T, N, R}(A, levels=levels, ordered=ordered)
CategoricalArray{T}(A::CategoricalArray{S, N, R};
                    levels::Union{AbstractVector, Nothing}=nothing,
                    ordered::Bool=_isordered(A)) where {S, T, N, R} =
    CategoricalArray{T, N, R}(A, levels=levels, ordered=ordered)
CategoricalArray(A::CategoricalArray{T, N, R};
                 levels::Union{AbstractVector, Nothing}=nothing,
                 ordered::Bool=_isordered(A)) where {T, N, R} =
    CategoricalArray{T, N, R}(A, levels=levels, ordered=ordered)

CategoricalVector(A::CategoricalArray{T, 1, R};
                  levels::Union{AbstractVector, Nothing}=nothing,
                  ordered::Bool=_isordered(A)) where {T, R} =
    CategoricalArray{T, 1, R}(A, levels=levels, ordered=ordered)

CategoricalMatrix(A::CategoricalArray{T, 2, R};
                  levels::Union{AbstractVector, Nothing}=nothing,
                  ordered::Bool=_isordered(A)) where {T, R} =
    CategoricalArray{T, 2, R}(A, levels=levels, ordered=ordered)

## Promotion methods

# Identical behavior to the Array method
# Needed to prevent promote_result from returning an Array
# Note that eltype returns Any if a type parameter is omitted
Base.promote_rule(x::Type{<:CategoricalArray},
                  y::Type{<:CategoricalArray}) =
    Base.el_same(promote_type(eltype(x), eltype(y)), x, y)

## Conversion methods

# From AbstractArray
convert(::Type{CategoricalArray{T, N}}, A::AbstractArray{S, N}) where {S, T, N} =
    convert(CategoricalArray{T, N, DefaultRefType}, A)
convert(::Type{CategoricalArray{T}}, A::AbstractArray{S, N}) where {S, T, N} =
    convert(CategoricalArray{T, N}, A)
convert(::Type{CategoricalArray}, A::AbstractArray{T, N}) where {T, N} =
    convert(CategoricalArray{fixtype(A), N}, A)

convert(::Type{CategoricalVector{T}}, A::AbstractVector) where {T} =
    convert(CategoricalVector{T, DefaultRefType}, A)
convert(::Type{CategoricalVector}, A::AbstractVector{T}) where {T} =
    convert(CategoricalVector{fixtype(A)}, A)
convert(::Type{CategoricalVector{T}},
        A::CategoricalVector{S, R}) where {S, T, R <: Integer} =
    convert(CategoricalVector{T, R}, A)
convert(::Type{CategoricalVector{T}}, A::CategoricalVector{T}) where {T} = A
convert(::Type{CategoricalVector}, A::CategoricalVector) = A

convert(::Type{CategoricalMatrix{T}}, A::AbstractMatrix) where {T} =
    convert(CategoricalMatrix{T, DefaultRefType}, A)
convert(::Type{CategoricalMatrix}, A::AbstractMatrix{T}) where {T} =
    convert(CategoricalMatrix{fixtype(A)}, A)
convert(::Type{CategoricalMatrix{T}},
        A::CategoricalMatrix{S, R}) where {S, T, R <: Integer} =
    convert(CategoricalMatrix{T, R}, A)
convert(::Type{CategoricalMatrix{T}}, A::CategoricalMatrix{T}) where {T} = A
convert(::Type{CategoricalMatrix}, A::CategoricalMatrix) = A

convert(::Type{CategoricalArray{T, N, R}}, A::AbstractArray{S, N}) where {S, T, N, R} =
    _convert(CategoricalArray{T, N, R}, A)

convert(::Type{CategoricalArray{T, N, R, V, C, U}},
        A::CategoricalArray{T, N, R, V, C, U}) where {T, N, R, V, C, U} = A
# V, C and U are not used since they are recomputed from T and R
convert(::Type{CategoricalArray{T, N, R, V, C, U}},
        A::AbstractArray{S, N}) where {S, T, N, R, V, C, U} =
    _convert(CategoricalArray{T, N, R}, A)

function _convert(::Type{CategoricalArray{T, N, R}}, A::AbstractArray{S, N};
                  levels::Union{AbstractVector, Nothing}=nothing) where {S, T, N, R}
    check_supported_eltype(T, T)

    res = CategoricalArray{T, N, R}(undef, size(A), levels=levels)
    copyto!(res, A)

    if levels !== nothing
        _levels(res) == levels ||
            throw(ArgumentError("encountered value(s) not in specified `levels`: " *
                                "$(setdiff(_levels(res), levels))"))
    else
        # if order is defined for level type, automatically apply it
        L = leveltype(res)
        if Base.OrderStyle(L) isa Base.Ordered
            levels!(res, sort(_levels(res)))
        elseif hasmethod(isless, (L, L))
            # isless may throw an error, e.g. for AbstractArray{T} of unordered T
            try
                levels!(res, sort(_levels(res)))
            catch e
                 e isa MethodError || rethrow(e)
            end
        end
    end

    res
end

# From CategoricalArray (preserve levels, ordering and R)
function convert(::Type{CategoricalArray{T, N, R}}, A::CategoricalArray{S, N}) where {S, T, N, R}
    if length(A.pool) > typemax(R)
        throw(LevelsException{T, R}(_levels(A)[typemax(R)+1:end]))
    end

    if !(T >: Missing) && S >: Missing && any(iszero, A.refs)
        throw(MissingException("cannot convert CategoricalArray with missing values to a CategoricalArray{$T}"))
    end

    pool = convert(CategoricalPool{unwrap_catvaluetype(nonmissingtype(T)), R}, A.pool)
    refs = convert(Array{R, N}, A.refs)
    CategoricalArray{unwrap_catvaluetype(T), N}(refs, pool)
end

convert(::Type{CategoricalArray{T, N}},
        A::CategoricalArray{S, N, R}) where {S, T, N, R <: Integer} =
    convert(CategoricalArray{T, N, R}, A)
convert(::Type{CategoricalArray{T}},
        A::CategoricalArray{S, N, R}) where {S, T, N, R <: Integer} =
    convert(CategoricalArray{T, N, R}, A)
convert(::Type{CategoricalArray}, A::CategoricalArray{T, N, R}) where {T, N, R} =
    convert(CategoricalArray{T, N, R}, A)

# R<:Integer is needed for this method to be considered more specific
# than the generic one above (JuliaLang/julia#18443)
convert(::Type{CategoricalArray{T, N, R}}, A::CategoricalArray{T, N, R}) where {T, N, R<:Integer} = A
convert(::Type{CategoricalArray{T, N}}, A::CategoricalArray{T, N}) where {T, N} = A
convert(::Type{CategoricalArray{T}}, A::CategoricalArray{T}) where {T} = A
convert(::Type{CategoricalArray}, A::CategoricalArray) = A

convert(::Type{Array}, A::CatArrOrSub) = unwrap.(A)
convert(::Type{Vector}, A::CatArrOrSub) = unwrap.(A)
convert(::Type{Matrix}, A::CatArrOrSub) = unwrap.(A)

function Base.:(==)(A::CategoricalArray{S}, B::CategoricalArray{T}) where {S, T}
    if size(A) != size(B)
        return false
    end
    anymissing = false
    if A.pool === B.pool
        @inbounds for (a, b) in zip(A.refs, B.refs)
            if a == 0 || b == 0
                (S >: Missing || T >: Missing) && (anymissing = true)
            elseif a != b
                return false
            end
        end
    else
        @inbounds for (a, b) in zip(A, B)
            eq = (a == b)
            if eq === false
                return false
            elseif S >: Missing || T >: Missing
                anymissing |= ismissing(eq)
            end
        end
    end
    return anymissing ? missing : true
end

function Base.isequal(A::CategoricalArray, B::CategoricalArray)
    if size(A) != size(B)
        return false
    end
    if A.pool === B.pool
        @inbounds for (a, b) in zip(A.refs, B.refs)
            if a != b
                return false
            end
        end
    else
        @inbounds for (a, b) in zip(A, B)
            if !isequal(a, b)
                return false
            end
        end
    end
    return true
end

size(A::CategoricalArray) = size(A.refs)
Base.IndexStyle(::Type{<:CategoricalArray}) = IndexLinear()

function update_refs!(A::CategoricalArray, newlevels::AbstractVector)
    oldlevels = _levels(A)
    levelsmap = similar(A.refs, length(oldlevels)+1)
    # 0 maps to a missing value
    levelsmap[1] = 0
    levelsmap[2:end] .= something.(indexin(oldlevels, newlevels), 0)

    refs = A.refs
    @inbounds for (i, x) in enumerate(refs)
        refs[i] = levelsmap[x+1]
    end
    A
end

function merge_pools!(A::CatArrOrSub,
                      B::Union{CategoricalValue, CatArrOrSub};
                      updaterefs::Bool=true,
                      updatepool::Bool=true)
    newlevels, ordered = merge_pools(pool(A), pool(B))
    oldlevels = _levels(A)
    pA = A isa SubArray ? parent(A) : A
    ordered!(pA, ordered)
    # If A's levels are an ordered superset of new (merged) pool, no need to recompute refs
    if updaterefs &&
        (length(newlevels) < length(oldlevels) ||
         view(newlevels, 1:length(oldlevels)) != oldlevels)
        update_refs!(pA, newlevels)
    end
    if updatepool
        pA.pool = typeof(pA.pool)(newlevels, ordered)
    end
    newlevels, ordered
end

@inline function setindex!(A::CategoricalArray, v::Any, I::Real...)
    @boundscheck checkbounds(A, I...)
    if v isa CategoricalValue && pool(v) !== pool(A) && pool(v) ⊈ pool(A)
        merge_pools!(A, v)
    end
    @inbounds A.refs[I...] = get!(A.pool, v)
end

Base.fill(v::CategoricalValue{T}, dims::NTuple{N, Integer}) where {T, N} =
    CategoricalArray{T, N}(fill(refcode(v), dims), copy(pool(v)))

# to avoid ambiguity
Base.fill(v::CategoricalValue, dims::Tuple{}) =
    invoke(fill, Tuple{CategoricalValue{T}, NTuple{N, Integer}} where {T, N}, v, dims)

function Base.fill!(A::CategoricalArray, v::Any)
    if v isa CategoricalValue && pool(v) !== pool(A) && pool(v) ⊈ pool(A)
        merge_pools!(A, v, updaterefs=false)
    end
    fill!(A.refs, get!(A.pool, v))
    A
end

# Methods preserving levels and more efficient than AbstractArray fallbacks
copy(A::CategoricalArray{T, N}) where {T, N} =
    CategoricalArray{T, N}(copy(A.refs), copy(A.pool))

function copyto!(dest::CatArrOrSub{T, N, R}, dstart::Integer,
                 src::CatArrOrSub{<:Any, N}, sstart::Integer,
                 n::Integer) where {T, N, R}
    n < 0 && throw(ArgumentError("tried to copy n=$n elements, but n should be nonnegative"))
    destinds, srcinds = LinearIndices(dest), LinearIndices(src)
    if n > 0
        (dstart ∈ destinds && dstart+n-1 ∈ destinds) || throw(BoundsError(dest, dstart:dstart+n-1))
        (sstart ∈ srcinds  && sstart+n-1 ∈ srcinds)  || throw(BoundsError(src,  sstart:sstart+n-1))
    end

    drefs = refs(dest)
    srefs = refs(src)
    dpool = pool(dest)
    spool = pool(src)

    # try converting src to dest type to avoid partial copy corruption of dest
    # in the event that the src cannot be copied into dest
    slevs = convert(Vector{T}, _levels(src))
    dlevs = _levels(dest)
    if eltype(src) >: Missing && !(eltype(dest) >: Missing) && !all(x -> x > 0, srefs)
        throw(MissingException("cannot copy array with missing values to an array with element type $T"))
    end

    destp = dest isa SubArray ? parent(dest) : dest

    # For partial copy, need to recompute existing refs
    # TODO: for performance, avoid ajusting refs which are going to be overwritten
    updaterefs = isa(dest, SubArray) || !(n == length(dest) == length(src))
    newlevels, ordered = merge_pools!(dest, src, updaterefs=updaterefs, updatepool=false)

    # If destination levels are an ordered superset of source, no need to recompute refs
    if view(newlevels, 1:length(slevs)) == slevs
        copyto!(drefs, dstart, srefs, sstart, n)
    else # Otherwise, recompute refs according to new levels
        # Then adjust refs from source
        levelsmap = similar(drefs, length(slevs)+1)
        # 0 maps to a missing value
        levelsmap[1] = 0
        levelsmap[2:end] = indexin(slevs, newlevels)

        @inbounds for i = 0:(n-1)
            x = srefs[sstart+i]
            drefs[dstart+i] = levelsmap[x+1]
        end
    end
    # Need to allocate a new pool only if reordering destination levels
    if view(newlevels, 1:length(dlevs)) == dlevs
        levels!(dpool, newlevels, checkunique=false)
    else
        destp.pool = CategoricalPool{nonmissingtype(T), R}(newlevels, ordered)
    end

    dest
end

function copyto!(dest::CatArrOrSub{T1, N, R}, dstart::Integer,
                 src::AbstractArray{T2, N}, sstart::Integer,
                 n::Integer) where {T1, T2, N, R}
    n == 0 && return dest
    n < 0 && throw(ArgumentError("tried to copy n=$n elements, but n should be nonnegative"))
    destinds, srcinds = LinearIndices(dest), LinearIndices(src)
    (checkbounds(Bool, destinds, dstart) && checkbounds(Bool, destinds, dstart+n-1)) || throw(BoundsError(dest, dstart:dstart+n-1))
    (checkbounds(Bool, srcinds, sstart)  && checkbounds(Bool, srcinds, sstart+n-1))  || throw(BoundsError(src,  sstart:sstart+n-1))
    srclevs = DataAPI.refpool(src)
    srcrefs = DataAPI.refarray(src)
    # Fast path only supports refs which can be used to index
    # into vector mapping from source levels to destination levels
    if !(srclevs isa AbstractVector) || !(srcrefs isa AbstractArray{<:Integer})
        return invoke(copyto!, Tuple{AbstractArray, Integer, AbstractArray, Integer, Integer},
                      dest, dstart, src, sstart, n)
    end
    newdestlevs = destlevs = copy(_levels(dest)) # copy since we need original levels below
    srclevsnm = T2 >: Missing ? setdiff(srclevs, [missing]) : srclevs
    if !(srclevsnm ⊆ destlevs)
        # if order is defined for level type, automatically apply it
        L = nonmissingtype(eltype(srclevsnm))
        if hasmethod(isless, Tuple{L, L})
            srclevsnm = srclevsnm === srclevs ? sort(srclevsnm) : sort!(srclevsnm)
        end
        newdestlevs = union(destlevs, srclevsnm)
        levels!(pool(dest), newdestlevs, checkunique=false)
    end
    levelsmap = something.(indexin(srclevs, [missing; newdestlevs])) .- 1
    destrefs = refs(dest)
    seen = fill(false, length(newdestlevs)+1)
    firstind = firstindex(srclevs)
    @inbounds for i in 0:(n-1)
        j = srcrefs[sstart+i] - firstind + 1
        ref = levelsmap[j]
        seen[ref+1] = true
        if !(T1 >: Missing) && T2 >: Missing && ref == 0
            throw(MethodError(convert, (T1, missing)))
        end
        destrefs[dstart+i] = ref
    end
    seennm = @view seen[2:end]
    if !all(seennm)
        destlevsset = Set(destlevs)
        keptlevs = [l for (i, l) in enumerate(newdestlevs)
                    if seennm[i] || l in destlevsset]
        levels!(dest, keptlevs)
    end
    dest
end

# This uses linear indexing even for IndexCartesian src, but
# the performance impact should be modest compared to the dict lookup
copyto!(dest::CatArrOrSub, src::AbstractArray) =
    copyto!(dest, 1, src, 1, length(src))

copyto!(dest::CatArrOrSub, dstart::Integer, src::AbstractArray) =
    copyto!(dest, dstart, src, 1, length(src))

if VERSION >= v"1.1"
    import Base: copy!
else
    import Future: copy!
end
copy!(dest::CatArrOrSub, src::AbstractArray) = copyto!(dest, 1, src, 1, length(src))
# To fix ambiguities
copy!(dest::CatArrOrSub{<:Any, 1}, src::AbstractArray{<:Any, 1}) =
    copyto!(dest, 1, src, 1, length(src))
copy!(dest::CatArrOrSub{T, 1}, src::AbstractArray{T, 1}) where {T} =
    copyto!(dest, 1, src, 1, length(src))

similar(A::CategoricalArray{S, M, R}, ::Type{T},
        dims::NTuple{N, Int}) where {T, N, S, M, R} =
    Array{T, N}(undef, dims)
similar(A::CategoricalArray{S, M, R}, ::Type{Missing},
        dims::NTuple{N, Int}) where {N, S, M, R} =
    Array{Missing, N}(missing, dims)
similar(A::CategoricalArray{S, M, Q}, ::Type{CategoricalValue{T, R}},
        dims::NTuple{N, Int}) where {R, T, N, S, M, Q} =
    CategoricalArray{T, N, R}(undef, dims)
similar(A::CategoricalArray{S, M, Q}, ::Type{CategoricalValue{T}},
        dims::NTuple{N, Int}) where {T, N, S, M, Q} =
    CategoricalArray{T, N, Q}(undef, dims)
similar(A::CategoricalArray{S, M, Q}, ::Type{Union{CategoricalValue{T, R}, Missing}},
        dims::NTuple{N, Int}) where {R, T, N, S, M, Q} =
    CategoricalArray{Union{T, Missing}, N, R}(undef, dims)
similar(A::CategoricalArray{S, M, Q}, ::Type{Union{CategoricalValue{T}, Missing}},
        dims::NTuple{N, Int}) where {T, N, S, M, Q} =
    CategoricalArray{Union{T, Missing}, N, Q}(undef, dims)

# AbstractRange methods are needed since collect uses 1:1 as dummy array
for A in (:Array, :Vector, :Matrix, :AbstractRange)
    @eval begin
        similar(A::$A, ::Type{CategoricalValue{T, R}},
                dims::NTuple{N, Int}=size(A)) where {T, R, N} =
            CategoricalArray{T, N, R}(undef, dims)
        similar(A::$A, ::Type{CategoricalValue{T}},
                dims::NTuple{N, Int}=size(A)) where {T, N} =
            CategoricalArray{T, N}(undef, dims)
        similar(A::$A, ::Type{Union{CategoricalValue{T, R}, Missing}},
                dims::NTuple{N, Int}=size(A)) where {T, R, N} =
            CategoricalArray{Union{T, Missing}, N, R}(undef, dims)
        similar(A::$A, ::Type{Union{CategoricalValue{T}, Missing}},
                dims::NTuple{N, Int}=size(A)) where {T, N} =
            CategoricalArray{Union{T, Missing}, N}(undef, dims)
    end
end

similar(::Type{T}, dims::Dims) where {U, R, T<:Array{CategoricalValue{U, R}}} =
    CategoricalArray{eltype(T)}(undef, dims)
similar(::Type{T}, dims::Dims) where {U, T<:Array{CategoricalValue{U}}} =
    CategoricalArray{eltype(T)}(undef, dims)
similar(::Type{T}, dims::Dims) where {U, R, T<:Array{Union{CategoricalValue{U, R}, Missing}}} =
    CategoricalArray{eltype(T)}(undef, dims)
similar(::Type{T}, dims::Dims) where {U, T<:Array{Union{CategoricalValue{U}, Missing}}} =
    CategoricalArray{eltype(T)}(undef, dims)

"""
    compress(A::CategoricalArray)

Return a copy of categorical array `A` using the smallest reference type able to hold the
number of [`levels`](@ref DataAPI.levels) of `A`.

While this will reduce memory use, this function is type-unstable, which can affect
performance inside the function where the call is made. Therefore, use it with caution.
"""
function compress(A::CategoricalArray{T, N}) where {T, N}
    R = reftype(length(_levels(A.pool)))
    convert(CategoricalArray{T, N, R}, A)
end

"""
    decompress(A::CategoricalArray)

Return a copy of categorical array `A` using the default reference type ($DefaultRefType).
If `A` is using a small reference type (such as `UInt8` or `UInt16`) the decompressed array
will have room for more levels.

To avoid the need to call decompress, ensure [`compress`](@ref) is not called when creating
the categorical array.
"""
decompress(A::CategoricalArray{T, N}) where {T, N} =
    convert(CategoricalArray{T, N, DefaultRefType}, A)

function vcat(A::CategoricalArray...)
    ordered = any(isordered, A) && all(a->isordered(a) || isempty(_levels(a)), A)
    newlevels, ordered = mergelevels(ordered, map(_levels, A)...)

    refsvec = map(A) do a
        ii = convert(Vector{Int}, indexin(_levels(a.pool), newlevels))
        [x==0 ? 0 : ii[x] for x in a.refs]::Array{Int,ndims(a)}
    end

    T = cat_promote_eltype(A...) >: Missing ?
        Union{eltype(newlevels), Missing} : eltype(newlevels)
    refs = DefaultRefType[refsvec...;]
    pool = CategoricalPool(newlevels, ordered)
    CategoricalArray{T, ndims(refs)}(refs, pool)
end

@inline function getindex(A::CategoricalArray{T}, I...) where {T}
    @boundscheck checkbounds(A, I...)
    # Let Array indexing code handle everything
    @inbounds r = A.refs[I...]

    if isa(r, Array)
        res = CategoricalArray{T, ndims(r)}(r, copy(A.pool))
        return ordered!(res, isordered(A))
    else
        r > 0 || throw(UndefRefError())
        @inbounds res = A.pool[r]
        return res
    end
end

leveltype(::Type{T}) where {T <: CategoricalArray} = leveltype(nonmissingtype(eltype(T)))

"""
    levels(x::CategoricalArray; skipmissing=true)
    levels(x::CategoricalValue)

Return the levels of categorical array or value `x`.
This may include levels which do not actually appear in the data
(see [`droplevels!`](@ref)).
`missing` will be included only if it appears in the data and
`skipmissing=false` is passed.

The returned vector is owned by `x` and must not be mutated
as doing so would corrupt it.
"""
@inline function DataAPI.levels(A::CatArrOrSub; skipmissing::Bool=true)
    if eltype(A) >: Missing && !skipmissing
        if any(==(0), refs(A))
            eltype(A)[levels(pool(A)); missing]
        else
            levels_missing(pool(A))
        end
    else
        levels(pool(A))
    end
end

_levels(A::CatArrOrSub) = _levels(pool(A))

"""
    levels!(A::CategoricalArray, newlevels::AbstractVector; allowmissing::Bool=false)

Set the levels categorical array `A`. The order of appearance of levels will be respected
by [`levels`](@ref DataAPI.levels), which may affect display of results in some operations; if `A` is
ordered (see [`isordered`](@ref)), it will also be used for order comparisons
using `<`, `>` and similar operators. Reordering levels will never affect the values
of entries in the array.

If `A` accepts missing values (i.e. `eltype(A) >: Missing`) and `allowmissing=true`,
entries corresponding to omitted levels will be set to `missing`.
Else, `newlevels` must include all levels which appear in the data.
"""
function levels!(A::CategoricalArray{T, N, R}, newlevels::AbstractVector;
                 allowmissing::Bool=false) where {T, N, R}
    (_levels(A) == newlevels) && return A # nothing to do

    # map each new level to its ref code
    newlv2ref = Dict{eltype(newlevels), Int}()
    dupnewlvs = similar(newlevels, 0)
    for (i, lv) in enumerate(newlevels)
        if get!(newlv2ref, lv, i) != i
            push!(dupnewlvs, lv)
        end
    end
    if !isempty(dupnewlvs)
        throw(ArgumentError(string("duplicated levels found: ", join(unique!(dupnewlvs), ", "))))
    end

    # map each old ref code to new ref code (or 0 if no such level)
    oldlevels = _levels(pool(A))
    oldref2newref = fill(0, length(oldlevels) + 1)
    for (i, lv) in enumerate(oldlevels)
        oldref2newref[i + 1] = get(newlv2ref, lv, 0)
    end

    # create the new pool early (throws if the new levels could not be encoded with R)
    newpool = CategoricalPool{nonmissingtype(T), R}(copy(newlevels), isordered(A))

    # recode the refs
    arefs = A.refs
    # check whether potentially an error can occur due to a missing level
    if (!(T >: Missing) || !allowmissing) && any(iszero, @view oldref2newref[2:end])
        # slow pass, check for missing levels
        failedpos = 0
        @inbounds for (i, oldref) in enumerate(arefs)
            newref = oldref2newref[oldref + 1]
            if (oldref > 0) && (newref == 0)
                failedpos = i
                break
            end
            arefs[i] = newref
        end

        if failedpos > 0 # a missing at failedpos, revert the changes to A.refs
            # build the inverse ref map
            newref2oldref = fill(0, length(newlevels) + 1)
            @inbounds for (oldref, newref) in enumerate(oldref2newref)
                newref2oldref[newref + 1] = oldref - 1
            end
            newref2oldref[1] = 0 # missing stays missing
            # revert the refs
            @inbounds for i in 1:(failedpos - 1)
                arefs[i] = newref2oldref[arefs[i] + 1]
            end
            # throw an error
            msg = "cannot remove level $(repr(oldlevels[arefs[failedpos]])) as it is used at position $failedpos"
            if !(T >: Missing)
                msg *= ". Change the array element type to Union{$T, Missing}" *
                       " using convert if you want to transform some levels to missing values."
            elseif !allowmissing
                msg *= " and allowmissing=false."
            end
            throw(ArgumentError(msg))
        end
    else # fast pass, either introducing new missings is allowed or no new missings can occur
        @inbounds for i in eachindex(arefs)
            arefs[i] = oldref2newref[arefs[i] + 1]
        end
    end
    A.pool = newpool # update the pool

    return A
end

# return unique refs (each value is unique) in the order of appearance in `refs`
# equivalent to fallback Base.unique() implementation,
# but short-circuits once references to all levels are encountered
function _uniquerefs(A::CatArrOrSub{T}) where T
    arefs = refs(A)
    res = similar(arefs, 0)
    nlevels = length(_levels(A))
    maxunique = nlevels + (T >: Missing ? 1 : 0)
    seen = fill(false, nlevels + 1) # always +1 for 0 (missing ref)
    @inbounds for ref in arefs
        if !seen[ref + 1]
            push!(res, ref)
            seen[ref + 1] = true
            (length(res) == maxunique) && break
        end
    end
    return res
end

unique(A::CatArrOrSub{T}) where T =
    CategoricalVector{T}(_uniquerefs(A), copy(pool(A)))

function unique!(A::CategoricalVector)
    urefs = _uniquerefs(A)
    if length(urefs) != length(A)
        resize!(A.refs, length(urefs))
        copyto!(A.refs, urefs)
    end
    return A
end

"""
    droplevels!(A::CategoricalArray)

Drop levels which do not appear in categorical array `A` (so that they will no longer be
returned by [`levels`](@ref DataAPI.levels)).
"""
function droplevels!(A::CategoricalArray)
    arefs = refs(A)
    nlevels = length(_levels(A)) + 1 # +1 for missing
    seen = fill(false, nlevels)
    seen[1] = true # assume that missing is always observed to simplify checks
    nseen = 1
    @inbounds for ref in arefs
        if !seen[ref + 1]
            seen[ref + 1] = true
            nseen += 1
            (nseen == nlevels) && return A # all levels observed, nothing to drop
        end
    end

    # replace the pool
    A.pool = typeof(pool(A))(@inbounds(_levels(A)[view(seen, 2:nlevels)]), isordered(A))
    # recode refs to keep only the seen ones (optimized version of update_refs!())
    seen[1] = false # to start levelsmap from 0
    levelsmap = cumsum(seen)
    @inbounds for i in eachindex(arefs)
        arefs[i] = levelsmap[Int(arefs[i]) + 1]
    end
    return A
end

"""
    isordered(A::CategoricalArray)

Test whether entries in `A` can be compared using `<`, `>` and similar operators,
using the ordering of levels.
"""
isordered(A::CategoricalArray) = isordered(A.pool)

"""
    ordered!(A::CategoricalArray, ordered::Bool)

Set whether entries in `A` can be compared using `<`, `>` and similar operators,
using the ordering of levels. Return the modified `A`.
"""
ordered!(A::CategoricalArray, ordered) = (ordered!(A.pool, ordered); return A)

function Base.resize!(A::CategoricalVector, n::Integer)
    n_orig = length(A)
    resize!(A.refs, n)
    if n > n_orig
        A.refs[n_orig+1:end] .= 0
    end
    A
end

function Base.push!(A::CategoricalVector, v::Any)
    if v isa CategoricalValue && pool(v) !== pool(A) && pool(v) ⊈ pool(A)
        merge_pools!(A, v)
    end
    r = get!(A.pool, v)
    push!(A.refs, r)
    return A
end

function Base.insert!(A::CategoricalVector, i::Integer, v::Any)
    i isa Bool && throw(ArgumentError("invalid index: $i of type Bool"))
    if !(1 <= i <= length(A.refs) + 1)
        throw(BoundsError("attempt to insert to a vector with length $(length(A)) at index $i"))
    end
    if v isa CategoricalValue && pool(v) !== pool(A) && pool(v) ⊈ pool(A)
        merge_pools!(A, v)
    end
    r = get!(A.pool, v)
    insert!(A.refs, i, r)
    return A
end

function Base.append!(A::CategoricalVector, B::CatArrOrSub)
    if pool(B) !== pool(A) && pool(B) ⊈ pool(A)
        merge_pools!(A, B)
    end
    # TODO: optimize recoding
    len = length(A)
    len2 = length(B)
    resize!(A.refs, len + len2)
    for i = 1:len2
        A[len + i] = B[i]
    end
    return A
end

Base.empty!(A::CategoricalVector) = (empty!(A.refs); return A)
Base.sizehint!(A::CategoricalVector, sz::Integer) = (sizehint!(A.refs, sz); return A)

function Base.reshape(A::CategoricalArray{T, N}, dims::Dims) where {T, N}
    x = reshape(A.refs, dims)
    res = CategoricalArray{T, ndims(x)}(x, A.pool)
    ordered!(res, isordered(res))
end

"""
    categorical(A::AbstractArray; levels=nothing, ordered=false, compress=false)

Construct a categorical array with the values from `A`.

The `levels` keyword argument can be a vector specifying possible values for the data
(this is equivalent to but more efficient than calling [`levels!`](@ref)
on the resulting array).
If `levels` is omitted and the element type supports it, levels are sorted
in ascending order; else, they are kept in their order of appearance in `A`.
The `ordered` keyword argument determines whether the array values can be compared
according to the ordering of levels or not (see [`isordered`](@ref)).

If `compress` is `true`, the smallest reference type able to hold the
number of unique values in `A` will be used. While this will reduce memory use, passing
this parameter will also introduce a type instability which can affect performance inside
the function where the call is made. Therefore, use this option with caution (the
one-argument version does not suffer from this problem).

    categorical(A::CategoricalArray; compress=false, levels=nothing, ordered=false)

If `A` is already a `CategoricalArray`, its levels, orderedness and reference type
are preserved unless explicitly overriden.
"""
@inline function categorical(A::AbstractArray{T, N};
                             levels::Union{AbstractVector, Nothing}=nothing,
                             ordered=_isordered(A),
                             compress::Bool=false) where {T, N}
    # @inline is needed so that return type is inferred when compress is not provided
    RefType = compress ? reftype(length(unique(A))) : DefaultRefType
    CategoricalArray{fixtype(A), N, RefType}(A, levels=levels, ordered=ordered)
end
@inline function categorical(A::CategoricalArray{T, N, R};
                             levels::Union{AbstractVector, Nothing}=nothing,
                             ordered=_isordered(A),
                             compress::Bool=false) where {T, N, R}
    # @inline is needed so that return type is inferred when compress is not provided
    RefType = compress ? reftype(length(_levels(A))) : R
    CategoricalArray{T, N, RefType}(A, levels=levels, ordered=ordered)
end

function in(x::Any, y::CategoricalArray{T, N, R}) where {T, N, R}
    ref = get(y.pool, x, zero(R))
    ref != 0 ? ref in y.refs : false
end

function in(x::CategoricalValue, y::CategoricalArray{T, N, R}) where {T, N, R}
    if x.pool === y.pool
        return refcode(x) in y.refs
    else
        ref = get(y.pool, _levels(x.pool)[refcode(x)], zero(R))
        return ref != 0 ? ref in y.refs : false
    end
end

Array(A::CatArrOrSub{T}) where {T} = Array{T}(A)
Vector(A::CatArrOrSub{T}) where {T} = Vector{T}(A)
Matrix(A::CatArrOrSub{T}) where {T} = Matrix{T}(A)
collect(A::CatArrOrSub) = copy(A)

# Defined for performance
collect(x::Base.SkipMissing{<: CatArrOrSub{T}}) where {T} =
    CategoricalVector{nonmissingtype(T)}(filter(v -> v > 0, refs(x.x)), copy(pool(x.x)))

function float(A::CategoricalArray{T}) where T
    if !isconcretetype(T)
        error("`float` not defined on abstractly-typed arrays; please convert to a more specific type")
    end
    convert(AbstractArray{typeof(float(zero(T)))}, A)
end
function complex(A::CategoricalArray{T}) where T
    if !isconcretetype(T)
        error("`complex` not defined on abstractly-typed arrays; please convert to a more specific type")
    end
    convert(AbstractArray{typeof(complex(zero(T)))}, A)
end

# Override AbstractArray method to avoid printing useless type parameters
if VERSION >= v"0.7.0-DEV.2657"
    summary(io::IO, A::CategoricalArray{T, N, R}) where {T, N, R} =
        print(io, Base.dims2string(size(A)), " $CategoricalArray{$T,$N,$R}")
else
    summary(A::CategoricalArray{T, N, R}) where {T, N, R} =
        string(Base.dims2string(size(A)), " $CategoricalArray{$T,$N,$R}")
end

refs(A::CategoricalArray) = A.refs
pool(A::CategoricalArray) = A.pool

Base.deleteat!(A::CategoricalArray, inds) = (deleteat!(A.refs, inds); A)

Base.Broadcast.broadcasted(::typeof(ismissing), A::CategoricalArray{T}) where {T} =
    T >: Missing ? Base.Broadcast.broadcasted(==, A.refs, 0) :
                   Base.Broadcast.broadcasted(_ -> false, A.refs)

Base.Broadcast.broadcasted(::typeof(!ismissing), A::CategoricalArray{T}) where {T} =
    T >: Missing ? Base.Broadcast.broadcasted(>, A.refs, 0) :
                   Base.Broadcast.broadcasted(_ -> true, A.refs)

function Base.Broadcast.broadcasted(::typeof(levelcode), A::CategoricalArray{T}) where {T}
    if T >: Missing
        Base.Broadcast.broadcasted(r -> r > 0 ? Signed(widen(r)) : missing, A.refs)
    else
        Base.Broadcast.broadcasted(r -> Signed(widen(r)), A.refs)
    end
end

function Base.sort!(v::CategoricalVector;
                    # alg is ignored since counting sort is more efficient
                    alg::Base.Algorithm=Base.Sort.defalg(v),
                    lt=isless,
                    by=identity,
                    rev::Bool=false,
                    order::Base.Ordering=Base.Forward)
    counts = zeros(UInt, length(v.pool) + (eltype(v) >: Missing))

    # do a count/histogram of the references
    @inbounds for ref in v.refs
        counts[ref + (eltype(v) >: Missing)] += 1
    end

    # compute the order in which to read from counts
    ord = Base.Sort.ord(lt, by, rev, order)
    seen = counts .> 0
    anymissing = eltype(v) >: Missing && seen[1]
    levs = eltype(v) >: Missing ?
        eltype(v)[i == 0 ? missing : CategoricalValue(v.pool, i) for i in 0:length(v.pool)] :
        eltype(v)[CategoricalValue(v.pool, i) for i in 1:length(v.pool)]
    sortedlevs = sort!(Vector{eltype(levs)}(view(levs, seen)), order=ord)
    levelsmap = something.(indexin(sortedlevs, levs))
    j = 0
    refs = v.refs
    @inbounds for i in eachindex(levelsmap)
        ref = levelsmap[i]
        tmpj = j + counts[ref]
        refs[(j+1):tmpj] .= ref - (eltype(v) >: Missing)
        j = tmpj
    end

    return v
end

Base.repeat(a::CatArrOrSub{T, N},
            counts::Integer...) where {T, N} =
    CategoricalArray{T, N}(repeat(refs(a), counts...), copy(pool(a)))

Base.repeat(a::CatArrOrSub{T, N};
            inner = nothing, outer = nothing) where {T, N} =
    CategoricalArray{T, N}(repeat(refs(a), inner=inner, outer=outer), copy(pool(a)))

# DataAPI refarray/refvalue/refpool support
struct CategoricalRefPool{T, P} <: AbstractVector{T}
    pool::P
end

Base.IndexStyle(::Type{<: CategoricalRefPool}) = Base.IndexLinear()

@inline function Base.getindex(x::CategoricalRefPool, i::Int)
    @boundscheck checkbounds(x, i)
    i > 0 ? @inbounds(x.pool[i]) : missing
end

Base.size(x::CategoricalRefPool{T}) where {T} = (length(x.pool) + (T >: Missing),)
Base.axes(x::CategoricalRefPool{T}) where {T} =
    ((T >: Missing ? 0 : 1):length(x.pool),)
Base.LinearIndices(x::CategoricalRefPool) = axes(x, 1)

DataAPI.refarray(A::CatArrOrSub) = refs(A)
DataAPI.refpool(A::CatArrOrSub{T}) where {T} =
    CategoricalRefPool{eltype(A), typeof(pool(A))}(pool(A))
DataAPI.invrefpool(A::CatArrOrSub{T}) where {T} =
    CategoricalInvRefPool{eltype(A), typeof(pool(A).invindex)}(pool(A).invindex)

@inline function DataAPI.refvalue(A::CatArrOrSub{T}, i::Integer) where T
    @boundscheck checkindex(Bool, (T >: Missing ? 0 : 1):length(pool(A)), i) ||
        throw(BoundsError())
    i > 0 ? @inbounds(pool(A)[i]) : missing
end

struct CategoricalInvRefPool{T, P}
    invpool::P
end

@inline function Base.haskey(x::CategoricalInvRefPool{T}, v) where {T}
    if T >: Missing && ismissing(v)
        return true
    else
        return haskey(x.invpool, v)
    end
end

@inline function Base.getindex(x::CategoricalInvRefPool{T}, v) where {T}
    if T >: Missing && ismissing(v)
        return zero(valtype(x.invpool))
    else
        return x.invpool[v]
    end
end

@inline function Base.get(x::CategoricalInvRefPool{T}, v, default) where {T}
    if T >: Missing && ismissing(v)
        return zero(valtype(x.invpool))
    else
        return get(x.invpool, v, default)
    end
end

# Implementation details

`CategoricalArray` is made of the two fields:

- `refs`: an integer array that stores the position of the category level in the `levels` field of `CategoricalPool` for each `CategoricalArray` element; `0` denotes a missing value (for `CategoricalArray{Union{T, Missing}}` only).
- `pool`: the `CategoricalPool` object that maintains the levels of the array.

The `CategoricalPool{V,R,C}` type keeps track of the levels of type `V` and associates them with an integer reference code of type `R` (for internal use). It offers methods to add new levels, and efficiently get the integer index corresponding to a level and vice-versa. Whether the values of `CategoricalArray` are ordered or not is defined by an `ordered` field of the pool.

Do note that `CategoricalPool` levels are semi-mutable: it is only allowed to add new levels, but never to remove or reorder existing ones. This ensures existing `CategoricalValue` objects remain valid and always point to the same level as when they were created. Therefore, `CategoricalArray`s create a new pool each time some of their levels are removed or reordered. This happens when calling `levels!`, but also when assigning a `CategoricalValue` via `setindex!`, `push!`, `append!`, `copy!` or `copyto!` (as new levels may be added to the front to preserve relative order of both source and destination levels). Doing so requires updating all reference codes to point to the new pool, and makes it impossible to compare existing ordered `CategoricalValue` objects with values from the array using `<` and `>`.

The type parameters of `CategoricalArray{T, N, R <: Integer, V, C, U}` are a bit complex:
 - `T` is the type of array elements without `CategoricalValue` wrappers; if `T >: Missing`, then the array supports missing values.
 - `N` is the number of array dimensions.
 - `R` is the reference type, the element type of the `refs` field; it allows optimizing memory usage depending on the number of levels (i.e. `CategoricalArray` with less than 256 levels can use `R = UInt8`).
 - `V` is the type of the levels, it is equal to `T` for arrays which do not support missing values; for arrays which support missing values, `T = Union{V, Missing}`
 - `C` is the type of categorical values, i.e. of the objects returned when indexing non-missing elements of `CategoricalArray`. It is always equal to `CategoricalValue{V, R}`, and only present for technical reasons (to break the recursive dependency between `CategoricalArray` and `CategoricalValue`).
 - `U` can be either `Union{}` for arrays which do not support missing values, or `Missing` for those which support them.

Only `T`, `N` and `R` could be specified upon construction. The last three parameters are chosen automatically, but are needed for the definition of the type. In particular, `U` allows expressing that `CategoricalArray{T, N}` inherits from `AbstractArray{Union{C, U}, N}` (which is equivalent to `AbstractArray{C, N}` for arrays which do not support missing values, and to `AbstractArray{Union{C, Missing}, N}` for those which support them).

The `CategoricalPool` type is designed to limit the need to go over all elements of the vector, either for reading or for writing. This is why unused levels are not dropped automatically (this would force checking all elements on every modification or keeping a counts table), but only when `droplevels!` is called. `levels` is a (very fast) O(1) operation since it merely returns the (ordered) vector of levels without accessing the data at all.

Scalar operations between `CategoricalValue` objects or between a `CategoricalValue` and a `CategoricalArray` generally require checking whether pools are equal or whether one is a superset of the other. In order to make these operations efficient, `CategoricalPool` stores a pointer to the last encountered equal pool in the `equalto` field, and a pointer to the last encountered strict superset pool in `subsetof` field. The hash of the levels is computed the first time it is needed and stored in the `hash` field. These optimizations mean that when looping over values in an array, the cost of comparing pools only has to be paid once.

# Overview

The package provides the `CategoricalArray` type designed to hold categorical data (either unordered/nominal or ordered/ordinal) efficiently and conveniently. `CategoricalArray{T}` holds values of type `T`. The `CategoricalArray{Union{T, Missing}}` variant can also contain missing values (represented as `missing`, of the [`Missing`](https://docs.julialang.org/en/stable/manual/missing/) type). When indexed, `CategoricalArray{T}` returns special `CategoricalValue{T}` objects rather than the original values of type `T`. `CategoricalValue` is a simple wrapper around the categorical levels; it allows very efficient retrieval and comparison of actual values. See the [PooledArrays.jl](https://github.com/JuliaComputing/PooledArrays.jl) and [IndirectArrays.jl](https://github.com/JuliaArrays/IndirectArrays.jl) packages for simpler array types storing data with a small number of values without wrapping them.

The main feature of `CategoricalArray` is that it maintains a pool of the levels which can appear in the data. These levels are stored in a specific order: for unordered arrays, this order is only used for pretty printing (e.g. in cross tables or plots); for ordered arrays, it also allows comparing values using the `<` and `>` operators: the comparison is then based on the ordering of levels stored in the array. An ordered `CategoricalValue` can be also compared with a value that when converted is equal to one of the levels of this `CategoricalValue`. Whether an array is ordered can be defined either on construction via the `ordered` argument, or at any time via the `ordered!` function. The `levels` function returns all the levels of `CategoricalArray`, and the `levels!` function can be used to set the levels and their order. Levels are also automatically extended when setting an array element to a level not encountered before. But they are never removed without manual intervention: use the `droplevels!` function for this.

# Using CategoricalArrays

## Basic usage

Suppose that you have data about four individuals, with three different age groups. Since this variable is clearly ordinal, we mark the array as such via the `ordered` argument.

```jldoctest using
julia> using CategoricalArrays

julia> x = CategoricalArray(["Old", "Young", "Middle", "Young"], ordered=true)
4-element CategoricalArray{String,1,UInt32}:
 "Old"
 "Young"
 "Middle"
 "Young"

```

By default, the levels are lexically sorted, which is clearly not correct in our case and would give incorrect results when testing for order. This is easily fixed using the `levels!` function to reorder levels:

```jldoctest using
julia> levels(x)
3-element CategoricalArray{String,1,UInt32}:
 "Middle"
 "Old"
 "Young"

julia> levels!(x, ["Young", "Middle", "Old"])
4-element CategoricalArray{String,1,UInt32}:
 "Old"
 "Young"
 "Middle"
 "Young"

```

Thanks to this order, we can not only test for equality between two values, but also compare the ages of e.g. individuals 1 and 2:

```jldoctest using
julia> x[1]
CategoricalValue{String, UInt32} "Old" (3/3)

julia> x[2]
CategoricalValue{String, UInt32} "Young" (1/3)

julia> x[2] == x[4]
true

julia> x[1] > x[2]
true

```

Now let us imagine the first individual is actually in the "Young" group. Let's fix this (notice how the string `"Young"` is automatically converted to a `CategoricalValue`):

```jldoctest using
julia> x[1] = "Young"
"Young"

julia> x[1]
CategoricalValue{String, UInt32} "Young" (1/3)

```

The `CategoricalArray` still considers `"Old"` as a possible level even if it is unused now. This is necessary to allow efficiently accessing the levels and setting values of elements in the array: indeed, dropping unused levels requires iterating over every element in the array, which is expensive. This property can also be useful to keep track of possible levels, even if they do not occur in practice.

To get rid of the `"Old"` group, just call the [`droplevels!`](@ref) function:

```jldoctest using
julia> levels(x)
3-element CategoricalArray{String,1,UInt32}:
 "Young"
 "Middle"
 "Old"

julia> droplevels!(x)
4-element CategoricalArray{String,1,UInt32}:
 "Young"
 "Young"
 "Middle"
 "Young"

julia> levels(x)
2-element CategoricalArray{String,1,UInt32}:
 "Young"
 "Middle"

```

Another solution would have been to call `levels!(x, ["Young", "Middle"])` manually. This command is safe too, since it will raise an error when trying to remove levels that are currently used:

```jldoctest using
julia> levels!(x, ["Young", "Midle"])
ERROR: ArgumentError: cannot remove level "Middle" as it is used at position 3. Change the array element type to Union{String, Missing} using convert if you want to transform some levels to missing values.
[...]

```

Note that entries in the `x` array cannot be treated as strings. Instead, they need to be converted to strings using `String(x[i])`:
```jldoctest using
julia> lowercase(String(x[3]))
"middle"

julia> replace(String(x[3]), 'M'=>'R')
"Riddle"
```
Note that the call to `String` does not reduce performance compared with working with a `Vector{String}` as it simply returns the string object which is stored by the pool.

Integer codes giving the index of each value in the levels can be obtained using the [`levelcode`](@ref) function:
```jldoctest using
julia> levelcode(x[1])
1

julia> levelcode.(x)
4-element Vector{Int64}:
 1
 1
 2
 1
```

## Handling Missing Values

The examples above assumed that the data contained no missing values. This is generally not the case for real data. This is where `CategoricalArray{Union{T, Missing}}` comes into play. It is essentially the categorical-data equivalent of `Array{Union{T, Missing}}`. It behaves exactly as `CategoricalArray{T}`, except that when indexed it returns either a `CategoricalValue{T}` object or `missing` if the value is missing. See [the Julia manual](https://docs.julialang.org/en/stable/manual/missing/) for more information on the `Missing` type.

Let's adapt the example developed above to support missing values. Since there are no missing values in the input vector, we need to specify that the array should be able to hold either a `String` or `missing`:

```jldoctest using
julia> y = CategoricalArray{Union{Missing, String}}(["Old", "Young", "Middle", "Young"], ordered=true)
4-element CategoricalArray{Union{Missing, String},1,UInt32}:
 "Old"
 "Young"
 "Middle"
 "Young"

```

Levels still need to be reordered manually:

```jldoctest using
julia> levels(y)
3-element CategoricalArray{String,1,UInt32}:
 "Middle"
 "Old"
 "Young"

julia> levels!(y, ["Young", "Middle", "Old"])
4-element CategoricalArray{Union{Missing, String},1,UInt32}:
 "Old"
 "Young"
 "Middle"
 "Young"

```

At this point, indexing into the array gives exactly the same result

```jldoctest using
julia> y[1]
CategoricalValue{String, UInt32} "Old" (3/3)
```

Missing values can be introduced either manually, or by restricting the set of possible levels. Let us imagine this time that we actually do not know the age of the first individual. We can set it to a missing value this way:

```jldoctest using
julia> y[1] = missing
missing

julia> y
4-element CategoricalArray{Union{Missing, String},1,UInt32}:
 missing
 "Young"
 "Middle"
 "Young"

julia> y[1]
missing

```

It is also possible to transform all values belonging to some levels into missing values, which gives the same result as above in the present case since we have only one individual in the `"Old"` group. Let's first restore the original value for the first element, and then set it to missing again using the `allowmissing` argument to `levels!`:

```jldoctest using
julia> y[1] = "Old"
"Old"

julia> y
4-element CategoricalArray{Union{Missing, String},1,UInt32}:
 "Old"
 "Young"
 "Middle"
 "Young"

julia> levels!(y, ["Young", "Middle"]; allowmissing=true)
4-element CategoricalArray{Union{Missing, String},1,UInt32}:
 missing
 "Young"
 "Middle"
 "Young"

```

Conversely, all missing values can be turned into a "normal" value using `replace`
(or `recode`, whose syntax is identical for this operation):
```jldoctest using
julia> replace(y, missing => "missing value")
4-element CategoricalArray{String,1,UInt32}:
 "missing value"
 "Young"
 "Middle"
 "Young"
```
Note that the returned array no longer allows for missing values (which is usually what is expected).
This syntax works for array types other than `CategoricalArray`.

An in-place variant `replace!` (respectively `recode!`) is also provided. Note that `y` still allows
for missing values (since the type of an object cannot be changed).
```jldoctest using
julia> replace!(y, missing => "missing value");

julia> y
4-element CategoricalArray{Union{Missing, String},1,UInt32}:
 "missing value"
 "Young"
 "Middle"
 "Young"
```

## Combining levels

Some operations imply combining levels of two categorical arrays: this is the case when concatenating arrays (`vcat`, `hcat` and `cat`) and when assigning a `CategoricalValue` from another categorical array.

For example, imagine we have two sets of observations, one with only the younger part of the population and one with the older part:
```jldoctest using
julia> x = categorical(["Middle", "Old", "Middle"], ordered=true);

julia> y = categorical(["Young", "Middle", "Middle"], ordered=true);

julia> levels!(y, ["Young", "Middle"]);
```

If we concatenate the two sets, the levels of the resulting categorical vector are chosen so that the relative orders of levels in `x` and `y` are preserved, if possible. In that case, comparisons with `<` and `>` are still valid, and resulting vector is marked as ordered:
```jldoctest using
julia> xy = vcat(x, y)
6-element CategoricalArray{String,1,UInt32}:
 "Middle"
 "Old"
 "Middle"
 "Young"
 "Middle"
 "Middle"

julia> levels(xy)
3-element CategoricalArray{String,1,UInt32}:
 "Young"
 "Middle"
 "Old"

julia> isordered(xy)
true
```

Likewise, assigning a `CategoricalValue` from `y` to an entry in `x` expands the levels of `x` with all levels from `y`, *respecting the ordering of levels of both vectors if possible*:
```jldoctest using
julia> levels(x)
2-element CategoricalArray{String,1,UInt32}:
 "Middle"
 "Old"

julia> x[1] = y[1]
CategoricalValue{String, UInt32} "Young" (1/2)

julia> levels(x)
3-element CategoricalArray{String,1,UInt32}:
 "Young"
 "Middle"
 "Old"

julia> x[1]
CategoricalValue{String, UInt32} "Young" (1/3)
```

In cases where levels with incompatible orderings are combined, the ordering of the destination array wins and the destination array is marked as unordered. The same happens when concatenating arrays, and the ordering of the first array wins in case of conflict:
```jldoctest using
julia> a = categorical(["a", "b", "c"], ordered=true);

julia> b = categorical(["a", "b", "c"], ordered=true);

julia> ab = vcat(a, b)
6-element CategoricalArray{String,1,UInt32}:
 "a"
 "b"
 "c"
 "a"
 "b"
 "c"

julia> levels(ab)
3-element CategoricalArray{String,1,UInt32}:
 "a"
 "b"
 "c"

julia> isordered(ab)
true

julia> levels!(b, ["c", "b", "a"])
3-element CategoricalArray{String,1,UInt32}:
 "a"
 "b"
 "c"

julia> ab2 = vcat(a, b)
6-element CategoricalArray{String,1,UInt32}:
 "a"
 "b"
 "c"
 "a"
 "b"
 "c"

julia> levels(ab2)
3-element CategoricalArray{String,1,UInt32}:
 "a"
 "b"
 "c"

julia> isordered(ab2)
false
```

The resulting array is marked as ordered only if all the source array(s) are ordered, with the exception that unordered arrays with no levels do not prompt the result to be marked as unordered. In particular, this allows assignment of a `CategoricalValue` to an empty `CategoricalArray` via `setindex!` to copy the levels of the source value and to mark the result as ordered.

Do note that in some cases the two sets of levels may have compatible orderings, but it is not possible to determine in what order should levels appear in the merged set. This is the case for example with `["a, "b", "d"]` and `["c", "d", "e"]`: there is no way to detect that `"c"` should be inserted exactly after `"b"` (lexicographic ordering is not relevant here). In such cases, the resulting array is marked as unordered. This situation can only happen when working with data subsets selected based on non-contiguous subsets of levels.

## Exported functions

`categorical(A)` - Construct a categorical array with values from `A`

`compress(A)` - Return a copy of categorical array `A` using the smallest possible reference type

`cut(x)` - Cut a numeric array into intervals and return an ordered `CategoricalArray`

`decompress(A)` - Return a copy of categorical array `A` using the default reference type

`isordered(A)` - Test whether entries in `A` can be compared using `<`, `>` and similar operators

`ordered!(A, ordered)` - Set whether entries in `A` can be compared using `<`, `>` and similar operators

`recode(a[, default], pairs...)` - Return a copy of `a` after replacing one or more values

`recode!(a[, default], pairs...)` - Replace one or more values in `a` in-place

`unwrap(x)` - Return the value contained in categorical value `x`; if `x` is `Missing`
              return `missing`

`levelcode(x)` - Return the code of categorical value `x`, i.e. its index
                  in the set of possible values returned by `levels(x)`.

See [API Index](@ref) for more details.
